function GroupStackedColumnBarChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "Food",
        data: [323, 237, 375, 175, 205],
        color: "#F7A25A",
        stack: "Male"
      },
      {
        name: "Home Appliances",
        color: "#94EF7B",
        data: [434, 142, 148, 155, 108],
        stack: "Male"
      },
      {
        name: "Electronics",
        color: "#7BB6EF",
        data: [201, 175, 420, 350, 263],
        stack: "Male"
      },
      {
        name: "Food",
        data: [300, 217, 280, 145, 196],
        color: "#F7A25A",
        stack: "Female",
        showInLegend: false
      },
      {
        name: "Home Appliances",
        color: "#94EF7B",
        data: [404, 120, 132, 105, 165],
        stack: "Female",
        showInLegend: false
      },
      {
        name: "Electronics",
        color: "#7BB6EF",
        data: [198, 150, 403, 270, 266],
        stack: "Female",
        showInLegend: false
      }
    ];
    return seriesData;
  };
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    var lassoObj = SeriesLibrary.prototype.lasso;
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();

    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset === "" || titletext == " ") {
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };

    var defaultValue = {
      chart: {
        type: "column",
        inverted: that.sgcharttype().split("-")[1] == "bar",
        //  animation: that.result() ?that.result().tuples.length>1000?false:that.chartanimation() :that.chartanimation(),
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            lassoObj.unselectByClick.call(this, that);
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          redraw: function() {
            if (that.ystacklabelsenabled()) {
              var yAxis = this.yAxis[0],
                stacks = yAxis.stacks.column;

              for (var stack in stacks) {
                if (stacks[stack].label.alignAttr.y < 0) {
                  stacks[stack].label
                    .attr({
                      visibility: "visible"
                    })
                    .translate(0, 25);
                }
              }
            } else if (that.xstacklabelsenabled()) {
              var xAxis = this.xAxis[0],
                stacks = xAxis.stacks.column;

              for (var stack in stacks) {
                if (stacks[stack].label.alignAttr.x < 0) {
                  stacks[stack].label
                    .attr({
                      visibility: "visible"
                    })
                    .translate(0, 25);
                }
              }
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }

            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  "http://www.visualbis.com",
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }

            if (that.ystacklabelsenabled()) {
              var yAxis = this.yAxis[0],
                stacks = yAxis.stacks.column;

              for (var stack in stacks) {
                if (stacks[stack].label.alignAttr.y < 0) {
                  stacks[stack].label
                    .attr({
                      visibility: "visible"
                    })
                    .translate(0, 25);
                }
              }
            } else if (that.xstacklabelsenabled()) {
              var xAxis = this.xAxis[0],
                stacks = xAxis.stacks.column;

              for (var stack in stacks) {
                if (stacks[stack].label.alignAttr.x < 0) {
                  stacks[stack].label
                    .attr({
                      visibility: "visible"
                    })
                    .translate(0, 25);
                }
              }
            }
          },

          selection: function(e) {
            var retVal = lassoObj.selectPointsByDrag.call(this, e, that);
            if (this.lasso == "lasso" || this.lasso == "rlasso") {
              that.fireEvent("chartonpointclick");
            } else {
              if (e.xAxis) {
                that.fireEvent("chartonselect");
              } //disabling the fireEvent while zoom out.
            }

            return retVal;
          }
        },
        //height:that.chartheight(),
        //width:that.chartwidth(),
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        panKey: that.chartpankey(),
        panning: that.chartpanning(),
        pinchType: that.chartpinchtype(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        /*                    spacingBottom:that.chartpaddingbottom(),
                              spacingLeft:that.chartpaddingleft(),
                              spacingRight:that.chartpaddingright(),
                              spacingTop:that.chartpaddingtop(),*/
        zoomType: that.chartzoomtype(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            //relativeTo:that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign() //x:that.zoombuttonxposition(),
            //y:that.zoombuttonyposition()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        //options3d: {
        //  enabled: that.chart3denabled(),
        //  alpha: that.chart3dalpha(),
        //  beta: that.chart3dbeta(),
        //  depth: that.chart3ddepth(),
        //  viewDistance: that.chart3dviewdistance()
        // },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor() /* style:{
        fontFamily:that.chartfontfamily(),
        fontSize:that.chartfontsize()+"px"
      } */
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      xAxis: {
        categories: ["Northeast", "Southeast", "Midwest", "West", "Central"],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        /*                      startOnTick:that.xaxisstartontick(),
      endOnTick:that.xaxisendontick(),*/
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        opposite: that.xaxisopposite(),
        labels: {
          reserveSpace: that.xaxisreservespace(),
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          //distance:that.xaxislabeldistance(), applies to polar
          format:
            that.xaxislabelprefix() +
            that.xaxislabelformat() +
            that.xaxislabelsuffix(),
          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          staggerLines:
            that.xaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines:
            that.xaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep() === 0 ? null : that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        stackLabels: {
          style: { color: "black" },
          enabled: that.xstacklabelsenabled(),
          formatter: function() {
            return (
              that.datalabelprefix() +
              " " +
              Highcharts.numberFormat(
                this.total,
                that.decimal(),
                decimalsep,
                thousandsep
              ) +
              " " +
              that.datalabelsuffix()
            );
          }
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          margin: that.xaxistitlemargin(),
          offset: offsetaxis(
            that.xaxistitleenabled(),
            that.xaxistitleoffset(),
            that.xaxistitletext()
          ),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [
          {
            color:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandcolor()
                : null,
            borderColor:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandbordercolor()
                : null,
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom() - 0.5,
            to: that.xaxisplotbandto() + 0.5,
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("xaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display:
                  that.xaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x:
                that.xaxisplotbandlabelxposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelxposition()),
              y:
                that.xaxisplotbandlabelyposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.xaxisplotlineenabled() === true
                ? that.xaxisplotlinecolor()
                : null,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display:
                  that.xaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotlinelabeltext(),
              align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign: that.xaxisplotlinelabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.xaxisplotlinelabelverticalalign()
            }
          }
        ]
      },
      yAxis: {
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        lineWidth: that.yaxislinewidth(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval:
          that.yaxisminortickinterval() == "null"
            ? "auto"
            : _.parseInt(that.yaxisminortickinterval()),
        tickInterval:
          that.yaxistickinterval() === ""
            ? null
            : _.parseInt(that.yaxistickinterval()),
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth(),
        ceiling:
          that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
        floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
        min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
        max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
        maxPadding:
          that.yaxismaxpadding() === ""
            ? null
            : parseFloat(that.yaxismaxpadding()),
        minPadding:
          that.yaxisminpadding() === ""
            ? null
            : parseFloat(that.yaxisminpadding()),
        minRange: that.yaxisminrange(),
        showEmpty: that.yaxisshowempty(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        offset: that.yaxisoffset(),
        opposite: that.yaxisopposite(),
        reversed: that.yaxisreversed() === true,
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: that.yaxistitleenabled() === true ? "block" : "none"
          }
        },
        labels: {
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          formatter: function() {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this);
          },
          staggerLines:
            that.yaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelstaggerline()),
          maxStaggerLines:
            that.yaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelmaxstaggerline()),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          rotation: that.yaxislabelrotation(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        stackLabels: {
          style: { color: "black" },
          enabled: that.ystacklabelsenabled(),
          formatter: function() {
            return (
              that.datalabelprefix() +
              " " +
              Highcharts.numberFormat(
                this.total,
                that.decimal(),
                decimalsep,
                thousandsep
              ) +
              " " +
              that.datalabelsuffix()
            );
          }
        },
        plotBands: [
          {
            color:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandcolor()
                : null,
            borderColor:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandbordercolor()
                : null,
            borderWidth: that.yaxisplotbandborderwidth(),
            from: that.yaxisplotbandfrom(),
            to: that.yaxisplotbandto(),
            zIndex: that.yaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("yaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.yaxisplotbandlabelcolor(),
                fontWeight: that.yaxisplotbandlabelfontweight(),
                textDecoration: that.yaxisplotbandlabelfontweight(),
                fontSize: that.yaxisplotbandlabelfontsize() + "px",
                fontFamily: that.yaxisplotbandlabelfontfamily(),
                display:
                  that.yaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotbandlabeltext(),
              align: that.yaxisplotbandlabelalign(),
              rotation: that.yaxisplotbandlabelrotation(),
              verticalAlign: that.yaxisplotbandlabelverticalalign(),
              x:
                that.yaxisplotbandlabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelxposition()),
              y:
                that.yaxisplotbandlabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.yaxisplotlineenabled() === true
                ? that.yaxisplotlinecolor()
                : null,
            dashStyle: that.yaxisplotlinedashstyle(),
            width: that.yaxisplotlinewidth(),
            value: that.yaxisplotlinevalue(),
            zIndex: that.yaxisplotlinezindex(),
            label: {
              style: {
                color: that.yaxisplotlinelabelcolor(),
                fontWeight: that.yaxisplotlinelabelfontweight(),
                textDecoration: that.yaxisplotlinelabelfontweight(),
                fontSize: that.yaxisplotlinelabelfontsize() + "px",
                fontFamily: that.yaxisplotlinelabelfontfamily(),
                display:
                  that.yaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotlinelabeltext(),
              align: that.yaxisplotlinelabelalign(),
              rotation: that.yaxisplotlinelabelrotation(),
              textAlign: that.yaxisplotlinelabeltextalign(),
              verticalAlign: that.yaxisplotlinelabelverticalalign(),
              x:
                that.yaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelxposition()),
              y:
                that.yaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelyposition())
            }
          }
        ]
      },
      plotOptions: {
        series: {
          /* borderColor: that.seriesbordercolor(),
             borderRadius:that.seriesborderradius(),
             borderWidth:that.seriesborderwidth(), */
          //  pointWidth:that.pointwidth(),
          cursor: "pointer",
          minPointLength: that.minimumpointlength(),
          point: {
            events: {
              click: function(event) {
                try {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  ); //sgchanged = 1;
                } catch (e) {}
              },

              select: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    if (that.chartenablezoom()) {
                      that.selectedPoints = $("#detail-container" + that["id"]())
                        .highcharts()
                        .getSelectedPoints();
                    } else {
                      that.selectedPoints = component
                        .highcharts()
                        .getSelectedPoints();
                    }
                    that.selectedPoints.push(this);
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    seriesLibrary.onSelectFunction(that);
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                }
                /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
              },

              unselect: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    // if (that.chartenablezoom()) {
                    //   var unselectedPoints = $('#detail-container' + that['id']() + '').highcharts().getSelectedPoints();
                    // } else {
                    //   var unselectedPoints = component.highcharts().getSelectedPoints();
                    // }
                    var index = that.selectedPoints.indexOf(this);
                    if (index > -1) {
                      that.selectedPoints.splice(index, 1);
                    }
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    if (that.selectedvalues() === "") {
                      that.selectedvalue("");
                    } else {
                      var select = seriesLibrary.createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      );
                      that.selectedvalue(select[0]);
                    }
                    /**
                       *Selectedvalue fix in all charts
                       *Multiple Selection getting the last selected value.
                      **/
                    if (that.clearSelect) {
                      if (that.selectedvalues() === "") {
                        that.clearSelect = false;
                      }
                    } else {
                      seriesLibrary.onSelectFunction(that);
                    } //clearselection callback issue on Onselect.
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                  /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
                }
              }
            }
          },
          //pointPlacement:that.xaxistickmarkplacement(),
          allowPointSelect: that.allowpointselect(),
          cropThreshold: that.cropthreshold(),
          //cursor:that.pointcursor(),
          //enableMouseTracking:that.enablemousetracking(),
          turboThreshold: 0,
          //stickyTracking:that.stickytracking(),
          dataLabels: {
            enabled: that.datalabelenabled(),
            align:
              that.datalabelalign() == "default" ? null : that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign:
              that.datalabelverticalalign() == "default"
                ? null
                : that.datalabelverticalalign(),
            inside: that.datalabelinside(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              /*                                if(this.y != null){
                                                return that.datalabelprefix() + '' + Highcharts.numberFormat(this.y, that.datavaluedecimals()) + '' + that.datalabelsuffix();}*/
              //VBX1.3 to VBX 1.4 migration
              if (that.decimal() === 2 && that.datavaluedecimals() != "auto") {
                that.decimal(that.datavaluedecimals());
                that.firePropertiesChanged(["decimal"]);
              }
              if (
                that.customdatalabel() !== "" &&
                Object.keys(JSON.parse(that.customdatalabel() || "{}")).length &&
                this.point.series.name.toLocaleLowerCase().indexOf("result") ==
                  -1 &&
                this.key.name.toLocaleLowerCase().indexOf("result") == -1
              ) {
                return vbiNumberFormat.barFamilyFormatterDataLabel(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              } else {
                return vbiNumberFormat.barFamilyDataLabelFormatter(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              }
            },

            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily: that.globalfont()
                ? this.fontfamily()
                : that.datalabelfontfamily()
            }
          },
          stacking: "normal"
        }
      },
      series: options.seriesData
    };
    return defaultValue;
  };
  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.measureValidation = function() {
        var returnValue = false;
        var measureinrow = false;
        try {
          for (var i = 0; i < component.result().dimensions.length; i++) {
            if (component.result().dimensions[i].containsMeasures === true && component.result().dimensions[i].axis == 'ROWS') {
              measureinrow = true;
            }
          }

          if (measureinrow === true) {
            returnValue = false;
          } else {
            returnValue = true;
          }  //return true;
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }

        return returnValue + '';  //callruntime handler won't handle object and boolean hence return string
      };

    component.createIdentical = function(defaultValue) {
      var entireData = [];
      for (var i = 0; i < defaultValue.series.length; i++) {
      if(defaultValue.series[i].data){
        for (var j = 0; j < defaultValue.series[i].data.length; j++) {
          entireData.push(defaultValue.series[i].data[j].y || 0);
        }
      }
      }

      if (entireData.length > 0) {

        component.minimumValue = entireData.reduce(function(p, v) {
        return p < v ? p : v;
      });

        component.maximumValue = entireData.reduce(function(p, v) {
        return p > v ? p : v;
      });
        /*
               * Getting all the value in a array
               * sorting minimum and maximum value in it.
               */
        if (component.minimumValue === undefined) {
          component.minimumValue = 0;
          component.maximumValue = 250;
        }
        /*
                 * If no data-source selected.
                 */
        var listGroup = component['list']();
        var restart = component['chartRestart']();
        var testingArrayTemp = component['testingArray']();
        var minimumVal = Math.floor(component.minimumValue).toFixed(component.decimal());
        var maximumVal = Math.ceil(component.maximumValue).toFixed(component.decimal());
        var datasourceAssigned = component['DATA_SOURCE_ALIAS_REF']();
        var chartId = component['id']();
        var customMin = component['groupingyaxismin']();
        var customMax = component['groupingyaxismax']();
        if (WhatIfLibrary != undefined && listGroup != '' || restart != 0) { /* jshint ignore: line */
          WhatIfLibrary.register(chartId, {
          type: 'Chart',
          name: 'Stacked&Grouped Chart',
          category: 'charts',
          data_source: datasourceAssigned,/* jshint ignore: line */
          custom_function: {/* jshint ignore: line */
            'custom_id_min_value': minimumVal,
            'custom_id_max_value': maximumVal,
            'custom_id_groupId': testingArrayTemp,
            'custom_id_SelectedValue': listGroup,
            'custom_id_min': customMin,
            'custom_id_max': customMax
          }
        }, component);
        }
        /*
                * Getting the minimum and maximum value and pushing it to whatifAnalyser(updating).
                * and also grouping name.
                */
        component.globalVal.push('None');
        for (var i in WhatIfLibrary.charts) {
          if (WhatIfLibrary.charts[i].custom_function !== undefined) {/* jshint ignore: line */
            var gettingArray = WhatIfLibrary.charts[i].custom_function.custom_id_groupId;/* jshint ignore: line */
            for (var j = 0; j < gettingArray.split(',').length; j++) {
              var localTest = gettingArray.split(',');
              if (component.globalVal.indexOf(localTest[j]) === -1) {
                component.globalVal.push(localTest[j]);
              }
            }
          }
        }

        seriesLibrary.creatIndenticalScaling(component, defaultValue, minimumVal, maximumVal, WhatIfLibrary);
        //identicalScaling Fix
        if (listGroup != '' || restart != 0) { /* jshint ignore: line */
          if (listGroup != 'None') {
            componentUtil.callHighCharts(component,component, defaultValue,{dependencyObject:dependencyObject,seriesData:seriesData});//jshint ignore:line
          }
        }
      }  //To stop the events
    };

    component.getChartNames = function() {
      return component.globalVal;
    };

    component.getMeasureMembers = function() {
      return seriesLibrary.getMeasureMembers(component);
    };

    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.isMeasureOnly = function() {
      var len = 0;
      if (component.result() !== undefined && component.result() !== '') {
        try {
          len = component.result().dimensions.length;
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return len;
    };

    component.getDropdownName = function() {
      return component.list();
    };

    component.getDataLengthVal = function() {
      return JSON.stringify(component.result());
    };

  component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
    var dataSeries = [];
    var seriesNames = [];
    var seriesKeyNames = [];
    component.dataRes = component.dispKeyTextResultSet();
    var bardatacustomizationJson = {
      'COLUMNS': [],
      'ROWS': []
    };
    if (component.bardatacustomization() !== '') {
      bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
    }

    try {
      if (component.dataRes === undefined || component.dataRes === '') {
        // return null;
      } else if (component.datautility() === true && bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0) {
        return null;
      }

      if (component.dataRes.dimensions.length === 1 && component.dataRes.dimensions[0].containsMeasures === true) {
        var defaultColor = [
          '#B586DA',
          '#FF6657',
          '#F3A730',
          '#946B66',
          '#B0AD53',
          '#7AC1DE',
          '#F1C337',
          '#566C6C',
          '#A1CC54',
          '#543F1E'
        ];
        var seriesColor = [];
        if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
          seriesColor = [];
        } else {
          seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
        }

        if (component.dataRes.dimensions[0].axis == 'COLUMNS') {
          for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
            seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
            seriesNames.push(component.dataRes.dimensions[0].members[i].text);
            seriesKeyNames.push(component.dataRes.dimensions[0].members[i].key);
          }
        } else {
          seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
          seriesNames.push('Measures');
          seriesKeyNames.push('Measures');
        }

        dataSeries = [
          seriesNames,
          seriesKeyNames
        ];
        seriesColor.splice(dataSeries[0].length, seriesColor.length);
        component.dataseriescolor(seriesColor.join());
      } else {
        //  dataSeries = seriesLibrary.createSeriesData(component, 'bar', defaultValueSeriesNames,"ncf");
        dataSeries = seriesLibrary.createSeriesAdditionalProperty(component, 'sgcolumn');
      }
    } catch (e) {   seriesLibrary.DSXalert(e.message);
    }

    return dataSeries;
  };

  component.getDataSeriesColor = function() {
    var dataseriescolor = '';
    try {
      dataseriescolor = component.dataseriescolor();
    } catch (e) {   seriesLibrary.DSXalert(e.message);
    }

    return dataseriescolor;
  };

  component.getDatUtility = function() {
    var datautility = '';
    try {
      datautility = component.datautility();
    } catch (e) {   seriesLibrary.DSXalert(e.message);
    }

    return datautility;
  };

  component.getChartType = function() {
    return 'sgcolumn';
  };

  component.componentDeleted = function() {
    $('#dsui_' + componentID).remove();
    function triggerDelete() {
      var chartId = component['id']();
      if (WhatIfLibrary !== undefined) {
        for (var i in WhatIfLibrary.charts) {
          if (i === chartId) {
            //Removing current instances from WhatIfLibrary
            delete WhatIfLibrary.charts[i];
            delete WhatIfLibrary.instances[i];
          }
        }
        /*
                       *Deleting the Removed chart from the WhatIfLibrary
                       *Manually Removed
                       *WhatIfLibrary is removing only after window.refresh Hence removing Manually
                       */
        for (var i in WhatIfLibrary.charts) {
          if (sap.zen.Dispatcher.instance.getRootControlForComponentId(i) !== undefined) {
            var instance = WhatIfLibrary.getInstance(i);
            if (instance.list() !== '' || instance.list() != 'None') {
              instance.afterUpdate();
            }
          }  /*
                         *Trigger afterUpdate of the charts which are grouped
                         *Auto-AfterUpdate is not getting trigged
                         */
        }
      }
    }

    setTimeout(triggerDelete, 200);  //getRootControlForComponentId need a setTimeout
  };

  component.getChartFamily = function() {
    return 'bar';
  };

  component.getDecimalName = function() {
    return component.datavaluedecimals();
  };

  component.lassoFireProp = function(selectedPoints) {
    component.selectedvalues(seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints).toString());
  //  ++component.changed;
    component.firePropertiesChanged(['selectedvalues']);
  };

  }
}