function LineChartUtil(){

  componentUtil.call(this);

  this.getDefaultValue = function (that, options) {
    var dependencyObject = options.dependencyObject;
    var vbiCharts = dependencyObject.VbiCharts; // jshint ignore:line
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var DataUtilityLib = dependencyObject.dataUtilityLib; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    var lassoObj = SeriesLibrary.prototype.lasso;
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;

    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();
    var  component = that.$();
    var offsetaxis = function (titledisplay, titleoffset, titletext) {
      if (titleoffset == "" || titletext == " ") {
        //jshint ignore:line
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };
    var defaultValue = {
      chart: {
        type: "line",
        inverted: false,
        //shouldn't expose this property to user
        //alignTicks:that.chartalignticks(),//applicable in multiple axes
        className: that.chartcssclassname(),
        events: {
          click: function (event) {
            lassoObj.unselectByClick.call(this, that);
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function () {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function () {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function (e) {
            var retVal = lassoObj.selectPointsByDrag.call(this, e, that);
            if (this.lasso == "lasso" || this.lasso == "rlasso") {
              that.fireEvent("chartonpointclick");
            } else {
              if (e.xAxis) {
                setTimeout(function () {
                  that.fireEvent("chartonselect");
                }, 10);
              } //disabling the fireEvent while zoom out.
            }

            return retVal;
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom: that.chartmarginbottom() == "auto" ?
          null :
          Number(that.chartmarginbottom()),
        marginLeft: that.chartmarginleft() == "auto" ?
          null :
          Number(that.chartmarginleft()),
        marginRight: that.chartmarginright() == "auto" ?
          null :
          Number(that.chartmarginright()),
        marginTop: that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom: that.chartpaddingbottom() == "auto" ?
          null :
          Number(that.chartpaddingbottom()),
        spacingLeft: that.chartpaddingleft() == "auto" ?
          null :
          Number(that.chartpaddingleft()),
        spacingRight: that.chartpaddingright() == "auto" ?
          null :
          Number(that.chartpaddingright()),
        spacingTop: that.chartpaddingtop() == "auto" ?
          null :
          Number(that.chartpaddingtop()),
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: true,
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: {
              color: that.resetzoombuttontextcolor()
            },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: {
                  color: that.resetzoombuttonhovertextcolor()
                }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor: that.plottransparency() === true ?
          "transparent" :
          that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      xAxis: {
        categories: [
          "Jan",
          "Feb",
          "Mar",
          "Apr",
          "May",
          "Jun",
          "Jul",
          "Aug",
          "Sep",
          "Oct",
          "Nov",
          "Dec"
        ],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        gridLineColor: that.xaxisgridlinecolor(),
        gridLineDashStyle: that.xaxisgridlinedashstyle(),
        gridLineWidth: that.xaxisgridlinewidth(),
        gridZIndex: that.xaxisgridzindex(),
        ceiling: that.xaxisceiling() === "" ? null : _.parseInt(that.xaxisceiling()),
        floor: that.xaxisfloor() === "" ? null : _.parseInt(that.xaxisfloor()),
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        min: that.xaxismin() === "" ? null : _.parseInt(that.xaxismin()),
        max: that.xaxismax() === "" ? null : _.parseInt(that.xaxismax()),
        maxPadding: that.xaxismaxpadding() === "" ?
          null :
          parseFloat(that.xaxismaxpadding()),
        minPadding: that.xaxisminpadding() === "" ?
          null :
          parseFloat(that.xaxisminpadding()),
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},
        minTickInterval: that.xaxismintickinterval(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        labels: {
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          format: that.xaxislabelprefix() +
            that.xaxislabelformat() +
            that.xaxislabelsuffix(),

          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          //distance:that.xaxislabeldistance(),
          staggerLines: that.xaxislabelstaggerline() === "" ?
            null :
            _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines: that.xaxislabelmaxstaggerline() === "" ?
            null :
            _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep() === 0 ? null : that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function () {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: offsetaxis(
            that.xaxistitleenabled(),
            that.xaxistitleoffset(),
            that.xaxistitletext()
          ),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [{
          color: that.xaxisplotbandenabled() === true ?
            that.xaxisplotbandcolor() :
            null,
          borderColor: that.xaxisplotbandenabled() === true ?
            that.xaxisplotbandbordercolor() :
            null,
          borderWidth: that.xaxisplotbandborderwidth(),
          from: that.xaxisplotbandfrom(),
          to: that.xaxisplotbandto(),
          zIndex: that.xaxisplotbandzindex(),
          events: {
            click: function () {
              that.fireEvent("xaxisplotbandonclick");
            },

            mouseover: function () {
              that.fireEvent("xaxisplotbandmousemove");
            }
          },
          label: {
            style: {
              color: that.xaxisplotbandlabelcolor(),
              fontWeight: that.xaxisplotbandlabelfontweight(),
              textDecoration: that.xaxisplotbandlabelfontweight(),
              fontSize: that.xaxisplotbandlabelfontsize() + "px",
              fontFamily: that.xaxisplotbandlabelfontfamily(),
              display: that.xaxisplotbandlabelenabled() === true ? "block" : "none"
            },
            text: that.xaxisplotbandlabeltext(),
            align: that.xaxisplotbandlabelalign(),
            rotation: that.xaxisplotbandlabelrotation(),
            textAlign: that.xaxisplotbandlabeltextalign(),
            verticalAlign: that.xaxisplotbandlabelverticalalign(),
            x: that.xaxisplotbandlabelxposition() === "" ?
              null :
              _.parseInt(that.xaxisplotbandlabelxposition()),
            y: that.xaxisplotbandlabelyposition() === "" ?
              null :
              _.parseInt(that.xaxisplotbandlabelyposition())
          }
        }],
        plotLines: [{
          color: that.xaxisplotlineenabled() === true ?
            that.xaxisplotlinecolor() :
            null,
          dashStyle: that.xaxisplotlinedashstyle(),
          width: that.xaxisplotlinewidth(),
          value: that.xaxisplotlinevalue(),
          zIndex: that.xaxisplotlinezindex(),
          label: {
            style: {
              color: that.xaxisplotlinelabelcolor(),
              fontWeight: that.xaxisplotlinelabelfontweight(),
              textDecoration: that.xaxisplotlinelabelfontweight(),
              fontSize: that.xaxisplotlinelabelfontsize() + "px",
              fontFamily: that.xaxisplotlinelabelfontfamily(),
              display: that.xaxisplotlinelabelenabled() === true ? "block" : "none"
            },
            text: that.xaxisplotlinelabeltext(),
            align: that.xaxisplotlinelabelalign(),
            rotation: that.xaxisplotlinelabelrotation(),
            textAlign: that.xaxisplotlinelabeltextalign(),
            verticalAlign: that.xaxisplotlinelabelverticalalign(),
            x: that.xaxisplotlinelabelxposition() == "null" ?
              null :
              _.parseInt(that.xaxisplotlinelabelxposition()),
            y: that.xaxisplotlinelabelyposition() == "null" ?
              null :
              _.parseInt(that.xaxisplotlinelabelyposition())
          }
        }]
      },
      yAxis: {
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        lineWidth: that.yaxislinewidth(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval: that.yaxisminortickinterval() === "" ?
          "auto" :
          _.parseInt(that.yaxisminortickinterval()),
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth(),
        tickColor: that.yaxistickcolor(),
        tickInterval: that.yaxistickinterval() === "" ?
          null :
          _.parseInt(that.yaxistickinterval()),
        tickLength: that.yaxisticklength(),
        tickPosition: that.yaxistickposition(),
        tickWidth: that.yaxistickwidth(),
        tickmarkPlacement: that.yaxistickmarkplacement(),
        dateTimeLabelFormats: {},
        ceiling: that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
        floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
        min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
        max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
        maxPadding: that.yaxismaxpadding() === "" ?
          null :
          parseFloat(that.yaxismaxpadding()),
        minPadding: that.yaxisminpadding() === "" ?
          null :
          parseFloat(that.yaxisminpadding()),
        minRange: that.yaxisminrange(),
        offset: that.yaxisoffset(),
        opposite: that.yaxisopposite(),
        reversed: that.yaxisreversed() === true,
        showEmpty: that.yaxisshowempty(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        //          startOnTick: that.yaxisstartontick(),
        //          endOnTick: that.yaxisendontick(),
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: that.yaxistitleenabled() === true ? "block" : "none"
          }
        },
        labels: {
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          formatter: function () {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this);
            // try {
            //   var value;
            //   var unitValueChart = "";
            //   if(that.yaxislabelautoscale()){
            //    var unitValue =  this.axis.defaultLabelFormatter.call({
            //         axis: this.axis,
            //         value: this.value
            //     });
            //    value = unitValue.replace(/[^\d.-]/g, '');
            //    unitValueChart= unitValue.slice(-1);
            //    if(!isNaN(unitValueChart)){
            //      unitValueChart = "";
            //    }
            //   }else {
            //    value  = this.value;
            //   }
            //   var scaling = "";
            //   var valuePrefix = "";
            //   var color = 'black';
            //   var valueSuffix="";
            //   if(that.yaxissemanticformatenable()){
            //      if(value >=0){
            //        color = that.yaxissemanticformatpostivecolor();
            //        if(that.yaxissemanticformatpostive() == 1){
            //          valuePrefix = '+'
            //        }else if(that.yaxissemanticformatpostive() == 2){
            //          valueSuffix = '+';
            //        }
            //      }else{
            //        color = that.yaxissemanticformatnegativecolor();
            //        if(that.yaxissemanticformatnegative() == 1){
            //          valuePrefix = '-'
            //        }else if(that.yaxissemanticformatnegative() == 2){
            //          valueSuffix = '-';
            //        }
            //      }
            //   }
            //   if(that.yaxisscalingfactorenable()){
            //     var temp = that.yaxisscalingfactor()*10;
            //     if(!temp) temp =1;
            //     value = value/temp;
            //     scaling = '(* '+temp+')';
            //   }
            //   that.yaxislabelprefix()+that.yaxislabelsuffix();
            //   return '<span style="color:'+color+';float:right">'+ scaling+valuePrefix+' ' + Highcharts.numberFormat(value, that.yaxisdecimal(), that.yaxisdecimalseparator(), that.yaxisthousandseparator()) +valueSuffix+' '+'</span>'+'<span style = float:left>'+unitValueChart+'</span>';
            // } catch (e) {
            //   console.log(e);
            // }
          },
          rotation: that.yaxislabelrotation(),
          staggerLines: that.yaxislabelstaggerline() === "" ?
            null :
            _.parseInt(that.yaxislabelstaggerline()),
          maxStaggerLines: that.yaxislabelmaxstaggerline() === "" ?
            null :
            _.parseInt(that.yaxislabelmaxstaggerline()),
          step: that.yaxislabelstep() === 0 ? null : that.yaxislabelstep(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          zIndex: that.yaxislabelzindex(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          },
          events: {
            click: function () {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        plotBands: [{
          color: that.yaxisplotbandenabled() === true ?
            that.yaxisplotbandcolor() :
            null,
          borderColor: that.yaxisplotbandenabled() === true ?
            that.yaxisplotbandbordercolor() :
            null,
          borderWidth: that.yaxisplotbandborderwidth(),
          from: that.yaxisplotbandfrom(),
          to: that.yaxisplotbandto(),
          zIndex: that.yaxisplotbandzindex(),
          events: {
            click: function () {
              that.fireEvent("yaxisplotbandonclick");
            },

            mouseover: function () {
              that.fireEvent("yaxisplotbandmousemove");
            }
          },
          label: {
            style: {
              color: that.yaxisplotbandlabelcolor(),
              fontWeight: that.yaxisplotbandlabelfontweight(),
              textDecoration: that.yaxisplotbandlabelfontweight(),
              fontSize: that.yaxisplotbandlabelfontsize() + "px",
              fontFamily: that.yaxisplotbandlabelfontfamily(),
              display: that.yaxisplotbandlabelenabled() === true ? "block" : "none"
            },
            text: that.yaxisplotbandlabeltext(),
            align: that.yaxisplotbandlabelalign(),
            rotation: that.yaxisplotbandlabelrotation(),
            textAlign: that.yaxisplotbandlabeltextalign(),
            verticalAlign: that.yaxisplotbandlabelverticalalign(),
            x: that.yaxisplotbandlabelxposition() == "null" ?
              null :
              _.parseInt(that.yaxisplotbandlabelxposition()),
            y: that.yaxisplotbandlabelyposition() == "null" ?
              null :
              _.parseInt(that.yaxisplotbandlabelyposition())
          }
        }],
        plotLines: [{
          color: that.yaxisplotlineenabled() === true ?
            that.yaxisplotlinecolor() :
            null,
          dashStyle: that.yaxisplotlinedashstyle(),
          width: that.yaxisplotlinewidth(),
          value: that.yaxisplotlinevalue(),
          zIndex: that.yaxisplotlinezindex(),
          label: {
            style: {
              color: that.yaxisplotlinelabelcolor(),
              fontWeight: that.yaxisplotlinelabelfontweight(),
              textDecoration: that.yaxisplotlinelabelfontweight(),
              fontSize: that.yaxisplotlinelabelfontsize() + "px",
              fontFamily: that.yaxisplotlinelabelfontfamily(),
              display: that.yaxisplotlinelabelenabled() === true ? "block" : "none"
            },
            text: that.yaxisplotlinelabeltext(),
            align: that.yaxisplotlinelabelalign(),
            rotation: that.yaxisplotlinelabelrotation(),
            textAlign: that.yaxisplotlinelabeltextalign(),
            verticalAlign: that.yaxisplotlinelabelverticalalign(),
            x: that.yaxisplotlinelabelxposition() == "null" ?
              null :
              _.parseInt(that.yaxisplotlinelabelxposition()),
            y: that.yaxisplotlinelabelyposition() == "null" ?
              null :
              _.parseInt(that.yaxisplotlinelabelyposition())
          }
        }]
      },
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      plotOptions: {
        series: {
          cursor: "pointer",
          lineWidth: that.linewidth(),
          point: {
            events: {
              click: function (event) {
                //that.selectedvalue(seriesLibrary.createMemberData(that,that.categoriesIndex[this.category],this.series.name));
                try {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  ); //changed = 1;
                } catch (e) {}
              },

              select: function () {
                if (!this.series.chart.lassoFlag) {
                  try {
                    if (that.chartenablezoom()) {
                      that.selectedPoints = $("#detail-container" + that["id"]() + "")
                        .highcharts()
                        .getSelectedPoints();
                    } else {
                      that.selectedPoints = component.highcharts().getSelectedPoints();
                    }
                    that.selectedPoints.push(this);
                    that.selectedvalues(
                      seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                    );
                    //++that.changed;
                    seriesLibrary.onSelectFunction(that);
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                }
                /**
                 *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                 **/
              },

              unselect: function () {
                if (!this.series.chart.lassoFlag) {
                  try {
                    if (that.chartenablezoom()) {
                      var unselectedPoints = $(
                          "#detail-container" + that["id"]() + ""
                        )
                        .highcharts()
                        .getSelectedPoints(); //jshint ignore:line
                    } else {
                      var unselectedPoints = component
                        .highcharts()
                        .getSelectedPoints();
                    } //jshint ignore:line
                    var index = that.selectedPoints.indexOf(this);
                    if (index > -1) {
                      that.selectedPoints.splice(index, 1);
                    }
                    that.selectedvalues(
                      seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                    );
                    if (that.selectedvalues() === "") {
                      that.selectedvalue("");
                    } else {
                      var select = seriesLibrary.createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      );
                      that.selectedvalue(select[0]);
                    }
                    /**
                     *Selectedvalue fix in all charts
                     *Multiple Selection getting the last selected value.
                     **/
                    if (that.clearSelect) {
                      if (that.selectedvalues() === "") {
                        that.clearSelect = false;
                      }
                    } else {
                      //++that.changed;
                      seriesLibrary.onSelectFunction(that);
                    } //clearselection callback issue on Onselect.
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                  /**
                   *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                   **/
                }
              }
            }
          },
          allowPointSelect: that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          turboThreshold: that.turbothreshold(),
          dataLabels: {
            allowOverlap: that.allowoverlap(),
            enabled: that.datalabelenabled(),
            align: that.datalabelalign() == "default" ? null : that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            overflow: "justify",
            verticalAlign: that.datalabelverticalalign() == "default" ?
              null :
              that.datalabelverticalalign(),
            x: that.datalabelx(),
            y: that.datalabely(),
            useHTML: false,
            formatter: function () {
              if (
                that.customdatalabel() !== "" &&
                Object.keys(JSON.parse(that.customdatalabel() || "{}")).length &&
                this.point.series.name.toLocaleLowerCase().indexOf("result") ==
                -1 &&
                this.key.name.toLocaleLowerCase().indexOf("result") == -1
              ) {
                return vbiNumberFormat.barFamilyFormatterDataLabel(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              } else {
                return vbiNumberFormat.barFamilyDataLabelFormatter(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              }
            },

            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily: that.globalfont() === true ?
                that.fontfamily() :
                that.datalabelfontfamily()
            }
          }
        },
        errorbar: {
          turboThreshold: 1000
        }
      },
      series: options.seriesData
    };
    return defaultValue;
  };

  this.getSampleDataSeries = function () {
    var seriesData = [{
      name: 'Sales',
      data: [
        95,
        203,
        110,
        220,
        203,
        297,
        250,
        170,
        248,
        160,
        170,
        267
      ],
      color: '#FF8E00'
    }];

    return seriesData;
  }

  this.attachGetters=function(component,options){
    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.getTrendline_add = function() {
      return component.yaxisstartontick();
    };

    component.getTrendline_json = function() {
      return component.testingArrayjson().toString();
    };

    component.getTrendlineColor = function() {
      if (component.trendcolorpickervalue()) {
       return component.trendcolorpickervalue();
      } else {
        return false;
      }
    };

    component.getChartFamily = function() {
      return 'bar';
    };

    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.lassoFireProp = function(selectedPoints) {
      component.selectedvalues(seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints).toString());
      // component.changed++;
      component.firePropertiesChanged(['selectedvalues']);
    };

    component.componentDeleted = function() {
      $('#dsui_' + componentID).remove();
      function triggerDelete() {
        var chartId = component['id']();
        if (WhatIfLibrary !== undefined) {
          for (var i in WhatIfLibrary.charts) {
            if (i === chartId) {
              //Removing current instances from WhatIfLibrary
              delete WhatIfLibrary.charts[i];
              delete WhatIfLibrary.instances[i];
            }
          }
          /*
                         *Deleting the Removed chart from the WhatIfLibrary
                         *Manually Removed
                         *WhatIfLibrary is removing only after window.refresh Hence removing Manually
                         */
          for (var i in WhatIfLibrary.charts) {
            if (sap.zen.Dispatcher.instance.getRootControlForComponentId(i) !== undefined) {
              var instance = WhatIfLibrary.getInstance(i);
              if (instance.list() !== '' || instance.list() != 'None') {
                instance.afterUpdate();
              }
            }  /*
                           *Trigger afterUpdate of the charts which are grouped
                           *Auto-AfterUpdate is not getting trigged
                           */
          }
        }
      }

      setTimeout(triggerDelete, 200);  //getRootControlForComponentId need a setTimeout
    };

    component.createIdentical = function(defaultValue) {
      var entireData = [];
      for (var i = 0; i < defaultValue.series.length; i++) {
      if(defaultValue.series[i].data){
        for (var j = 0; j < defaultValue.series[i].data.length; j++) {
          if (defaultValue.series[i].type == 'errorbar') {
            entireData.push(defaultValue.series[i].data[j][0] || 0);
            entireData.push(defaultValue.series[i].data[j][1] || 0);
          } else {
            entireData.push(defaultValue.series[i].data[j].y || 0);
          }
        }
      }
      }

      if (entireData.length > 0) {

        component.minimumValue = entireData.reduce(function(p, v) {
        return p < v ? p : v;
      });

        component.maximumValue = entireData.reduce(function(p, v) {
        return p > v ? p : v;
      });

        if (component.minimumValue === undefined) {
          component.minimumValue = 0;
          component.maximumValue = 250;
        }

        var listGroup = component['list']();
        var restart = component['chartRestart']();
        var testingArrayTemp = component['testingArray']();
        var minimumVal = Math.floor(component.minimumValue).toFixed(component.decimal());
        var maximumVal = Math.ceil(component.maximumValue).toFixed(component.decimal());
        var datasourceAssigned = component['DATA_SOURCE_ALIAS_REF']();
        var chartId = component['id']();
        var customMin = component['groupingyaxismin']();
        var customMax = component['groupingyaxismax']();
        if (WhatIfLibrary != undefined && listGroup != '' || restart != 0) { /* jshint ignore: line */
          WhatIfLibrary.register(chartId, {
          type: 'Chart',
          name: 'Stacked&Grouped Chart',
          category: 'charts',
          data_source: datasourceAssigned,
          custom_function: {/* jshint ignore: line */
            custom_id_min_value: minimumVal,
            custom_id_max_value: maximumVal,
            custom_id_groupId: testingArrayTemp,
            custom_id_SelectedValue: listGroup,
            custom_id_min: customMin,
            custom_id_max: customMax
          }
        }, component);
        }
        /*
                     * Getting the minimum and maximum value and pushing it to whatifAnalyser(updating).
                     * and also grouping name.
                     */
        component.globalVal.push('None');
        for (var i in WhatIfLibrary.charts) {
          if (WhatIfLibrary.charts[i].custom_function !== undefined) {
            var gettingArray = WhatIfLibrary.charts[i].custom_function.custom_id_groupId;//jshint ignore:line
            for (var j = 0; j < gettingArray.split(',').length; j++) {
              var localTest = gettingArray.split(',');
              if (component.globalVal.indexOf(localTest[j]) == -1) {
                component.globalVal.push(localTest[j]);
              }
            }
          }
        }

        seriesLibrary.creatIndenticalScaling(component, defaultValue, minimumVal, maximumVal, WhatIfLibrary);
        //identicalScaling Fix
        if (listGroup != '' || restart != 0) { /* jshint ignore: line */
          if (listGroup != 'None') {
           componentUtil.callHighCharts(component,component, defaultValue,{dependencyObject:dependencyObject,seriesData:seriesData});//jshint ignore:line
          }
        }
      }  //To stop the events
    };

    component.getDropdownName = function() {
      return component.list();
    };

    component.getChartNames = function() {
      return component.globalVal;
    };

    component.getDataLengthVal = function() {
      return JSON.stringify(component.result());
    };

    component.getDataSeries = function() {
    if (!component.dataRes) { return null; }
      var dataSeries = [];
      var seriesNames = [];
      var seriesKeyNames = [];
      component.dataRes = component.dispKeyTextResultSet();
      var bardatacustomizationJson = {
        'COLUMNS': [],
        'ROWS': []
      };
      if (component.bardatacustomization() !== '') {
        bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
      }

      try {
        if (component.dataRes === undefined || component.dataRes === '') {
          return null;
        } else if (component.datautility() === true && bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0) {
          return null;
        }

        if (component.dataRes.dimensions.length === 1 && component.dataRes.dimensions[0].containsMeasures === true) {
          var defaultColor = [
            '#B586DA',
            '#FF6657',
            '#F3A730',
            '#946B66',
            '#B0AD53',
            '#7AC1DE',
            '#F1C337',
            '#566C6C',
            '#A1CC54',
            '#543F1E'
          ];
          var seriesColor = [];
          if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
            seriesColor = [];
          } else {
            seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
          }

          if (component.dataRes.dimensions[0].axis == 'COLUMNS') {
            for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
              seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
          //    seriesNames.push(component.dataRes.dimensions[0].members[i].text);
              seriesNames.push(component.dataRes.dimensions[0].members[i]['picker_text']);
              seriesKeyNames.push(component.dataRes.dimensions[0].members[i].key);
            }
          } else {
            seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
            seriesNames.push('Measures');
            seriesKeyNames.push('Measures');
          }

          dataSeries = [
            seriesNames,
            seriesKeyNames
          ];
        //  seriesColor.splice(dataSeries.length, seriesColor.length);
          seriesColor.splice(dataSeries[0].length, seriesColor.length);
          component.dataseriescolor(seriesColor.join());
        } else {
          //  dataSeries = seriesLibrary.createSeriesData(component, 'bar', component.defaultValueSeriesNames,"ncf");
          dataSeries = seriesLibrary.createSeriesAdditionalProperty(component, 'bar');
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataSeries;
    };

    component.getDataSeriesColor = function() {
      var dataseriescolor = '';
      try {
        dataseriescolor = component.dataseriescolor();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataseriescolor;
    };

    component.getDatUtility = function() {
      var datautility = '';
      try {
        datautility = component.datautility();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return datautility;
    };

    component.getChartType = function() {
      return 'bar';
    };

    component.isMeasureOnly = function() {
      var len = 0;
      if (component.result() !== undefined && component.result() !== '') {
        try {
          len = component.result().dimensions.length;
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return len;
    };

    component.getLegendNames = function() {
      var leglist = [];
      var charttype = [];
      var legcolors = [];
      var leglistkey = [];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          for (var i = 0; i < component.defaultValueSeriesNames.series.length; i++) {
            if (!component.defaultValueSeriesNames.series[i].hasOwnProperty('isRegressionLine')) {
              if (component.defaultValueSeriesNames.series[i].name.indexOf('Trendline') == -1 && component.defaultValueSeriesNames.series[i].name.indexOf('error') == -1) {
                leglist.push(component.defaultValueSeriesNames.series[i].name);
                leglistkey.push(component.defaultValueSeriesNames.series[i].uniquekey);//Making changes because same series-name causing problem VBX141-3099
                charttype.push('line');
                legcolors.push(component.defaultValueSeriesNames.series[i].color);
              }
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        leglist,
        charttype,
        legcolors,
        leglistkey
      ];
    };

    component.seriesdata = function() {
      var chartJson = seriesLibrary.getMeasuresName(component.result()).split('=');
      var chartmeasurenames = [];
      var key = chartJson[1].split(',');
      var name = chartJson[0].split(',');
      var measurenamechange;
      if (component.chartmeasurechange() !== '' && component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== null) {
        measurenamechange = JSON.parse(component.chartmeasurechange());
      } else {
        measurenamechange = {};
      }

      for (var i = 0; i < key.length; i++) {
        var measure = {};
        measure.uniquekey = key[i];
        if (measurenamechange[key[i]] !== '' && measurenamechange[key[i]] !== undefined) {
          measure.name = measurenamechange[key[i]];
        } else {
          measure.name = name[i];
        }

        chartmeasurenames.push(measure);
      }

      return JSON.stringify(chartmeasurenames);  //return  JSON.stringify(new seriesLibrary.defaultvalueseries());
    };
    //~ error bar functions to get seriesdata and completedata to additional properties
    //sereies style change fucntion returns default series
    component.seriesstyledata = function() {
      return JSON.stringify(new seriesLibrary.defaultvalueseries());
    };

    component.getAllDS = function(DSList) {
      window.p1value = window.p1value || {};
      var DS = DSList.split(',')[0];
      if (DS === undefined || DS === '') {return;}
      component.callZTLFunction('getDS', function(pendingDS) {
        setTimeout(function() {
          window.p1value[component.oControlProperties.DATA_SOURCE_ALIAS_REF] = component.oControlProperties.result;
          if (pendingDS.length !== 0) {
            setTimeout(function() { component.getAllDS(pendingDS); }, 200);
          } else {
            component.dsObject(JSON.stringify(window.p1value));
            component.firePropertiesChanged(['dsObject']);
          }
        }, 200);
      }, DSList);
    };

    //error bar functions to get seriesdata and completedata to additional properties
    component.fulldataseries = function() {
      return JSON.stringify(seriesLibrary.createErrorbar());
    };

    component.errorbardata = function() {
      //alert(new seriesLibrary.createErrorbar());
      /*  var completedJson=seriesLibrary.getMeasuresName(component.fulljson()).split('=');
        var key=completedJson[0].split(',');
        var name=completedJson[1].split(',');
        var completeMeasure=[];
        completeMeasure.push(key,name);
      //  return  JSON.stringify(new seriesLibrary.createErrorbar()); */
      var completedJson = seriesLibrary.getMeasuresName(component.fulljson()).split('=');
      var completemeasurenames = [];
      var key = completedJson[1].split(',');
      var name = completedJson[0].split(',');
      var measurenamechange;
      if (component.chartmeasurechange() !== '' && component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== null) {
        measurenamechange = JSON.parse(component.chartmeasurechange());
      } else {
        measurenamechange = {};
      }

      for (var i = 0; i < key.length; i++) {
        var measure = {};
        measure.uniquekey = key[i];
        if (measurenamechange[key[i]] !== '' && measurenamechange[key[i]] !== undefined) {
          measure.name = measurenamechange[key[i]];
        } else {
          measure.name = name[i];
        }

        completemeasurenames.push(measure);
      }

      return JSON.stringify(completemeasurenames);
    };

    component.errocheckvaluechange = function() {
      component.errorCheck = 1;
    };

    component.measureValidation = function() {
      var returnValue = false;
      var measureinrow = false;
      try {
        for (var i = 0; i < component.result().dimensions.length; i++) {

          if (component.result().dimensions[i].containsMeasures === true && component.result().dimensions[i].axis == 'ROWS') {
            measureinrow = true;
          }
        }

        if (measureinrow === true) {
          returnValue = false;
        } else {
          returnValue = true;
        }  //return true;
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return returnValue + '';  //callruntime handler won't handle object and boolean hence return string
    };

  }
}