function MarimekkoChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "Series1",
        data: [
          {
            data: [1799],
            x: 0,
            y: 1799,
            z: 33.44174208144796,
            key: "0:0-2:0-1:0"
          },
          {
            data: [2718],
            x: 1,
            y: 2718,
            z: 66.55825791855203,
            key: "0:0-2:0-1:1"
          }
        ],
        type: "marimekko",
        total: 4517,
        percentage: 63.87160633484162,
        color: "#B586DA",
        key: "0:0-2:0"
      },
      {
        name: "Series2",
        data: [
          {
            data: [274],
            x: 0,
            y: 274,
            z: 33.44174208144796,
            key: "0:0-2:1-1:0"
          },
          {
            data: [719],
            x: 1,
            y: 719,
            z: 66.55825791855203,
            key: "0:0-2:1-1:1"
          }
        ],
        type: "marimekko",
        total: 993,
        percentage: 14.041289592760181,
        color: "#FF6657",
        key: "0:0-2:1"
      },
      {
        name: "Series3",
        data: [
          {
            data: [292],
            x: 0,
            y: 292,
            z: 33.44174208144796,
            key: "0:0-2:2-1:0"
          },
          {
            data: [301],
            x: 1,
            y: 301,
            z: 66.55825791855203,
            key: "0:0-2:2-1:1"
          }
        ],
        type: "marimekko",
        total: 593,
        percentage: 8.385180995475112,
        color: "#F3A730",
        key: "0:0-2:2"
      },
      {
        name: "Series4",
        data: [
          {
            data: [],
            x: 0,
            y: 0,
            z: 33.44174208144796,
            key: "0:0-2:4-1:0"
          },
          {
            data: [969],
            x: 1,
            y: 969,
            z: 66.55825791855203,
            key: "0:0-2:4-1:1"
          }
        ],
        type: "marimekko",
        total: 969,
        percentage: 13.701923076923078,
        color: "#946B66",
        key: "0:0-2:4"
      }
    ];

    return seriesData;
  };
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();
    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset == "" || titletext == " ") {
        //jshint ignore:line
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };
    var stacktype = that.marimekkocharttype().split('-');
    var defaultValue = {
      chart: {
        type: "column",
        inverted: stacktype[1] == 'bar',
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            /*var contextMenuOptions={event:event,
                                      enableContextMenu:that.enableContextMenu(),
                                      enableDisplayDataButton:that.enableDisplayDataButton(),
                                      enableMaximizeButton:that.enableMaximizeButton(),
                                      enableMoreActionsButton:that.enableMoreActionsButton()};

                //The If condition is fire the charafterload event only once - Fix 1200
                vbiContextMenu.attachContextMenu(contextMenuOptions);*/

            if (that.isChartAfterLoaded) {
              that.isChartAfterLoaded = false;
              //The If condition is fire the charafterload event only once - Fix 1200
              if (!isLoad) {
                that.fireEvent("chartafterload");
                isLoad = true;
              }

              if (that.creditsenabled() === true) {
                this.credits.element.onclick = function() {
                  window.open(
                    that.creditshref(),
                    "_blank" // <- This is what makes it open in a new window.
                  );
                };
              }
            }
          },

          selection: function(event) {
            if (event.xAxis) {
              that.fireEvent("chartonselect");
            } //disabling the fireEvent while zoom out.
          },

          redraw: function() {
            setTimeout(function() {
              component.empty();
              that.afterUpdate();
            }, 100);
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries() || false,
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        pinchType: that.chartpinchtype(),
        // zoomType: that.chartzoomtype(),
        panning: that.chartpanning(),
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: true, //that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            //relativeTo:that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      xAxis: {
        categories: [
          "Jan",
          "Feb",
          "Mar",
          "Apr",
          "May",
          "Jun",
          "Jul",
          "Aug",
          "Sep",
          "Oct",
          "Nov",
          "Dec"
        ],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        gridLineColor: that.xaxisgridlinecolor(),
        gridLineDashStyle: that.xaxisgridlinedashstyle(),
        gridLineWidth: that.xaxisgridlinewidth(),
        gridZIndex: that.xaxisgridzindex(),
        ceiling:
          that.xaxisceiling() === "" ? null : _.parseInt(that.xaxisceiling()),
        floor: that.xaxisfloor() === "" ? null : _.parseInt(that.xaxisfloor()),
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        min: that.xaxismin() === "" ? null : _.parseInt(that.xaxismin()),
        max: that.xaxismax() === "" ? null : _.parseInt(that.xaxismax()),
        maxPadding:
          that.xaxismaxpadding() === ""
            ? null
            : _.parseInt(that.xaxismaxpadding()),
        minPadding:
          that.xaxisminpadding() === ""
            ? null
            : _.parseInt(that.xaxisminpadding()),
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},
        minTickInterval: that.xaxismintickinterval(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        labels: {
          align: that.xaxislabelalign(),
          enabled: true,
          //that.xaxislabelenabled(),
          //  format: that.xaxislabelprefix() + that.xaxislabelformat() +
          //    that.xaxislabelsuffix(),
          formatter: function() {
            var totalText = this.value.toString();
            var index = totalText.lastIndexOf("(");
            if (index == -1) {
              index = totalText.length;
            }

            var name = totalText.substring(0, index);
            var total = totalText.substring(index).replace(/[\%(,)]/g, "");
            if (total.length > 0) {
              total = Number(total);
            }

            if (total > 0 && that.xstacklabelsenabled()) {
              if (that.xstacklabelsenabled() && that.xstackpercentageenabled()) {
                totalText =
                  name +
                  " (" +
                  Highcharts.numberFormat(
                    total,
                    that.decimal(),
                    decimalsep,
                    thousandsep
                  ) +
                  " %)";
              } else {
                totalText =
                  name +
                  " (" +
                  Highcharts.numberFormat(
                    total,
                    that.decimal(),
                    decimalsep,
                    thousandsep
                  ) +
                  ")";
              }
            }

            if (that.xaxislabelenabled() && !that.xaxisboxlabelenabled()) {
              totalText =
                that.xaxislabelprefix() +
                " " +
                totalText +
                " " +
                that.xaxislabelsuffix();
            } else {
              totalText = "";
            }

            return totalText;
          },
          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          //distance:that.xaxislabeldistance(),
          staggerLines:
            that.xaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines:
            that.xaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          }
        },
        stackLabels: {
          style: { color: "black" },
          enabled: that.xstacklabelsenabled()
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: offsetaxis(
            that.xaxistitleenabled(),
            that.xaxistitleoffset(),
            that.xaxistitletext()
          ),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [
          {
            color:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandcolor()
                : null,
            borderColor:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandbordercolor()
                : null,
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom() - 0.5,
            to: that.xaxisplotbandto() + 0.5,
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("xaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display:
                  that.xaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x:
                that.xaxisplotbandlabelxposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelxposition()),
              y:
                that.xaxisplotbandlabelyposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            /* style:{
           display:'block':'none'
        */
            color:
              that.xaxisplotlineenabled() === true
                ? that.xaxisplotlinecolor()
                : null,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display:
                  that.xaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotlinelabeltext(),
              align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign: that.xaxisplotlinelabeltextalign(),
              verticalAlign: that.xaxisplotlinelabelverticalalign(),
              x:
                that.xaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelxposition()),
              y:
                that.xaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelyposition())
            }
          }
        ]
      },
      yAxis: {
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        lineWidth: that.yaxislinewidth(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval:
          that.yaxisminortickinterval() == "null"
            ? "auto"
            : _.parseInt(that.yaxisminortickinterval()),
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth(),
        tickColor: that.yaxistickcolor(),
        tickInterval:
          that.yaxistickinterval() == "0" || that.yaxistickinterval() === ""
            ? null
            : _.parseInt(that.yaxistickinterval()),
        tickLength: that.yaxisticklength(),
        tickPosition: that.yaxistickposition(),
        tickWidth: that.yaxistickwidth(),
        tickmarkPlacement: that.yaxistickmarkplacement(),
        dateTimeLabelFormats: {},
        ceiling:
          that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
        floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
        min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
        max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
        maxPadding:
          that.yaxismaxpadding() === ""
            ? null
            : parseFloat(that.yaxismaxpadding()),
        minPadding:
          that.yaxisminpadding() === ""
            ? null
            : parseFloat(that.yaxisminpadding()),
        minRange: that.yaxisminrange(),
        offset: that.yaxisoffset(),
        opposite: that.yaxisopposite(),
        reversed: that.yaxisreversed() === true,
        showEmpty: that.yaxisshowempty(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        //        startOnTick: that.yaxisstartontick(),
        //        endOnTick: that.yaxisendontick(),
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: that.yaxistitleenabled() === true ? "block" : "none"
          }
        },
        stackLabels: {
          style: { color: "black" },
          enabled: that.ystacklabelsenabled()
        },
        labels: {
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          formatter: function() {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this);
          },
          //overflow:that.yaxislabeloverflow(),
          rotation: that.yaxislabelrotation(),
          staggerLines:
            that.yaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelstaggerline()),
          maxStaggerLines:
            that.yaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelmaxstaggerline()),
          step: that.yaxislabelstep(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          zIndex: that.yaxislabelzindex(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          }
        },
        plotBands: [
          {
            color:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandcolor()
                : null,
            borderColor:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandbordercolor()
                : null,
            borderWidth: that.yaxisplotbandborderwidth(),
            from: that.yaxisplotbandfrom(),
            to: that.yaxisplotbandto(),
            zIndex: that.yaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("yaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.yaxisplotbandlabelcolor(),
                fontWeight: that.yaxisplotbandlabelfontweight(),
                textDecoration: that.yaxisplotbandlabelfontweight(),
                fontSize: that.yaxisplotbandlabelfontsize() + "px",
                fontFamily: that.yaxisplotbandlabelfontfamily(),
                display:
                  that.yaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotbandlabeltext(),
              align: that.yaxisplotbandlabelalign(),
              rotation: that.yaxisplotbandlabelrotation(),
              textAlign: that.yaxisplotbandlabeltextalign(),
              verticalAlign: that.yaxisplotbandlabelverticalalign(),
              x:
                that.yaxisplotbandlabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelxposition()),
              y:
                that.yaxisplotbandlabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.yaxisplotlineenabled() === true
                ? that.yaxisplotlinecolor()
                : null,
            dashStyle: that.yaxisplotlinedashstyle(),
            width: that.yaxisplotlinewidth(),
            value: that.yaxisplotlinevalue(),
            zIndex: that.yaxisplotlinezindex(),
            label: {
              style: {
                color: that.yaxisplotlinelabelcolor(),
                fontWeight: that.yaxisplotlinelabelfontweight(),
                textDecoration: that.yaxisplotlinelabelfontweight(),
                fontSize: that.yaxisplotlinelabelfontsize() + "px",
                fontFamily: that.yaxisplotlinelabelfontfamily(),
                display:
                  that.yaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotlinelabeltext(),
              align: that.yaxisplotlinelabelalign(),
              rotation: that.yaxisplotlinelabelrotation(),
              textAlign: that.yaxisplotlinelabeltextalign(),
              verticalAlign: that.yaxisplotlinelabelverticalalign(),
              x:
                that.yaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelxposition()),
              y:
                that.yaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelyposition())
            }
          }
        ]
      },
      tooltip: {
        animation: that.tooltipanimation() || false,
        crosshairs: that.tooltipcrosshair(),
        enabled: that.tooltipenable(),
        followPointer: true,
        followTouchMove: that.tooltipfollowtouchmove(),
        hideDelay: that.tooltiphidedelay(),
        shadow: that.tooltipshadow(),
        shape: that.tooltipshape(),
        shared: that.tooltipshared(),
        snap: that.tooltipsnap(),
        valueDecimals: that.tooltipvaluedecimals(),
        valuePrefix: that.tooltipvalueprefix(),
        valueSuffix: that.tooltipvaluesuffix(),
        backgroundColor: that.tooltipbackgroundcolor(),
        borderColor: that.tooltipbordercolor(),
        borderRadius: that.tooltipborderradius(),
        borderWidth: that.tooltipborderwidth(),
        style: {
          color: that.tooltipcolor(),
          fontWeight: that.tooltipfontweight(),
          textDecoration: that.tooltipfontweight(),
          fontSize: that.tooltipfontsize() + "px",
          fontFamily: that.tooltipfontfamily()
        },
        positioner: function(labelWidth, labelHeight, point) {
          var tooltipX, tooltipY;
          // if (point.plotX + labelWidth > bulletchart.plotWidth) {
          //     tooltipX = point.plotX + bulletchart.plotLeft - labelWidth + 15;
          // } else {
          //     tooltipX = point.plotX + bulletchart.plotLeft -15;
          // }
          tooltipX = point.plotX;
          tooltipY = point.plotY + 15;
          return {
            x: tooltipX,
            y: tooltipY
          };
        }
      },
      plotOptions: {
        series: {
          dataLabels: {
            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() === true
                  ? that.fontfamily()
                  : that.datalabelfontfamily()
            }
          },
          borderColor: that.seriesbordercolor(),
          borderRadius: that.seriesborderradius(),
          borderWidth: that.seriesborderwidth(),
          pointWidth:
            that.pointwidth() == "auto" ? null : _.parseInt(that.pointwidth()),
          pointPadding: that.pointpadding(),
          cursor: "pointer",
          events: {
            legendItemClick: function() {
              return false;
            }
          },
          point: {
            events: {
              click: function(event) {
                try {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  ); //columncolorChanged = 1;
                } catch (e) {}
              },

              select: function() {
                try {
                  selectedPoints = component.highcharts().getSelectedPoints();
                  selectedPoints.push(this);
                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        selectedPoints
                      )
                      .toString()
                  );
                  seriesLibrary.onSelectFunction(that);
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }

                /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
              },

              unselect: function() {
                try {
                  // var unselectedPoints = component.highcharts().getSelectedPoints();
                  var index = selectedPoints.indexOf(this);
                  if (index > -1) {
                    selectedPoints.splice(index, 1);
                  }

                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        selectedPoints
                      )
                      .toString()
                  );
                  if (that.selectedvalues() === "") {
                    that.selectedvalue("");
                  } else {
                    var select = seriesLibrary.createMembersData(
                      that,
                      that.categoriesIndex,
                      selectedPoints
                    );
                    that.selectedvalue(select[0]);
                  }
                  /**
                       *Selectedvalue fix in all charts
                       *Multiple Selection getting the last selected value.
                      **/
                  if (that.clearSelect) {
                    if (that.selectedvalues() === "") {
                      that.clearSelect = false;
                    }
                  } else {
                    seriesLibrary.onSelectFunction(that);
                  } //clearselection callback issue on Onselect.
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
                /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
              }
            }
          }
        },
        marimekko: {
          stacking: stacktype[0],
          allowPointSelect: that.allowpointselect(),
          cropThreshold: that.cropthreshold(),
          turboThreshold: that.turbothreshold(),
          dataLabels: {
            allowOverlap: that.allowoverlap(),
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              if (that.datalabelpercent()) {
                if (
                  isNaN(_.parseInt(this.percentage)) ||
                  _.parseInt(this.percentage) === 0
                ) {
                  return "";
                }
              } else {
                if (isNaN(_.parseInt(this.y)) || _.parseInt(this.y) === 0) {
                  return "";
                }
              }

              var index = this.series.xAxis.categories[this.point.x]
                .toString()
                .lastIndexOf("(");
              if (index == -1) {
                index = this.series.xAxis.categories[this.point.x].toString()
                  .length;
              }
              //          console.log(this);
              var measurepos = this.series.userOptions.key.split(":")[0];
              var measuredatapos = this.series.userOptions.key
                .split(":")[1]
                .split("-")[0];
              var measurekey = that.dataRes
                ? that.dataRes.dimensions[measurepos].members[measuredatapos].key
                : "";

              if (that.datalabelpercent()) {
                return (
                  that.datalabelprefix() +
                  " " +
                  Highcharts.numberFormat(
                    this.percentage,
                    that.decimal(),
                    decimalsep,
                    thousandsep
                  ) +
                  " % " +
                  that.datalabelsuffix()
                );
              } else {
                if (
                  that.dataRes &&
                  that.numberFormatDefinition() === "initialView"
                ) {
                  return vbiNumberFormat.processDataLabelInitialView(
                    this,
                    that,
                    measurekey
                  );
                } else {
                  return vbiNumberFormat.processDataLabel(
                    that,
                    this,
                    measurekey,
                    false,
                    decimalsep,
                    thousandsep,
                    false
                  );
                }
              }

              // if (that.datavaluedecimals() != 'auto') {
              //   if (that.datalabelpercent()) {
              //     return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.percentage, that.decimal(), decimalsep, thousandsep) + ' % ' + that.datalabelsuffix();
              //   } else {
              //     return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, that.decimal(), decimalsep, thousandsep) + ' ' + that.datalabelsuffix();
              //   }
              // } else {
              //   if (that.datalabelpercent()) {
              //     return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.percentage, that.decimal(), decimalsep, thousandsep) + ' % ' + that.datalabelsuffix();
              //   } else {
              //     return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, that.decimal(), decimalsep, thousandsep) + ' ' + that.datalabelsuffix();
              //   }
              // }
            },

            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() === true
                  ? that.fontfamily()
                  : that.datalabelfontfamily()
            }
          }
        }
      },
      series: options.seriesData
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.getDataSeries = function() {
    if (!component.dataRes) { return null; }
      var dataSeries = [];
      var dimName = [];
      var dimKey = [];
      var DefaultColor = [
        '#B586DA',
        '#FF6657',
        '#F3A730',
        '#946B66',
        '#B0AD53',
        '#7AC1DE',
        '#F1C337',
        '#566C6C',
        '#A1CC54',
        '#543F1E'
      ];
      var seriesColor = [];
      if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
        seriesColor = [];
      } else {
        seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
      }

      component.dataRes = component.dispKeyTextResultSet();
      try {
        if (component.dataRes === undefined || component.dataRes === '') {
          return null;
        }

        if (component.dataRes.dimensions.length >= 3 && JSON.stringify(component.dataRes.dimensions).indexOf('containsMeasures') > -1) {
          var stackDimIndex = 0;
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
            if (component.dataRes.dimensions[i].key == component.stackeddimension()) {
              stackDimIndex = i;
              break;
            }
          }

          $.each(component.dataRes.dimensions[stackDimIndex].members, function(index, value) {
            if (/*component.showtotal() || !component.showtotal() &&*/ value.type != 'RESULT') {
              seriesLibrary.getSeriesColors(component, seriesColor, dimName.length, DefaultColor);
              dimName.push(value.text);
              dimKey.push(value.key);
            }
          });

          dataSeries.push(dimName);
          dataSeries.push(dimKey);
          seriesColor.splice(dimName.length, seriesColor.length);
          component.dataseriescolor(seriesColor.join());
        } else {
          return null;
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataSeries;
    };

    component.getDataSeriesColor = function() {
      var dataseriescolor = '';
      try {
        dataseriescolor = component.dataseriescolor();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataseriescolor;
    };
    /*
     * Getting the charts name in Additional Property.
     */
    component.getDropdownName = function() {
      return component.list();
    };

    component.getChartNames = function() {
      return component.globalVal;
    };

    component.getMeasureMembers = function() {
      var measName = [];
      var measKey = [];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          for (var i = 0; i < component.result().dimensions.length; i++) {
            if (component.dataRes.dimensions[i].containsMeasures === true) {
              $.each(component.dataRes.dimensions[i].members, function(index, value) {
                measName.push(value.text);
                measKey.push(value.key);
              });

              break;
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        measName,
        measKey
      ];
    };

    component.getChartType = function() {
      return 'marimekko';
    };

    component.getChartFamily = function() {
      return 'bar';
    };

    component.getDimensionList = function() {
      // var dimlist =[];
      var dimname = [];
      var dimkey = [];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          for (var i = 0; i < component.result().dimensions.length; i++) {
            if (component.dataRes.dimensions[i].containsMeasures !== true) {
              dimname.push(component.result().dimensions[i].text);
              dimkey.push(component.result().dimensions[i].key);
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        dimname,
        dimkey
      ];
    };

    component.getDataLengthVal = function() {
      return JSON.stringify(component.result());
    };

    component.getDatUtility = function() {
      var datautility = '';
      try {
        datautility = component.datautility();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return datautility;
    };

    component.componentDeleted = function() {
      $('#dsui_' + componentID).remove();
    };

  }
}