function MultipleAxesChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "Actuals",
        type: "column",
        yAxis: 0,
        data: [297, 200, 110, 220, 203, 110, 250, 170, 208, 160, 170, 67],
        color: "#B586DA"
      },
      {
        name: "Pre-Budget",
        type: "line",
        yAxis: 1,
        data: [300, 215, 50, 120, 150, 50, 220, 141, 50, 150, 150, 60],
        color: "#FF6657"
      },
      {
        name: "Post-Budget",
        type: "spline",
        yAxis: 2,
        data: [190, 200, 20, 50, 50, 30, 195, 71, 40, 90, 109, 20],
        color: "#F3A730"
      }
    ];

    return seriesData;
  };

  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    var lassoObj = SeriesLibrary.prototype.lasso;
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();
    var newPropertyValues = {
      yaxisceiling: that.multiyaxisceiling().split(',#'),
      yaxisfloor: that.multiyaxisfloor().split(',#'),
      yaxismax: that.multiyaxismax().split(',#'),
      yaxismin: that.multiyaxismin().split(',#'),
      yaxistitletext: that.yaxistitletext().split(',#'),
      yaxistickinterval: that.yaxistickinterval().split(',#'),
      yaxisminortickinterval: that.yaxisminortickinterval().split(',#'),
      //          yaxisplotbandfrom : that.yaxisplotbandfrom().split(',#'),
      //          yaxisplotbandto : that.yaxisplotbandto().split(',#'),
      //          yaxisplotbandlabeltext : that.yaxisplotbandlabeltext().split(',#'),
      //          yaxisplotlinevalue : that.yaxisplotlinevalue().split(',#'),
      //          yaxisplotlinelabeltext : that.yaxisplotlinelabeltext().split(',#'),
      yaxislabelprefix: that.yaxislabelprefix().split(',#'),
      yaxislabelsuffix: that.yaxislabelsuffix().split(',#'),
      tooltipvalueprefix: that.tooltipvalueprefix().split(',#'),
      tooltipvaluesuffix: that.tooltipvaluesuffix().split(',#')
    };
    var defaultValue = {
      chart: {
        alignThresholds: undefined,
        type:
          that.chartorientation().toLowerCase() == "vertical" ? "column" : "bar",
        //inverted:that.chartinverted(),//shouldn't expose this property to user
        alignTicks: that.chartalignticks(),
        //applicable in multiple axes
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            lassoObj.unselectByClick.call(this, that);
            if (event.target.textContent == "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() == true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function(e) {
            var retVal = lassoObj.selectPointsByDrag.call(this, e, that);
            if (this.lasso == "lasso" || this.lasso == "rlasso") {
              that.fireEvent("chartonpointclick");
            } else {
              if (e.xAxis) {
                that.fireEvent("chartonselect");
              } //disabling the fireEvent while zoom out.
            }

            return retVal;
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: true,
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() == true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      xAxis: {
        categories: [
          "Jan",
          "Feb",
          "Mar",
          "Apr",
          "May",
          "Jun",
          "Jul",
          "Aug",
          "Sep",
          "Oct",
          "Nov",
          "Dec"
        ],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        gridLineColor: that.xaxisgridlinecolor(),
        gridLineDashStyle: that.xaxisgridlinedashstyle(),
        gridLineWidth: that.xaxisgridlinewidth(),
        gridZIndex: that.xaxisgridzindex(),
        ceiling:
          that.xaxisceiling() == "" ? null : _.parseInt(that.xaxisceiling()),
        floor: that.xaxisfloor() == "" ? null : _.parseInt(that.xaxisfloor()),
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        min: that.xaxismin() == "" ? null : _.parseInt(that.xaxismin()),
        max: that.xaxismax() == "" ? null : _.parseInt(that.xaxismax()),
        maxPadding:
          that.xaxismaxpadding() == ""
            ? null
            : parseFloat(that.xaxismaxpadding()),
        minPadding:
          that.xaxisminpadding() == ""
            ? null
            : parseFloat(that.xaxisminpadding()),
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},
        minTickInterval: that.xaxismintickinterval(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        labels: {
          reserveSpace: that.xaxisreservespace(),
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          format:
            that.xaxislabelprefix() +
            that.xaxislabelformat() +
            that.xaxislabelsuffix(),
          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          //distance:that.xaxislabeldistance(),
          staggerLines:
            that.xaxislabelstaggerline() == ""
              ? null
              : _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines:
            that.xaxislabelmaxstaggerline() == ""
              ? null
              : _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: that.xaxistitleoffset() == "" ? null : that.xaxistitleoffset(),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() == true ? "block" : "none"
          }
        },
        plotBands: [
          {
            color:
              that.xaxisplotbandenabled() == true
                ? that.xaxisplotbandcolor()
                : null,
            borderColor:
              that.xaxisplotbandenabled() == true
                ? that.xaxisplotbandbordercolor()
                : null,
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom(),
            to: that.xaxisplotbandto(),
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("xaxisplotbandonclick");
              },

              mouseover: function() {
                that.fireEvent("xaxisplotbandmousemove");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display:
                  that.xaxisplotbandlabelenabled() == true ? "block" : "none"
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x:
                that.xaxisplotbandlabelxposition() == ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelxposition()),
              y:
                that.xaxisplotbandlabelyposition() == ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.xaxisplotlineenabled() == true
                ? that.xaxisplotlinecolor()
                : null,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display:
                  that.xaxisplotlinelabelenabled() == true ? "block" : "none"
              },
              text: that.xaxisplotlinelabeltext(),
              align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign: that.xaxisplotlinelabeltextalign(),
              verticalAlign: that.xaxisplotlinelabelverticalalign(),
              x:
                that.xaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelxposition()),
              y:
                that.xaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelyposition())
            }
          }
        ]
      },
      yAxis: [
        {
          allowDecimals: that.yaxisallowdecimals(),
          alternateGridColor: that.yaxisalternategridcolor(),
          gridLineColor: that.yaxisgridlinecolor(),
          gridLineDashStyle: that.yaxisgridlinedashstyle(),
          gridLineWidth: that.yaxisgridlinewidth(),
          gridZIndex: that.yaxisgridzindex(),
          lineColor: that.yaxislinecolor(),
          lineWidth: that.yaxislinewidth(),
          minorGridLineColor: that.yaxisminorgridlinecolor(),
          minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
          minorGridLineWidth: that.yaxisminorgridlinewidth(),
          minorTickColor: that.yaxisminortickcolor(),
          minorTickInterval:
            _.parseInt(newPropertyValues.yaxisminortickinterval[0]) || "auto",
          minorTickLength: that.yaxisminorticklength(),
          minorTickPosition: that.yaxisminortickposition(),
          minorTickWidth: that.yaxisminortickwidth(),
          tickColor: that.yaxistickcolor(),
          tickInterval:
            _.parseInt(newPropertyValues.yaxistickinterval[0]) || null,
          tickLength: that.yaxisticklength(),
          tickPosition: that.yaxistickposition(),
          tickWidth: that.yaxistickwidth(),
          tickmarkPlacement: that.yaxistickmarkplacement(),
          dateTimeLabelFormats: {},
          ceiling: _.parseInt(newPropertyValues.yaxisceiling[0]) || null,
          floor: _.parseInt(newPropertyValues.yaxisfloor[0]) || null,
          min: _.parseInt(newPropertyValues.yaxismin[0]) || null,
          max: _.parseInt(newPropertyValues.yaxismax[0]) || null,
          maxPadding:
            that.yaxismaxpadding() == ""
              ? null
              : parseFloat(that.yaxismaxpadding()),
          minPadding:
            that.yaxisminpadding() == ""
              ? null
              : parseFloat(that.yaxisminpadding()),
          minRange: that.yaxisminrange(),
          offset: that.yaxisoffset(),
          opposite: that.yaxisopposite(),
          reversed: that.yaxisreversed() === true,
          showEmpty: that.yaxisshowempty(),
          showFirstLabel: that.yaxisshowfirstlabel(),
          showLastLabel: that.yaxisshowlastlabel(),
          //          startOnTick: that.yaxisstartontick(),
          //          endOnTick: that.yaxisendontick(),
          title: {
            text:
              that.yaxistitletext().split(",#")[0] === undefined
                ? ""
                : that.yaxistitletext().split(",#")[0],
            //                        align: that.yaxistitlealign(),
            rotation: that.yaxistitlerotation(),
            //                        offset: that.yaxistitleoffset() == '' ? null : that.yaxistitleoffset(),
            //                        margin: that.yaxistitlemargin(),
            style: {
              color: that.yaxistitlecolor(),
              fontWeight: that.yaxistitlefontweight(),
              textDecoration: that.yaxistitlefontweight(),
              fontSize: that.yaxistitlefontsize() + "px",
              fontFamily: that.yaxistitlefontfamily(),
              display: that.yaxistitleenabled() == true ? "block" : "none"
            }
          },
          labels: {
            //                        align: that.yaxislabelalign(),
            enabled: that.yaxislabelenabled(),
            format:
              that.yaxislabelautoscale() == true
                ? null
                : (newPropertyValues.yaxislabelprefix[0] || "") +
                  that.yaxislabelformat() +
                  (newPropertyValues.yaxislabelsuffix[0] || ""),
            rotation: that.yaxislabelrotation(),
            staggerLines:
              that.yaxislabelstaggerline() == ""
                ? null
                : _.parseInt(that.yaxislabelstaggerline()),
            maxStaggerLines:
              that.yaxislabelmaxstaggerline() == ""
                ? null
                : _.parseInt(that.yaxislabelmaxstaggerline()),
            step: that.yaxislabelstep(),
            //                        x: that.yaxislabelx(),
            //                        y: that.yaxislabely(),
            zIndex: that.yaxislabelzindex(),
            style: {
              color: that.yaxislabelcolor(),
              fontWeight: that.yaxislabelfontweight(),
              textDecoration: that.yaxislabelfontweight(),
              fontSize: that.yaxislabelfontsize() + "px",
              fontFamily: that.yaxislabelfontfamily()
            },
            events: {
              click: function() {
                seriesLibrary.axisClickEvent(this, that);
              }
            }
          },
          plotBands: [
            {
              color:
                that.yaxisplotbandenabled() == true
                  ? that.yaxisplotbandcolor()
                  : null,
              borderColor:
                that.yaxisplotbandenabled() == true
                  ? that.yaxisplotbandbordercolor()
                  : null,
              borderWidth: that.yaxisplotbandborderwidth(),
              from: that.yaxisplotbandfrom(),
              to: that.yaxisplotbandto(),
              zIndex: that.yaxisplotbandzindex(),
              events: {
                click: function() {
                  that.fireEvent("yaxisplotbandonclick");
                },

                mouseover: function() {
                  that.fireEvent("yaxisplotbandmousemove");
                }
              },
              label: {
                style: {
                  color: that.yaxisplotbandlabelcolor(),
                  fontWeight: that.yaxisplotbandlabelfontweight(),
                  textDecoration: that.yaxisplotbandlabelfontweight(),
                  fontSize: that.yaxisplotbandlabelfontsize() + "px",
                  fontFamily: that.yaxisplotbandlabelfontfamily(),
                  display:
                    that.yaxisplotbandlabelenabled() == true ? "block" : "none"
                },
                text: that.yaxisplotbandlabeltext() || null,
                align: that.yaxisplotbandlabelalign(),
                rotation: that.yaxisplotbandlabelrotation(),
                textAlign: that.yaxisplotbandlabeltextalign(),
                verticalAlign: that.yaxisplotbandlabelverticalalign(),
                x:
                  that.yaxisplotbandlabelxposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotbandlabelxposition()),
                y:
                  that.yaxisplotbandlabelyposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotbandlabelyposition())
              }
            }
          ],
          plotLines: [
            {
              color:
                that.yaxisplotlineenabled() == true
                  ? that.yaxisplotlinecolor()
                  : null,
              dashStyle: that.yaxisplotlinedashstyle(),
              width: that.yaxisplotlinewidth(),
              value: that.yaxisplotlinevalue(),
              zIndex: that.yaxisplotlinezindex(),
              label: {
                style: {
                  color: that.yaxisplotlinelabelcolor(),
                  fontWeight: that.yaxisplotlinelabelfontweight(),
                  textDecoration: that.yaxisplotlinelabelfontweight(),
                  fontSize: that.yaxisplotlinelabelfontsize() + "px",
                  fontFamily: that.yaxisplotlinelabelfontfamily(),
                  display:
                    that.yaxisplotlinelabelenabled() == true ? "block" : "none"
                },
                text: that.yaxisplotlinelabeltext() || null,
                align: that.yaxisplotlinelabelalign(),
                rotation: that.yaxisplotlinelabelrotation(),
                textAlign: that.yaxisplotlinelabeltextalign(),
                verticalAlign: that.yaxisplotlinelabelverticalalign(),
                x:
                  that.yaxisplotlinelabelxposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotlinelabelxposition()),
                y:
                  that.yaxisplotlinelabelyposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotlinelabelyposition())
              }
            }
          ]
        },
        //Secondary Axis goes here
        {
          allowDecimals: that.yaxisallowdecimals(),
          alternateGridColor: that.yaxisalternategridcolor(),
          gridLineColor: that.yaxisgridlinecolor(),
          gridLineDashStyle: that.yaxisgridlinedashstyle(),
          gridLineWidth: that.yaxisgridlinewidth(),
          gridZIndex: that.yaxisgridzindex(),
          lineColor: "#FF6657",
          lineWidth: that.yaxislinewidth(),
          minorGridLineColor: that.yaxisminorgridlinecolor(),
          minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
          minorGridLineWidth: that.yaxisminorgridlinewidth(),
          minorTickColor: that.yaxisminortickcolor(),
          minorTickInterval:
            _.parseInt(newPropertyValues.yaxisminortickinterval[1]) || "auto",
          minorTickLength: that.yaxisminorticklength(),
          minorTickPosition: that.yaxisminortickposition(),
          minorTickWidth: that.yaxisminortickwidth(),
          tickColor: that.yaxistickcolor(),
          tickInterval:
            _.parseInt(newPropertyValues.yaxistickinterval[1]) || null,
          tickLength: that.yaxisticklength(),
          tickPosition: that.yaxistickposition(),
          tickWidth: that.yaxistickwidth(),
          tickmarkPlacement: that.yaxistickmarkplacement(),
          dateTimeLabelFormats: {},
          ceiling: _.parseInt(newPropertyValues.yaxisceiling[1]) || null,
          floor: _.parseInt(newPropertyValues.yaxisfloor[1]) || null,
          min: _.parseInt(newPropertyValues.yaxismin[1]) || null,
          max: _.parseInt(newPropertyValues.yaxismax[1]) || null,
          maxPadding:
            that.yaxismaxpadding() == ""
              ? null
              : parseFloat(that.yaxismaxpadding()),
          minPadding:
            that.yaxisminpadding() == ""
              ? null
              : parseFloat(that.yaxisminpadding()),
          minRange: that.yaxisminrange(),
          //offset: that.yaxisoffset(),
          opposite: !that.yaxisopposite(),
          reversed: that.yaxisreversed() === true,
          showEmpty: that.yaxisshowempty(),
          showFirstLabel: that.yaxisshowfirstlabel(),
          showLastLabel: that.yaxisshowlastlabel(),
          //          startOnTick: that.yaxisstartontick(),
          //          endOnTick: that.yaxisendontick(),
          title: {
            text:
              that.yaxistitletext().split(",#")[1] === undefined
                ? ""
                : that.yaxistitletext().split(",#")[1],
            align: that.yaxistitlealign(),
            rotation: that.yaxistitlerotation(),
            //offset: that.yaxistitleoffset() == '' ? null : that.yaxistitleoffset(),
            //margin: that.yaxistitlemargin(),
            style: {
              color: "#FF6657",
              fontWeight: that.yaxistitlefontweight(),
              textDecoration: that.yaxistitlefontweight(),
              fontSize: that.yaxistitlefontsize() + "px",
              fontFamily: that.yaxistitlefontfamily(),
              display: that.yaxistitleenabled() == true ? "block" : "none"
            }
          },
          labels: {
            //align: that.yaxislabelalign(),
            enabled: that.yaxislabelenabled(),
            format:
              that.yaxislabelautoscale() == true
                ? null
                : (newPropertyValues.yaxislabelprefix[1] || "") +
                  that.yaxislabelformat() +
                  (newPropertyValues.yaxislabelsuffix[1] || ""),
            rotation: that.yaxislabelrotation(),
            staggerLines:
              that.yaxislabelstaggerline() == ""
                ? null
                : _.parseInt(that.yaxislabelstaggerline()),
            maxStaggerLines:
              that.yaxislabelmaxstaggerline() == ""
                ? null
                : _.parseInt(that.yaxislabelmaxstaggerline()),
            step: that.yaxislabelstep(),
            //x: that.yaxislabelx(),
            //y: that.yaxislabely(),
            zIndex: that.yaxislabelzindex(),
            style: {
              color: "#FF6657",
              fontWeight: that.yaxislabelfontweight(),
              textDecoration: that.yaxislabelfontweight(),
              fontSize: that.yaxislabelfontsize() + "px",
              fontFamily: that.yaxislabelfontfamily()
            },
            events: {
              click: function() {
                seriesLibrary.axisClickEvent(this, that);
              }
            }
          },
          plotBands: [
            {
              color:
                that.yaxisplotbandenabled() == true
                  ? that.yaxisplotbandcolor()
                  : null,
              borderColor:
                that.yaxisplotbandenabled() == true
                  ? that.yaxisplotbandbordercolor()
                  : null,
              borderWidth: that.yaxisplotbandborderwidth(),
              from: that.yaxisplotbandfrom(),
              to: that.yaxisplotbandto(),
              zIndex: that.yaxisplotbandzindex(),
              events: {
                click: function() {
                  that.fireEvent("yaxisplotbandonclick");
                },

                mouseover: function() {
                  that.fireEvent("yaxisplotbandmousemove");
                }
              },
              label: {
                style: {
                  color: that.yaxisplotbandlabelcolor(),
                  fontWeight: that.yaxisplotbandlabelfontweight(),
                  textDecoration: that.yaxisplotbandlabelfontweight(),
                  fontSize: that.yaxisplotbandlabelfontsize() + "px",
                  fontFamily: that.yaxisplotbandlabelfontfamily(),
                  display:
                    that.yaxisplotbandlabelenabled() == true ? "block" : "none"
                },
                text: that.yaxisplotbandlabeltext() || null,
                align: that.yaxisplotbandlabelalign(),
                rotation: that.yaxisplotbandlabelrotation(),
                textAlign: that.yaxisplotbandlabeltextalign(),
                verticalAlign: that.yaxisplotbandlabelverticalalign(),
                x:
                  that.yaxisplotbandlabelxposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotbandlabelxposition()),
                y:
                  that.yaxisplotbandlabelyposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotbandlabelyposition())
              }
            }
          ],
          plotLines: [
            {
              color:
                that.yaxisplotlineenabled() == true
                  ? that.yaxisplotlinecolor()
                  : null,
              dashStyle: that.yaxisplotlinedashstyle(),
              width: that.yaxisplotlinewidth(),
              value: that.yaxisplotlinevalue(),
              zIndex: that.yaxisplotlinezindex(),
              label: {
                style: {
                  color: that.yaxisplotlinelabelcolor(),
                  fontWeight: that.yaxisplotlinelabelfontweight(),
                  textDecoration: that.yaxisplotlinelabelfontweight(),
                  fontSize: that.yaxisplotlinelabelfontsize() + "px",
                  fontFamily: that.yaxisplotlinelabelfontfamily(),
                  display:
                    that.yaxisplotlinelabelenabled() == true ? "block" : "none"
                },
                text: that.yaxisplotlinelabeltext() || null,
                align: that.yaxisplotlinelabelalign(),
                rotation: that.yaxisplotlinelabelrotation(),
                textAlign: that.yaxisplotlinelabeltextalign(),
                verticalAlign: that.yaxisplotlinelabelverticalalign(),
                x:
                  that.yaxisplotlinelabelxposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotlinelabelxposition()),
                y:
                  that.yaxisplotlinelabelyposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotlinelabelyposition())
              }
            }
          ]
        },
        //Third Axis goes here
        {
          allowDecimals: that.yaxisallowdecimals(),
          alternateGridColor: that.yaxisalternategridcolor(),
          gridLineColor: that.yaxisgridlinecolor(),
          gridLineDashStyle: that.yaxisgridlinedashstyle(),
          gridLineWidth: that.yaxisgridlinewidth(),
          gridZIndex: that.yaxisgridzindex(),
          lineColor: "#F3A730",
          lineWidth: that.yaxislinewidth(),
          minorGridLineColor: that.yaxisminorgridlinecolor(),
          minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
          minorGridLineWidth: that.yaxisminorgridlinewidth(),
          minorTickColor: that.yaxisminortickcolor(),
          minorTickInterval:
            _.parseInt(newPropertyValues.yaxisminortickinterval[2]) || "auto",
          minorTickLength: that.yaxisminorticklength(),
          minorTickPosition: that.yaxisminortickposition(),
          minorTickWidth: that.yaxisminortickwidth(),
          tickColor: that.yaxistickcolor(),
          tickInterval:
            _.parseInt(newPropertyValues.yaxistickinterval[2]) || null,
          tickLength: that.yaxisticklength(),
          tickPosition: that.yaxistickposition(),
          tickWidth: that.yaxistickwidth(),
          tickmarkPlacement: that.yaxistickmarkplacement(),
          dateTimeLabelFormats: {},
          ceiling: _.parseInt(newPropertyValues.yaxisceiling[2]) || null,
          floor: _.parseInt(newPropertyValues.yaxisfloor[2]) || null,
          min: _.parseInt(newPropertyValues.yaxismin[2]) || null,
          max: _.parseInt(newPropertyValues.yaxismax[2]) || null,
          maxPadding:
            that.yaxismaxpadding() == ""
              ? null
              : parseFloat(that.yaxismaxpadding()),
          minPadding:
            that.yaxisminpadding() == ""
              ? null
              : parseFloat(that.yaxisminpadding()),
          minRange: that.yaxisminrange(),
          //offset: that.yaxisoffset(),
          opposite: !that.yaxisopposite(),
          reversed: that.yaxisreversed() === true,
          showEmpty: that.yaxisshowempty(),
          showFirstLabel: that.yaxisshowfirstlabel(),
          showLastLabel: that.yaxisshowlastlabel(),
          //          startOnTick: that.yaxisstartontick(),
          //          endOnTick: that.yaxisendontick(),
          title: {
            text:
              that.yaxistitletext().split(",#")[2] === undefined
                ? ""
                : that.yaxistitletext().split(",#")[2],
            align: that.yaxistitlealign(),
            rotation: that.yaxistitlerotation(),
            //offset: that.yaxistitleoffset() == '' ? null : that.yaxistitleoffset(),
            //margin: that.yaxistitlemargin(),
            style: {
              color: "#F3A730",
              fontWeight: that.yaxistitlefontweight(),
              textDecoration: that.yaxistitlefontweight(),
              fontSize: that.yaxistitlefontsize() + "px",
              fontFamily: that.yaxistitlefontfamily(),
              display: that.yaxistitleenabled() == true ? "block" : "none"
            }
          },
          labels: {
            //align: that.yaxislabelalign(),
            enabled: that.yaxislabelenabled(),
            format:
              that.yaxislabelautoscale() == true
                ? null
                : (newPropertyValues.yaxislabelprefix[2] || "") +
                  that.yaxislabelformat() +
                  (newPropertyValues.yaxislabelsuffix[2] || ""),
            rotation: that.yaxislabelrotation(),
            staggerLines:
              that.yaxislabelstaggerline() == ""
                ? null
                : _.parseInt(that.yaxislabelstaggerline()),
            maxStaggerLines:
              that.yaxislabelmaxstaggerline() == ""
                ? null
                : _.parseInt(that.yaxislabelmaxstaggerline()),
            step: that.yaxislabelstep(),
            //x: that.yaxislabelx(),
            //y: that.yaxislabely(),
            zIndex: that.yaxislabelzindex(),
            style: {
              color: "#F3A730",
              fontWeight: that.yaxislabelfontweight(),
              textDecoration: that.yaxislabelfontweight(),
              fontSize: that.yaxislabelfontsize() + "px",
              fontFamily: that.yaxislabelfontfamily()
            }
          },
          plotBands: [
            {
              color:
                that.yaxisplotbandenabled() == true
                  ? that.yaxisplotbandcolor()
                  : null,
              borderColor:
                that.yaxisplotbandenabled() == true
                  ? that.yaxisplotbandbordercolor()
                  : null,
              borderWidth: that.yaxisplotbandborderwidth(),
              from: that.yaxisplotbandfrom(),
              to: that.yaxisplotbandto(),
              zIndex: that.yaxisplotbandzindex(),
              events: {
                click: function() {
                  that.fireEvent("yaxisplotbandonclick");
                },
                mouseover: function() {
                  that.fireEvent("yaxisplotbandmousemove");
                }
              },
              label: {
                style: {
                  color: that.yaxisplotbandlabelcolor(),
                  fontWeight: that.yaxisplotbandlabelfontweight(),
                  textDecoration: that.yaxisplotbandlabelfontweight(),
                  fontSize: that.yaxisplotbandlabelfontsize() + "px",
                  fontFamily: that.yaxisplotbandlabelfontfamily(),
                  display:
                    that.yaxisplotbandlabelenabled() == true ? "block" : "none"
                },
                text: that.yaxisplotbandlabeltext() || null,
                align: that.yaxisplotbandlabelalign(),
                rotation: that.yaxisplotbandlabelrotation(),
                textAlign: that.yaxisplotbandlabeltextalign(),
                verticalAlign: that.yaxisplotbandlabelverticalalign(),
                x:
                  that.yaxisplotbandlabelxposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotbandlabelxposition()),
                y:
                  that.yaxisplotbandlabelyposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotbandlabelyposition())
              }
            }
          ],
          plotLines: [
            {
              color:
                that.yaxisplotlineenabled() == true
                  ? that.yaxisplotlinecolor()
                  : null,
              dashStyle: that.yaxisplotlinedashstyle(),
              width: that.yaxisplotlinewidth(),
              value: that.yaxisplotlinevalue(),
              zIndex: that.yaxisplotlinezindex(),
              label: {
                style: {
                  color: that.yaxisplotlinelabelcolor(),
                  fontWeight: that.yaxisplotlinelabelfontweight(),
                  textDecoration: that.yaxisplotlinelabelfontweight(),
                  fontSize: that.yaxisplotlinelabelfontsize() + "px",
                  fontFamily: that.yaxisplotlinelabelfontfamily(),
                  display:
                    that.yaxisplotlinelabelenabled() == true ? "block" : "none"
                },
                text: that.yaxisplotlinelabeltext() || null,
                align: that.yaxisplotlinelabelalign(),
                rotation: that.yaxisplotlinelabelrotation(),
                textAlign: that.yaxisplotlinelabeltextalign(),
                verticalAlign: that.yaxisplotlinelabelverticalalign(),
                x:
                  that.yaxisplotlinelabelxposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotlinelabelxposition()),
                y:
                  that.yaxisplotlinelabelyposition() == "null"
                    ? null
                    : _.parseInt(that.yaxisplotlinelabelyposition())
              }
            }
          ]
        }
      ],
      plotOptions: {
        series: {
          minPointLength: 3,
          borderWidth: 0,
          cursor: "pointer",
          events: {
            legendItemClick: function() {
              /* if(this.chart.yAxis.length>1 && (that.zerothresholdenabled() || that.alignthresholds())){
                  var index = this.index;
                    var visibility = !this.visible;
                    that.legendVisibleArray = [];

                    var legendList = this.chart.legend.allItems;
                    for (var i = 0; i < legendList.length; i++) {
                        if (legendList[i].visible) {
                            that.legendVisibleArray.push(legendList[i].index);
                        }
                    }
                    var thisindex = that.legendVisibleArray.indexOf(index);
                    if (!visibility && thisindex > -1) {
                        that.legendVisibleArray.splice(thisindex, 1);
                    }
                    if (visibility) {
                        that.legendVisibleArray.push(index);
                    }

                    that.updateYaxisonLegendClick(that.legendVisibleArray);
                }*/
            }
          },
          point: {
            events: {
              click: function(event) {
                try {
                  //that.selectedvalue(seriesLibrary.createMemberData(that,that.categoriesIndex[event.point.index]));
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  ); //changed = 1;
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
              },

              select: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    if (that.chartenablezoom()) {
                      that.selectedPoints = $("#detail-container" + that["id"]())
                        .highcharts()
                        .getSelectedPoints();
                    } else {
                      that.selectedPoints = component.highcharts().getSelectedPoints();
                    }
                    that.selectedPoints.push(this);
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    seriesLibrary.onSelectFunction(that);
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                  /**
                  *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                  **/
                }
              },

              unselect: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    var index = that.selectedPoints.indexOf(this);
                    if (index > -1) {
                      that.selectedPoints.splice(index, 1);
                    }

                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    if (that.selectedvalues() == "") {
                      that.selectedvalue("");
                    } else {
                      var select = seriesLibrary.createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      );
                      that.selectedvalue(select[0]);
                    }
                    /**
                     *Selectedvalue fix in all charts
                     *Multiple Selection getting the last selected value.
                    **/
                    if (that.clearSelect) {
                      if (that.selectedvalues() == "") {
                        that.clearSelect = false;
                      }
                    } else {
                      seriesLibrary.onSelectFunction(that);
                    } //clearselection callback issue on Onselect.
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                }
              }
            }
          },
          allowPointSelect: that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          turboThreshold: that.turbothreshold(),
          dataLabels: {
            allowOverlap: that.allowoverlap(),
            enabled: that.datalabelenabled(),
            align: that.multidatalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            overflow: "justify",
            verticalAlign: that.multidatalabelverticalalign(),
            inside: that.datalabelinside(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              if (
                that.customdatalabel() !== "" &&
                Object.keys(JSON.parse(that.customdatalabel() || "{}")).length &&
                this.point.series.name.toLocaleLowerCase().indexOf("result") ==
                  -1 &&
                this.key.name.toLocaleLowerCase().indexOf("result") == -1
              ) {
                return vbiNumberFormat.barFamilyFormatterDataLabel(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              } else {
                return vbiNumberFormat.barFamilyDataLabelFormatter(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              }
            },
            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() == true
                  ? this.fontfamily()
                  : that.datalabelfontfamily()
            }
          },
          marker: {}
        },
        errorbar: {
          turboThreshold: 1000
        }
      },
      series: options.seriesData
    };
    return defaultValue;
  };
  
  this.attachGetters=function(component,options){
    
    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.fulldataseries = function() {
      return JSON.stringify(seriesLibrary.createErrorbar());
    };

    component.errorbardata = function() {
      //alert(new seriesLibrary.createErrorbar());
      /*  var completedJson=seriesLibrary.getMeasuresName(component.fulljson()).split('=');
        var key=completedJson[0].split(',');
        var name=completedJson[1].split(',');
        var completeMeasure=[];
        completeMeasure.push(key,name);
      //  return  JSON.stringify(new seriesLibrary.createErrorbar()); */


     var completedJson = seriesLibrary.getMeasuresName(component.fulljson()).split('=');
      var completemeasurenames = [];
      var key = completedJson[1].split(',');
      var name = completedJson[0].split(',');
      var measurenamechange = {};
      if (component.chartmeasurechange() != '' && component.chartmeasurechange() != undefined && component.chartmeasurechange() != null) {
         measurenamechange = JSON.parse(component.chartmeasurechange());
      } else {
         measurenamechange = {};
      }

      for (var i = 0; i < key.length; i++) {
        var measure = {};
        measure.uniquekey = key[i];
        if (measurenamechange[key[i]] != '' && measurenamechange[key[i]] != undefined) {
          measure.name = measurenamechange[key[i]];
        } else {
          measure.name = name[i];
        }

        completemeasurenames.push(measure);
      }

      return JSON.stringify(completemeasurenames);
    };

    component.seriesdata = function() {
      var completedJson = seriesLibrary.getMeasuresName(component.fulljson()).split('=');
      var chartmeasurenames = [];
      var key = completedJson[1].split(',');
      var name = completedJson[0].split(',');

      var measurenamechange = {};
      if (component.chartmeasurechange() != '' && component.chartmeasurechange() != undefined && component.chartmeasurechange() != null) {
         measurenamechange = JSON.parse(component.chartmeasurechange());
      } else {
         measurenamechange = {};
      }

      for (var i = 0; i < key.length; i++) {
        var measure = {};
        measure.uniquekey = key[i];
        if (measurenamechange[key[i]] != '' && measurenamechange[key[i]] != undefined) {
          measure.name = measurenamechange[key[i]];
        } else {
          measure.name = name[i];
        }

        chartmeasurenames.push(measure);
      }

      return JSON.stringify(chartmeasurenames);  //return  JSON.stringify(new seriesLibrary.defaultvalueseries());
    };


    component.seriesstyledata = function() {
        return JSON.stringify(new seriesLibrary.defaultvalueseries());
      };

    component.getDynamicYaxisTitle = function(value) {
      if (value === undefined) {
        return component.dynamicyaxistitle();
      } else {
        component.dynamicyaxistitle(value);
        component.firePropertiesChanged(['dynamicyaxistitle']);
      }
    };

    component.getDataSeries = function() {
    if (!component.dataRes) { return null; }
      var dataSeries = [
        [],
        []
      ];
      var bardatacustomizationJson = {
        'COLUMNS': [],
        'ROWS': []
      };
      if (component.bardatacustomization() != '') {
        bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
      }

      try {
        if (component.dataRes === undefined || component.dataRes == '') {
          // return null;
        } else if (component.datautility() == true && bardatacustomizationJson['COLUMNS'].length == 0 && bardatacustomizationJson['ROWS'].length == 0) {
          return null;
        } else if (component.dataRes.dimensions.length == 1 && component.dataRes.dimensions[0].containsMeasures == true) {
          if (component.dataRes.dimensions[0].axis == 'COLUMNS') {
            for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
              dataSeries[0].push(component.dataRes.dimensions[0].members[i].text);
              dataSeries[1].push(component.dataRes.dimensions[0].members[i].key);
            }
          } else {
            dataSeries[0].push('Measures');
            dataSeries[1].push('Measures');
          }
        } else {
          dataSeries = seriesLibrary.createSeriesData(component, 'multipleAxes', component.defaultValueSeriesNames);  //csdSeriesNames;
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
        if (window.console) {
          console.log('Exception-vbiMultipleAxesChart:component.getDataSeries():' + e); // jshint ignore:line
        }
      }

      return dataSeries;
    };

    component.getDataSeriesColor = function() {
      var dataseriescolor = '';
      try {
        dataseriescolor = component.dataseriescolor();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
        if (window.console) {
          console.log('Exception-vbiDualAxesChart:component.getDataSeriesColor():' + e); // jshint ignore:line
        }
      }

      return dataseriescolor;
    };

    component.getDatUtility = function() {
      var datautility = '';
      try {
        datautility = component.datautility();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return datautility;
    };

    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.getChartType = function() {
      return 'multipleAxes';
    };

    component.isMeasureOnly = function() {
      var len = 0;
      if (component.result() !== undefined && component.result() != '') {
        try {
          len = component.result().dimensions.length;
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return len;
    };

    component.getLegendNames = function() {
      var charttype = [],leglist = [],legcolors = [],leglistkey = [];
      if (component.result() !== undefined && component.result() != '') {
        try {
          for (var i = 0; i < component.defaultValueSeriesNames.series.length; i++) {
            if (component.defaultValueSeriesNames.series[i].name.indexOf('Trendline') == -1 && component.defaultValueSeriesNames.series[i].type != 'errorbar') {
              leglist.push(component.defaultValueSeriesNames.series[i].name);
              charttype.push(component.defaultValueSeriesNames.series[i].type);
              legcolors.push(component.defaultValueSeriesNames.series[i].color);
              leglistkey.push(component.defaultValueSeriesNames.series[i].uniquekey);//Making changes because same series-name causing problem VBX141-3099
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        leglist,
        charttype,
        legcolors,
        leglistkey
      ];
    };

    component.isAllStacked = function(/*dimIndex*/) {
        var allStacked = 'true';
        if (component.result() !== undefined && component.result() != '') {
          try {
            for (var i = 0; i < component.defaultValueSeriesNames.series.length; i++) {
              if (component.defaultValueSeriesNames.series[i].stacking  === '') {
                allStacked = 'false';
                break;
              }
            }
          } catch (e) {   seriesLibrary.DSXalert(e.message);
          }
        }

        return allStacked;
      };

    component.getChartFamily = function() {
      return 'bar';
    };

    component.lassoFireProp = function(selectedPoints) {
      component.selectedvalues(seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints).toString());
     // component.changed++;
      component.firePropertiesChanged(['selectedvalues']);
    };

    component.getChartType = function() {
      return component['chartorientation']();
    };

    //Measure validation function for errorbar to check whether measure is in row and if the column contains more than two dimension
    component.measureValidation = function() {
      var returnValue = false;
      var measureinrow = false;
      try {
        for (var i = 0; i < component.result().dimensions.length; i++) {

          if (component.result().dimensions[i].containsMeasures == true && component.result().dimensions[i].axis == 'ROWS') {
            measureinrow = true;
          }
        }

        if (measureinrow == true) {
          returnValue = false;
        } else {
          returnValue = true;
        }  //return true;
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return returnValue + '';  //callruntime handler won't handle object and boolean hence return string
    };



  }
}