function TreeMapDrilldownChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        id: "Africa",
        name: "Africa"
      },
      {
        id: "1960",
        name: "1960",
        parent: "Africa"
      },
      {
        name: "HEL",
        parent: "1960",
        value: 76,
        colorValue: 6
      },
      {
        name: "OIl",
        parent: "1960",
        value: 89,
        colorValue: 7
      },
      {
        name: "NGS",
        parent: "1960",
        value: 501,
        colorValue: 8
      },
      {
        id: "1961",
        name: "1961",
        parent: "Africa"
      },
      {
        name: "HEL",
        parent: "1961",
        value: 549,
        colorValue: 9
      },
      {
        name: "OIl",
        parent: "1961",
        value: 64,
        colorValue: 10
      },
      {
        name: "NGS",
        parent: "1961",
        value: 235,
        colorValue: 11
      }
    ];
    return seriesData;
  };
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();
    var thousandseptool = that.tooltipthousandseparator();
    var decimalseptool = that.tooltipdecimalseparator();

    var isExportEnable = that.exportingsymbolenabled();
    if (that.enableMoreActionsButton && isExportEnable) {
      isExportEnable =
        !that.enableMoreActionsButton() && !that.enableContextMenu();
    }
    var treechoroplethcolor = that.brewerflag();
    var treetype = that.treechoroplethColorDataType();
    var colormin;
    var colormax;
    if (that.treeColorType() == 'custom') {
        if (treetype && treechoroplethcolor !== '' && treechoroplethcolor !== undefined && treechoroplethcolor != 'SelectProperties') {
            colormin = that.colorBrewer[treechoroplethcolor]['8'][0];
            colormax = that.colorBrewer[treechoroplethcolor]['8'][7];
        } else {
            colormin = that.coloraxismincolor();
            colormax = that.coloraxismaxcolor();
        }
    } else {
        colormin = that.coloraxismincolor();
        colormax = that.coloraxismaxcolor();
    }
    var subtitley;
    if (that.subtitleverticalalign() == 'bottom') {
        subtitley = Number(that.subtitley()) - 2;
    } else {
        subtitley = Number(that.subtitley());
    }
    var exportMenuItems = Highcharts.getOptions().exporting.buttons.contextButton.menuItems.slice(0);
    exportMenuItems.splice(7, 4); // Removing Lasso options from export menu
    var loadingfont = that.loadingfontweight().split(':');
    var defaultValue = {
      chart: {
        type: "treemap",
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            if (event.toElement.innerHTML === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function(event) {
            if (event.xAxis) {
              that.fireEvent("chartonselect");
            } //disabling the fireEvent while zoom out.
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: that.chartpanning(),
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            //relativeTo:that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign(),
            x: -10,
            y: -15
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: {
              color: that.resetzoombuttontextcolor()
            },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: {
                  color: that.resetzoombuttonhovertextcolor()
                }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor:
          that.plotbordercolor() == "rgba(255, 255, 255, 0)" ||
          that.plotbordercolor() === ""
            ? null
            : that.plotbordercolor(),
        plotBorderWidth:
          that.plotbordercolor() === "" ||
          that.plotbordercolor() === null ||
          that.plotbordercolor() == "rgba(255, 255, 255, 0)"
            ? null
            : that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      lang: {
        noData: ""
      },
      title: {
        align: that.titlealign(),
        floating: that.titlefloating(),
        margin: that.titlemargin() === "" ? null : that.titlemargin(),
        text: that.titletext(),
        x: that.titlex() === "" ? null : _.parseInt(that.titlex()),
        y: that.titley() === "" ? null : _.parseInt(that.titley()),
        verticalAlign:
          that.titleverticalalign() == "auto" ? null : that.titleverticalalign(),
        style: {
          color: that.titlecolor(),
          fontWeight: that.titlefontweight(),
          textDecoration: that.titlefontweight(),
          fontSize: that.titlefontsize() + "px",
          fontFamily: that.titlefontfamily(),
          display: that.titleenable() === true ? "block" : "none"
        }
      },
      subtitle: {
        align: that.subtitlealign(),
        floating: that.subtitlefloating(),
        text: that.subtitletext(),
        x: that.subtitlex() === "" ? null : that.subtitlex(),
        y: that.subtitley() === "" ? null : subtitley,
        verticalAlign:
          that.subtitleverticalalign() == "auto"
            ? null
            : that.subtitleverticalalign(),
        style: {
          color: that.subtitlecolor(),
          fontWeight: that.subtitlefontweight(),
          textDecoration: that.subtitlefontweight(),
          fontSize: that.subtitlefontsize() + "px",
          fontFamily: that.subtitlefontfamily(),
          display: that.subtitleenable() === true ? "block" : "none"
        }
      },
      credits: {
        enabled: that.creditsenabled(),
        href: that.creditshref(),
        position: {
          align: that.creditsalign(),
          verticalAlign: that.creditsverticalalign(),
          x: that.creditsxposition(),
          y:
            that.creditsverticalalign() == "top"
              ? that.creditsyposition() + 15
              : that.creditsyposition()
        },
        text: that.creditstext(),
        style: {
          color: that.creditstextcolor(),
          fontSize: that.creditsfontsize() + "px",
          fontFamily: that.creditsfontfamily(),
          fontWeight: that.creditsfontweight(),
          cursor: that.creditscursor()
        }
      },

      exporting: {
        buttons: {
          contextButton: {
            enabled: isExportEnable,
            align: that.exportingsymbolalign(),
            verticalAlign: that.exportingsymbolverticalalign(),
            symbol: that.exportingsymbol(),
            symbolFill: that.exportingsymbolfill(),
            symbolSize: that.exportingsymbolsize(),
            symbolStroke: that.exportingsymbolstroke(),
            symbolStrokeWidth: that.exportingsymbolstrokewidth(),
            height:
              that.exportingsymbolheight() == "auto"
                ? 20
                : _.parseInt(that.exportingsymbolheight()),
            width:
              that.exportingsymbolwidth() == "auto"
                ? 24
                : _.parseInt(that.exportingsymbolwidth()),
            symbolX:
              that.exportingsymbolxposition() == "auto"
                ? 12
                : _.parseInt(that.exportingsymbolxposition()),
            symbolY:
              that.exportingsymbolyposition() == "auto"
                ? 10
                : _.parseInt(that.exportingsymbolyposition()),
            x:
              that.exportingxposition() == "auto"
                ? 0
                : _.parseInt(that.exportingxposition()),
            y:
              that.exportingyposition() == "auto"
                ? 0
                : _.parseInt(that.exportingyposition()),
            menuItems: that.chartthemeenabled()
              ? exportMenuItems
              : exportMenuItems.slice(0, 6),
            theme: {
              r: that.exportingsymbolradius(),
              fill:
                that.exportingsymbolbackgroundfill() === ""
                  ? null
                  : that.exportingsymbolbackgroundfill(),
              states: {
                hover: {
                  fill: that.exportingsymbolhoverbackgroundfill()
                }
              }
            }
          }
        },
        filename: that.exportedfilename(),
        sourceWidth: that.exportedchartwidth(),
        sourceHeight: that.exportedchartheight(),
        scale: that.exportedchartscale()
      },
      navigation: {
        menuStyle: {
          background: that.exportingmenustylebackgroundcolor()
        },
        menuItemStyle: {
          color: that.exportingmenuitemstyletextcolor(),
          fontWeight: that.exportingmenuitemstylefontweight(),
          textDecoration: that.exportingmenuitemstylefontweight()
        },
        menuItemHoverStyle: {
          background: that.exportingmenuitemhoverstylebackgroundcolor(),
          color: that.exportingmenuitemhoverstyletextcolor(),
          fontWeight: that.exportingmenuitemhoverstylefontweight(),
          textDecoration: that.exportingmenuitemhoverstylefontweight()
        }
      },
      loading: {
        labelStyle: {
          fontSize: "18px",
          fontWeight: loadingfont[0],
          fontStyle: loadingfont[1],
          color: that.loadingcolor()
        },
        style: {
          backgroundColor: that.loadingstylebackgroundcolor(),
          opacity: Number(that.loadingopacity()),
          textAlign: that.loadingtextalign()
        }
      },
      tooltip: {
        animation: that.tooltipanimation() || false,
        //                    crosshairs: that.tooltipcrosshair(),
        enabled: that.tooltipenable(),
        followPointer: that.tooltipfollowpointer(),
        followTouchMove: that.tooltipfollowtouchmove(),
        hideDelay: that.tooltiphidedelay(),
        shadow: that.tooltipshadow(),
        shape: that.tooltipshape(),
        shared: that.tooltipshared(),
        snap: that.tooltipsnap(),
        valueDecimals: that.tooltipvaluedecimals(),
        valuePrefix: that.tooltipvalueprefix(),
        valueSuffix: that.tooltipvaluesuffix(),
        formatter: function() {
          if (
            that.customtooltip() !== "" &&
            !that.tooltipshared() &&
            Object.keys(JSON.parse(that.customtooltip() || "{}")).length
          ) {
            return vbiNumberFormat.DrillDownFamilyTooltipFormatter(
              this,
              that,
              decimalseptool,
              thousandseptool,
              false
            );
          } else {
            var seriesNameforTreemeasure1 = "";
            var seriesNameforTreemeasure2 = "";
            var keyvalformeasure1;
            var keyvalformeasure2;
            if (
              that.dataRes !== undefined &&
              that.dataRes !== null &&
              that.dataRes !== ""
            ) {
              var xaxisname;
              if (that.chartmeasurechange()) {
                xaxisname = JSON.parse(that.chartmeasurechange());
              }

              for (var i = 0; i < that.dataRes.dimensions.length; i++) {
                if (that.dataRes.dimensions[i].containsMeasures === true) {
                  for (
                    var j = 0;
                    j < that.dataRes.dimensions[i].members.length;
                    j++
                  ) {
                    if (
                      that.chartmeasurechange() &&
                      xaxisname[that.dataRes.dimensions[i].members[j].key]
                    ) {
                      if (
                        that.treecolormeasure() ===
                        that.dataRes.dimensions[i].members[j].key
                      ) {
                        seriesNameforTreemeasure1 =
                          xaxisname[that.dataRes.dimensions[i].members[j].key];
                        keyvalformeasure1 =
                          that.dataRes.dimensions[i].members[j].key;
                      }
                      if (
                        that.treesizemeasure() ===
                        that.dataRes.dimensions[i].members[j].key
                      ) {
                        seriesNameforTreemeasure2 =
                          xaxisname[that.dataRes.dimensions[i].members[j].key];
                        keyvalformeasure2 =
                          that.dataRes.dimensions[i].members[j].key;
                      }
                    } else {
                      if (
                        that.treecolormeasure() ===
                        that.dataRes.dimensions[i].members[j].key
                      ) {
                        seriesNameforTreemeasure1 =
                          that.dataRes.dimensions[i].members[j].text;
                        keyvalformeasure1 =
                          that.dataRes.dimensions[i].members[j].key;
                      }
                      if (
                        that.treesizemeasure() ===
                        that.dataRes.dimensions[i].members[j].key
                      ) {
                        seriesNameforTreemeasure2 =
                          that.dataRes.dimensions[i].members[j].text;
                        keyvalformeasure2 =
                          that.dataRes.dimensions[i].members[j].key;
                      }
                    }
                  }
                }
              }
            }

            var value;
            var colorVal;
            var measure1val = "",
              measure2val = "";
            value = this.point.options.value;
            if (this.point.options.colorValue !== undefined) {
              colorVal = this.point.options.colorValue;
              var tooltiparr2 = seriesLibrary.tooltipScaling(
                "",
                colorVal,
                that,
                keyvalformeasure2
              );
              if (
                that.dataRes &&
                that.numberFormatDefinitionTooltip() === "initialView"
              ) {
                measure2val =
                  (tooltiparr2[0] || "") +
                  " (Color) : " +
                  vbiNumberFormat.processTooltipInitialView(
                    this,
                    that,
                    keyvalformeasure2,
                    false,
                    colorVal
                  );
              } else {
                measure2val =
                  (tooltiparr2[0] || "") +
                  " (Color) : " +
                  vbiNumberFormat.processData(
                    that,
                    this,
                    keyvalformeasure2,
                    false,
                    decimalseptool,
                    thousandseptool,
                    false,
                    colorVal
                  );
              }
            }

            var tooltiparr1 = seriesLibrary.tooltipScaling(
              "",
              value,
              that,
              keyvalformeasure1
            );
            if (
              that.dataRes &&
              that.numberFormatDefinitionTooltip() === "initialView"
            ) {
              measure1val =
                (tooltiparr1[0] || "") +
                " (Size) : " +
                vbiNumberFormat.processTooltipInitialView(
                  this,
                  that,
                  keyvalformeasure1,
                  false,
                  value
                );
            } else {
              measure1val =
                (tooltiparr1[0] || "") +
                " (Size) : " +
                vbiNumberFormat.processData(
                  that,
                  this,
                  keyvalformeasure1,
                  false,
                  decimalseptool,
                  thousandseptool,
                  false,
                  value
                );
            }
            var parent = this.point.parenttext ? this.point.parenttext + "/" : "";
            return (
              '<span style="color:' +
              this.color +
              '">\u25CF</span> ' +
              parent +
              this.point.name +
              " : <br/>" +
              measure1val +
              "<br/>" +
              measure2val
            );
          }
        },

        backgroundColor: that.tooltipbackgroundcolor(),
        borderColor: that.tooltipbordercolor(),
        borderRadius: that.tooltipborderradius(),
        borderWidth: that.tooltipborderwidth(),
        style: {
          color: that.tooltipcolor(),
          fontWeight: that.tooltipfontweight(),
          textDecoration: that.tooltipfontweight(),
          fontSize: that.tooltipfontsize() + "px",
          fontFamily: that.tooltipfontfamily()
        }
      },
      legend: {
        enabled:
          that.treeColorType() === "seriescolor" ? false : that.legendenable(),
        backgroundColor: that.legendbackgroundcolor(),
        borderColor: that.legendbordercolor(),
        borderRadius: that.legendborderradius(),
        borderWidth: that.legendborderwidth(),
        align: that.legendalign(),
        floating: that.legendfloating(),
        itemDistance: that.legenditemdistance(),
        itemMarginBottom: that.legenditemmarginbottom(),
        itemMarginTop: that.legenditemmargintop(),
        itemWidth:
          that.legenditemwidth() == "auto"
            ? null
            : Number(that.legenditemwidth()),
        width: that.legendboxwidth(),
        labelFormat: that.legendlabelformat(),
        layout: that.legendlayout(),
        lineHeight: that.legendlineheight(),
        margin: that.legendmargin(),
        padding: that.legendpadding(),
        reversed: that.legendreversed(),
        rtl: that.legendsymboltoright(),
        shadow: that.legendshadow(),
        symbolHeight: that.legendsymbolheight(),
        symbolPadding: that.legendsymbolpadding(),
        symbolRadius: that.legendsymbolradius(),
        symbolWidth: that.legendsymbolwidth(),
        x: that.treelegendxposition(),
        y: that.treelegendyposition(),
        verticalAlign: that.legendverticalalign(),
        itemHiddenStyle: {
          color: that.legenditemhiddenstylecolor()
        },
        itemHoverStyle: {
          color: that.legenditemhoverstylecolor()
        },
        itemStyle: {
          color: that.legenditemstylecolor(),
          fontSize: that.legenditemfontsize() + "px",
          fontWeight: that.legenditemfontweight(),
          textDecoration: that.legenditemfontweight(),
          fontFamily: that.legenditemfontfamily()
        },
        title: {
          text: that.legendtitletext(),
          style: {
            color: that.legendtitlecolor(),
            fontWeight: that.legendtitlefontweight(),
            textDecoration: that.legendtitlefontweight(),
            fontSize: that.legendtitlefontsize() + "px",
            fontFamily: that.legendtitlefontfamily()
          }
        },

        navigation: {
          activeColor: that.legendnavigationactivecolor(),
          animation: that.legendnavigationanimation(),
          arrowSize: that.legendnavigationarrowsize(),
          inactiveColor: that.legendnavigationinactivecolor(),
          style: {
            fontWeight: that.legendnavigationfontweight(),
            textDecoration: that.legendnavigationfontweight(),
            color: that.legendnavigationcolor(),
            fontSize: that.legendnavigationfontsize() + "px",
            fontFamily: that.legendnavigationfontfamily()
          }
        }
      },
      colorAxis: {
        min:
          that.coloraxismin() == "auto" ? null : _.parseInt(that.coloraxismin()),
        max:
          that.coloraxismax() == "auto" ? null : _.parseInt(that.coloraxismax()),
        minColor: colormin,
        maxColor: colormax
      },
      plotOptions: {
        series: {
          turboThreshold: 0,
          allowPointSelect: that.allowpointselect(),
          type: "treemap",
          borderColor: that.seriesbordercolor(),
          cursor: "pointer",
          pointWidth:
            that.pointwidth() == "auto" ? null : _.parseInt(that.pointwidth()),
          pointPadding: that.pointpadding(),
          point: {
            events: {
              click: function(event) {
                if (that.isHierarchy === false) {
                  if (that.maxvalueJSON == event.point.level) {
                    that.drilldownlevel(Number(event.point.level));
                  } else {
                    that.drilldownlevel(Number(event.point.level) + 1);
                  }

                  that.selectedvalue(
                    JSON.stringify(that.ztlSelectedRowJson[event.point.namekey])
                  );
                } else {
                  var allowednooflevels = Number(that.allowednooflevels());
                  if (isNaN(allowednooflevels) || allowednooflevels < 2) {
                    allowednooflevels = 1000;
                  }

                  if (that.includerootnodes()) {
                    allowednooflevels = allowednooflevels - 1;
                  }

                  if (
                    allowednooflevels > event.point.level &&
                    event.point.nodestate == "COLLAPSED"
                  ) {
                    that.setlevl = true;
                    that.drilldownlevel(Number(event.point.level) + 1);
                  } else {
                    that.setlevl = false;
                    if (that.maxvalueJSON == event.point.level) {
                      that.drilldownlevel(Number(event.point.level));
                    } else {
                      that.drilldownlevel(Number(event.point.level) + 1);
                    }
                  }

                  that.vlaue = {};
                  that.vlaue[
                    that.dataRes.dimensions[that.selectedDimension].key
                  ] = {
                    internalKey: event.point.nameKey,
                    text: event.point.name
                  };
                  that.selectedvalue(that.vlaue);
                  that.selectednode(event.point.nameKey);
                  that.newval = event.point.id;
                  that.newvalname = event.point.name;
                  that.selecteddimension(
                    that.dataRes.dimensions[that.selectedDimension].key
                  );
                }
              },

              select: function() {
                if (that.isHierarchy === false) {
                  that.selectedPoints = component.highcharts().getSelectedPoints();
                  that.selectedPoints.push(this);
                  var pointMemberJson = [];
                  for (var i = 0; i < that.selectedPoints.length; i++) {
                    var ztlPointJson = {};
                    if (i === 0) {
                      ztlPointJson = $.extend(
                        true,
                        {},
                        that.ztlSelectedColumnJson[that.treecolormeasure()]
                      );
                      $.extend(
                        true,
                        ztlPointJson,
                        that.ztlSelectedRowJson[that.selectedPoints[i].namekey]
                      );
                      pointMemberJson.push(JSON.stringify(ztlPointJson));
                    } else if (
                      that.selectedPoints[i].level == that.selectedPoints[i - 1].level
                    ) {
                      ztlPointJson = $.extend(
                        true,
                        {},
                        that.ztlSelectedColumnJson[that.treecolormeasure()]
                      );
                      $.extend(
                        true,
                        ztlPointJson,
                        that.ztlSelectedRowJson[that.selectedPoints[i].namekey]
                      );
                      pointMemberJson.push(JSON.stringify(ztlPointJson));
                    } else {
                      pointMemberJson = [];
                      ztlPointJson = $.extend(
                        true,
                        {},
                        that.ztlSelectedColumnJson[that.treecolormeasure()]
                      );
                      $.extend(
                        true,
                        ztlPointJson,
                        that.ztlSelectedRowJson[that.selectedPoints[i].namekey]
                      );
                      pointMemberJson.push(JSON.stringify(ztlPointJson));
                    }
                  }

                  that.selectedvalues(pointMemberJson.toString());
                  that.columncolorChanged = 1;
                  that.firePropertiesChangedAndEvent(
                    ["selectedvalue", "selectedvalues", "drilldownlevel"],
                    "chartonpointclick"
                  );
                } else {
                  that.selectedPoints = component.highcharts().getSelectedPoints();
                  that.selectedPoints.push(this);
                  that.memberDatasCollection.push(JSON.stringify(that.vlaue));
                  that.selectedvalues(that.memberDatasCollection.toString());
                  if (that.setlevl) {
                    that.firePropertiesChangedAndEvent(
                      [
                        "selectednode",
                        "selecteddimension",
                        "selectedvalue",
                        "selectedvalues",
                        "drilldownlevel"
                      ],
                      "onHExpand" /*,'chartonpointclick'*/
                    );
                    that.setflag = true;
                    that.drilldownflag = 1;
                  } else {
                    that.firePropertiesChangedAndEvent(
                      ["selectedvalue", "selectedvalues", "drilldownlevel"],
                      "chartonpointclick"
                    );
                    that.setflag = false;
                    that.columncolorChanged = 1;
                  }
                }
              },

              unselect: function() {
                if (that.isHierarchy === false) {
                  //var unselectedPoints = component.highcharts().getSelectedPoints();
                  var index = that.selectedPoints.indexOf(this);
                  if (index > -1) {
                    that.selectedPoints.splice(index, 1);
                  }

                  var pointMemberJson = [];
                  for (var i = 0; i < that.selectedPoints.length; i++) {
                    var ztlPointJson = {};
                    if (i === 0) {
                      ztlPointJson = $.extend(
                        true,
                        {},
                        that.ztlSelectedColumnJson[that.treecolormeasure()]
                      );
                      $.extend(
                        true,
                        ztlPointJson,
                        that.ztlSelectedRowJson[that.selectedPoints[i].namekey]
                      );
                      pointMemberJson.push(JSON.stringify(ztlPointJson));
                    } else if (
                      that.selectedPoints[i].level == that.selectedPoints[i - 1].level
                    ) {
                      ztlPointJson = $.extend(
                        true,
                        {},
                        that.ztlSelectedColumnJson[that.treecolormeasure()]
                      );
                      $.extend(
                        true,
                        ztlPointJson,
                        that.ztlSelectedRowJson[that.selectedPoints[i].namekey]
                      );
                      pointMemberJson.push(JSON.stringify(ztlPointJson));
                    } else {
                      pointMemberJson = [];
                      ztlPointJson = $.extend(
                        true,
                        {},
                        that.ztlSelectedColumnJson[that.treecolormeasure()]
                      );
                      $.extend(
                        true,
                        ztlPointJson,
                        that.ztlSelectedRowJson[that.selectedPoints[i].namekey]
                      );
                      pointMemberJson.push(JSON.stringify(ztlPointJson));
                    }
                  }

                  that.selectedvalues(pointMemberJson.toString());
                  that.columncolorChanged = 1;
                  that.firePropertiesChanged(["selectedvalues"]);
                }
              }
            }
          }
        }
      },
      series: [
        {
          drillUpButton: {
            theme: {
              style: {
                fontFamily:
                  that.globalfont() === true
                    ? this.fontfamily()
                    : "Lucida Grande, Lucida Sans Unicode, Arial, Helvetica, sans-serif"
              }
            },
            position: {
              x: that.drilldownbuttonx(),
              y: that.drilldownbuttony(),
              align: that.drilldownbuttonalign(),
              verticalAlign: that.drilldownbuttonverticalalign()
            }
          },
          layoutAlgorithm: that.chartlayouttype(),
          allowDrillToNode: true,
          borderDashStyle: that.treemaplinestyle(),
          /*borderWidth: that.seriesborderwidth(),*/
          borderColor: that.seriesbordercolor(),
          dataLabels: {
            enabled: false
          },
          levelIsConstant: false,
          levels: [
            {
              level: 1,
              borderWidth: that.seriesborderwidth(),
              dataLabels: {
                enabled: true,
                crop: that.datalabelcrop(),
                backgroundColor: that.datalabelbackgroundcolor(),
                useHTML: false,
                borderColor: that.datalabelbordercolor(),
                borderRadius: that.datalabelborderradius(),
                borderWidth: that.datalabelborderwidth(),
                padding: that.datalabelpadding(),
                rotation: that.datalabelrotation(),
                shadow: that.datalabelshadow(),
                x: that.treedatalabelx(),
                y: that.treedatalabely(),
                formatter: function() {
                  if (that.datalabelenabled() === true) {
                    var value;
                    value = this.point.options.value;
                    if (
                      that.customdatalabel() !== "" &&
                      Object.keys(JSON.parse(that.customdatalabel() || "{}"))
                        .length
                    ) {
                      return vbiNumberFormat.drillDownFamilyFormatterDataLabel(
                        this,
                        that,
                        decimalsep,
                        decimalsep,
                        false
                      );
                    } else {
                      if (that.numberFormatDefinition() === "initialView") {
                        return (
                          this.point.name +
                          " " +
                          vbiNumberFormat.processDataLabelInitialView(
                            this,
                            that,
                            that.treecolormeasure(),
                            value
                          )
                        );
                      } else {
                        return (
                          this.point.name +
                          " " +
                          vbiNumberFormat.processDataLabel(
                            that,
                            this,
                            that.treecolormeasure(),
                            false,
                            decimalsep,
                            thousandsep,
                            false,
                            value
                          )
                        );
                      }
                    }
                  } else {
                    return this.point.name;
                  }
                },
                align: that.treemaplevlabelalign(),
                verticalAlign: that.treemaplevlabelverticalalign(),
                style: {
                  fontSize: that.treemaplevlabelfontsize() + "px",
                  fontWeight: that.treemaplevlabelfontweight(),
                  fontFamily: that.treemaplevlabelfontfamily(),
                  color: that.treemaplevlabeltextcolor()
                }
              }
            }
          ],
          data: options.seriesData
        }
      ]
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.getChartFamily = function() {
        return 'treemapdrilldown';
    };

    component.isMeasureOnly = function() {
        var len = 0;
        if (component.result() !== undefined && component.result() !== '') {
            try {
                len = component.result().dimensions.length;
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return len;
    };

    component.getDimensionList = function() {
        var dimensions = [];
        if (component.result() !== undefined && component.result() !== '') {
            try {
                for (var i = 0; i < component.result().dimensions.length; i++) {
                    dimensions.push(component.result().dimensions[i].text);
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return dimensions;
    };

    component.getDimensionJson = function() {
        // var dimlist =[];
        var dimJson = {};
        if (component.dataRes !== undefined && component.dataRes !== '' && component.dataRes !== null) {
            try {
                var resultSet = component.dataRes.dimensions;
                for (var i = 0; i < resultSet.length; i++) {
                    if (resultSet[i].containsMeasures !== true) {
                        dimJson[resultSet[i].key] = {
                            'text': resultSet[i].text,
                            'index': i
                        };
                    }
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return JSON.stringify(dimJson);
    };

    component.getMeasureMembersKeyAndText = function() {
        var measureMemberKeys = [];
        var measureMemberText = [];
        if (component.dataRes !== undefined && component.dataRes !== '') {
            try {
                var mesIndex = component.getMeasureIndex();
                for (var i = 0; i < component.dataRes.dimensions[mesIndex].members.length; i++) {
                    measureMemberKeys.push(component.dataRes.dimensions[mesIndex].members[i].key);
                    measureMemberText.push(component.dataRes.dimensions[mesIndex].members[i]['picker_text']);
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return [
            measureMemberText,
            measureMemberKeys
        ];
    };

    component.getColorMesureIndex = function() {
        try {
            if (component.dataRes !== undefined && component.dataRes !== null && component.dataRes !== '') {
                var getMeasureArr = component.getMeasureArr();
                var treecolormeasureindex = getMeasureArr[0].indexOf(component.treesizemeasure());
                return treecolormeasureindex;
            }
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }
    };

    component.getMeasureJson = function() {
        try {
            if (component.dataRes !== undefined && component.dataRes !== null && component.dataRes !== '') {
                var measureJson = {};
                for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                    if ('containsMeasures' in component.dataRes.dimensions[i]) {
                        $.each(component.dataRes.dimensions[i].members, function(key, value) {
                            measureJson[value.key] = {
                                text: value.text,
                                index: key
                            };
                        });

                        break;
                    }
                }

                return JSON.stringify(measureJson);
            }
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }
    };

    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.getMeasureArr = function() {
        var seriesName = [];
        var seriesKey = [];
        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
            if ('containsMeasures' in component.dataRes.dimensions[i]) {
                $.each(component.dataRes.dimensions[i].members, function(key, value) {
                    seriesKey.push(value.key);
                    seriesName.push(value.text);
                });

                break;
            }
        }

        return [seriesKey, seriesName];
    };

    component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
        //component.dataRes = component.dispKeyTextResultSet();
        var defaultColor = [
            '#B586DA',
            '#FF6657',
            '#F3A730',
            '#946B66',
            '#B0AD53',
            '#7AC1DE',
            '#F1C337',
            '#566C6C',
            '#A1CC54',
            '#543F1E'
        ];
        var seriesColor = [];
        if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
            seriesColor = [];
        } else {
            seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
        }

        if (component.dataRes === undefined || component.dataRes === '')
        // If data source not available
        {
            return null;
        } else {
            if (component.enablehierarchydrilldown() === true && JSON.stringify(component.result()).indexOf('HIERARCHY_NODE') != -1) {
                var seriesName = [];
                var seriesKey = [];
                var selectedDimension;
                if (seriesLibrary.getNumberOfRowsColumns(component, 'ROWS') >= 1) {
                    for (var j = 0; j < component.dataRes.dimensions.length; j++) {
                        if (JSON.stringify(component.dataRes.dimensions[j]).indexOf('HIERARCHY_NODE') != -1) {
                            selectedDimension = j;
                            for (var i = 0; i < component.dataRes.dimensions[selectedDimension].members.length; i++) {

                                if (component.dataRes.dimensions[selectedDimension].members[i].type != 'RESULT') {
                                    if (component.includerootnodes() === false) {
                                        if (component.dataRes.dimensions[selectedDimension].members[i].level == 1) {
                                            seriesLibrary.getSeriesColors(component, seriesColor, seriesName.length, defaultColor);
                                            seriesName.push(component.dataRes.dimensions[selectedDimension].members[i]['picker_text']);
                                            seriesKey.push(component.dataRes.dimensions[selectedDimension].members[i].key);
                                        }
                                    } else {
                                        if (typeof component.dataRes.dimensions[selectedDimension].members[i].level == 'undefined') {
                                            seriesLibrary.getSeriesColors(component, seriesColor, seriesName.length, defaultColor);
                                            seriesName.push(component.dataRes.dimensions[selectedDimension].members[i]['picker_text']);
                                            seriesKey.push(component.dataRes.dimensions[selectedDimension].members[i].key);
                                        }
                                    }
                                }
                            }

                            break;
                        }
                    }

                    /*if (component.showtotals()) {
                      seriesLibrary.getSeriesColors(component, seriesColor, seriesName.length, defaultColor);
                      seriesName.push('Total');
                      seriesKey.push('Total');
                    }*/
                    seriesColor.splice(seriesName.length, seriesColor.length);
                    component.dataseriescolor(seriesColor.join());
                    return [
                        seriesName,
                        seriesKey
                    ];
                }
            } else {
                var measureDimensionIndex = component.getMeasureIndex();
                var measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
                var selectedRowdimIndexes = [];
                var selectedColumndimIndexes = [];
                var seriesName = [];
                var seriesKey = [];
                var bardatacustomizationJson = {
                    'COLUMNS': [],
                    'ROWS': []
                };
                if (component.bardatacustomization() !== '') {
                    bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
                }

                if (measureInRow) {
                    selectedRowdimIndexes.push(measureDimensionIndex);

                        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                            if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
                                selectedColumndimIndexes.push(i);
                            }
                        }

                        if (selectedColumndimIndexes.length === 0) {
                            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                                if (component.dataRes.dimensions[i].axis == 'ROWS' && !component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
                                    selectedColumndimIndexes.push(i);
                                }
                            }
                        }

                        if (selectedColumndimIndexes.length < 2) {
                            return null;
                        }

                } else {
                    selectedColumndimIndexes.push(measureDimensionIndex);

                        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                            if (component.dataRes.dimensions[i].axis == 'ROWS' && !component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
                                selectedRowdimIndexes.push(i);
                            }
                        }

                        if (selectedRowdimIndexes.length === 0) {
                            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                                if (component.dataRes.dimensions[i].axis == 'COLUMNS' && !component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
                                    selectedRowdimIndexes.push(i);
                                }
                            }
                        }

                        if (selectedRowdimIndexes.length < 2) {
                            return null;
                        }

                }

                var rowDim = measureInRow ? selectedColumndimIndexes[0] : selectedRowdimIndexes[0];
                for (var i = 0, mem = component.dataRes.dimensions[rowDim].members; i < mem.length; i++) {
                    if (mem[i].type != 'RESULT') {
                        seriesLibrary.getSeriesColors(component, seriesColor, seriesName.length, defaultColor);
                        seriesName.push(mem[i].text);
                        seriesKey.push(mem[i].key);
                    }
                }

                seriesColor.splice(seriesName.length, seriesColor.length);
                component.dataseriescolor(seriesColor.join());
                return [
                    seriesName,
                    seriesKey
                ];
            }
        }
    };

    component.getDataSeriesColor = function() {
        var dataseriescolor = '';
        try {
            if(component.dataseriescolor()){
                dataseriescolor = component.dataseriescolor();
            }else{
                dataseriescolor =[
                                    '#B586DA',
                                    '#FF6657',
                                    '#F3A730',
                                    '#946B66',
                                    '#B0AD53',
                                    '#7AC1DE',
                                    '#F1C337',
                                    '#566C6C',
                                    '#A1CC54',
                                    '#543F1E'
                                ].join(",");
                }
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }

        return dataseriescolor;
    };

    component.getDatUtility = function() {
        var datautility = '';
        try {
            datautility = component.datautility();
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }

        return datautility;
    };

    component.getChartType = function() {
        return 'TreeMapDrilldown';
    };

    component.componentDeleted = function() {
        $('#dsui_' + componentID).remove();
    };

    component.getMeasureMembers = function() {
        return seriesLibrary.getMeasureMembers(component);
    };


  }
}