var app = angular.module('GridStack', ['gridstack-angular','ui.bootstrap']).
  controller('DemoCtrl', function($scope, $log,$window) {
    $scope.widgets=[];
    $scope.viewGrid={};
    $scope.componentSelectionJson={};
    $scope.componentOrginalObject='';
    $scope.viewStatus=1;
    $scope.tabs = [
       { title:'Profile 1'},
    ];
    $scope.view="portrait";
    $scope.gridlines="gridsmall";
    $scope.selectedDevice="iphone6";
    $scope.count=1;


    $scope.addComp = function(componentID) {
             var newWidget = { x:0, y:0, width:25, height:25,autoPosition:true,id:componentID,content:componentID};
             $scope.widgets.push(newWidget);
             var index = $scope.components.indexOf(componentID);
             $scope.components.splice(index, 1);
             $scope.addbackgroundImageSidebar($scope.components);
             $scope.addScrollbar();
       };

    $scope.componentListRefresh=function(){
      if(sessionStorage['componentslist'] !== undefined){
          $scope.componentOrginalObject=JSON.parse(sessionStorage['componentslist']);
          $scope.components= angular.copy($scope.componentOrginalObject.text);
        }else{
          $scope.components=["Linechart","Areachart","Button","ListBox"];
        }
    }

   $scope.componentListRefresh() //first time load

   //GETTING IF PROFILE HAS BEEN ALREADY CREATED
   if(sessionStorage['componentselection'] !== undefined){
       $scope.componentSelectionJson=JSON.parse(sessionStorage['componentselection']);
   }

   //DISPLAY TEXT HANDLE USING KEY ID
   $scope.componentNameConversion=function(element,output){
     if(output === "id"){
       var index=$scope.componentOrginalObject.text.indexOf(element);
       return $scope.componentOrginalObject.value[index];
     }else{
      var index=$scope.componentOrginalObject.value.indexOf(element);
       return $scope.componentOrginalObject.text[index];
     }
   }

    //GRID STACK INIT OPTIONS
    $scope.options = {
         verticalMargin: 0,
         float: true,
         cellHeight:$('.screen').height()/100,
    };

    /** GRIDSTACK EVEENTS LISTENER **/
    $scope.onChange = function(event, items) {
        //$scope.addScrollbar();
    };
    $scope.onDragStart = function(event, ui) {
        $scope.addScrollbar();
    };
    $scope.onDragStop = function(event, ui) {
        $scope.addScrollbar();
        $scope.addBackgroundImage(ui.helper.attr('data-custom-id'));
    };
    $scope.onResizeStart = function(event, ui) {
        $scope.addScrollbar();
    };
    $scope.onResizeStop = function(event, ui) {
        $scope.addScrollbar();
        $scope.addBackgroundImage(ui.element.attr('data-custom-id'));
    };
    $scope.onItemAdded = function(item) {
        $scope.addBackgroundImage(item.el.attr('data-custom-id'));
        $scope.addScrollbar();
   };
   /** GRIDSTACK EVEENTS LISTENER ENDS HERE**/

   /*CUSTOM EVENT LISTENERS REMOVE EVENTS,SCROLLBAR AND DRAGGED EVENTS*/
   $scope.addScrollbar=function(){   // IF CONTENT EXISTS SCREEN SIZE
     setTimeout(function(){
       var maximumHeight=angular.element('.screen').height();
       var gridSelector=angular.element('.grid1');
       var Screen=angular.element('.screen');
       var gridHeight=parseInt(gridSelector.height())+50;
       if(maximumHeight<gridHeight){
          Screen.css('overflow-y','scroll');
       }else{
           Screen.css('overflow-y','hidden');
       }
     },400)

   }

   $scope.addBackgroundImage=function(element){
      var index=$scope.componentOrginalObject.text.indexOf(element);
      var imageSrc=$scope.componentOrginalObject.type[index];
       setTimeout(function(){
          if(ImageDefinition[imageSrc] !== undefined){
            $(document.getElementById(element)).css('background-image','url('+ImageDefinition[imageSrc]+')');
         }else{

            $(document.getElementById(element)).css('background-image','url('+ImageDefinition['default']+')');
         }
       },200)
   }


   $scope.addbackgroundImageSidebar=function(value){
     for(var i=0;i<value.length;i++){
       $scope.addBackgroundImage(value[i]);
     }
   }


   $scope.$watch('components', function(value) {
       $scope.addbackgroundImageSidebar(value);
    });

   $scope.removeWidget = function(w) {
           var index = $scope.widgets.indexOf(w);
           $scope.components.push($scope.widgets[index].id);
           $scope.widgets.splice(index, 1);
           $scope.addbackgroundImageSidebar(_.map($scope.widgets, 'id')); //to update the screen  (can be optimizied)
           $scope.addbackgroundImageSidebar( $scope.components); //to update the sidebar  (can be optimizied)
    };


    //TO REMOVE FROM UI CONTAINER
    $scope.onComponentsDragged = function(comp) {
        var removeComponent=function(comp){
          var index=$scope.components.indexOf(comp);
          if(index !== -1){
            $scope.components.splice(index,1);
          }
        }
        if(comp.indexOf('&') !== -1){
          var groupdcomponent=comp.split('&');
          _.each(groupdcomponent,function(value){
            removeComponent(value);
          })
        }else{
          removeComponent(comp);
        }
      //  $scope.addScrollbar();
    };

    //Intializing the controller with the layout if profile already exist
    $scope.init = function () {
      if(sessionStorage['componentselection'] !== "" && sessionStorage['componentselection'] !== undefined){
            $scope.tabs=[];
            angular.forEach($scope.componentSelectionJson, function(value, key) {
                  var gridstackData=[];
                 if(key !== "activeProfile"){
                    var newView={ title:key,hide:true};
                    $scope.tabs.push(newView);
                        for(var i=0;i<value.panels.length;i++){

                       if(value.panels[i].length>0){
                          var gridstackItemData={
                             id: "",
                             content:"",
                             x: "",
                             y: "",
                             width: '50%',
                             height:'50%',
                             autoPosition:false,
                            }

                            for(var j=0;j<value.panels[i].length;j++){
                              value.panels[i][j]=$scope.componentNameConversion(value.panels[i][j],"text") || value.panels[i][j]; //VBX141-8275 Fix
                              $scope.onComponentsDragged(value.panels[i][j]);
                              if(j>0){
                                gridstackItemData.id+='&'+value.panels[i][j];
                                gridstackItemData.content+='&'+value.panels[i][j];
                              }else{
                                gridstackItemData.id+=value.panels[i][j];
                                gridstackItemData.content+=value.panels[i][j];
                              }
                            }


                            if(value.height !== undefined && value.height[i]){
                              gridstackItemData.height=value.height[i];
                            }

                            if(value.width !== undefined && value.width[i]){
                              gridstackItemData.width=value.width[i];
                            }

                            if(value.x === undefined){
                              gridstackItemData.autoPosition=true;
                            }else{
                              gridstackItemData.x=0;
                            }
                            if(value.y !== undefined){
                              gridstackItemData.y=0;
                            }

                            gridstackData.push(gridstackItemData);
                          }
                        }
                    $scope.viewGrid[key]=gridstackData;
             }
        });

          $scope.componentListRefresh(); //refresh componentList

          //To make sure gridstack has been intialised before the controller function
          setTimeout(function(){
            $scope.grid = $('.grid-stack').data('gridstack');
            _.each($scope.viewGrid[Object.keys($scope.viewGrid)[0]], function (node) {
              var newWidget = { x:node.x, y:node.y, width:node.width, height:node.height,autoPosition:true,id:node.id,content:node.id};
              $scope.widgets.push(newWidget);
              $scope.onComponentsDragged(node.id);
            });
              $scope.$apply(); //to make sure widgets or comes into scope at init
          },1000);

      }

      $scope.tabs[$scope.tabs.length-1].hide=false; //to make last profile to show
    }
    $scope.init();

    /*To add more views*/
    $scope.addTab=function(index,$event,tab){
          if(typeof $event !== undefined){
            $event.stopPropagation()
          }
          tab.hide=true;
          var newView={ title:'Profile '+($scope.count)};
          $scope.count+=1;
          $scope.tabs.push(newView);
    }

    $scope.deleteTab=function(index,$event){
          if(typeof $event !== undefined){
            $event.stopPropagation()
          }
        if($scope.tabs[index] !== undefined && $scope.tabs.length !== 1){
          if($scope.viewGrid[$scope.tabs[index].title] !== undefined){
             delete $scope.viewGrid[$scope.tabs[index].title];   //delete from view storage
          }
          if($scope.componentSelectionJson[$scope.tabs[index].title] !== undefined){
            delete $scope.componentSelectionJson[$scope.tabs[index].title]; //delete from the final JSON
          }
          $scope.tabs.splice(index,1);           //delete from the tabs
          if($scope.viewStatus === index+1){
            $scope.grid.removeAll();
            $scope.viewStatus=$scope.tabs.length;
            $scope.loadGrid($scope.tabs.length);
          }
          $scope.tabs[$scope.tabs.length-1].hide=false; //make the last element to add;
        }
    }

    $scope.loadGrid = function(index) {
      $scope.componentListRefresh() //refresh component list
      if($scope.viewGrid[$scope.tabs[index-1].title]){
          var profileItems=$scope.viewGrid[$scope.tabs[index-1].title];
          $scope.widgets=[];
          if(profileItems.length > 0){
              var items = GridStackUI.Utils.sort(profileItems);
              _.each(items, function (node) {
                var newWidget = { x:0, y:0, width:node.width, height:node.height,autoPosition:true,id:node.id,content:node.id};
                $scope.widgets.push(newWidget);
                $scope.onComponentsDragged(node.id)  //to remove the components used in that view
              });
              $scope.addbackgroundImageSidebar(_.map($scope.widgets, 'id'));
              return false;
          }
      }
    };

    /*On view change*/
     $scope.viewChange=function(index,$event){
        $scope.grid = $('.grid-stack').data('gridstack');
        $scope.widgets=[];


        $scope.componentListRefresh() //refresh component list

       if($('.grid-stack .grid-stack-item:visible').length >0){
            var res = _.map($('.grid-stack .grid-stack-item:visible'), function (el) {
                 el = $(el);
                 var node = el.data();
                 return {
                     id: el.attr('data-custom-id'),
                     content:el.attr('data-custom-id'),
                     x: node.gsX,
                     y: node.gsY,
                     width: node.gsWidth,
                     height: node.gsHeight
                 };
             });

            $scope.componentSelectionJson["activeProfile"]=$scope.tabs[$scope.viewStatus-1].title;
            $scope.componentSelectionJson[$scope.tabs[$scope.viewStatus-1].title]={
                "panels":[],
                "order":[],
                "defaultHeight":300,
                "defaultWidth":350,
                "height":[],
                "width":[],
                "scroll":[],
              };

              //save part
              var data= GridStackUI.Utils.sort(res);
              $scope.viewGrid[$scope.tabs[$scope.viewStatus-1].title]=[];
              $scope.viewGrid[$scope.tabs[$scope.viewStatus-1].title]=data;



              for(var i=0;i<data.length;i++){
                var itemselector=$(document.getElementById(data[i].id));
                elementId=$scope.componentNameConversion(data[i].id,"id") || elementId; //to convert text into ID
                if(elementId.indexOf('&') !== -1){
                  var panelItems=elementId.split('&');
                  $scope.componentSelectionJson[$scope.tabs[$scope.viewStatus-1].title].panels.push(panelItems);
                  $scope.componentSelectionJson[$scope.tabs[$scope.viewStatus-1].title].order.push(i);
                }else{
                   $scope.componentSelectionJson[$scope.tabs[$scope.viewStatus-1].title].panels.push([elementId]);
                   $scope.componentSelectionJson[$scope.tabs[$scope.viewStatus-1].title].order.push(i);
                }
                $scope.componentSelectionJson[$scope.tabs[$scope.viewStatus-1].title].height.push(data[i].height+'%');
                $scope.componentSelectionJson[$scope.tabs[$scope.viewStatus-1].title].width.push(data[i].width+'%');
                $scope.componentSelectionJson[$scope.tabs[$scope.viewStatus-1].title].scroll.push("none");
              }
              $scope.grid.removeAll();
          }else{
            $scope.viewGrid[$scope.tabs[$scope.viewStatus-1].title]=[];
          }
          $scope.viewStatus=index;


            //Load part
            $scope.loadGrid(index);
      }

    /*UI TRANSFORMATIONS*/
   $scope.$watch('selectedDevice', function(newvalue,oldvalue) {
     if(newvalue === oldvalue){
       return;
      }
      $('.marvel-device').removeClass(oldvalue);
      $('.marvel-device').addClass(newvalue);
   });

   $scope.$watch('view', function(value) {
     if(value == "landscape"){
       $('.marvel-device').addClass('landscape');
     }else{
       $('.marvel-device').removeClass('landscape');
     }
   });

   $scope.$watch('gridlines', function(value) {
       $('.screen').css('background-image',"url('css/"+value+".svg')");
   });

    /*UI TRANSFORMATIONS*/


   //** EXPORT FUNCTION TO ITERATE AND FORM THE REQUIRED JSON **//
    $scope.export=function(){
        var currentTabIndex=angular.element('.nav-tabs li.active').index()+1;
        $scope.viewChange(currentTabIndex);
        var propertyData=JSON.stringify($scope.componentSelectionJson);
        window.parent.opener.mobilePreviewUpdate(propertyData);
        top.close();
    }
    $scope.cancel=function(){
        top.close()
    }

});
