/**
 * Creates an instance of InfoBox.
 *
 * @author Vignesh Gopalakrishnan
 * @constructor
 * @param {map, props} Map Instance and Addt prop object..
 * @this {InfoBox}
 */
 /* global  L */
function InfoBox(map, props) {
  var mapContainer = map;
  var addProps = props;
  this.getMapContainer = function() {
    return mapContainer;
  };

  this.getProps = function() {
    return addProps;
  };
}
/**
 * A box will be created with the given information on the map.
 * Here it is used to validate sample mode activated or not.
 *
 * @return {null} .
 */
InfoBox.prototype.drawInfoBox = function() {
  var self = this;
  var component = self.getProps();
  // To show a textbox saying it shows sample data
  var info = component.info;
  try {
    self.getMapContainer().removeControl(info);
  } catch (e) {
  }

  info.onAdd = function() {
    this._div = L.DomUtil.create('div', 'info');
    this.update();
    return this._div;
  };

  info.update = function() {
    this._div.innerHTML = '<h4>Sample Mode Activated.</h4>';
  };

  if (this.getProps().samplePreview()) {
    info.addTo(self.getMapContainer());
  }
};
