/* global  L */
function LeafletMap(props, container) {
  var addProps = props;
  var mapContainer = container;
  var map;
  this.getProps = function() {
    return addProps;
  };

  this.getContainer = function() {
    return mapContainer;
  };

  this.setMap = function(mapObj) {
    map = mapObj;
  };

  this.getMap = function() {
    return map;
  };
}

LeafletMap.prototype.loadMap = function() {
  var self = this;
  //var component = self.getProps();
  //Instantiating the map
  self.map = L.map(self.getContainer()[0],{ center: [ 39.5, -98.35 ], zoom: 4, maxBounds: [ [ -85, -180 ], [ 85, 180 ] ] }).setView([39.5, -98.35], 4);
 
  return self.map;
};

LeafletMap.prototype.loadData = function() {
  var self = this;
  var component = self.getProps();
  var mbAttr = '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors.';
  try{
    component.map.setView(new L.LatLng(component.setInitialLatitude(), component.setInitialLongitude()), component.mapZoomLevel());
  }catch(e){
    //alert(JSON.stringify(e));
  }
    
  component.dragMapToDefault = JSON.stringify({'latlng':[component.setInitialLatitude(),component.setInitialLongitude()],'zoom':component.mapZoomLevel()});

  //alert((component.layerIndex != component.mapLayers()) +'2'+ (component.thunderForestTile!==component.thunderForestLayers()) +'3'+ (component.esriTileName!==component.esriTileLayers()) +'4'+ (component.customBaselayerURL!=component.customBaseURL()) +'5'+ (component.customAttribution !=component.customBaseAttr()))
  if((component.layerIndex != component.mapLayers() || 
      component.thunderForestTile!==component.thunderForestLayers() ||
      component.esriTileName!==component.esriTileLayers() ||
      component.customBaselayerURL!=component.customBaseURL() ||
      component.customAttribution !=component.customBaseAttr())) {
    
      component.customBaselayerURL = component.customBaseURL();
      component.customAttribution = component.customBaseAttr();
      

      if(component.layerIndex!=-1){
        component.map.eachLayer(function (layer) {
          component.map.removeLayer(layer);
        });
      }
      component.layerIndex = component.mapLayers();

    //var mbUrl = 'https://{s}.tiles.mapbox.com/v3/visualbi.jn18f940/{z}/{x}/{y}.png';
    component.thunderForestTile = component.thunderForestLayers();
    var thunderforestURL = 'https://{s}.tile.thunderforest.com/'+component.thunderForestLayers()+'/{z}/{x}/{y}.png';
    if(component.thunderforestKey()!==''){
        thunderforestURL = thunderforestURL+'?apikey='+component.thunderforestKey();
    }
    if(component.mapLayers()==2){
      if(component.customBaseURL().trim()){
        component.customBaselayerURL = component.customBaseURL();
      }

      if(component.customBaseAttr().trim()){
        component.customAttribution = component.customBaseAttr();
      }
    }
    //Loading all the layers everytime - because of Some leaflet issue
    var layerOSM = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
      maxZoom: 19,
      zIndex: -1,
      attribution: mbAttr,
      noWrap: true
    });
    var customBaseLayer = null;
    try{
      if(component.customBaselayerURL && component.customAttribution){
      customBaseLayer = L.tileLayer(component.customBaselayerURL, {
        maxZoom: 18,
        zIndex: -1,
        attribution: component.customAttribution,
        noWrap: true
      });
    }
  }catch(e){
    alert(JSON.stringify(e));// jshint ignore:line
  }
    
    /*var layerMapQuestOSM = L.tileLayer("http://{s}.mqcdn.com/tiles/1.0.0/osm/{z}/{x}/{y}.png", {
      maxZoom: 19,
      zIndex: -1,
      subdomains: ["otile1", "otile2", "otile3", "otile4"],
      attribution: mbAttr,
      noWrap: true
    });*/
    var layerTFL = L.tileLayer(thunderforestURL, {
      maxZoom: 18,
      zIndex: -1,
      attribution: mbAttr,
      noWrap: true
    });
    var layerMapBoxImagery = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
      maxZoom: 19,
      zIndex: -1,
      attribution: mbAttr,
      noWrap: true
    });
   /* var layerMapBox = L.tileLayer(mbUrl, {
      maxZoom: 18,
      attribution: mbAttr,
      noWrap: true
    });*/
    /*var layerOSMTopo = L.tileLayer('http://opentopomap.org/{z}/{x}/{y}.png', {
      maxZoom: 16,
      zIndex: -1,
      attribution: mbAttr,
      noWrap: true
    });*/
    var stamenTonerAttr = 'Map tiles by <a href="http://stamen.com">Stamen Design</a>, under <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a>. Data by <a href="http://openstreetmap.org">OpenStreetMap</a>, under <a href="http://www.openstreetmap.org/copyright">ODbL</a>.';
    var stamen = L.tileLayer('http://{s}.tile.stamen.com/toner/{z}/{x}/{y}.png', {
      attribution: stamenTonerAttr,
      noWrap: true
    });
    var stamenWaterColorAttr = 'Map tiles by <a href="http://stamen.com">Stamen Design</a>, under <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a>. Data by <a href="http://openstreetmap.org">OpenStreetMap</a>, under <a href="http://creativecommons.org/licenses/by-sa/3.0">CC BY SA</a>.';
    var stamenWaterColor = L.tileLayer('http://tile.stamen.com/watercolor/{z}/{x}/{y}.jpg', {
      attribution: stamenWaterColorAttr,
      noWrap: true
    });
	var googleRoadMap;
	var googleSatellite; 
	var googleTerrain;
	var googleHybrid;
	var leafletESRI;
try{
    googleRoadMap = L.gridLayer.googleMutant({
      type: 'roadmap'
    });
    googleSatellite = L.gridLayer.googleMutant({
      type: 'satellite'
    });
    googleTerrain = L.gridLayer.googleMutant({
      type: 'terrain'
    });
    googleHybrid = L.gridLayer.googleMutant({
      type: 'hybrid'
    });
    leafletESRI = L.esri.basemapLayer(component.esriTileLayers());
}catch(e){
	console.log(e+'layer not loaded'); // jshint ignore:line
	googleRoadMap = googleSatellite = googleTerrain = googleHybrid = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
      maxZoom: 19,
      zIndex: -1,
      attribution: mbAttr,
      noWrap: true
    });
}
    component.esriTileName=component.esriTileLayers();
    var layers = [
          layerOSM,
          layerMapBoxImagery,
          customBaseLayer,
          stamenWaterColor,
          stamen,
          layerTFL,
          googleRoadMap,
          googleSatellite,
          googleTerrain,
          googleHybrid,
          leafletESRI
        ];

   /* if (component.layerIndex >= 0 ) {
      component.map.removeLayer(layers[component.layerIndex]);
    }*/
    //if(component.layerIndex!=component.mapLayers()){
    if(layers[component.mapLayers()]){
	layers[_.parseInt(component.mapLayers())].addTo(component.map);

    
    layers[_.parseInt(component.mapLayers())].on('load', function() {
      component.isMapLoaded = true;
    });
	} 
    //}
    component.baseLayers = {
      //'Custom Baselayer': customBaseLayer,
      'OpenStreetMap': layerOSM,
      "Water Color": stamenWaterColor,
      'Thunderforest': layerTFL,
      'Stamen': stamen,
      'ESRI': leafletESRI,
      'Google Roadmap': googleRoadMap,
      'Google Satellite': googleSatellite,
      'Google Terrain': googleTerrain,
      'Google Hybrid': googleHybrid
    };
    if(customBaseLayer){
      component.baseLayers['Custom BaseLayer'] = customBaseLayer;
    }
   /*component.googleBaseLayers = {
        'Google Roadmap': googleRoadMap,
        'Google Satellite': googleSatellite,
        'Google Terrain': googleTerrain,
        'Google Hybrid': googleHybrid
    };*/
  }

  //Can Add Control Scale- Working feature just commented out.
  /*component.controlScale.options.position='topright';
  component.controlScale.options.imperial=false;
  component.controlScale.options.metric=true;
  component.controlScale.addTo(component.map);*/


  var _latt = component.setInitialLatitude(), _lngg = component.setInitialLongitude();
  component.mapMarker(JSON.stringify(L.latLng(_latt, _lngg)));
  if (component.mapMarker()) {
    _latt = JSON.parse(component.mapMarker()).lat;
    _lngg = JSON.parse(component.mapMarker()).lng;
  }
  //Setting the zoom level for map.
  if (component.zoomLevel !== 0 && component.zoomLevel != component.mapZoomLevel()) {
    component.mapZoomLevel(component.zoomLevel);
  }

  if (!isNaN(component.mapZoomLevel()) && component.mapZoomLevel() <= 18 && component.mapZoomLevel() > 0) {
    component.zoomLevel = component.mapZoomLevel();
  } else {
    component.mapZoomLevel(4);
    component.zoomLevel = 4;
  }

  if (component.isGeoFencing()) {
    if (navigator.geolocation) {
      var startPos;
	  //var zoom = component.zoomLevel;
      var geoSuccess = function(position, zoom) {
        startPos = position;
        _latt = startPos.coords.latitude;
        _lngg = startPos.coords.longitude;
        component.map.setView(new L.LatLng(_latt, _lngg),zoom);
      };

      navigator.geolocation.getCurrentPosition(geoSuccess);
    } else {
      alert('Geolocation is not supported by this browser.'); // jshint ignore:line
    }
  }
  //component.map.setView(new L.LatLng(_latt, _lngg), component.zoomLevel);
  component.map.invalidateSize();
  component.map.options.maxZoom = component.maxZoomLevel();
  
  //Changing z-index of properties on map.
  $('.leaflet-top').css('z-index', '1');
  $('.leaflet-bottom').css('z-index', '1');
  $('.leaflet-top.leaflet-right').css('z-index','1');
  //if(!component.browser)
    //self.getContainer().append('<div class="overlay" style="opacity:0; filter: alpha(opacity = 0); position:absolute; top:0; bottom:0; left:0; right:0; display:block; z-index:1000; background:transparent;"></div>')
  
  //Pushing back all the map tiles back from 400
  $('.leaflet-pane').css('z-index','0');
  //Resetting zoomlevel
  component.zoomLevel = 0;
};
