function VbiNumberFormat(){
}


/**
Wraps the html for a given string
*/
function wrapHtml(htmlAttrs,value) {
    var wrappedContent = value;
    _.each(Object.keys(htmlAttrs),function(key){
        if(key === "bold"){
            wrappedContent = "<b>" + wrappedContent + "</b>";
        }
        if(key === "italic") {
            wrappedContent = "<i>" + wrappedContent + "</i>";
        }
        if(key === "underline") {
            wrappedContent = "<u>" + wrappedContent + "</u>";
        }
        if(key === "color") {
            wrappedContent = "<span style='color:" + htmlAttrs[key] + "'>" + wrappedContent + "</span>";
        }
        if(key === "size") {
            if(htmlAttrs[key] === 'small')
              htmlAttrs[key] = 'xx-small';
            if(htmlAttrs[key] === 'huge')
              htmlAttrs[key] = 'x-large';
            wrappedContent = "<span style='font-size:" + htmlAttrs[key] + "'>" + wrappedContent + "</span>";
        }
    });
    return wrappedContent;
}


VbiNumberFormat.prototype.getmeasure_col_index = function(that) {
  var   dataResultValue = that.result();
  if (dataResultValue && dataResultValue.dimensions) {
    for (var i = 0; i < dataResultValue.dimensions.length; i++) {
      if (dataResultValue.dimensions[i].containsMeasures == true && dataResultValue.dimensions[i].axis == 'COLUMNS') {
        return i;
      }
    }
  }

  return -1;
};

VbiNumberFormat.prototype.getMeasuresNamesForFormatter = function(that) {

    var dataResultValue = that.dataRes;
    if (dataResultValue && dataResultValue.dimensions) {
        var measureArray = [];
        for (var i = 0; i < dataResultValue['axis_columns'].length; i++) {
            var ColName = '';
            var colText = '';
            var tempColumn = dataResultValue['axis_columns'][i];
            var MeasureMemberKey = '';
            var MeasureMemberText = '';
            for (var k = 0; k < tempColumn.length; k++) {
                if (tempColumn[k] != -1) {
                    if (ColName !== '') {
                        colText = colText + '/ ' + dataResultValue.dimensions[k].members[tempColumn[k]].text
                        ColName = ColName + dataResultValue.dimensions[k].members[tempColumn[k]].key;
                    } else {
                        ColName = dataResultValue.dimensions[k].members[tempColumn[k]].key;
                        colText = dataResultValue.dimensions[k].members[tempColumn[k]].text;
                    }
                }
            }
            measureArray.push({
                'key': ColName,
                'text': colText
            });
        }
        return JSON.stringify(measureArray);
    }

    return [];

};

VbiNumberFormat.prototype.getDimensionsNamesForFormatter = function(that) {
    var dataResultValue = that.dataRes;
    if (dataResultValue && dataResultValue.dimensions) {
        var rowArrayMatrix = [];
        _.each(dataResultValue.dimensions, function(element, index, arr) {
            if (element.axis === "ROWS") {
                rowArrayMatrix.push({
                    'key': element.key,
                    'text': element.text
                });
            }
        });
        return JSON.stringify(rowArrayMatrix);
    }

    return [];

};


 VbiNumberFormat.prototype.getScalingUnitNumberAbbreviation = function(val, returnWithValue){
    var numericSymbol = ['K', 'M', 'G', 'T', 'P', 'E'];
    var res = val;
    var chosenSymbol;
    var finalString;
    if (val && val >= 1000) {
        for (var i = 0, len = numericSymbol.length; i < len; i++) {
            res = res / 1000;
            if (res < 1000 || i === (len - 1)) {
                chosenSymbol = numericSymbol[i];
                break;
            }
        }
    }
    if (chosenSymbol) {
        finalString = returnWithValue ? (res % 1 ? res.toFixed(2) : res) + chosenSymbol : chosenSymbol;
    } else {
        finalString = returnWithValue ? res : '';
    }
    return finalString;
};
VbiNumberFormat.prototype.datalabelScaling = function(index, y, that, keyval) {
    if(!keyval){
        return ['',y,'','','',''];
    }
    var measureNames = [];
    var measureIndex = [];
    var measureKey = [];
    var dataResultValue;
    if (that.CID == 'solidgauge' || that.CID == 'progressbar' || that.CID == 'angulargauge') {
        dataResultValue = that.fulljson();
    }else if(that.CID === 'CCounter'){
        dataResultValue = that.countervalue();
    }else if(that.CID === 'NumCounter'){
        dataResultValue = that.source();
    } else {
        dataResultValue = that.dataRes || that.result();
    }
    //console.log(that.source());
    if (dataResultValue && dataResultValue.dimensions) {
        if (that.CID != 'ganttChart') {
            if (that.chartmeasurechange && that.chartmeasurechange()) {
                var xaxisname = JSON.parse(that.chartmeasurechange());
            }
        }

        for (var i = 0; i < dataResultValue.dimensions.length; i++) {
            if (dataResultValue.dimensions[i].containsMeasures) {
                for (var j = 0; j < dataResultValue.dimensions[i].members.length; j++) {
                    that.keyfigureIndex = i;
                    if (that.CID != 'ganttChart') {
                        if (that.chartmeasurechange && that.chartmeasurechange() && xaxisname) {
                            if (xaxisname[dataResultValue.dimensions[i].members[j].key] != '' && xaxisname[dataResultValue.dimensions[i].members[j].key] != undefined) {
                                measureNames.push(xaxisname[dataResultValue.dimensions[i].members[j].key]);
                            } else {
                                measureNames.push(dataResultValue.dimensions[i].members[j].text);
                            }
                        } else {
                            measureNames.push(dataResultValue.dimensions[i].members[j].text);
                        }
                    } else {
                        measureNames.push(dataResultValue.dimensions[i].members[j].text);
                    }


                    measureKey.push(dataResultValue.dimensions[i].members[j].key);
                    measureIndex.push(j);
                }
            }
        }
    }

    var scalingFactorinDS = '';
    var unitValinDS = '';
    var sindex = '';
    var seriesName = '';
    if (keyval != undefined && keyval != '') {
        sindex = $.inArray(keyval, measureKey);
        seriesName = measureNames[sindex];
    } else {
        sindex = $.inArray(index, measureIndex);
        seriesName = measureNames[sindex];
    }

    if (that.CID == 'superCombination' && seriesName == undefined) {
        var seriesName = 'Average';
    }

    if (sindex != -1) {
        if (dataResultValue.dimensions[that.keyfigureIndex].members[sindex].scalingFactor != undefined) {
            scalingFactorinDS = dataResultValue.dimensions[that.keyfigureIndex].members[sindex].scalingFactor;
            unitValinDS = dataResultValue.dimensions[that.keyfigureIndex].members[sindex].unitOfMeasure;
        } else {
            scalingFactorinDS = '';
            unitValinDS = '';
        }
    }

    var dataLabelScalingFactorString = '';
    var dataLabelScalingFactor = that.scalingfactor();
    var usedScalingFactor = 0;
    if (that.scalingfactorenable() == true) {
        if (dataLabelScalingFactor == -1 || dataLabelScalingFactor == '') {
            dataLabelScalingFactorString = ' (* ' + Math.pow(10, scalingFactorinDS) + ')';
            usedScalingFactor = scalingFactorinDS;
        } else {
            dataLabelScalingFactorString = ' (* ' + Math.pow(10, dataLabelScalingFactor) + ')';
            usedScalingFactor = dataLabelScalingFactor;
        }
    }

    if (that.CID == 'bullet') {
        if (that.scalingfactorperformancemeasure() === 0) {
            var scalingFactorVal = Math.pow(10, that.scalingfactorperformancemeasure());
        } else if (that.scalingfactorperformancemeasure() == -1 || !that.scalingfactorperformancemeasure()) {
            var scalingFactorVal = Math.pow(10, scalingFactorinDS);
        } else {
            var scalingFactorVal = Math.pow(10, that.scalingfactorperformancemeasure());
        }
    } else {
        var scalingFactorVal = Math.pow(10, scalingFactorinDS);
    }

    var originalValue = y * scalingFactorVal;

    if (that.scalingfactorenable() == true && dataLabelScalingFactor) {
        if (dataLabelScalingFactor != -1) {
            var newPointVal = originalValue / Math.pow(10, dataLabelScalingFactor);
        } else {
            /*if(that.CID == 'bullet')
              var newPointVal = originalValue;
            else*/
            var newPointVal = y;
        }
    } else {
        /*if(that.CID == 'bullet')
          var newPointVal = originalValue;
        else*/
        var newPointVal = y;
    }

    var dataLabelUnitVal = '';
    if(that.unitcurrency !== undefined && that.unitcurrency() && unitValinDS){ //for drilldown chart
        dataLabelUnitVal = '(in ' + unitValinDS + ')';
    }else if (that.showunit() && unitValinDS) {
        dataLabelUnitVal = '(in ' + unitValinDS + ')';
    }else{
        dataLabelUnitVal = '';
    }

    var newSeriesName = seriesName;
    return [newSeriesName, newPointVal, dataLabelUnitVal, scalingFactorinDS, usedScalingFactor, dataLabelScalingFactorString];
};


VbiNumberFormat.prototype.barFamilyFormatterDataLabel = function(objarr, that, decimalseptool, thousandseptool, is_chart_container) {
  try {
    var self = this;
    var customdatalabel = that.customdatalabel();
    if (customdatalabel) {
      customdatalabel = JSON.parse(that.customdatalabel());
    }

    var getDimensionKeyIndex = function(result, key) {
      var index;
      _.each(that.dataRes.dimensions, function(e, i, array) {
        if (e.key == key) {
          index = i;
        }
      });
      return index;
    };

    var measurekey = function(result) {
      var index;
      _.any(that.dataRes.dimensions, function(e, i, array) {
        if (e.containsMeasures) {
          index = i;
          return true;
        }
      });
      return index;
    };


    var prefix = "";
    var suffix = '';
    that.generateHTML = "";

    var getDimensionName = function(dimensionName, tooltipkeytext) {
      var dimensionName = that.dataRes.dimensions[dimensionName];
      switch (tooltipkeytext) {
        case 'key':
        return dimensionName.key;
        break;
        case 'text':
        return dimensionName.text;
        break;
        case 'keyandtext':
        return dimensionName.key + " " + dimensionName.text;
        break;
        case 'textandkey':
        return dimensionName.text + " " + dimensionName.key;
        break;
      }
    }; //Dimension Name

    var getDimensionMemberName = function(dimensionName, dimensionMemberName, tooltipkeytext) {
      var dimensionMember = that.dataRes.dimensions[dimensionName].members[dimensionMemberName];
      switch (tooltipkeytext) {
        case 'key':
        return dimensionMember.key;
        break;
        case 'text':
        return dimensionMember.text;
        break;
        case 'keyandtext':
        return dimensionMember.key + ' ' + dimensionMember.text;
        break;
        case 'textandkey':
        return dimensionMember.text + ' ' + dimensionMember.key;
        break;
      }
    }; //Dimension Member Name

    var dimensionIndexGlobal;
    var measureIndexGLobal;
    var tuppleArray = [];
    /**
    *Checking with Regexp
    *{{checking postion-key}}
    *Once the position is identified then modifying the text according to that without change the HTML
    **/

    var tooltipHtml = "";
    _.each(customdatalabel.ops, function(element, index, arr) {

      /**
      * If it it Dimension Name
      **/
      if (element.insert.mention != undefined) {
        var id = element.insert.mention.id;
        var displayType = element.insert.mention.display;
        switch (element.insert.mention.type) {
          case "Dimension":
          if(id =="Default Dimension"){
            var member = that.categoriesIndex[objarr.point.x].split('-');
            var dimension = "";
            var memberList = function(item, index, list) {
              if(index >0){
                dimension += "/";
              }
              dimension += getDimensionName(item[0], displayType);
            };
            _.each(member, memberList);
          }else{
            var dimensionIndex = getDimensionKeyIndex(that.dataRes, id);
            var dimension = getDimensionName(dimensionIndex, displayType);
          }
          var attributes = element.attributes != undefined ? element.attributes : {};
          tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
          break;

          case "DimensionMember":
          var dimensionIndex = getDimensionKeyIndex(that.dataRes, id);
          var member = that.categoriesIndex[objarr.point.x].split('-');

          var dimensionName, dimensionMemberName;
          if(id =="Default Dimension"){
            var dimension = "";
            var memberList = function(item, index, list) {
              if(index >0){
                dimension += "/";
              }
              dimension += getDimensionMemberName(item[0], item[2], displayType);
            };
            _.each(member, memberList);
          }else{
            var memberList = function(item, index, list) {
              if (item[0] == dimensionIndex) {
                dimensionName = item[0];
                dimensionMemberName = item[2];
              }
            };
            _.each(member, memberList);
            var dimension = getDimensionMemberName(dimensionName, dimensionMemberName, displayType);
          }
          var attributes = element.attributes != undefined ? element.attributes : {};
          tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
          break;
          case "Measure":
          self.measureIndex = undefined;
          self.measureObject = JSON.parse(that.getMeasuresNamesForFormatter());
          _.each(self.measureObject, function(e, i, arr) {
            if (e.key == id) {
              self.measureIndex = i;
            }
          });
          if (self.measureIndex == undefined) {
            if(that.customdatalabelFamily == undefined){
              self.measureIndex = objarr['point']['series']['index'];
            }else {
              self.measureIndex = objarr.point.series.userOptions.index
            }
          }
          var measure = "";
          _.each(that.dataRes['axis_columns'][self.measureIndex], function(e, i, arr) {
            if (e !== -1) {
              if(i>0){
                measure += '-';
              }
              measure += getDimensionMemberName(i, e, displayType);
            }
          });
          var attributes = element.attributes != undefined ? element.attributes : {};
          tooltipHtml = tooltipHtml + wrapHtml(attributes, measure);
          break;

          case "MeasureValue":
          self.measureIndex = undefined;
          self.measureObject = JSON.parse(that.getMeasuresNamesForFormatter());
          _.each(self.measureObject, function(e, i, arr) {
            if (e.key == id) {
              self.measureIndex = i;
            }
          });
          if (self.measureIndex == undefined) {
            if(that.customdatalabelFamily == undefined){
              self.measureIndex = objarr['point']['series']['index'];
            }else {
              self.measureIndex = objarr.point.series.userOptions.index
            }
          }
          var tuppleArray = [];
          _.each(that.dataRes['axis_columns'][self.measureIndex], function(e, i, arr) {
            if (e !== -1) {
              tuppleArray[i] = e;
            }
          });

          _.each(that.dataRes['axis_rows'][objarr['point']['index']], function(e, i, arr) {
            if (e !== -1) {
              tuppleArray[i] = e;
            }
          });
          var tupleIndex = undefined;
          _.filter(that.dataRes['tuples'], function(num, index) {
            if (_.isEqual(num, tuppleArray)) {
              tupleIndex = index;
              return index;
            }
          });

          var dataValue = that.dataRes['data'][tupleIndex];
          var measureIndex = measurekey(that.dataRes);
          var keyval = that.dataRes.dimensions[measureIndex].members[tuppleArray[measureIndex]].key;

          var percentVal = false;
          if(that.numberFormatDefinition == undefined){
            var measureVal = dataValue;
          }
          else if(that.numberFormatDefinition() === 'initialView'){
            var measureVal = self.processDataLabelInitialView(objarr,that,keyval,dataValue);
          }
          else{
            var measureVal = self.processDataLabel(that,objarr,keyval,is_chart_container,decimalseptool,thousandseptool,percentVal,dataValue);
          }
          var attributes = element.attributes != undefined ? element.attributes : {};
          tooltipHtml = tooltipHtml + wrapHtml(attributes, measureVal);
        }
      } else {
        var attributes = element.attributes != undefined ? element.attributes : {};
        if (element.insert.split("\n").length > 1) {
          var newLine = element.insert.split("");
          _.each(newLine, function(value) {
            if (value === "\n") //represents "\n"
            tooltipHtml = tooltipHtml + wrapHtml(attributes, "<br />");
            else
            tooltipHtml = tooltipHtml + wrapHtml(attributes, value);
          })
        } else
        tooltipHtml = tooltipHtml + wrapHtml(attributes, element.insert);
      }
    });
    return tooltipHtml;
  } catch (e) {

  }

};
VbiNumberFormat.prototype.bulletTextFormatter = function(objarr,that,decimalseptool,thousandseptool,is_chart_container,valueBullet){
  var self = objarr;
  var component = that;
  var valueBullet = valueBullet;
  var customdatalabel = component.customdatalabel();
  if (customdatalabel) {
      customdatalabel = JSON.parse(component.customdatalabel());
  }

  var getDimensionKeyIndex = function(result, key) {
      var index;
      _.each(component.result().dimensions, function(e, i, array) {
          if (e.key == key) {
              index = i;
          }
      });
      return index;
  };

  var measurekey = function(result) {
      var index;
      _.any(component.result().dimensions, function(e, i, array) {
          if (e.containsMeasures) {
              index = i;
              return true;
          }
      });
      return index;
  };


  var prefix = "";
  var suffix = '';
  component.generateHTML = "";

  var getDimensionName = function(dimensionName, tooltipkeytext) {
      var dimensionName = component.dataRes.dimensions[dimensionName];
      switch (tooltipkeytext) {
          case 'key':
              return dimensionName.key;
              break;
          case 'text':
              return dimensionName.text;
              break;
          case 'keyandtext':
              return dimensionName.key + " " + dimensionName.text;
              break;
          case 'textandkey':
              return dimensionName.text + " " + dimensionName.key;
              break;
      }
  }; //Dimension Name

  var getDimensionMemberName = function(dimensionName, dimensionMemberName, tooltipkeytext) {
      var dimensionMember = component.dataRes.dimensions[dimensionName].members[dimensionMemberName];
      switch (tooltipkeytext) {
          case 'key':
              return dimensionMember.key;
              break;
          case 'text':
              return dimensionMember.text;
              break;
          case 'keyandtext':
              return dimensionMember.key + ' ' + dimensionMember.text;
              break;
          case 'textandkey':
              return dimensionMember.text + ' ' + dimensionMember.key;
              break;
      }
  }; //Dimension Member Name

  var dimensionIndexGlobal;
  var measureIndexGLobal;
  var tuppleArray = [];
  /**
   *Checking with Regexp
   *{{checking postion-key}}
   *Once the position is identified then modifying the text according to component without change the HTML
   **/

  var tooltipHtml = "";
  _.each(customdatalabel.ops, function(element, index, arr) {

      /**
       * If it it Dimension Name
       **/
      if (element.insert.mention != undefined) {
          var id = element.insert.mention.id;
          var displayType = element.insert.mention.display;
          switch (element.insert.mention.type) {
              case "Dimension":
                      var member = self.point.rowIndex.split('-');
                      var dimension = "";
                      var memberList = function(item, index, list) {
                         if(index >0){
                          dimension += "/";
                         }
                         dimension += getDimensionName(item[0], displayType);
                      };
                      _.each(member, memberList);
                  var attributes = element.attributes != undefined ? element.attributes : {};
                  tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
                  break;

              case "DimensionMember":
                  var dimensionIndex = getDimensionKeyIndex(component.result(), id);
                  var member =  self.point.rowIndex.split('-');
                  var dimensionName, dimensionMemberName;
                  var dimension = "";
                  var memberList = function(item, index, list) {
                      if(index >0){
                          dimension += "/";
                      }
                      dimension += getDimensionMemberName(item[0], item[2], displayType);
                  };
                  _.each(member, memberList);
                  var attributes = element.attributes != undefined ? element.attributes : {};
                  tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
                  break;
              case "Measure":
                  var measureIndex = objarr.point.series.userOptions.key.split('-');
                  var dimensionName, dimensionMemberName;
                  var dimension = "";
                  var memberList = function(item, index, list) {
                    if(item == "")
                    return;
                      if(index >0){
                          dimension += "/";
                      }
                      dimension += getDimensionMemberName(item[0], item[2], displayType);
                  };
                  _.each(measureIndex, memberList);
                  var attributes = element.attributes != undefined ? element.attributes : {};
                  tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
                  break;

              case "MeasureValue":
                  var attributes = element.attributes != undefined ? element.attributes : {};
                  tooltipHtml = tooltipHtml + wrapHtml(attributes, valueBullet);
          }
      } else {
          var attributes = element.attributes != undefined ? element.attributes : {};
          if (element.insert.split("\n").length > 1) {
              var newLine = element.insert.split("");
              _.each(newLine, function(value) {
                  if (value === "\n") //represents "\n"
                      tooltipHtml = tooltipHtml + wrapHtml(attributes, "<br />");
                  else
                      tooltipHtml = tooltipHtml + wrapHtml(attributes, value);
              })
          } else
              tooltipHtml = tooltipHtml + wrapHtml(attributes, element.insert);
      }
  });
  return tooltipHtml;
};
VbiNumberFormat.prototype.drillDownFamilyFormatterDataLabel = function(objarr, that, decimalseptool, thousandseptool, is_chart_container) {
  try {
    var self = this;
    var customdatalabel = that.customdatalabel();
    if (customdatalabel) {
        customdatalabel = JSON.parse(that.customdatalabel());
    }

    var getDimensionKeyIndex = function(result, key) {
        var index;
        _.each(that.dataRes.dimensions, function(e, i, array) {
            if (e.key == key) {
                index = i;
            }
        });
        return index;
    };

    var getMeasureKeyIndexVal = function(result, key) {
    var index;
    _.each(that.dataRes.dimensions[result].members, function(e, i, array) {
      debugger;
        if (e.key == key) {
            index = i;
        }
    });
    debugger;
    return index||0;
  };

    var getDimensionMemberKeyIndex = function(result, key) {
    	var index;
    	_.each(result.members, function(e, i, array) {
    		if (e.key == key) {
    			index = i;
    		}
    	});
    	return index;
    };


    var measurekey = function(result) {
        var index;
        _.any(that.dataRes.dimensions, function(e, i, array) {
            if (e.containsMeasures) {
                index = i;
                return true;
            }
        });
        return index;
    };


    var prefix = "";
    var suffix = '';
    that.generateHTML = "";

    var getDimensionName = function(dimensionName, tooltipkeytext) {
        var dimensionName = that.dataRes.dimensions[dimensionName];
        switch (tooltipkeytext) {
            case 'key':
                return dimensionName.key;
                break;
            case 'text':
                return dimensionName.text;
                break;
            case 'keyandtext':
                return dimensionName.key + " " + dimensionName.text;
                break;
            case 'textandkey':
                return dimensionName.text + " " + dimensionName.key;
                break;
        }
    }; //Dimension Name

    var getDimensionMemberName = function(dimensionName, dimensionMemberName, tooltipkeytext) {
        var dimensionMember = that.dataRes.dimensions[dimensionName].members[dimensionMemberName];
        switch (tooltipkeytext) {
            case 'key':
                return dimensionMember.key;
                break;
            case 'text':
                return dimensionMember.text;
                break;
            case 'keyandtext':
                return dimensionMember.key + ' ' + dimensionMember.text;
                break;
            case 'textandkey':
                return dimensionMember.text + ' ' + dimensionMember.key;
                break;
        }
    }; //Dimension Member Name

    var dimensionIndexGlobal;
    var measureIndexGLobal;
    var tuppleArray = [];
    /**
     *Checking with Regexp
     *{{checking postion-key}}
     *Once the position is identified then modifying the text according to that without change the HTML
     **/

    var tooltipHtml = "";
    _.each(customdatalabel.ops, function(element, index, arr) {
    if (element.insert.mention != undefined) {

                var id = element.insert.mention.id;
                var displayType = element.insert.mention.display;
                switch (element.insert.mention.type) {
              case "Dimension":
                        var dimensionIndex = getDimensionKeyIndex(that.dataRes, id);
                        var dimension = getDimensionName(dimensionIndex, displayType);
                        var attributes = element.attributes != undefined ? element.attributes : {};
                        tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
                        break;

                    case "DimensionMember":
                      try {
                        var dimensionIndex = getDimensionKeyIndex(that.dataRes, id);
                        if(that.CID == "scatter" || that.CID == "bubble"){
                          var dimensionIndexkey = objarr.point.rowIndex;
                          var dimension = getDimensionMemberName(dimensionIndexkey.charAt(0), dimensionIndexkey.charAt(2), displayType);
                        }else if(that.CID == "treeMapDrilldown"){
                          var index = objarr.point.namekey;
                          var dimension = getDimensionMemberName(index.split('-')[0].split(':')[0], index.split('-')[0].split(':')[1], displayType);
                        }else{
                          var index = objarr.point.indexInfo;
                          var dimension = getDimensionMemberName(index.split('-')[0].split(':')[0], index.split('-')[0].split(':')[1], displayType);
                        }
                      } catch (e) {
                        var dimension = '';
                      }
                      var attributes = element.attributes != undefined ? element.attributes : {};
                        tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
                        break;
                    case "Measure":
                        self.measureIndex = undefined;
                        self.measureObject = JSON.parse(that.getMeasuresNamesForFormatter());
                        _.each(self.measureObject, function(e, i, arr) {
                            if (e.key == id) {
                                self.measureIndex = i;
                            }
                        });
                        var measure = "";
                      if(that.CID == "treeMapDrilldown"){
                        var  measureIndexKey  = measurekey(that.treecolormeasure());
                        var measureIndex = getMeasureKeyIndexVal(measureIndexKey[0],that.treecolormeasure());
                         measure = getDimensionMemberName(measureIndex, measureIndexKey, displayType);
                      }else if(that.CID == "scatter" || that.CID == "bubble"){
                        var measureVal = measurekey(that.yaxismeasure());
                        var measureIndex = getMeasureKeyIndexVal(measureVal[0],that.yaxismeasure());
                             measure = getDimensionMemberName(measureIndex, measureVal, displayType);
                      }
                      else{
                          _.each(objarr.point.columnIndexKey.split('-'), function(e, i, arr) {
                          measure += getDimensionMemberName(e.charAt(0), e.charAt(2), displayType);
                      });
                      }
                        var attributes = element.attributes != undefined ? element.attributes : {};
                        tooltipHtml = tooltipHtml + wrapHtml(attributes, measure);
                        break;

                    case "MeasureValue":

                        var measureIndex = objarr.point.series.userOptions.columnIndexKey;
                      if(that.CID == "treeMapDrilldown"){
                      var dataValue = objarr.point.value;
                      var keyval = that.treecolormeasure();
                      }else if(that.CID == "scatter" || that.CID == "bubble"){
                      var keyval =that.xaxismeasure();
                      }
                      else{
                      var dataValue = objarr.y;
                      var keyval = that.dataRes.dimensions[measureIndex.charAt(0)].members[measureIndex.charAt(2)].key;
                      }
                        var percentVal = false;
                        if (that.numberFormatDefinitionTooltip === undefined) {
                            var measureVal = dataValue;
                        } else if (that.numberFormatDefinition() === 'initialView') {
                            var measureVal = self.processDataLabelInitialView(objarr, that, keyval, dataValue,false);
                        } else {
                            var measureVal = self.processDataLabel(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false, dataValue);
                        }

                        var attributes = element.attributes != undefined ? element.attributes : {};
                        tooltipHtml = tooltipHtml + wrapHtml(attributes, measureVal);
                }
            } else {
            var attributes = element.attributes != undefined ? element.attributes : {};
            if (element.insert.split("\n").length > 1) {
                var newLine = element.insert.split("");
                _.each(newLine, function(value) {
                    if (value === "\n") //represents "\n"
                        tooltipHtml = tooltipHtml + wrapHtml(attributes, "<br />");
                    else
                        tooltipHtml = tooltipHtml + wrapHtml(attributes, value);
                })
            } else
                tooltipHtml = tooltipHtml + wrapHtml(attributes, element.insert);
        }
    });
    return tooltipHtml;

  } catch (e) {

  }

};

VbiNumberFormat.prototype.barFamilyDataLabelFormatter = function(objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    if (!that.result()) {
        return that.datalabelprefix() + ' ' + Highcharts.numberFormat(objarr.y, that.decimal(), decimalseptool, thousandseptool) + ' ' + that.datalabelsuffix();
    }

    var measure_col_index = this.getmeasure_col_index(that);
    var is_measure_in_col = that.measureValidation();
    var prefixIndex = 0;
    if (that.CID == 'superCombination') {

        if (is_measure_in_col == 'false' && objarr.point.series.xAxis.userOptions.categorieskey) { //measure is in row
            var keyval = objarr.point.series.xAxis.userOptions.categorieskey[objarr.point.x].split("\\")[0];

        } else { //measure is in col
            var keyval = objarr.point.series.options.uniquekey;
        }
    } else if (that.CID == 'combination') {
        if (that.result().dimensions.length == 1) {
            var keyval = objarr.point.series.options.keyvalue;
        } else if (is_measure_in_col == 'false' && objarr.point.series.xAxis.userOptions.categorieskey) { //measure is in row
            var keyval = objarr.point.series.xAxis.userOptions.categorieskey[objarr.point.x].split("\\")[0];
        } else { //measure is in col
            var keyval = objarr.point.series.options.uniquekey;
        }
    } else if (that.CID == 'bullet') { //console.log(objarr.series.userOptions);
        var keyval = that.result().dimensions[measure_col_index].members[objarr.series.userOptions.key.split('-')[0].split(':')[1]].key;
    } else if (is_measure_in_col == 'false' && objarr.point.series.xAxis.userOptions.measurecategories != '' && objarr.point.series.xAxis.userOptions.measurecategories != undefined) {
        var keyval = objarr.point.series.xAxis.userOptions.measurecategories[objarr.point.x];
    } else if (objarr.point.series.options.keyvalue || objarr.point.series.options.nameAsKey || objarr.point.series.options.name) {
        if (that.CID == 'dualAxes' || that.CID == 'multipleAxes' || that.CID == 'columnBar') {
            if (that.CID != 'columnBar')
                var keyval = objarr.point.series.options.nameAsKey.split('/')[measure_col_index].trim();
            else
                var keyval = objarr.point.series.options.uniquekey;
        } else {

            if (that.CID == 'fixedColumn' || that.CID == 'area' || that.CID == 'line' || that.CID == 'radar' || that.CID == 'polar' || that.CID == 'stackedColumnBar' || that.CID == 'stackedArea' || that.CID == 'groupStacked')
                var keyval = objarr.point.series.options.uniquekey;
            else
                var keyval = objarr.point.series.options.keyvalue;
        }

    } else {
        var keyval = objarr.point.series.options.uniquekey;
    }
    //  console.log(keyval);
    that.generateHTML = "";
    if(that.numberFormatDefinition() === 'initialView'){
        return self.processDataLabelInitialView(objarr,that,keyval);
    }
    else{
        return self.processDataLabel(that,objarr,keyval,is_chart_container,decimalseptool,thousandseptool,false);
    }
    return that.generateHTML;

    //////////////////////

    function getDimensionName() {
        var nameToReturn = '';
        switch (datalabelkeytext) {
            case 'key':
                nameToReturn =  that.dataRes.dimensions[dimensionName].key;
                break;
            case 'text':
                nameToReturn = that.dataRes.dimensions[dimensionName].text;
                break;
            case 'keyandtext':
               nameToReturn = that.dataRes.dimensions[dimensionName].key + " " + that.dataRes.dimensions[dimensionName].text;
                break;
            case 'textandkey':
                nameToReturn = that.dataRes.dimensions[dimensionName].text + " " + that.dataRes.dimensions[dimensionName].key;
                break;
        }
        return nameToReturn;
    }; //Dimension Name

    function getDimensionMemberName() {
        var nameToReturn = '';
        switch (datalabelkeytext) {
            case 'key':
                nameToReturn = that.dataRes.dimensions[dimensionName].members[dimensionMemberName].key;
                break;
            case 'text':
                nameToReturn = that.dataRes.dimensions[dimensionName].members[dimensionMemberName].text;
                break;
            case 'keyandtext':
                nameToReturn = that.dataRes.dimensions[dimensionName].members[dimensionMemberName].key + ' ' + that.dataRes.dimensions[dimensionName].members[dimensionMemberName].text;
                break;
            case 'textandkey':
                nameToReturn = that.dataRes.dimensions[dimensionName].members[dimensionMemberName].text + ' ' + that.dataRes.dimensions[dimensionName].members[dimensionMemberName].key;
                break;
        }
        return nameToReturn;
    }; //Dimension Member Name

    function measureMemberValue() {
        var formattedValue = Highcharts.numberFormat(tooltiparr[1], that.decimal(), decimalseptool, thousandseptool);
        var baseString = self.processSemanticFormatting(tooltiparr[1], formattedValue, semanticFormattingOptions);
        baseString = self.processUnitPlacement(dataLabelUnitVal, unitPlacement, baseString);
        baseString = self.processScalingUnitPlacement(scalingUnit, scalingUnitPlacement, baseString);
        baseString = prefix + ' ' + baseString + ' ' + suffix;
        that.generateHTML += dataLabelScalingFactorString + '' + baseString;
        //that.generateHTML += tooltipscalingUnit + '' + tooltipUnitVal + ' ' + prefix + ' ' + Highcharts.numberFormat(tooltiparr[1], that.datavaluedecimals(), decimalseptool, thousandseptool) + ' ' + suffix;
    };

    function dimensionValue(value) {
        that.generateHTML += '' + getDimensionName();
    };

    function dimensionMemberValue(value) {
        that.generateHTML += ' ' + getDimensionMemberName();
    };

    function measureValue(value) {
        that.generateHTML += ' ' + tooltiparr[0];
    };

    function getMemberNameValue(value) {
        switch (value) {
            case 'dim':
                dimensionValue();
                break;
            case 'dval':
                dimensionMemberValue();
                break;
            case 'measure':
                measureValue();
                break;
            case 'mval':
                measureMemberValue();
                break;
        }
    };
};

VbiNumberFormat.prototype.processDataLabelInitialView = function (objarr,that,keyval,dataValue,appendPercenatge) {
    if(dataValue === undefined){
        dataValue = objarr.y;
    }
    var self = this;
    var memberInfo = self.getFormatString(that, keyval);
    var formatString =  memberInfo.formatString.split(';')[0]; // eg. "#,##0.000;'-'#,##0.000"
    var rawValue = dataValue;
    var initialViewOptions = self.getInitialViewNumberFormat(rawValue, formatString);
    var dataLabelScalingFactorString =keyval ? self.getScalingFactorString(that, keyval) : '';
    var semanticFormattingOptions = {
        'enableSemanticFormatting': that.enableSemanticFormatting(),
        'negativeValueSemanticFormat': that.negativeValueSemanticFormat(),
        'negativeValueSemanticFormatColor': that.negativeValueSemanticFormatColor(),
        'positiveValueSemanticFormat': that.positiveValueSemanticFormat(),
        'positiveValueSemanticFormatColor': that.positiveValueSemanticFormatColor()
    };
    self.numberFormatOptions = {
        'noOfDecimals': initialViewOptions.noOfDecimals,
        'decimalSeparator' : initialViewOptions.decimalSeparator,
        'thousandSeparator' : initialViewOptions.thousandSeparator,
        'y': rawValue,
        'semanticFormattingOptions' : semanticFormattingOptions,
        'unit':initialViewOptions.unit ? '(in ' + initialViewOptions.unit + ')' : '',
        'unitPlacement': '10$',
        'percent': false,
        'scalingFactor': dataLabelScalingFactorString,
        'appendPercenatge' : appendPercenatge
    };

    var composedProcess = self.getInitialViewComposedProcess();
    that.generateHTML = composedProcess();
    //that.generateHTML = categoryInfo.dimension + ' ' + categoryInfo.member + '<br/>' + that.generateHTML;
    return that.generateHTML;
};

VbiNumberFormat.prototype.processTooltipInitialView = function (objarr,that,keyval,percentVal,dataValue,appendPercenatge) {
    if(dataValue === undefined){
        dataValue = objarr.y;
    }
    var self = this;
    var memberInfo = this.getFormatString(that, keyval);
    var formatString =  memberInfo.formatString.split(';')[0]; // eg. "#,##0.000;'-'#,##0.000"
    var rawValue = percentVal?objarr.percentage : dataValue;
    var tooltipScalingFactor = keyval ? self.getScalingFactorString(that, keyval) : '';
    var initialViewOptions = this.getInitialViewNumberFormat(rawValue, formatString);
    var semanticFormattingOptions = {
        'enableSemanticFormatting': that.enableSemanticFormattingTooltip(),
        'positiveValueSemanticFormat': that.positiveValueSemanticFormatTooltip(),
        'positiveValueSemanticFormatColor': that.positiveValueSemanticFormatColorTooltip(),
        'negativeValueSemanticFormat': that.negativeValueSemanticFormatTooltip(),
        'negativeValueSemanticFormatColor': that.negativeValueSemanticFormatColorTooltip()
    };
    self.numberFormatOptions = {
        'noOfDecimals': initialViewOptions.noOfDecimals,
        'decimalSeparator' : initialViewOptions.decimalSeparator,
        'thousandSeparator' : initialViewOptions.thousandSeparator,
        'y': rawValue,
        'semanticFormattingOptions' : semanticFormattingOptions,
        'unit':initialViewOptions.unit ? '(in ' + initialViewOptions.unit + ')' : '',
        'unitPlacement': '10$',
        'percent': percentVal,
        'scalingFactor': tooltipScalingFactor,
        'appendPercenatge' : appendPercenatge
    };

    var composedProcess = self.getInitialViewComposedProcess();
    generatedHtml = composedProcess();
    return generatedHtml;
};

VbiNumberFormat.prototype.tooltipScaling = function (index, y, that, keyval, isErrorBar, hcObj) {
    if(!isErrorBar && !keyval){
        return ['',y,'','','',''];
    }
    var measureNames = [];
    var measureIndex = [];
    var measureKey = [];
    var dataResultValue;
    if (that.CID == 'solidgauge' || that.CID == 'progressbar' || that.CID == 'angulargauge') {
        dataResultValue = that.fulljson();
    } else if(that.CID === 'CCounter'){
        dataResultValue = that.countervalue();
    } else if(that.CID === 'NumCounter'){
        dataResultValue = that.source();
    } else{
        dataResultValue = that.dataRes || that.result();
    }
    //console.log(that.source());
    if (dataResultValue && dataResultValue.dimensions) {
        if (that.CID != 'ganttChart') {
            if (that.chartmeasurechange && that.chartmeasurechange()) {
                var xaxisname = JSON.parse(that.chartmeasurechange());
            }
        }

        for (var i = 0; i < dataResultValue.dimensions.length; i++) {
            if (dataResultValue.dimensions[i].containsMeasures) {
                for (var j = 0; j < dataResultValue.dimensions[i].members.length; j++) {
                    that.keyfigureIndex = i;
                    if (that.CID != 'ganttChart') {
                        if (that.chartmeasurechange && that.chartmeasurechange() && xaxisname) {
                            if (xaxisname[dataResultValue.dimensions[i].members[j].key] != '' && xaxisname[dataResultValue.dimensions[i].members[j].key] != undefined) {
                                measureNames.push(xaxisname[dataResultValue.dimensions[i].members[j].key]);
                            } else {
                                measureNames.push(dataResultValue.dimensions[i].members[j].text);
                            }
                        } else {
                            measureNames.push(dataResultValue.dimensions[i].members[j].text);
                        }
                    } else {
                        measureNames.push(dataResultValue.dimensions[i].members[j].text);
                    }


                    measureKey.push(dataResultValue.dimensions[i].members[j].key);
                    measureIndex.push(j);
                }
            }
        }
    }

    var scalingFactorinDS = '';
    var unitValinDS = '';
    var sindex = '';
    var seriesName = '';
    if (keyval != undefined && keyval != '') {
        sindex = $.inArray(keyval, measureKey);
        seriesName = measureNames[sindex];
    } else {
        sindex = $.inArray(index, measureIndex);
        seriesName = measureNames[sindex];
    }

    if (that.CID == 'superCombination' && seriesName == undefined) {
        var seriesName = 'Average';
    }

    if (sindex != -1) {
        if (dataResultValue.dimensions[that.keyfigureIndex].members[sindex].scalingFactor != undefined) {
            scalingFactorinDS = dataResultValue.dimensions[that.keyfigureIndex].members[sindex].scalingFactor;
            unitValinDS = dataResultValue.dimensions[that.keyfigureIndex].members[sindex].unitOfMeasure;
        } else {
            scalingFactorinDS = '';
            unitValinDS = '';
        }
    }

    var scalingFactTooltip = '';
    var tooltipScalingFact = that.tooltipscalingfactor();
    var usedScalingFactor = '';
    if (that.tooltipscalingfactorenable() == true) {
        if (tooltipScalingFact == -1 || tooltipScalingFact == '-1' || tooltipScalingFact == '') {
            scalingFactTooltip = ' (* ' + Math.pow(10, scalingFactorinDS) + ')';
            usedScalingFactor = scalingFactorinDS;
        } else {
            scalingFactTooltip = ' (* ' + Math.pow(10, tooltipScalingFact) + ')';
            usedScalingFactor = tooltipScalingFact;
        }
    }

    var scalingFactorVal;
    if (that.CID == 'bullet') {
        var hcseries = hcObj.series;
        var scalingFactorInLabel = typeof hcseries.userOptions.scalingFactor == "undefined" ? -1 : hcseries.userOptions.scalingFactor;
        var scalingFactorInValue = scalingFactorInLabel != -1 ? scalingFactorInLabel : scalingFactorinDS;
        scalingFactorVal = Math.pow(10, scalingFactorInValue);

    } else {
        scalingFactorVal = Math.pow(10, scalingFactorinDS);
    }

    var originalValue = y * scalingFactorVal;
    if (that.tooltipscalingfactorenable() == true && tooltipScalingFact != -1) {
        var newPointVal = originalValue / Math.pow(10, tooltipScalingFact);
    } else {
        var newPointVal = y;
        if(that.CID == 'bullet'){
            newPointVal = originalValue / Math.pow(10,scalingFactorinDS);
        }
    }

    var tooltipUnitVal = '';
    if (that.tooltipshowunit() == true && unitValinDS != '' && unitValinDS != undefined) {
        tooltipUnitVal = '(in ' + unitValinDS + ')';
    } else {
        tooltipUnitVal = '';
    }

    var newSeriesName = seriesName;
    return [newSeriesName, newPointVal, tooltipUnitVal, scalingFactorinDS, usedScalingFactor, scalingFactTooltip];
};

VbiNumberFormat.prototype.tooltipScalingFactorValue = function(finaltext, tooltipUnitVal, scalingFactorinDS, scalingfactorenable, showunit, tooltipscalingfactor, tooltipscalingfactorenable, tooltipshowunit) {
  var textbuffer = finaltext.replace(/ *\(in [^)]*\) */g,'');
  finaltext = textbuffer.replace(/\(\*([^)]+)\)/g,'');
  var textwithnewscaling = '';
  if (tooltipscalingfactor == -1)
      var newtooltipscalingfactor = scalingFactorinDS;
  else
      var newtooltipscalingfactor = tooltipscalingfactor;
  if (tooltipscalingfactorenable == true && tooltipshowunit == true) {
    textwithnewscaling = finaltext +  ' ( *' + Math.pow(10, newtooltipscalingfactor) + ') ' + tooltipUnitVal;
  }else if (tooltipshowunit == true && tooltipscalingfactorenable == false) {
    textwithnewscaling = finaltext  + ' ' + tooltipUnitVal;
  }else if (tooltipshowunit == false && tooltipscalingfactorenable == true) {
    textwithnewscaling = finaltext +  ' ( * ' + Math.pow(10, newtooltipscalingfactor) + ')';
  }else {
    textwithnewscaling = finaltext;
  }
  return textwithnewscaling;
};

VbiNumberFormat.prototype.heatMapTooltip = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var dimRes = that.result().dimensions;
    var col_count = 0;
    if(dimRes){
        for (var dim = 0; dim < dimRes.length; dim++) {
            if (dimRes[dim].axis == 'COLUMNS') {
                col_count++;
            }
        }
    }else{
        col_count = 1;
    }

    var final_text1 = objarr.series.xAxis.categories[objarr.point.x].name.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'');
    var final_text2 = objarr.series.yAxis.categories[objarr.point.y].name.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'');
    if (col_count > 1) {
        final_text2 += ' / ' + objarr.series.userOptions.name.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'');
    }
    var data = '';
    if(objarr.point.value){
      var keyval = objarr.point.series.userOptions.uniquekey;
      if(that.result() && that.numberFormatDefinitionTooltip() === 'initialView'){
        data = self.processTooltipInitialView(objarr,that,keyval,false,objarr.point.value);
      }else{
        data = self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false, objarr.point.value);
      }
    }else{
      data = "";
    }

    return final_text1 + '<br>' + final_text2 + ' : '  + data;
};

VbiNumberFormat.prototype.heatMapDatalabel = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var keyval = objarr.point.series.userOptions.uniquekey;
    if(objarr.point.value){
      if(that.numberFormatDefinition() === 'initialView' && that.result()){
          return self.processDataLabelInitialView(objarr, that, keyval, objarr.point.value);
      }else{
          return self.processDataLabel(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false, objarr.point.value);
      }
    }else{
      return ;
    }

};


VbiNumberFormat.prototype.pieFamilyTooltip = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var keyval = objarr.point.series.userOptions.uniquekey;
    var data = self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false);
    var series = objarr.point.name.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'') + ': <br/>' + objarr.series.name.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'') + " : ";
    return series + data;
};

VbiNumberFormat.prototype.pieFamilyDefaultDataLabelFormatter = function (that,defaultValue) {
    if (that.displayformat() == 'both') {
      if (that.datavaluedecimals() != 'auto') {
        defaultValue.plotOptions.pie.dataLabels.formatter = function() {
          return Highcharts.numberFormat(this.percentage, that.decimal(), that.decimalsep, that.thousandsep) + '%<br>' + that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, this.y, that.decimal(), that.decimalsep, that.thousandsep) + ' ' + that.datalabelsuffix();
        };
      }else{
        defaultValue.plotOptions.pie.dataLabels.formatter = function() {
          return Highcharts.numberFormat(this.percentage, that.decimal(), that.decimalsep, that.thousandsep) + '%<br>' + that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, that.decimal(), that.decimalsep, that.thousandsep) + ' ' + that.datalabelsuffix();
        };
      }
    } else if (that.displayformat() == 'percent') {
      if (that.datavaluedecimals() != 'auto') {
        defaultValue.plotOptions.pie.dataLabels.formatter = function() {
          return Highcharts.numberFormat(this.percentage, that.decimal(), that.decimalsep, that.thousandsep) + '%';
        };
      } else {
        defaultValue.plotOptions.pie.dataLabels.formatter = function() {
          return Highcharts.numberFormat(this.percentage, that.decimal(), that.decimalsep, that.thousandsep) + '%';
        };
      }
    }else if (that.displayformat() == 'value') {
      if (that.datavaluedecimals() != 'auto') {
        defaultValue.plotOptions.pie.dataLabels.formatter = function() {
          return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, that.decimal(), that.decimalsep, that.thousandsep) + ' ' + that.datalabelsuffix();
        };
      } else {
        defaultValue.plotOptions.pie.dataLabels.formatter = function() {
          return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, that.decimal(), that.decimalsep, that.thousandsep) + ' ' + that.datalabelsuffix();
        };
      }
    }
};

VbiNumberFormat.prototype.piedrilldownFamilyDataLabelFormatter = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var measureId = objarr.point.series.userOptions.seriesKeyName;
    if(that.displayformat !== undefined && that.numberFormatDefinition() !== 'initialView'){
        if(that.displayformat() === 'both'){
            return Highcharts.numberFormat(objarr.percentage, that.decimal(), decimalseptool, thousandseptool) + '%<br/>' + self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
        }else if(that.displayformat() === 'percent'){
            return Highcharts.numberFormat(objarr.percentage, that.decimal(), decimalseptool, thousandseptool) + '%';
        }else if(that.displayformat() === 'value'){
            return self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
        }
    }else if(that.numberFormatDefinition() !== 'initialView'){
        return self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
    }else if(that.numberFormatDefinition() === 'initialView'){
        return self.processDataLabelInitialView(objarr,that,measureId);
    }

};

VbiNumberFormat.prototype.piedrilldownFamilyTooltip = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var keyval = objarr.point.series.userOptions.seriesKeyName;
    var series = objarr.point.name.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'') + ': <br/>' + objarr.series.name.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'') + " : ";
    if(that.numberFormatDefinitionTooltip() === 'initialView'){
        var data = self.processTooltipInitialView(objarr,that,keyval,false);
    }else{
        var data = self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false);
    }
    return series + data;
};

VbiNumberFormat.prototype.pieFamilyDataLabelFormatter = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var measureId = objarr.point.series.userOptions.uniquekey;
    if(that.displayformat !== undefined && that.numberFormatDefinition() !== 'initialView'){
        if(that.displayformat() === 'both'){
            return Highcharts.numberFormat(objarr.percentage, that.decimal(), decimalseptool, thousandseptool) + '%<br/>' + self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
        }else if(that.displayformat() === 'percent'){
            return Highcharts.numberFormat(objarr.percentage, that.decimal(), decimalseptool, thousandseptool) + '%';
        }else if(that.displayformat() === 'value'){
            return self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
        }
    }else if(that.numberFormatDefinition() !== 'initialView'){
        return self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
    }else if(that.numberFormatDefinition() === 'initialView'){
        return self.processDataLabelInitialView(objarr,that,measureId);
    }

};

VbiNumberFormat.prototype.gaugeFamilyDataLabelFormatter = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var measureId = objarr.series.userOptions.key;
    if(that.displayformat !== undefined && that.numberFormatDefinition() !== 'initialView'){
        if(that.displayformat() === 'both'){
            return Highcharts.numberFormat(objarr.percentage, that.decimal(), decimalseptool, thousandseptool) + '%<br/>' + self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
        }else if(that.displayformat() === 'percent'){
            return Highcharts.numberFormat(objarr.percentage, that.decimal(), decimalseptool, thousandseptool) + '%';
        }else if(that.displayformat() === 'value'){
            return self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
        }
    }else if(that.numberFormatDefinition() !== 'initialView'){
        return self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
    }else if(that.numberFormatDefinition() === 'initialView'){
        return self.processDataLabelInitialView(objarr,that,measureId);
    }

};

VbiNumberFormat.prototype.gaugeFamilyTooltip = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var keyval = objarr.series.userOptions.key;
    var series = objarr.series.name.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'') + " : ";
    if(that.numberFormatDefinitionTooltip() === 'initialView'){
        var data = self.processTooltipInitialView(objarr,that,keyval,false);
    }else{
        var data = self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false);
    }
    return series + data;
};

VbiNumberFormat.prototype.HCMapTooltip = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var keyval = objarr.series.userOptions.key;
    if(that.numberFormatDefinitionTooltip() === 'initialView'){
        return self.processTooltipInitialView(objarr,that,keyval,false);
    }else{
        var data = self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false);
    }
};

VbiNumberFormat.prototype.scatterDataLabelFormatter = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var measureKey = null;
    if(that.result()){
        if(!objarr.series.userOptions.key)
            return  objarr.series.userOptions.name;
        measureKey = objarr.series.userOptions.key.split("-");
    }else{
        measureKey = ['Measure 1','Measure 2','Measure 3'];
    }
    if(that.swapaxes()){
        var temp = measureKey[0];
        measureKey[0] =measureKey[1];
        measureKey[1] = temp;
    }
    var formattedData = [];
    _.each(measureKey,function(measure,index){
        var dataValue = null;
        if(index === 0){
            dataValue = objarr.point.x;
        }else if(index === 1){
            dataValue = objarr.point.y;
        }else if(index === 2){//For bubble chart
            dataValue = objarr.point.z;
        }
        var keyval = null;
        if(that.result()){
            var measureIndex = measure.split(":")[0];
            var measureMemberIndex = measure.split(":")[1];
            keyval = that.result().dimensions[measureIndex].members[measureMemberIndex].key;
        }
        if(that.result() && that.numberFormatDefinition() === 'initialView'){
            formattedData.push(self.processDataLabelInitialView(objarr,that,keyval, dataValue));
        }else{
            formattedData.push(self.processDataLabel(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false, dataValue));
        }
    });
    if(that.CID === 'scatter'){
        return formattedData[1];
    }else{//Bubble chart
        var mtype = that.datalabelmeasuretype();
        if(objarr.series.userOptions.isRegressionLine !== undefined){
            mtype = "y";
        }
        if(mtype == 'all') {
            return that.xAxisLabel + ' (X): ' + formattedData[0].replace('<br/>','') + '<br/>' + that.yAxisLabel + ' (Y): ' + formattedData[1].replace('<br/>','') + '<br/>' + that.zAxisLabel + ' (Size): ' + formattedData[2].replace('<br/>','');
        }else if (mtype == 'x') {
            return that.xAxisLabel + ' (X): ' + formattedData[0].replace('<br/>','');
        }else if (mtype == 'y') {
            return that.yAxisLabel + ' (Y): ' + formattedData[1].replace('<br/>','');
        }else {
            return formattedData[2] ? that.zAxisLabel + ' (Size): ' + formattedData[2].replace('<br/>','') :'';
        }
    }
//    return self.processDataLabel(that,objarr,measureId,is_chart_container,decimalseptool,thousandseptool,false);
};

VbiNumberFormat.prototype.scatterTooltip = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    var measureKey = null;
    if(that.result()){
        if(!objarr.series.userOptions.key)
            return objarr.series.userOptions.name;
        measureKey = objarr.series.userOptions.key.split("-");
    }else{
        measureKey = ['Measure 1','Measure 2','Measure 3'];
    }
     if(that.swapaxes()){
        var temp = measureKey[0];
        measureKey[0] =measureKey[1];
        measureKey[1] = temp;
    }
    var formattedData = [];
    _.each(measureKey,function(measure,index){
        var dataValue = null;
        if(index === 0){
            dataValue = objarr.point.x;
        }else if(index === 1){
            dataValue = objarr.point.y;
        }else if(index === 2){//For bubble chart
            dataValue = objarr.point.z;
        }
        var keyval = null;
        if(that.result()){
            var measureIndex = measure.split(":")[0];
            var measureMemberIndex = measure.split(":")[1];
            keyval = that.result().dimensions[measureIndex].members[measureMemberIndex].key;
        }
        if(that.result() && that.numberFormatDefinitionTooltip() === 'initialView'){
            formattedData.push(self.processTooltipInitialView(objarr,that,keyval,false, dataValue));
        }else{
            formattedData.push(self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false, dataValue));
        }
    });
    var xAxisLabel = that.xAxisLabel.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'').trim();
    var yAxisLabel = that.yAxisLabel.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'').trim();

    if(that.CID === 'scatter'){
        return '<span style="color:' + objarr.color + '">\u25CF</span><b> ' + objarr.series.name + '</b><br/><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em"><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">' + xAxisLabel +   ' (x) :'  + ' ' + formattedData[0] + ' '  + '</p><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">' + yAxisLabel  + ' (y) :' +  ' ' + formattedData[1] + '</p></p>';
    }else{//Bubble
      if (objarr.point.z != undefined) {
        var zAxisLabel = that.zAxisLabel.replace(/ *\(in [^)]*\) */g,'').replace(/\(\*([^)]+)\)/g,'').trim();
        return '<span style="color:' + objarr.color + '">\u25CF</span><b> ' + objarr.series.name + '</b><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">' + objarr.point.name + '</p><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em"><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">' + xAxisLabel +  ' (x): ' +  formattedData[0] + '</p><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">' + yAxisLabel  + ' (y): ' +  formattedData[1] + '</p><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">' + that.zAxisLabel + ' (Size): ' +  formattedData[2] + '</p></p>';
      } else {
        return '<span style="color:' + objarr.color + '">\u25CF</span><b> ' + objarr.series.name + '</b><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em"><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">' + '' + ' (x): ' + formattedData[0] + '</p><p style="line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">' + '' + ' (y): '+ formattedData[1] + '</p></p>';
      }
    }
};

VbiNumberFormat.prototype.barFamilyTooltip = function (objarr, that, decimalseptool, thousandseptool, is_chart_container) {
    var self = this;
    if (sap.zen.designmode !== undefined) return;
    var measure_col_index = this.getmeasure_col_index(that);
    var is_measure_in_col = that.measureValidation();
    var prefixIndex = 0;
    if (that.tooltipshared()) {

        var points = objarr.points;
        var pointsLength = points.length;
        var FlagforTooltip = true;
        var tooltipMarkup = '';
        var index, yValue;
        var fontsize = 10;
        if (that.tooltipfontsize && !isNaN(that.tooltipfontsize())) {
            fontsize = that.tooltipfontsize() - 1;
        }
        if (is_measure_in_col == 'true') {
            FlagforTooltip = true;
            tooltipMarkup = pointsLength ? '<span style="font-size: ' + fontsize + 'px">' + points[0].key + '</span><br/>' : '';
        } else {
            FlagforTooltip = false;
        }

        var new_index_error_bar = 0;
        if (FlagforTooltip == true) {
            for (index = 0; index < pointsLength; index += 1) {
                yValue = points[index].y;
                if (that.CID == 'dualAxes' || that.CID == 'multipleAxes' || that.CID == 'columnBar') {
                    try {
                        if (that.CID == 'dualAxes' || that.CID == 'multipleAxes')
                            var keyval = points[index].series.options.nameAsKey.split('/')[measure_col_index].trim();
                        else {
                            var keyval = points[index].series.options.uniquekey.trim();
                        }
                    }
                    catch (e) {
                        //for error bar
                        var keyval = points[index].series.options.name.split('/')[measure_col_index].replace('error', '').trim();
                        for (var i = 0; i < that.result().dimensions.length; i++) {
                            if (that.result().dimensions[i].containsMeasures == true) {
                                for (var j = 0; j < that.result().dimensions[i].members.length; j++) {
                                    if (that.result().dimensions[i].members[j].text == keyval) {
                                        keyval = that.result().dimensions[i].members[j].key;
                                    }
                                }
                            }
                        }

                    }
                } else if (that.CID == 'bullet') {
                    var keyval = that.result().dimensions[measure_col_index].members[points[index].series.userOptions.key.split('-')[0].split(':')[1]].key;
                } else {
                    if (points[index].series.options.keyval != '' && points[index].series.options.keyval != undefined) {
                        var keyval = points[index].series.options.keyval;
                    } else {
                        var keyval = points[index].series.options.uniquekey;
                    }
                }

                var tooltiparr = this.tooltipScaling('', yValue, that, keyval, points[index].series.type === 'errorbar', objarr);
                var finaltext = points[index].series.name;
                var tooltipUnitVal = tooltiparr[2];
                var scalingFactorinDS = tooltiparr[3];
                var textwithnewscaling = this.tooltipScalingFactorValue(finaltext, tooltipUnitVal, scalingFactorinDS, that.scalingfactorenable(), that.showunit(), that.tooltipscalingfactor(), that.tooltipscalingfactorenable(), that.tooltipshowunit());
                var new_error_index = 0;
                if (!is_chart_container && (that.CID == 'dualAxes' || that.CID == 'multipleAxes') && that.errorbarenable()) {
                    if (points[index].series.type == 'errorbar') {
                        new_error_index = prefixIndex - 1;
                    } else {
                        new_error_index = prefixIndex;
                        prefixIndex++;
                    }

                    //var new_error_index = index ==0 ? 0: index-1;
                    // var new_error_index = Math.floor(index / 2);
                } else {
                    if(that.CID == 'multipleAxes'){
                        if(that.measuretypepair()){
                            var measureAxis = JSON.parse(that.measuretypepair());
                            if(measureAxis[points[index].series.userOptions.nameAsKey]){
                                new_error_index = measureAxis[points[index].series.userOptions.nameAsKey].yAxis;
                            }else{
                                new_error_index = 0;
                            }
                        }else{//default case when the user doesn't change the series type
                            if(index>2){
                                new_error_index = index - 1;
                            }
                            if(that.dataseriestype().split(",")[index] === 'column-stacked'){
                                new_error_index = 1;
                            }
                        }
                    }else{
                        new_error_index = index;
                    }
                }

                if (that.tooltipvalueprefix().split(",#").length > 1) {
                    var prefix = that.tooltipvalueprefix().split(",#")[new_error_index];
                    prefix = prefix ? prefix : '';
                } else {
                    var prefix = that.tooltipvalueprefix();
                }
                if (that.tooltipvaluesuffix().split(",#").length > 1) {
                    var suffix = that.tooltipvaluesuffix().split(",#")[new_error_index];
                    suffix = suffix ? suffix : '';
                } else {
                    var suffix = that.tooltipvaluesuffix();
                }

                tooltipMarkup += '<span style="color:' + points[index].series.color + '">\u25CF</span> ' + textwithnewscaling + ': ' + prefix + ' ' + '<b>' + Highcharts.numberFormat(tooltiparr[1], that.tooltipvaluedecimals(), decimalseptool, thousandseptool) + '</b>' + ' ' + suffix + '<br/>';
            }
        } else {
            if (objarr.points[0].series.xAxis.userOptions.measurecategories || objarr.points[0].series.xAxis.userOptions.categorieskey) {
                var ind = objarr.points[0].point.index;
                if (that.CID == 'combination' || that.CID == 'superCombination') {
                    var m_cat = points[0].series.xAxis.userOptions.categorieskey;
                    var keyval = [];
                    for (var i = 0; i < m_cat.length; i++) {
                        keyval.push(m_cat[i].split("\\")[0]);
                    }
                } else {
                    var keyval = points[0].series.xAxis.userOptions.measurecategories;
                }

                var originalkeyval = keyval[ind];
                var tooltiparr = '';
                var tooltipUnitVal = '';
                var scalingFactorinDS = '';
                for (index = 0; index < pointsLength; index += 1) {
                    yValue = points[index].y;
                    tooltiparr = this.tooltipScaling('', yValue, that, originalkeyval, false, objarr);
                    tooltipUnitVal = tooltiparr[2];
                    scalingFactorinDS = tooltiparr[3];
                    var textwithnewscaling = this.tooltipScalingFactorValue(points[0].key.name, tooltipUnitVal, scalingFactorinDS, that.scalingfactorenable(), that.showunit(), that.tooltipscalingfactor(), that.tooltipscalingfactorenable(), that.tooltipshowunit());
                    if (index == 0) {
                        tooltipMarkup += pointsLength ? '<span style="font-size: 10px">' + textwithnewscaling + '</span><br/>' : '';
                    }

                    if (!is_chart_container && (that.CID == 'dualAxes' || that.CID == 'multipleAxes') && that.errorbarenable()) {

                        //var new_error_index = index ==0 ? 0: index-1;
                        // var new_error_index = Math.floor(index / 2);
                        if (points[index].series.type == 'errorbar') {
                            var new_error_index = prefixIndex - 1;
                        } else {
                            var new_error_index = prefixIndex;
                            prefixIndex++;
                        }

                    }
                    else {
                        var new_error_index = index;
                    }
                    if (that.tooltipvalueprefix().split(",#").length > 1)
                        var prefix = that.tooltipvalueprefix().split(",#")[new_error_index];

                    else
                        var prefix = that.tooltipvalueprefix();

                    if (that.tooltipvaluesuffix().split(",#").length > 1)
                        var suffix = that.tooltipvaluesuffix().split(",#")[new_error_index];

                    else
                        var suffix = that.tooltipvaluesuffix();


                    tooltipMarkup += '<span style="color:' + points[index].series.color + '">\u25CF</span> ' + points[index].series.name + ': ' + prefix + ' ' + '<b>' + Highcharts.numberFormat(tooltiparr[1], that.tooltipvaluedecimals(), decimalseptool, thousandseptool) + '</b>' + ' ' + suffix + '<br/>';

                }
            }

        }

        return tooltipMarkup;
    } else {

        if (that.CID == 'superCombination') {

            if (is_measure_in_col == 'false' && objarr.point.series.xAxis.userOptions.categorieskey) {//measure is in row
                var keyval = objarr.point.series.xAxis.userOptions.categorieskey[objarr.point.x].split("\\")[0];

            } else {//measure is in col
                var keyval = objarr.point.series.options.uniquekey;
            }
        } else if (that.CID == 'combination') {
            if (that.result().dimensions.length == 1) {
                var keyval = objarr.point.series.options.keyvalue;
            } else if (is_measure_in_col == 'false' && objarr.point.series.xAxis.userOptions.categorieskey) {//measure is in row
                var keyval = objarr.point.series.xAxis.userOptions.categorieskey[objarr.point.x].split("\\")[0];
            } else {//measure is in col
                var keyval = objarr.point.series.options.uniquekey;
            }
        } else if (that.CID == 'bullet') {//console.log(objarr.series.userOptions);
            var keyval = that.result().dimensions[measure_col_index].members[objarr.series.userOptions.key.split('-')[0].split(':')[1]].key;
        } else if (is_measure_in_col == 'false' && objarr.point.series.xAxis.userOptions.measurecategories != '' && objarr.point.series.xAxis.userOptions.measurecategories != undefined) {
            var keyval = objarr.point.series.xAxis.userOptions.measurecategories[objarr.point.x];
        } else if (objarr.point.series.options.keyvalue || objarr.point.series.options.nameAsKey || objarr.point.series.options.name) {
            if (that.CID == 'dualAxes' || that.CID == 'multipleAxes' || that.CID == 'columnBar') {

                if (is_chart_container || !that.errorbarenable()) {
                    if (that.CID != 'columnBar')
                        var keyval = objarr.point.series.options.nameAsKey.split('/')[measure_col_index].trim();
                    else
                        var keyval = objarr.point.series.options.uniquekey;
                } else {//if error bar is enabled (to identify key from name)
                    var keyval = objarr.point.series.options.name.split('/')[measure_col_index].replace('error', '').trim();
                    for (var i = 0; i < that.result().dimensions.length; i++) {
                        if (that.result().dimensions[i].containsMeasures == true) {
                            for (var j = 0; j < that.result().dimensions[i].members.length; j++) {
                                if (that.result().dimensions[i].members[j].text == keyval) {
                                    keyval = that.result().dimensions[i].members[j].key;
                                }
                            }
                        }
                    }

                }

            } else {

                if (that.CID == 'fixedColumn' || that.CID == 'area' || that.CID == 'line' || that.CID == 'radar' || that.CID == 'polar' || that.CID == 'stackedColumnBar' || that.CID == 'stackedArea' || that.CID == 'groupStacked')
                    var keyval = objarr.point.series.options.uniquekey;
                else
                    var keyval = objarr.point.series.options.keyvalue;
            }

        } else {
            var keyval = objarr.point.series.options.uniquekey;
        }
        //  console.log(keyval);
        var percentVal = false;
        var generatedHtml = '';


        if (that.tooltiplabelpercent !== undefined && that.tooltiplabelpercent()) {
            percentVal = true;
        }

        // if (percentVal) {
        //     var tooltiparr = this.tooltipScaling('', objarr.percentage, that, keyval);
        // } else {
        //     var tooltiparr = this.tooltipScaling('', objarr.y, that, keyval);  //measurename,new value,unit,Ds sF
        // }
        var finaltext = '';
        var flagA = true;

        if (is_measure_in_col == 'false') { // doubt what is the need for the code
            if (objarr.series.xAxis.categories.length > 0) {
                finaltext = objarr.series.xAxis.categories[objarr.point.x].name;
            }
            flagA = true;
        } else if (is_measure_in_col == 'true') {
            // if measure is in column

            finaltext = objarr.point.series.name;
            flagA = false;
        }

        // var tooltipUnitVal = tooltiparr[2];
        // var scalingFactorinDS = tooltiparr[3];
        // var usedScalingFactor = tooltiparr[4];
        var textwithnewscaling;
        if (((finaltext == '') && (is_measure_in_col == 'true')) || (finaltext === undefined)) {
            textwithnewscaling = objarr.point.series.name;
            //textwithnewscaling = this.tooltipScalingFactorValue(objarr.point.series.name, scalingFactorinDS, that.tooltipscalingfactor(), that.tooltipscalingfactorenable());
        } else {
            textwithnewscaling = finaltext;
            //textwithnewscaling = this.tooltipScalingFactorValue(finaltext, scalingFactorinDS, that.tooltipscalingfactor(), that.tooltipscalingfactorenable());
        }
        textwithnewscaling = textwithnewscaling.replace(/ *\(in [^)]*\) */g, '').replace(/\(\*([^)]+)\)/g, '');
        var seriesname = '';
        if (finaltext != '') {
            if (flagA == true) {
                if (that.CID == 'combination' && that.result().dimensions.length == 1) {//only singlmeasure is in row with no dimensions
                    seriesname = objarr.point.series.name.replace(/ *\(in [^)]*\) */g, '').replace(/\(\*([^)]+)\)/g, '') + ' ' + textwithnewscaling;
                } else if (textwithnewscaling != ' ')
                    seriesname = textwithnewscaling + ': <br/> ' + objarr.point.series.name;
                else
                    seriesname = objarr.point.series.name;
            } else {
                if (objarr.series.xAxis.categories[objarr.point.x] != ' ')
                    seriesname = objarr.series.xAxis.categories[objarr.point.x] + ': <br/> ' + textwithnewscaling;
                else
                    seriesname = textwithnewscaling;
            }
        } else {
            if (is_measure_in_col == 'false') {
                if (textwithnewscaling != ' ')
                    seriesname = textwithnewscaling + ': <br/> ' + objarr.point.series.name;
                else
                    seriesname = objarr.point.series.name;
            } else {
                if (objarr.series.xAxis.categories[objarr.point.x] != ' ')
                    seriesname = objarr.series.xAxis.categories[objarr.point.x] + ': <br/> ' + textwithnewscaling;
                else
                    seriesname = textwithnewscaling;
            }

        }
        if(that.numberFormatDefinitionTooltip() === 'initialView'){
            return seriesname + ' ' + self.processTooltipInitialView(objarr,that,keyval,percentVal);
        }
        else{
                baseString = self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, percentVal);
                 if(that.CID === 'bullet' && objarr.series.data && objarr.series.data[objarr.point.index]){
                     seriesname = seriesname.replace("<br/>", '<br/><span style="color:' + objarr.series.data[objarr.point.index].color + '">\u25CF</span>');
                 }
                generatedHtml = seriesname + ' ' + baseString + '<br/>';
        }
        return generatedHtml;
    }
};

VbiNumberFormat.prototype.processDataLabel = function processPercentAndStyle(that, objarr, measureId, is_chart_container, decimalseptool, thousandseptool, percentVal, dataValue, appendPercenatge) {
    if(dataValue === undefined){
        dataValue = objarr.y;
    }
    var self = this;
    var semanticFormattingOptions = {
        'enableSemanticFormatting': that.enableSemanticFormatting(),
        'negativeValueSemanticFormat': that.negativeValueSemanticFormat(),
        'negativeValueSemanticFormatColor': that.negativeValueSemanticFormatColor(),
        'positiveValueSemanticFormat': that.positiveValueSemanticFormat(),
        'positiveValueSemanticFormatColor': that.positiveValueSemanticFormatColor()
    };

    if (that.datalabelpercent !== undefined && that.datalabelpercent()) {
        percentVal = true;
    }
    if (percentVal) {
        var tooltiparr = this.datalabelScaling('', objarr.percentage, that, measureId);
    } else {
        var tooltiparr = this.datalabelScaling('', dataValue, that, measureId); //measurename,new value,unit,Ds sF
    }
    var finaltext = '';
    var flagA = true;

    // if (is_measure_in_col == 'false') { // doubt what is the need for the code
    //     if (objarr.series.xAxis.categories.length > 0) {
    //         finaltext = objarr.series.xAxis.categories[objarr.point.x].name;
    //     }
    //     flagA = true;
    // } else if (is_measure_in_col == 'true') {
    //     // if measure is in column

    //     finaltext = objarr.point.series.name;
    //     flagA = false;
    // }

    var dataLabelUnitVal = tooltiparr[2];
    var scalingFactorinDS = tooltiparr[3];
    var usedScalingFactor = tooltiparr[4];
    var dataLabelScalingFactorString = tooltiparr[5]; //tooltipscalingUnit
    var scalingUnit = '';
    var showScalingUnit = that.showscalingunit();
    if(showScalingUnit){
        scalingUnit = that.useAbbreviationForScalingUnit() ? this.getScalingUnitNumberAbbreviation(Math.pow(10,usedScalingFactor)) : that.numberFormatScalingUnit();
    }
    var decimals = 0;
    if(that.CID === 'WAFFLECHART' || that.CID === 'pictogram'){
        decimals = that.graphValueDecimalPlaces();
    }else if(that.CID === 'CCounter'){
        decimals = that.noofdecimals();
    }else{
        decimals = that.decimal();
    }
    self.numberFormatOptions = {
        'noOfDecimals': decimals,
        'decimalSeparator' : decimalseptool,
        'thousandSeparator' : thousandseptool,
        'y': tooltiparr[1],
        'semanticFormattingOptions' : semanticFormattingOptions,
        //'showUnit': that.showUnit(),
        'unit': dataLabelUnitVal,
        'unitPlacement': that.unitPlacement() || '10$',
        'showScalingUnit': showScalingUnit,
        'scalingUnit': scalingUnit,
        'scalingUnitPlacement': that.scalingUnitPlacement(),
        'prefix': that.CID === 'CCounter' ? that.counterprefix() : that.datalabelprefix(),
        'suffix': that.CID === 'CCounter' ? that.countersuffix() : that.datalabelsuffix(),
        'scalingFactor' : dataLabelScalingFactorString,
        //'showScalingFactor': that.showScalingFactor(),
        // 'scalingFactor': scalingFactor,
        'percent':  percentVal,
        'appendPercenatge' : appendPercenatge
    };

    var composedProcess = self.getComposedProcess();
    var baseString = self.composedProcess();
    that.generateHTML = baseString;
    return that.generateHTML;




    function getDimensionName() {
        var nameToReturn = '';
        switch (datalabelkeytext) {
            case 'key':
                nameToReturn =  that.dataRes.dimensions[dimensionName].key;
                break;
            case 'text':
                nameToReturn = that.dataRes.dimensions[dimensionName].text;
                break;
            case 'keyandtext':
               nameToReturn = that.dataRes.dimensions[dimensionName].key + " " + that.dataRes.dimensions[dimensionName].text;
                break;
            case 'textandkey':
                nameToReturn = that.dataRes.dimensions[dimensionName].text + " " + that.dataRes.dimensions[dimensionName].key;
                break;
        }
        return nameToReturn;
    }; //Dimension Name

    function getDimensionMemberName() {
        var nameToReturn = '';
        switch (datalabelkeytext) {
            case 'key':
                nameToReturn = that.dataRes.dimensions[dimensionName].members[dimensionMemberName].key;
                break;
            case 'text':
                nameToReturn = that.dataRes.dimensions[dimensionName].members[dimensionMemberName].text;
                break;
            case 'keyandtext':
                nameToReturn = that.dataRes.dimensions[dimensionName].members[dimensionMemberName].key + ' ' + that.dataRes.dimensions[dimensionName].members[dimensionMemberName].text;
                break;
            case 'textandkey':
                nameToReturn = that.dataRes.dimensions[dimensionName].members[dimensionMemberName].text + ' ' + that.dataRes.dimensions[dimensionName].members[dimensionMemberName].key;
                break;
        }
        return nameToReturn;
    }; //Dimension Member Name

    function measureMemberValue() {
        var formattedValue = Highcharts.numberFormat(tooltiparr[1], that.decimal(), decimalseptool, thousandseptool);
        var baseString = self.processSemanticFormatting(tooltiparr[1], formattedValue, semanticFormattingOptions);
        baseString = self.processUnitPlacement(dataLabelUnitVal, unitPlacement, baseString);
        baseString = self.processScalingUnitPlacement(scalingUnit, scalingUnitPlacement, baseString);
        baseString = prefix + ' ' + baseString + ' ' + suffix;
        that.generateHTML += dataLabelScalingFactorString + '' + baseString;
        //that.generateHTML += tooltipscalingUnit + '' + tooltipUnitVal + ' ' + prefix + ' ' + Highcharts.numberFormat(tooltiparr[1], that.datavaluedecimals(), decimalseptool, thousandseptool) + ' ' + suffix;
    };

    function dimensionValue(value) {
        that.generateHTML += '' + getDimensionName();
    };

    function dimensionMemberValue(value) {
        that.generateHTML += ' ' + getDimensionMemberName();
    };

    function measureValue(value) {
        that.generateHTML += ' ' + tooltiparr[0];
    };

    function getMemberNameValue(value) {
        switch (value) {
            case 'dim':
                dimensionValue();
                break;
            case 'dval':
                dimensionMemberValue();
                break;
            case 'measure':
                measureValue();
                break;
            case 'mval':
                measureMemberValue();
                break;
        }
    };

};

VbiNumberFormat.prototype.processData = function processPercentAndStyle(that, objarr, measureId, is_chart_container, decimalseptool, thousandseptool, percentVal,dataValue,appendPercenatge) {
    var self = this;
    if(!dataValue){
      dataValue = objarr.y;
    }
    if (percentVal) {
        var tooltiparr = this.tooltipScaling('', objarr.percentage, that, measureId, false, objarr);
    } else {
        var tooltiparr = this.tooltipScaling('', dataValue, that, measureId, false, objarr);  //measurename,new value,unit,Ds sF
    }
    var semanticFormattingOptions = {
        'enableSemanticFormatting': that.enableSemanticFormattingTooltip(),
        'positiveValueSemanticFormat': that.positiveValueSemanticFormatTooltip(),
        'positiveValueSemanticFormatColor': that.positiveValueSemanticFormatColorTooltip(),
        'negativeValueSemanticFormat': that.negativeValueSemanticFormatTooltip(),
        'negativeValueSemanticFormatColor': that.negativeValueSemanticFormatColorTooltip()
    };
    var new_error_index = 0;
    if (!is_chart_container && (that.CID == 'dualAxes' || that.CID == 'multipleAxes') && that.errorbarenable())
        new_error_index = Math.floor(objarr.series.index / 2);
    else{
        if(that.CID == 'multipleAxes'){
            if(that.measuretypepair()){
                var measureAxis = JSON.parse(that.measuretypepair());
                if(measureAxis[objarr.series.userOptions.nameAsKey]){
                    new_error_index = measureAxis[objarr.series.userOptions.nameAsKey].yAxis;
                }else{
                    new_error_index = 0;
                }
            }else{//default case when the user doesn't change the series type
                if(objarr.series.index>2){
                    new_error_index = objarr.series.index - 1;
                }
                if(that.dataseriestype().split(",")[objarr.series.index] === 'column-stacked'){
                    new_error_index = 1;
                }
            }
        }else{
            new_error_index = objarr ? objarr.series.index : -1;
        }
    }

    if (that.tooltipvalueprefix().split(",#").length > 1)
        var prefix = that.tooltipvalueprefix().split(",#")[new_error_index];
    else
        var prefix = that.tooltipvalueprefix();

    if (that.tooltipvaluesuffix().split(",#").length > 1)
        var suffix = that.tooltipvaluesuffix().split(",#")[new_error_index];
    else
        var suffix = that.tooltipvaluesuffix();


    var showScalingUnit = that.tooltipshowscalingunit();
    var scalingUnit = '';
    if (showScalingUnit) {
        scalingUnit = that.useAbbreviationForScalingUnitTooltip() ? this.getScalingUnitNumberAbbreviation(Math.pow(10, tooltiparr[4])) : that.numberFormatScalingUnitTooltip();
    }
    var rawValue = tooltiparr[1];
    self.numberFormatOptions = {
        'noOfDecimals':(that.CID === 'rMatrix' || that.CID === 'WAFFLECHART' || that.CID === 'pictogram') ? that.tooltipdecimal() : that.tooltipvaluedecimals(),
        'decimalSeparator' : decimalseptool,
        'thousandSeparator' : thousandseptool,
        'y': tooltiparr[1],
        'semanticFormattingOptions' : semanticFormattingOptions,
        //'showUnit': that.showUnit(),
        'unit': tooltiparr[2] ,
        'unitPlacement': that.unitPlacementTooltip(),
        'showScalingUnit': showScalingUnit,
        'scalingUnit': scalingUnit,
        'scalingUnitPlacement': that.scalingUnitPlacementTooltip(),
        'prefix': prefix,
        'suffix': suffix,
        'scalingFactor': tooltiparr[5],
        'percent':  percentVal,
        'appendPercenatge' : appendPercenatge
    };

    var composedProcess = self.getComposedProcess();
    var baseString = composedProcess();
    return baseString;
};

VbiNumberFormat.prototype.processPercentAndStyle = function processPercentAndStyle(baseString) {
    var self = this;
    var options = self.numberFormatOptions;
    var percent = options.percent;
    if(percent){
        baseString+= '%';
    }
    return baseString;
};

VbiNumberFormat.prototype.processPrefixSuffix = function processPrefixSuffix(baseString) {
    var self = this;
    var options = self.numberFormatOptions;
    var prefix = options.prefix;
    var suffix = options.suffix;

    if(prefix){
        baseString = prefix + ' ' + baseString;
    }

    if(suffix){
        baseString+= ' ' + suffix;
    }
    return baseString;
};

VbiNumberFormat.prototype.processUnitPlacement = function processUnitPlacement(baseString) {
    var self = this;
    var options = self.numberFormatOptions;
    var unit = options.unit;
    var placement = options.unitPlacement;

    if(unit){
        if (placement === '10$') {
            baseString = baseString + ' ' + unit;
        }
        else if (placement === '$10') {
            baseString = unit + ' ' + baseString;
        }
        else if (placement === '$_10') {
            /**
             * left and right align could be done by float:left and float:right on the two spans but it has side effects.
             * Even padding does not work beacuse "useHTML" is disabled for dataLabels. Hence using the following approcah of "white-space:pre".
             */
            baseString = '<span style="white-space:pre;">' + unit + '       </span><span>' + baseString + '</span>';
        }
    }
    return baseString;
};


VbiNumberFormat.prototype.processScalingUnitPlacement = function processScalingUnitPlacement(baseString) {
    var self = this;
    var options = self.numberFormatOptions;
    var scalingUnit = options.scalingUnit;
    var placement = options.scalingUnitPlacement;

    if(scalingUnit){
        if (placement === '10K') {
            baseString = baseString + ' ' + scalingUnit;
        }
        else if (placement === 'K10') {
            baseString = scalingUnit + ' ' + baseString;
        }
    }
    return baseString;
};

/*  @value (Number | String) Raw Value
    @formattedValue (String) Formatted Value should not have any styling. It's just raw value with no. of decimals, decimal separator and thousand separator applied.
    @options (Object) Semantic Formatting related properties.
*/
VbiNumberFormat.prototype.processSemanticFormattingColor = function processSemanticFormattingColor(formattedValue){
    var self = this;
    var options = self.numberFormatOptions.semanticFormattingOptions;
    var stringToReturn = formattedValue;
    if (!options.enableSemanticFormatting) {
        return stringToReturn;
    }

    var semanticFormatColor;
    var sematicFormat;
    var rawValue = Number(self.numberFormatOptions.y);
    if (rawValue > 0) {
        semanticFormatColor = options.positiveValueSemanticFormatColor;
        // if semanticFormat === 'X', do nothing because positive values are by default not preceeded by any sign
    }
    else if(rawValue < 0){
        semanticFormatColor = options.negativeValueSemanticFormatColor;
        // if semanticFormat === '-X', do nothing because negative values are by default preceeded by '-' sign
    }

    stringToReturn = '<span style="color:' + semanticFormatColor + '">' + stringToReturn + '</span>';
    return stringToReturn;

};


VbiNumberFormat.prototype.processSemanticFormatting = function processSemanticFormatting(formattedValue) {
    var self = this;
    var options = self.numberFormatOptions.semanticFormattingOptions;
    var stringToReturn = formattedValue;
    if (!options.enableSemanticFormatting) {
        return stringToReturn;
    }

    var semanticFormatColor;
    var sematicFormat;
    var rawValue = Number(self.numberFormatOptions.y);
    if (rawValue > 0) {
        sematicFormat = options.positiveValueSemanticFormat;
        if (sematicFormat === '+X') {
            stringToReturn = '+' + stringToReturn;
        }
        else if (sematicFormat === 'X+') {
            stringToReturn = stringToReturn + '+';
        }
        // if semanticFormat === 'X', do nothing because positive values are by default not preceeded by any sign
    }
    else if(rawValue < 0){
        sematicFormat = options.negativeValueSemanticFormat;
        if (sematicFormat === '(X)') {
            stringToReturn = '(' + stringToReturn.substring(1) + ')';
        }
        else if (sematicFormat === 'X-') {
            stringToReturn = stringToReturn.substring(1) + '-';
        }
        // if semanticFormat === '-X', do nothing because negative values are by default preceeded by '-' sign
    }
    return stringToReturn;
};


VbiNumberFormat.prototype.barFamilyTooltipFormatter = function(objarr, that, decimalseptool, thousandseptool, is_chart_container) {
  try {

	var self = this;
	var customtooltip = that.customtooltip();

	if (customtooltip) {
		customtooltip = JSON.parse(that.customtooltip());
	}

	var getDimensionKeyIndex = function(result, key) {
		var index;
		_.each(that.dataRes.dimensions, function(e, i, array) {
			if (e.key == key) {
				index = i;
			}
		});
		return index;
	};

	var measurekey = function(result) {
		var index;
		_.any(that.dataRes.dimensions, function(e, i, array) {
			if (e.containsMeasures) {
				index = i;
				return true;
			}
		});
		return index;
	};

	var prefix = "";
	var suffix = '';
	that.generateHTML = "";

	var getDimensionName = function(dimensionName, tooltipkeytext) {
		var dimensionName = that.dataRes.dimensions[dimensionName];
		switch (tooltipkeytext) {
			case 'key':
				return dimensionName.key;
				break;
			case 'text':
				return dimensionName.text;
				break;
			case 'keyandtext':
				return dimensionName.key + " " + dimensionName.text;
				break;
			case 'textandkey':
				return dimensionName.text + " " + dimensionName.key;
				break;
		}
	}; //Dimension Name

	var getDimensionMemberName = function(dimensionName, dimensionMemberName, tooltipkeytext) {
		var dimensionMember = that.dataRes.dimensions[dimensionName].members[dimensionMemberName];
		switch (tooltipkeytext) {
			case 'key':
				return dimensionMember.key;
				break;
			case 'text':
				return dimensionMember.text;
				break;
			case 'keyandtext':
				return dimensionMember.key + ' ' + dimensionMember.text;
				break;
			case 'textandkey':
				return dimensionMember.text + ' ' + dimensionMember.key;
				break;
		}
	}; //Dimension Member Name

	var dimensionIndexGlobal;
	var measureIndexGLobal;
	var tuppleArray = [];
	/**
	 *Checking with Regexp
	 *{{checking postion-key}}
	 *Once the position is identified then modifying the text according to that without change the HTML
	 **/

	var tooltipHtml = "";
	_.each(customtooltip.ops, function(element, index, arr) {

		/**
		 * If it it Dimension Name
		 **/

		if (element.insert.mention != undefined) {

			var id = element.insert.mention.id;
			var displayType = element.insert.mention.display;
			switch (element.insert.mention.type) {
				case "Dimension":
                    if(id =="Default Dimension"){
                        var member = that.categoriesIndex[objarr.point.x].split('-');
                        var dimension = "";
                        var memberList = function(item, index, list) {
                           if(index >0){
                            dimension += "/";
                           }
                           dimension += getDimensionName(item[0], displayType);
                        };
                        _.each(member, memberList);
                    }else{
                    var dimensionIndex = getDimensionKeyIndex(that.dataRes, id);
                    var dimension = getDimensionName(dimensionIndex, displayType);
                    }
					var attributes = element.attributes != undefined ? element.attributes : {};
					tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
					break;

				case "DimensionMember":
					var dimensionIndex = getDimensionKeyIndex(that.dataRes, id);
					var member = that.categoriesIndex[objarr.point.x].split('-');
                    if(id =="Default Dimension"){
                    var dimension = "";
                    var memberList = function(item, index, list) {
                        if(index >0){
                            dimension += "/";
                        }
                        dimension += getDimensionMemberName(item[0], item[2], displayType);

                    };
                    _.each(member, memberList);
                    }else{
                        var dimensionName, dimensionMemberName;
                        var memberList = function(item, index, list) {
                            if (item[0] == dimensionIndex) {
                                dimensionName = item[0];
                                dimensionMemberName = item[2];
                            }
                        };
                        _.each(member, memberList);
                        var dimension = getDimensionMemberName(dimensionName, dimensionMemberName, displayType);
                    }
					var attributes = element.attributes != undefined ? element.attributes : {};
					tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
					break;
				case "Measure":
					self.measureIndex = undefined;
					self.measureObject = JSON.parse(that.getMeasuresNamesForFormatter());
					_.each(self.measureObject, function(e, i, arr) {
						if (e.key == id) {
							self.measureIndex = i;
						}
					});
					if (self.measureIndex == undefined) {
            if(self.customdatalabelFamily == undefined){
              self.measureIndex = objarr['point']['series']['index'];
            }else {
              self.measureIndex = objarr.point.series.userOptions.index
            }
					}
					var measure = "";
					_.each(that.dataRes['axis_columns'][self.measureIndex], function(e, i, arr) {
						if (e !== -1) {
							measure += getDimensionMemberName(i, e, displayType);
						}
					});
					var attributes = element.attributes != undefined ? element.attributes : {};
					tooltipHtml = tooltipHtml + wrapHtml(attributes, measure);
					break;

				case "MeasureValue":
                    self.measureIndex = undefined;
                    self.measureObject = JSON.parse(that.getMeasuresNamesForFormatter());
                    _.each(self.measureObject, function(e, i, arr) {
                        if (e.key == id) {
                            self.measureIndex = i;
                        }
                    });
                    if (self.measureIndex == undefined) {
                      if(self.customdatalabelFamily == undefined){
                        self.measureIndex = objarr['point']['series']['index'];
                      }else {
                        self.measureIndex = objarr.point.series.userOptions.index
                      }
                    }
					var tuppleArray = [];
					_.each(that.dataRes['axis_columns'][self.measureIndex], function(e, i, arr) {
						if (e !== -1) {
							tuppleArray[i] = e;
						}
					});

					_.each(that.dataRes['axis_rows'][objarr['point']['index']], function(e, i, arr) {
						if (e !== -1) {
							tuppleArray[i] = e;
						}
					});
					var tupleIndex = undefined;
					_.filter(that.dataRes['tuples'], function(num, index) {
						if (_.isEqual(num, tuppleArray)) {
							tupleIndex = index;
							return index;
						}
					});

					var dataValue = that.dataRes['data'][tupleIndex];
					var measureIndex = measurekey(that.dataRes);
					var keyval = that.dataRes.dimensions[measureIndex].members[tuppleArray[measureIndex]].key;

					var percentVal = false;
          if(that.numberFormatDefinitionTooltip === undefined){
            var measureVal = dataValue;
          }
          else if(that.numberFormatDefinitionTooltip() === 'initialView'){
              var measureVal = self.processTooltipInitialView(objarr,that,keyval,false,dataValue);
          }else{
              var measureVal = self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false,dataValue);
          }

					var attributes = element.attributes != undefined ? element.attributes : {};
					tooltipHtml = tooltipHtml + wrapHtml(attributes, measureVal);
			}
		} else {
			var attributes = element.attributes != undefined ? element.attributes : {};
			if (element.insert.split("\n").length > 1) {
				var newLine = element.insert.split("");
                _.each(newLine, function(value) {
                    if (value === "\n") //represents "\n"
						tooltipHtml = tooltipHtml + wrapHtml(attributes, "<br />");
					else
						tooltipHtml = tooltipHtml + wrapHtml(attributes, value);
				})
			} else
				tooltipHtml = tooltipHtml + wrapHtml(attributes, element.insert);
		}
	});

	return tooltipHtml;
} catch (e) {

}

};

VbiNumberFormat.prototype.DrillDownFamilyTooltipFormatter = function(objarr, that, decimalseptool, thousandseptool, is_chart_container) {
  try {
  var self = this;
  var customtooltip = that.customtooltip();

  if (customtooltip) {
  	customtooltip = JSON.parse(that.customtooltip());
  }

    var measurekey = function(result) {
        var index;
        var key  = 0;
        _.any(that.dataRes.dimensions, function(e, i, array) {
             key++;
            if (e.containsMeasures) {
                index = i;
                key--;
                return true;
            }
        });
        return [index,key];
    };

    var getMeasureKeyIndexVal = function(result, key) {
    var index;
    _.each(that.dataRes.dimensions[result].members, function(e, i, array) {
        if (e.key == key) {
            index = i;
        }
    });
    return index||0;
  };

  var getDimensionKeyIndex = function(result, key) {
  	var index;
  	_.each(that.dataRes.dimensions, function(e, i, array) {
  		if (e.key == key) {
  			index = i;
  		}
  	});
  	return index;
  };

  var getDimensionMemberKeyIndex = function(result, key) {
  	var index;
  	_.each(result.members, function(e, i, array) {
  		if (e.key == key) {
  			index = i;
  		}
  	});
  	return index;
  };


  var prefix = "";
  var suffix = '';
  that.generateHTML = "";

  var getDimensionName = function(dimensionName, tooltipkeytext) {
  	var dimensionName = that.dataRes.dimensions[dimensionName];
  	switch (tooltipkeytext) {
  		case 'key':
  			return dimensionName.key;
  			break;
  		case 'text':
  			return dimensionName.text;
  			break;
  		case 'keyandtext':
  			return dimensionName.key + " " + dimensionName.text;
  			break;
  		case 'textandkey':
  			return dimensionName.text + " " + dimensionName.key;
  			break;
  	}
  }; //Dimension Name

  var getDimensionMemberName = function(dimensionName, dimensionMemberName, tooltipkeytext) {
  	var dimensionMember = that.dataRes.dimensions[dimensionName].members[dimensionMemberName];
  	switch (tooltipkeytext) {
  		case 'key':
  			return dimensionMember.key;
  			break;
  		case 'text':
  			return dimensionMember.text;
  			break;
  		case 'keyandtext':
  			return dimensionMember.key + ' ' + dimensionMember.text;
  			break;
  		case 'textandkey':
  			return dimensionMember.text + ' ' + dimensionMember.key;
  			break;
  	}
  }; //Dimension Member Name

  var dimensionIndexGlobal;
  var measureIndexGLobal;
  var tuppleArray = [];
  /**
   *Checking with Regexp
   *{{checking postion-key}}
   *Once the position is identified then modifying the text according to that without change the HTML
   **/

  var tooltipHtml = "";
  _.each(customtooltip.ops, function(element, index, arr) {
    if (element.insert.mention != undefined) {

                var id = element.insert.mention.id;
                var displayType = element.insert.mention.display;
                switch (element.insert.mention.type) {
              case "Dimension":
                        var dimensionIndex = getDimensionKeyIndex(that.dataRes, id);
                        var dimension = getDimensionName(dimensionIndex, displayType);
                        var attributes = element.attributes != undefined ? element.attributes : {};
                        tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
                        break;

                    case "DimensionMember":
                    try {
                      var dimensionIndex = getDimensionKeyIndex(that.dataRes, id);
                      if(that.CID == "scatter" || that.CID == "bubble"){
                        var dimensionIndexkey = objarr.point.rowIndex;
                        var dimension = getDimensionMemberName(dimensionIndexkey.charAt(0), dimensionIndexkey.charAt(2), displayType);
                      }else if(that.CID == "treeMapDrilldown"){
                        var index = objarr.point.namekey;
                        var dimension = getDimensionMemberName(index.split('-')[0].split(':')[0], index.split('-')[0].split(':')[1], displayType);
                      }else{
                        var index = objarr.point.indexInfo;
                        var dimension = getDimensionMemberName(index.split('-')[0].split(':')[0], index.split('-')[0].split(':')[1], displayType);
                      }
                    } catch (e) {
                      var dimension = '';
                    }
                    var attributes = element.attributes != undefined ? element.attributes : {};
                      tooltipHtml = tooltipHtml + wrapHtml(attributes, dimension);
                      break;
                    case "Measure":
                    self.measureIndex = undefined;
                    self.measureObject = JSON.parse(that.getMeasuresNamesForFormatter());
                    _.each(self.measureObject, function(e, i, arr) {
                        if (e.key == id) {
                            self.measureIndex = i;
                        }
                    });
                    var measure = "";
                  if(that.CID == "treeMapDrilldown"){
                     var  measureIndexKey  = measurekey(that.treecolormeasure());
                     var measureIndex = getMeasureKeyIndexVal(measureIndexKey[0],that.treecolormeasure());
                     measure = getDimensionMemberName(measureIndex, measureIndexKey, displayType);
                  }else if(that.CID == "scatter" || that.CID == "bubble"){
                         var measureVal = measurekey();
                         var measureIndex = getMeasureKeyIndexVal(measureVal[0],that.xaxismeasure());
                         measure = getDimensionMemberName(measureVal[0],measureIndex , displayType);
                  }
                  else{
                      _.each(objarr.point.columnIndexKey.split('-'), function(e, i, arr) {
                      measure += getDimensionMemberName(e.charAt(0), e.charAt(2), displayType);
                  });
                  }
                    var attributes = element.attributes != undefined ? element.attributes : {};
                    tooltipHtml = tooltipHtml + wrapHtml(attributes, measure);
                        break;

                    case "MeasureValue":

                        var measureIndex = objarr.point.series.userOptions.columnIndexKey;
                      if(that.CID == "treeMapDrilldown"){
                      var dataValue = objarr.point.value;
                      var keyval = that.treecolormeasure();
                      }else if(that.CID == "scatter" || that.CID == "bubble"){
                      var keyval =that.xaxismeasure();
                      }
                      else{
                      var dataValue = objarr.y;
                      var keyval = that.dataRes.dimensions[measureIndex.charAt(0)].members[measureIndex.charAt(2)].key;
                      }
                        var percentVal = false;
                        if (that.numberFormatDefinitionTooltip === undefined) {
                            var measureVal = dataValue;
                        } else if (that.numberFormatDefinitionTooltip() === 'initialView') {
                            var measureVal = self.processTooltipInitialView(objarr, that, keyval, false,dataValue);
                        } else {
                            var measureVal = self.processData(that, objarr, keyval, is_chart_container, decimalseptool, thousandseptool, false, dataValue);
                        }

                        var attributes = element.attributes != undefined ? element.attributes : {};
                        tooltipHtml = tooltipHtml + wrapHtml(attributes, measureVal);
                }
            } else {
      		var attributes = element.attributes != undefined ? element.attributes : {};
      		if (element.insert.split("\n").length > 1) {
      			var newLine = element.insert.split("");
                _.each(newLine, function(value) {
                    if (value === "\n") //represents "\n"
      					tooltipHtml = tooltipHtml + wrapHtml(attributes, "<br />");
      				else
      					tooltipHtml = tooltipHtml + wrapHtml(attributes, value);
      			})
      		} else
      			tooltipHtml = tooltipHtml + wrapHtml(attributes, element.insert);
  	}
  });

  return tooltipHtml;
} catch (e) {
}
};

VbiNumberFormat.prototype.getFormatString = function getFormatString(that, memberKey){
    var resultSet = null;
    var memberInfo = {
        'name': '',
        'formatString': ''
    };

    if (that.CID == 'solidgauge' || that.CID == 'progressbar' || that.CID == 'angulargauge') {
        resultSet = that.fulljson();
    }else if(that.CID === 'CCounter'){
        resultSet = that.countervalue();
    } else if(that.CID === 'NumCounter'){
        resultSet = that.source();
    } else{
        resultSet = that.result();
    }

    _.each(resultSet.dimensions, function(dimension){
        if(dimension.containsMeasures){
            _.each(dimension.members, function(member){
                if(member.key === memberKey){
                    memberInfo.name = member.text;
                    memberInfo.formatString = member.formatString || '';
                }
            });
        }
    });

    memberInfo.formatString = memberInfo.formatString.replace(/\\/g,'');
    return memberInfo;
};

VbiNumberFormat.prototype.getInitialViewNumberFormat = function getInitialViewNumberFormat(rawValue, formatString){
    var formatStringRegex = /(^[^#\d])?#(\D)##0(\D(?=0+))?(0*)?(?:\s(?=\w+))?(\w*)?/g;
    var formattedString = rawValue;
    var matched;
    var options = {
        sign:'',
        decimalSeparator: '',
        thousandSeparator: '',
        noOfDecimals: 0,
        unit:''
    };

    if(formatString){
        matched = formatStringRegex.exec(formatString);
        if(matched){
            options.sign = matched[1] || '';
            options.thousandSeparator = matched[2] || '';
            options.decimalSeparator = matched[3] || '';
            options.noOfDecimals = matched[4]? matched[4].length : 0;
            options.unit = matched[5] || '';

            //formattedString = Highcharts.numberFormat(rawValue, options.noOfDecimals, options.decimalSeparator, options.thousandSeparator);
        }
    }

    //formattedString = '<b>' +  this.processSemanticFormatting(rawValue,formattedString, semanticFormattingOptions) + '</b> ' + options.unit;
    //return memberInfo.name ?  memberInfo.name + ' ' + formattedString : formattedString;
    return options;
}

VbiNumberFormat.prototype.getDimensionAndMember = function getDimensionAndMember(that, point){
	var pointInfo = {
		dimension: '',
		member: ''
	};
	var dimensionIndex = that.categoriesIndex[point.index] || '';
	var splittedIndex = dimensionIndex.split('-');
	var dimensions = [];
	var members = [];
	var resultSet = that.result();
	if(typeof dimensionIndex !== 'undefined'){
		_.each(splittedIndex, function(indexes){
			var info = indexes.split(':');
			dimensions.push(resultSet.dimensions[info[0]].text);
			members.push(resultSet.dimensions[info[0]].members[info[1]].text);
		});
	}
	pointInfo.dimension = dimensions.join('\\');
	pointInfo.member = members.join('\\');
	return pointInfo;
}

VbiNumberFormat.prototype.numberFormat = function(data, decimalPlaces, decimalSeperator, thousandSeparator) {
    var value = parseFloat(data).toFixed(decimalPlaces);
    if (value.indexOf('.') > -1) {
        var gvalue = value.split('.');
        gvalue[0] = gvalue[0].replace(/\B(?=(\d{3})+(?!\d))/g, thousandSeparator);
        data = gvalue.join(decimalSeperator);
    } else {
        data = value.replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    }
    if(this.numberFormatOptions.appendPercenatge){
        data = data + '%';
    }
    return data;
};

VbiNumberFormat.prototype.getFormattedNumber = function getFormattedNumber(){
    var self = this;
    var options = self.numberFormatOptions;
    try{
        return Highcharts.numberFormat(options.y, options.noOfDecimals, options.decimalSeparator, options.thousandSeparator);
    }catch(e){
        return self.numberFormat(options.y, options.noOfDecimals, options.decimalSeparator, options.thousandSeparator);
    }
}

VbiNumberFormat.prototype.processScalingFactor = function processScalingFactor(baseString){
    var self = this;
    if(self.numberFormatOptions.scalingFactor){
        baseString = baseString + ' ' + (self.numberFormatOptions.scalingFactor ? self.numberFormatOptions.scalingFactor :'');
    }
    return baseString;
}

VbiNumberFormat.prototype.getScalingFactorString = function(that, measureKey){
    var dataResultValue = '';
    if (that.CID == 'solidgauge' || that.CID == 'progressbar' || that.CID == 'angulargauge') {
        dataResultValue = that.fulljson();
    }else if(that.CID === 'CCounter'){
        dataResultValue = that.countervalue();
    }else if(that.CID === 'NumCounter'){
        dataResultValue = that.source();
    } else {
        dataResultValue = that.dataRes || that.result();
    }
    var dimensions = dataResultValue.dimensions;
    var scalingFactorString = '';
    var member;
    var scalingFactor;
    if(typeof measureKey !== "undefined" && dimensions){
        for(var i=0; i<dimensions.length; i++){
            if(dimensions[i].containsMeasures){
                member = _.find(dimensions[i].members,{key: measureKey});
                if(member){
                    scalingFactor = member.scalingFactor || 0;
                    scalingFactorString = '(* ' + Math.pow(10, scalingFactor) + ')';
                }
                break;
            }
        }
    }

    return scalingFactorString;
};

VbiNumberFormat.prototype.getScalingFactor = function(that, measureKey){
    var dataResultValue = '';
    if (that.CID == 'solidgauge' || that.CID == 'progressbar' || that.CID == 'angulargauge') {
        dataResultValue = that.fulljson();
    }else if(that.CID === 'CCounter'){
        dataResultValue = that.countervalue();
    }else if(that.CID === 'NumCounter'){
        dataResultValue = that.source();
    } else {
        dataResultValue = that.result();
    }
    var dimensions = dataResultValue.dimensions;
    var scalingFactorString = '';
    var member;
    var scalingFactor;
    if(typeof measureKey !== "undefined" && dimensions){
        for(var i=0; i<dimensions.length; i++){
            if(dimensions[i].containsMeasures){
                member = _.find(dimensions[i].members,{key: measureKey});
                if(member){
                    scalingFactor = member.scalingFactor || 0;
                }
                break;
            }
        }
    }

    return scalingFactor;
};

VbiNumberFormat.prototype.getComposedProcess = function(){
    var self = this;
    if(!self.composedProcess){
        self.composedProcess = _.compose(
                        self.processSemanticFormattingColor.bind(self),
                        self.processPrefixSuffix.bind(self),
                        self.processScalingUnitPlacement.bind(self),
                        self.processUnitPlacement.bind(self),
                        self.processScalingFactor.bind(self),
                        self.processPercentAndStyle.bind(self),
                        self.processSemanticFormatting.bind(self),
                        self.getFormattedNumber.bind(self)
                    );
    }
    return self.composedProcess;
};

VbiNumberFormat.prototype.getInitialViewComposedProcess = function(){
    var self = this;
    if(!self.initialViewComposedProcess){
        self.initialViewComposedProcess = _.compose(
                        self.processSemanticFormattingColor.bind(self),
                        self.processUnitPlacement.bind(self),
                        self.processScalingFactor.bind(self),
                        self.processPercentAndStyle.bind(self),
                        self.processSemanticFormatting.bind(self),
                        self.getFormattedNumber.bind(self)
                    );
    }
    return self.initialViewComposedProcess;
};
