function boxPlotChartSeries() { // jshint ignore:line
    var that = this;
    /**
     * Map data from JSON Tuple to Highchart
     * @override
     * @param {object} component - Reference to component
     * @param {string} type - type of the chart
     * @param {object} defaultValue - HighCharts values
     * @return {Array} seriesNames
     */
    that.createSeriesData = function(component, defaultValue) {
        var colCount = 0;
        var rowCount = 0;
        var series = [];
        component.categoriesIndex = [];

        var ColArrayIndex = [];
        defaultValue.xAxis.categories = [];
        defaultValue.series = [{}];
        var xaxisLength = [];
        var tempColLastIndex;
        if (component.dataRes === undefined || component.dataRes === '') {
            return '';
        }

        var newsRowsIndex = [];
        var tempRowSelected = [];
        for (var i = 0; i < component.dataRes['axis_rows'].length; i++) {
            var RowName = '';
            var dimensionMemberPair = '';
            var tempRow = component.dataRes['axis_rows'][i];

            for (var k = 0; k < tempRow.length; k++) {
                if (tempRow[k] !== -1) {
                    if (RowName !== '') {
                        RowName = RowName + '/ ' + component.dataRes.dimensions[k].members[tempRow[k]].text;//VBX141-5817 || component.dataRes.dimensions[k].members[tempRow[k]].key;
                        dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempRow[k];
                    } else {
                        RowName = component.dataRes.dimensions[k].members[tempRow[k]].text;//VBX141-5817 || component.dataRes.dimensions[k].members[tempRow[k]].key;
                        dimensionMemberPair = k + ':' + tempRow[k];
                    }
                }
            }

            xaxisLength.push(RowName);
            ColArrayIndex.push(dimensionMemberPair);
            component.categoriesIndex.push(dimensionMemberPair);
        }
        /**
         *Creating Xaxis Categories
         **/
        newsRowsIndex = [];
        var dime;
        component.dimeColumn = "";
        for (var lenn = 0; lenn < component.dataRes.dimensions.length; lenn++) {
            if (component.dataRes.dimensions[lenn].containsMeasures !== true) {
                if (component.dataRes.dimensions[lenn].axis == 'COLUMNS') {
                    colCount++;
                    //column dimension count.
                    tempColLastIndex = lenn;
                } else if (component.dataRes.dimensions[lenn].axis == 'ROWS') {
                    rowCount++;
                    //row dimension count.
                    tempRowSelected.push(lenn);
                    newsRowsIndex.push(lenn);
                }
            } else {
                component.dimeColumn = false;
                dime = lenn;
                //Measures location//
                if (component.dataRes.dimensions[dime].axis == 'ROWS') {
                    component.dimeColumn = true;

                }
            }
        }

        var bool = false;
        if (component.dataRes.dimensions[dime].members.length == 1) {
            //only one Key-figure issue fix
            bool = true;
        }


        var majorData = [];
        var q1Arr, q3Arr;
        var TempData = component.dataRes.tuples;
        var TempDataLogic = 0;
        var TempDataLogicCol = 0;
        if (colCount === 0 && component.dimeColumn === false) {
            for (var d = 0; d < component.dataRes.data.length; d++) {
                if (majorData[TempDataLogic] === undefined) {
                    majorData[TempDataLogic] = [];
                }
                //Creating Array in column.
                var temp = component.dataRes.data[d];
                if (temp === null) {
                    temp = '/';
                }
                if (TempData[d][dime] === 0 && d!==0) {
                    TempDataLogic++;
                    majorData[TempDataLogic] = [];
                    majorData[TempDataLogic].push(temp);

                } else {
                    majorData[TempDataLogic].push(temp);
                }
                /**
                 *If there is no column then follow the direct logic.
                 *Creating Array depending on the measure value and assinging the value according to xAxis catagory
                 **/
            }
        } else if (colCount !== 0 && component.dimeColumn === false) {
            var TempDataLogic = 0;
            var TempDataLogicCol = 0;
            for (var d = 0; d < component.dataRes.data.length; d++) {
                TempDataLogic++;


                /**
                 *First creating the Array upon the measure Value
                 *Creating new Array when ever the loop is re-excuted once again
                 **/
                var temp = component.dataRes.data[d];
                if (temp === null) {
                    temp = '/';
                }

                if (majorData[TempDataLogicCol] === undefined) {
                    majorData[TempDataLogicCol] = [];
                }
                //single Array.
                majorData[TempDataLogicCol].push(temp);
                if (TempDataLogic ==component.dataRes.columnCount) {
                    TempDataLogic = 0;
                    TempDataLogicCol++;
                }
            }
        } else {
            if (colCount === 0) {
                for (var d = 0; d < component.dataRes.data.length; d++) {
                    if (majorData[d] === undefined) {
                        majorData[d] = [];
                    }
                    //Creating Array in column.
                    var temp = component.dataRes.data[d];
                    if (temp === null) {
                        temp = '/';
                    }

                    majorData[d].push(temp);
                }
            } else {
                //For getting the members length-And bisecting according to that.
                var tempVal = 0;
                var tempMesureArray1 = 0;
                for (var d = 0; d < component.dataRes.data.length; d++) {
                    if (component.dataRes.columnCount == tempVal) {
                        tempVal = 0;
                        tempMesureArray1++;
                    }

                    if (majorData[tempMesureArray1] === undefined) {
                        majorData[tempMesureArray1] = [];
                    }
                    //Creating Array in column.
                    var temp = component.dataRes.data[d];
                    if (temp === null) {
                        temp = '/';
                    }

                    majorData[tempMesureArray1].push(temp);
                    tempVal++;
                }
            }
        }

        var bardatacustomizationJson = {
            'COLUMNS': [],
            'ROWS': []
        };
        if (component.bardatacustomization() !== '') {
            bardatacustomizationJson = $.parseJSON(component.bardatacustomization());
        }


        /**
         *End of Datautility logic
         **/
        var boxplotSeries = [];
        var scatter = [];
        var bool = false;
        if (!component.boxplotcondition() && !component.dimeColumn) {
            if (component.testingArray() === '') {
                var temp = JSON.parse('{"0":"0","1":"0","2":"0","3":"0","4":"0","5":"0"}');
                bool = true;
            } else {
                var Arr = [];
                var temp = JSON.parse(component.testingArray());
                for (var j = 0; j < 6; j++) {
                    for (var i = 0; i < component.dataRes.dimensions[dime].members.length; i++) {
                        if (component.dataRes.dimensions[dime].members[i].key == temp[j]) {
                            i++;

                            Arr.push(i);
                        }
                    }
                }
                temp['0'] = Arr[0] === undefined ? 0 : Arr[0];
                temp['1'] = Arr[1] === undefined ? 0 : Arr[1];
                temp['2'] = Arr[2] === undefined ? 0 : Arr[2];
                temp['3'] = Arr[3] === undefined ? 0 : Arr[3];
                temp['4'] = Arr[4] === undefined ? 0 : Arr[4];
                temp['5'] = Arr[5] === undefined ? 0 : Arr[5];
            }

            var boxValues = function(values) {
                var boxValues = {};
                boxValues.min = temp['0'] === 0 ? 0 : values[temp['0'] - 1];
                boxValues.q1 = temp['1'] === 0 ? 0 : values[temp['1'] - 1];
                boxValues.median = temp['2'] === 0 ? 0 : values[temp['2'] - 1];
                boxValues.q3 = temp['3'] === 0 ? 0 : values[temp['3'] - 1];
                boxValues.high = temp['4'] === 0 ? 0 : values[temp['4'] - 1];
                try {

                    boxValues.lowunitofmeasure = component.dataRes.dimensions[dime].members[temp['0'] - 1].unitOfMeasure;
                    boxValues.lowscalingfactor = component.dataRes.dimensions[dime].members[temp['0'] - 1].scalingFactor;
                    boxValues.lowUniqueKey = component.dataRes.dimensions[dime].members[temp['0'] - 1].key;

                    boxValues.q1unitofmeasure = component.dataRes.dimensions[dime].members[temp['1'] - 1].unitOfMeasure;
                    boxValues.q1scalingfactor = component.dataRes.dimensions[dime].members[temp['1'] - 1].scalingFactor;
                    boxValues.q1UniqueKey = component.dataRes.dimensions[dime].members[temp['1'] - 1].key;


                    boxValues.medianunitofmeasure = component.dataRes.dimensions[dime].members[temp['2'] - 1].unitOfMeasure;
                    boxValues.medianscalingfactor = component.dataRes.dimensions[dime].members[temp['2'] - 1].scalingFactor;
                    boxValues.medianUniqueKey = component.dataRes.dimensions[dime].members[temp['2'] - 1].key;


                    boxValues.q3unitofmeasure = component.dataRes.dimensions[dime].members[temp['3'] - 1].unitOfMeasure;
                    boxValues.q3scalingfactor = component.dataRes.dimensions[dime].members[temp['3'] - 1].scalingFactor;
                    boxValues.q3UniqueKey = component.dataRes.dimensions[dime].members[temp['3'] - 1].key;

                    boxValues.highunitofmeasure = component.dataRes.dimensions[dime].members[temp['4'] - 1].unitOfMeasure;
                    boxValues.highscalingfactor = component.dataRes.dimensions[dime].members[temp['4'] - 1].scalingFactor;
                    boxValues.highUniqueKey = component.dataRes.dimensions[dime].members[temp['4'] - 1].key;

                } catch (e) {}
                return boxValues;
            };

            for (var i = 0; i < majorData.length; i++) {
                var values = majorData[i];

                boxplotSeries.push(boxValues(values));
                var tempOutlier = temp['5'] === 0 ? 0 : values[temp['5'] - 1];
                if (tempOutlier !== 0) {
                    scatter.push([
                        i,
                        tempOutlier
                    ]);
                }
            }

            series = [];
            series.push({
                data: boxplotSeries,
                name: 'Box-plot',
                key:''+dime+':0',
                color: component.boxplotplotseriesColor()
            });
            series.push({
                data: scatter,
                name: 'outlier',
                type: 'scatter',
                key:''+dime+':0',
                color: component.boxplotplotseriesoutlier(),
                marker: {
                    fillColor: 'white',
                    lineWidth: 1,
                    lineColor: component.boxplotplotseriesoutlier()
                }
            });
        }


        var isMinmum = function(value) {
            return function(element) {
                return element < value;
            };
        };

        var isMaximum = function(value) {
            return function(element) {
                return element > value;
            };
        };

        var getHighchartsValue = function(data) {
            if (data.length === 0) {
                data.push('');
            }

            var boxValues = {};
            boxValues.low = data[0];
            boxValues.q1 = data[0];
            boxValues.median = data[0];
            boxValues.q3 = data[0];
            boxValues.high = data[0];
            return boxValues;
        };

        var median = function(values) {
            var half = Math.floor(values.length / 2);
            if (values.length % 2) {
                return values[half];//odd
            } else {
                return (values[half - 1] + values[half]) / 2;//even
            }
        };
        //Logic for Finding Mean

        var getBoxValue = function(data, valueswithoutsort) { // jshint ignore:line
            var boxValues = {};
            var q1 = median(q1Arr);
            var medianMean = median(data);
            var q3 = median(q3Arr);
            var iqr = q3 - q1;
            var minimum = values.filter(isMinmum(q1 - 1.5 * iqr));
            var maximum = values.filter(isMaximum(q3 + 1.5 * iqr));
            if (minimum.length < 1) {
                boxValues.low = Math.min.apply(Math, data);
            } else {
                var cal = q1 * 25 / 100 + q1;
                if (cal === 0) {
                    boxValues.low = 0; //if q1 is zero
                } else {
                    var local = values.filter(isMinmum(cal));
                    //to check outlier
                    if (local.length < 1) {
                        boxValues.low = Math.min.apply(Math, data);
                    } else {
                        boxValues.low = Math.min.apply(Math, local);
                    }
                }
            }
            boxValues.q1 = q1;
            boxValues.median = medianMean;
            boxValues.q3 = q3;


            if (maximum.length < 1) {
                boxValues.high = Math.max.apply(Math, data);
            } else {
                var cal = q3 * 25 / 100 + q3;
                if (cal === 0) {
                    boxValues.high = 0; //if q3 is zero//
                } else {
                    var local = values.filter(isMaximum(cal));
                    //find outlier above q3
                    if (local.length < 1) {
                        boxValues.high = Math.max.apply(Math, data);
                    } else {
                        boxValues.high = Math.min.apply(Math, local);
                    }
                }
            }
            return boxValues;
        };
        /**
         *Creating the data for Highchart Logic
         **/


        if (component.boxplotcondition()) {

            for (var i = 0; i < majorData.length; i++) {
                var values = majorData[i];
                var valueswithoutsort = majorData[i];
                values = values.filter(function(n) {
                    return n != '/';
                });

                values.sort(function(a, b) {
                    return a - b;
                });
                //Need to Sort() the Data First.
                q1Arr = values.length % 2 === 0 ? values.slice(0, (values.length / 2)-1) : values.slice(0, Math.ceil(values.length / 2));
                //for sclice q1
                //q2Arr =  Median;
                q3Arr = values.length % 2 === 0 ? values.slice(values.length / 2, values.length-1) : values.slice(Math.floor(values.length / 2), values.length);
                //var iqr = getBoxValue(values, valueswithoutsort).q3 - getBoxValue(values, valueswithoutsort).q1;
                //  var calIqr = iqr * 1.5;
                var minimum = values.filter(isMinmum(getBoxValue(values, valueswithoutsort).low));
                var maximum = values.filter(isMaximum(getBoxValue(values, valueswithoutsort).high));
                if (maximum.length >= 1) {
                    for (var j = 0; j < maximum.length; j++) {
                        if (maximum[i] != getBoxValue(values, valueswithoutsort).high) {
                            scatter.push([
                                i,
                                maximum[j]
                            ]);
                        }
                    }
                }

                if (maximum.length >= 1) {
                    for (var k = 0; k < minimum.length; k++) {
                        if (minimum[i] != getBoxValue(values, valueswithoutsort).low) {
                            scatter.push([
                                i,
                                minimum[k]
                            ]);
                        }
                    }
                }


                if (values.length <= 1) {
                    boxplotSeries.push(getHighchartsValue(values));
                } else {
                    boxplotSeries.push(getBoxValue(values, valueswithoutsort));
                }
            }

            series = [];
            series.push({
                data: boxplotSeries,
                name: 'Box-plot',
                color: component.boxplotplotseriesColor()
            });
            series.push({
                data: scatter,
                name: 'outlier',
                type: 'scatter',
                color: component.boxplotplotseriesoutlier(),
                marker: {
                    fillColor: 'white',
                    lineWidth: 1,
                    lineColor: component.boxplotplotseriesoutlier()
                }
            });
        }

        if (component.enablehierarchylabels() === true) {
            defaultValue.xAxis.categories = this.createHierarchyLabels(component.dataRes, newsRowsIndex, component);
            /* Following code is required to manipulate the series according to the order of xAxis categories.
            			   This case will occur when the row Dimension selected in Data Utility is not in the same order as in Initial View.
            			*/
            var selRowInd = [];
            selRowInd = selRowInd.concat(newsRowsIndex);
            selRowInd.sort(function(a, b) {
                return a - b;
            });

            if (selRowInd.join(',') != newsRowsIndex.join(',')) {
                var newCategoriesOrder = [];
                $.each(defaultValue.xAxis.categories, function(i, v) {
                    that.createFlatCategory(v, newCategoriesOrder, [v.name]);
                });

                var newcategoryDataRowAggr = [];
                $.extend(true, newcategoryDataRowAggr, series);
                $.each(newCategoriesOrder, function(i, v) {
                    var k = xaxisLength.indexOf(v);
                    $.each(newcategoryDataRowAggr, function(ind, ele) {
                        var val = ele.data[k];
                        series[ind].data[i] = val;
                    });
                });
            }
        } else {
            defaultValue.xAxis.categories = xaxisLength; //Xaxis Values
        }

        defaultValue.series = series;
        return defaultValue;
    };
}
