/*jshint loopfunc: true */
function bulletSeries() { //jshint ignore:line
	var that = this;
	that.calculateQualitativeRange = function (qmPercent1, qmPercent2, seriesData, qmIndex, rangeSliderJson, valArray, stackedqm) {
		var qmArr = [
			0,
			0,
			0
		];
		qmArr[qmIndex] = 1;
		for (var i = 0; i < seriesData[qmIndex].data.length; i++) {
			var count = 0;
			for (var j = qmArr.length - 1; j >= 0; j--) {
				if (qmArr[j] != 1) {
					count++;
					//var percentage=(Number(count==1?qmPercent1:qmPercent2)/100);
					var val = Number(seriesData[qmIndex].data[i].y) * (Number(count == 1 ? qmPercent1 : qmPercent2) / 100);
					//alert("val="+val);
					seriesData[j].data[i].y = val; //console.log("seriesData["+qmIndex+"].data["+i+"].y="+seriesData[qmIndex].data[i].y+" seriesData["+j+"].data["+i+"].y="+seriesData[j].data[i].y);
				}
			}

			//rangeSliderJson[seriesData[qmIndex].data[i].key].from = seriesData[2].data[i].y;
			//rangeSliderJson[seriesData[qmIndex].data[i].key].to = seriesData[1].data[i].y;
			if (!rangeSliderJson[seriesData[qmIndex].data[i].key]) {
				rangeSliderJson[seriesData[qmIndex].data[i].key] = {
					"config": "auto",
					"maxtype": "abs"
				};
			}
			rangeSliderJson[seriesData[qmIndex].data[i].key].qm1 = 0; //qm1 start
			rangeSliderJson[seriesData[qmIndex].data[i].key].qm2 = seriesData[2].data[i].y; //qm2 start
			rangeSliderJson[seriesData[qmIndex].data[i].key].qm3 = seriesData[1].data[i].y; //qm3 start
			if (stackedqm) {
				rangeSliderJson[seriesData[qmIndex].data[i].key].qm3 += rangeSliderJson[seriesData[qmIndex].data[i].key].qm2;
			}

			valArray.push(rangeSliderJson[seriesData[qmIndex].data[i].key].qm2);
			valArray.push(rangeSliderJson[seriesData[qmIndex].data[i].key].qm3);
			valArray.push(seriesData[0].data[i].y);
		}
	};

	that.populateRangeSliderJson = function (seriesData, rangeSliderJson, valArray, stackedqm) {
		for (var i = 0, len = seriesData[3].data.length; i < len; i++) {
			var catKey = seriesData[3].data[i].key;
			rangeSliderJson[catKey] = {
				"qm1": 0,
				"config": "auto",
				"maxtype": "abs"
			};

			rangeSliderJson[catKey]["qm2"] = seriesData[2].data[i].y;
			rangeSliderJson[catKey]["qm3"] = seriesData[1].data[i].y;
			if (stackedqm) {
				rangeSliderJson[catKey]["qm3"] += rangeSliderJson[catKey]["qm2"];
			}
			valArray.push(rangeSliderJson[catKey]["qm2"]);
			valArray.push(rangeSliderJson[catKey]["qm3"]);
			valArray.push(seriesData[0].data[i].y);
		}
	};

	that.transformRangeSliderJson = function (rangeSliderJson, min, max) {
		var qRangeJson = $.extend({}, rangeSliderJson);
		/*
		Mapping
		-----------
		qm1 => min,
		qm2 => from,
		qm3 => to,
		max => max
		 */
		$.each(qRangeJson, function (key, obj) {
			obj.qm1 = min;
			obj.qm2 = obj.from || 0;
			obj.qm3 = obj.to || 0;
			obj.max = max;
			obj.maxtype = "abs";
			obj.config = "auto";
			delete obj.from;
			delete obj.to;
		});
		return qRangeJson;
	};

	/* Check if Start of each bullet is same in order to be plotted on the same scale otherwise start with default */
	that.isQm1Same = function (rangeSliderJson) {
		var rangeKeys = Object.keys(rangeSliderJson),
		ret = true,
		i = 1,
		len = rangeKeys.length;
		for (; i < len; i++) {
			if (rangeSliderJson[rangeKeys[i]].qm1 !== rangeSliderJson[rangeKeys[i - 1]].qm1) {
				ret = false;
				break;
			}
		}
		return ret;
	};

	that.bulletValueAggregation = function (component, dataArr) {
		if(dataArr.length === 1)
		{
			return dataArr[0];
		}
		var getSum = function (numArr) {
			var sum = 0;
			var nullCount = 0;
			$.each(numArr, function (index, value) {
				sum += value;
				if(value === null){
					nullCount++;
				}
			});
			return numArr.length === nullCount ? null : sum;
		},
		getNumWithSetDec = function (num, numOfDec) {
			var pow10s = Math.pow(10, numOfDec || 0);
			return numOfDec ? Math.round(pow10s * num) / pow10s : num;
		},
		getAverageFromNumArr = function (numArr) {
			var sum = getSum(numArr);
			return getNumWithSetDec(sum / numArr.length, 2);
		},
		getVariance = function (numArr) {

			var avg = getAverageFromNumArr(numArr),
			i = numArr.length,
			v = 0;
			while (i--) {
				v += Math.pow(numArr[i] - avg, 2);
			}

			v /= numArr.length;
			return getNumWithSetDec(v, 2);
		},
		getStandardDeviation = function (numArr) {

			var stdDev = Math.sqrt(getVariance(numArr));
			return getNumWithSetDec(stdDev, 2);
		};

		if (component.chartaggregation() === '') {
			component.chartaggregation('sum');
		}

		if (component.chartaggregation() == 'sum') {
			return getSum(dataArr);
		} else if (component.chartaggregation() == 'avg') {
			return getAverageFromNumArr(dataArr);
		} else if (component.chartaggregation() == 'min') {
			return Math.min.apply(Math, dataArr);
		} else if (component.chartaggregation() == 'max') {
			return Math.max.apply(Math, dataArr);
		} else if (component.chartaggregation() == 'sd') {
			return getStandardDeviation(dataArr);
		} else if (component.chartaggregation() == 'variance') {
			return getVariance(dataArr);
		}
	};

	that.isScalingFactorEnabled = function(component){
		var scalingFactorEnable = component.scalingfactorenable(); 
		return component.numberFormatDefinition() === 'customNumberFormat' && (scalingFactorEnable === true || scalingFactorEnable === 'true');
	};

	that.setColumnMemberJson = function(component){
		var resultSet = component.dataRes;
		var index = [];
		var key = [];
		var text = [];
		var i = 0;
		component.columnMembersJson = {};
		if(resultSet && resultSet['axis_columns']){
			_.each(resultSet['axis_columns'], function(columnTuple){
				index.length = 0;
				key.length = 0;
				text.length = 0;
				for(i=0;i<columnTuple.length;i++){
					if(columnTuple[i] === -1){
						break;
					}

					if(resultSet.dimensions[i].members[columnTuple[i]].type === 'RESULT'){
						// Ignore the tuple if any of it's member is a result
						index.length = 0;
						key.length = 0;
						text.length = 0;
					}

					if(!resultSet.dimensions[i].containsMeasures){
						key.push(resultSet.dimensions[i].members[columnTuple[i]].key);
						text.push(resultSet.dimensions[i].members[columnTuple[i]]['picker_text']);
						index.push(i + ':' + columnTuple[i]);
					}
				}

				if(key.length){					
					component.columnMembersJson[key.join('-')] = {
						'text': text.join('-'),
						'index': index.join('-')
					};
				}
			});
		}
	};
	/**
	 * Map data from JSON Tuple to Highchart
	 * @override
	 * @param {object} component - Reference to component
	 * @param {string} type - type of the chart
	 * @param {object} defaultValue - HighCharts values
	 * @return {Array} seriesNames
	 */
	that.createSeriesData = function (component, type, defaultValue, vbiNumberFormat) {
		var self = this;
		var scalingFactorEnabled = self.isScalingFactorEnabled(component);
		// var seriesColor = component.dataseriescolor().split(",");
		component.categoriesIndex = [];
		//var columnCount = 0;
		//console.log("Series Data");
		//    alert('overridden');
		var noOfColumns = 0;
		//var noOfCellsInRow = 1;
		var bulletDefaultColor = ['#000000'];
		var seriesColor = [];
		if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
			seriesColor = [];
		} else {
			seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
		}

		var stackedqm = component.stackedvalues();
		var scalingFactorPerformanceMeasure = 0;
		var scalingFactorComparativeMeasure1 = 0;
		var scalingFactorComparativeMeasure2 = 0;
		var scalingfactorqualitativerange = 0;
		var featuredMeasureIndex = 0;
		var measureDimensionIndex = self.getMeasureDimensionIndex(component);
		var membersJsonLocal = {};
		var measureJson = JSON.parse(component.getMeasureJson());
		var measureMembersLength = Object.keys(measureJson).length;		
		var measurelist = component.measurelistbullet();

		if (measurelist !== null && measurelist !== undefined && measurelist !== '') {
			if (!isNaN(Number(measurelist)) && measurelist < measureMembersLength)
				// Managing Migrations
			{
				featuredMeasureIndex = measurelist;
			} else if (measureJson[measurelist]) {
				featuredMeasureIndex = measureJson[measurelist].index;
			}
		}

		var compSFPM = component.scalingfactorperformancemeasure();
		if (scalingFactorEnabled && compSFPM != -1 && compSFPM !== undefined && compSFPM !== '' && compSFPM !== ' ') {
			scalingFactorPerformanceMeasure = compSFPM;
		}

		var comparativeMeasureIndex = [];
		var comparativemeasurelist1 = component.comparativemeasurelist1();
		if (comparativemeasurelist1 !== null && comparativemeasurelist1 !== undefined && comparativemeasurelist1 !== '') {
			if (!isNaN(Number(comparativemeasurelist1)) && comparativemeasurelist1 < measureMembersLength)
				// Managing Migrations
			{
				comparativeMeasureIndex = comparativeMeasureIndex.concat(comparativemeasurelist1);
			} else {
				comparativeMeasureIndex = comparativeMeasureIndex.concat(measureJson[comparativemeasurelist1] ? measureJson[comparativemeasurelist1].index : 'none');
			}
		} else {
			var cm = featuredMeasureIndex + 1;
			if (cm >= component.dataRes.dimensions[measureDimensionIndex].members.length) {
				cm = cm - 2;
			}

			comparativeMeasureIndex.push(cm);
		}

		if (scalingFactorEnabled && component.scalingfactorcomparativemeasure1() !== undefined && component.scalingfactorcomparativemeasure1() !== '' && component.scalingfactorcomparativemeasure1() !== ' ') {
			scalingFactorComparativeMeasure1 = component.scalingfactorcomparativemeasure1();
		}

		if (scalingFactorEnabled && component.scalingfactorcomparativemeasure2() !== undefined && component.scalingfactorcomparativemeasure2() !== '' && component.scalingfactorcomparativemeasure2() !== ' ') {
			scalingFactorComparativeMeasure2 = component.scalingfactorcomparativemeasure2();
		}

		if (scalingFactorEnabled && component.scalingfactorqualitativerange() !== undefined && component.scalingfactorqualitativerange() !== '' && component.scalingfactorqualitativerange() !== ' ') {
			scalingfactorqualitativerange = component.scalingfactorqualitativerange();
		}
		component.measurelistbullet(component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].key);
		component.comparativemeasurelist1(comparativeMeasureIndex[0] == 'none' ? 'none' : component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].key);
		var comparativemeasurelist2 = component.comparativemeasurelist2();
		if (comparativemeasurelist2 !== null && comparativemeasurelist2 !== undefined && comparativemeasurelist2 !== '' && comparativemeasurelist2 != 'none') {
			if (!isNaN(Number(comparativemeasurelist2)) && comparativemeasurelist2 < measureMembersLength)
				// Managing Migrations
			{
				comparativeMeasureIndex = comparativeMeasureIndex.concat(comparativemeasurelist2);
			}

			if (measureJson[comparativemeasurelist2]) {
				comparativeMeasureIndex = comparativeMeasureIndex.concat(measureJson[comparativemeasurelist2].index);
			}
		}

		var unitOfMeasureFMI = (component.unitcurrency() || component.showunit()) ? component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].unitOfMeasure || '' : '';
		var unitOfMeasureCMI = ((component.showunit() || component.unitcurrency()) && comparativeMeasureIndex[0] != 'none') ? component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].unitOfMeasure || '' : '';

		var scalingfactorFMI = scalingFactorEnabled ? component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].scalingFactor || '' : '';
		//var scalingfactorCMI = (scalingFactorEnabled && comparativeMeasureIndex[0] != 'none') ? component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].scalingFactor || '' : '';

		//alert("component.datalabelbackgroundcolor()="+component.datalabelbackgroundcolor());
		var seriesData = [{
				pointRange: isNaN(Number(component.qmpointrange())) || Number(component.qmpointrange()) <= 0 || Number(component.qmpointrange()) > 2 ? 1 : Number(component.qmpointrange()),
				name: 'Bands 3',
				key: '',
				unitOfMeasure: '',
				enableMouseTracking: false,
				borderWidth: 0,
				borderRadius: 0,
				stacking: stackedqm ? 'normal' : null,
				grouping: false,
				color: 'rgba(156,156,156,.1)',
				data: []
			}, {
				pointRange: isNaN(Number(component.qmpointrange())) || Number(component.qmpointrange()) <= 0 || Number(component.qmpointrange()) > 2 ? 1 : Number(component.qmpointrange()),
				name: 'Bands 2',
				key: '',
				unitOfMeasure: '',
				enableMouseTracking: false,
				borderWidth: 0,
				borderRadius: 0,
				stacking: stackedqm ? 'normal' : null,
				grouping: false,
				color: 'rgba(156,156,156,.4)',
				data: []
			}, {
				pointRange: isNaN(Number(component.qmpointrange())) || Number(component.qmpointrange()) <= 0 || Number(component.qmpointrange()) > 2 ? 1 : Number(component.qmpointrange()),
				name: 'Bands 1',
				key: '',
				unitOfMeasure: '',
				enableMouseTracking: false,
				borderWidth: 0,
				borderRadius: 0,
				stacking: stackedqm ? 'normal' : null,
				grouping: false,
				color: 'rgba(156,156,156,.7)',
				data: []
			}, {
				name: 'Measure',
				key: '',
				unitOfMeasure: unitOfMeasureFMI,
				//scalingFactor: scalingfactorFMI,
				pointRange: isNaN(Number(component.pmpointrange())) || Number(component.pmpointrange()) <= 0 || Number(component.pmpointrange()) > 2 ? 0.5 : Number(component.pmpointrange()),
				zIndex: 10,
				dataLabels: {
					enabled: component.datalabelenabled(),
					align: component.datalabelalign(),
					crop: component.datalabelcrop(),
					//defer: component.datalabeldefer(),
					backgroundColor: component.datalabelbackgroundcolor().trim() === '' ? undefined : component.datalabelbackgroundcolor(),
					borderColor: component.datalabelbordercolor(),
					borderRadius: component.datalabelborderradius(),
					borderWidth: component.datalabelborderwidth(),
					padding: component.datalabelpadding(),
					rotation: component.datalabelrotation(),
					shadow: component.datalabelshadow(),
					overflow: 'justify',
					verticalAlign: component.datalabelverticalalign(),
					inside: component.datalabelinside(),
					x: component.datalabelx(),
					y: component.datalabely(),
					formatter: function () {
						
					    var semanticFormattingOptions = {
					        'enableSemanticFormatting': component.enableSemanticFormatting(),
					        'negativeValueSemanticFormat': component.negativeValueSemanticFormat(),
					        'negativeValueSemanticFormatColor': component.negativeValueSemanticFormatColor(),
					        'positiveValueSemanticFormat': component.positiveValueSemanticFormat(),
					        'positiveValueSemanticFormatColor': component.positiveValueSemanticFormatColor()
					    };

					    if(component.dataRes && component.numberFormatDefinition() === 'initialView'){
					    	var	keyval = component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].key;					    	
						    var memberInfo = vbiNumberFormat.getFormatString(component, keyval);
						    var formatString =  memberInfo.formatString.split(';')[0]; // eg. "#,##0.000;'-'#,##0.000"
						    var rawValue = this.y;
						    var initialViewOptions = vbiNumberFormat.getInitialViewNumberFormat(rawValue, formatString);
						    var dataLabelScalingFactorString =keyval ? vbiNumberFormat.getScalingFactorString(component, keyval) : '';
						    
						    vbiNumberFormat.numberFormatOptions = {
						        'noOfDecimals': initialViewOptions.noOfDecimals,
						        'decimalSeparator' : initialViewOptions.decimalSeparator,
						        'thousandSeparator' : initialViewOptions.thousandSeparator,
						        'y': rawValue,
						        'semanticFormattingOptions' : semanticFormattingOptions,
						        'unit':initialViewOptions.unit ? '(in ' + initialViewOptions.unit + ')' : '',
						        'unitPlacement': '10$',
						        'percent': false,
						        'scalingFactor': dataLabelScalingFactorString,
						        'appendPercenatge' : false
						    };

						    var composedProcess = vbiNumberFormat.getInitialViewComposedProcess();
						    return composedProcess();
					    }else{
							var scalingFactor = '',
								unitOfMeasure = '';
							if (scalingFactorEnabled) {
								if (component.scalingfactorperformancemeasure() === -1 || component.scalingfactorperformancemeasure() === "-1") {
									scalingFactor = ' (* ' + Math.pow(10, scalingfactorFMI) + ')';
								} else {
									scalingFactor = ' (* ' + Math.pow(10, component.scalingfactorperformancemeasure()) + ')';
								}
							}
							if (component.showunit() || component.unitcurrency()) {
								unitOfMeasure = (unitOfMeasureFMI !== '' ? ' (in ' + unitOfMeasureFMI + ')' : '');
							}
						    var scalingUnit = '';
						    var showScalingUnit = component.showscalingunit();
						    if(showScalingUnit){
						        scalingUnit = component.numberFormatScalingUnit();
						    }
						    vbiNumberFormat.numberFormatOptions = {
						        'noOfDecimals': isNaN(component.decimal()) ? 2 : component.decimal(),
						        'decimalSeparator' : component.bulletdecimalseparator(),
						        'thousandSeparator' : component.bulletthousandseparator(),
						        'y': this.y,
						        'semanticFormattingOptions' : semanticFormattingOptions,
						        //'showUnit': that.showUnit(),
						        'unit': unitOfMeasure,
						        'unitPlacement': component.unitPlacement() || '10$',
						        'showScalingUnit':component.showscalingunit(),
						        'scalingUnit': scalingUnit,
						        'scalingUnitPlacement': component.scalingUnitPlacement(),
						        'prefix': component.datalabelprefix(),
						        'suffix': component.datalabelsuffix(),
						        'scalingFactor' : scalingFactor,
						        'percent':  false,
						        'appendPercenatge' : false
						    };
					      var composedProcess = vbiNumberFormat.getComposedProcess();
						    var baseString = vbiNumberFormat.composedProcess();
								if(component.customdatalabel() !== ""  && Object.keys(JSON.parse(component.customdatalabel()||'{}')).length && this.point.series.name.toLocaleLowerCase().indexOf('result') == -1 && this.key.toLocaleLowerCase().indexOf('result') == -1){
										return vbiNumberFormat.bulletTextFormatter(this,component,',','.',false,baseString);
								}else {
									 return baseString;
								}
					    }

					},

					style: {
						color: component.datalabeltextcolor(),
						fontWeight: component.datalabelfontweight(),
						textDecoration: component.datalabelfontweight(),
						fontSize: component.datalabelfontsize() + 'px',
						fontFamily: component.globalfont() ? component.fontfamily() : component.datalabelfontfamily()
					}
				},
				data: []
			}, {
				name: '__Target__',
				key: '',
				type: 'scatter',
				unitOfMeasure: unitOfMeasureCMI,
				// scalingFactor: scalingfactorCMI,
				color: component.scattermarkerlinecolor1(),
				zIndex: 20,
				marker: {
					symbol: 'line',
					lineWidth: component.scattermarkerlinewidth1(),
					//that.scattermarkerlinewidth()
					radius: component.scattermarkerlineradius1(),
					//that.scattermarkerlineradius()
					lineColor: component.scattermarkerlinecolor1() //
				},
				data: []
			}
		];
		
		SeriesLibrary.prototype.adjustDataLabelAlignment.call(null, component, seriesData[3]);

		var defaultValuexAxiscategories = [];
		var seriesCategory = [];
		//var dispKeyText = component.dispkeytext();
		//var xAxisCategories = [];
		//component.measurelistbullet(featuredMeasureIndex.toString());
		//component.comparativemeasurelist1(comparativeMeasureIndex[0]);
		/*if(component.comparativemeasurelist2()!=null && component.comparativemeasurelist2()!=undefined && component.comparativemeasurelist2()!="" && component.comparativemeasurelist2()!="none")
	{
		comparativeMeasureIndex=comparativeMeasureIndex.concat(component.comparativemeasurelist2());

		}*/
		if (comparativeMeasureIndex.length == 2) {
			var unitOfMeasure = (component.showunit() || component.unitcurrency()) ? component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[1]].unitOfMeasure || '' : '';
			//var scalingfactor = (scalingFactorEnabled) ? component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[1]].scalingFactor || '' : '';
			seriesData.push({
				name: '',
				key: '',
				type: 'scatter',
				unitOfMeasure: unitOfMeasure,
				//scalingFactor: scalingfactor,
				color: component.scattermarkerlinecolor2(),
				zIndex: 20,
				marker: {
					symbol: 'line',
					lineWidth: component.scattermarkerlinewidth2(),
					//that.scattermarkerlinewidth()
					radius: component.scattermarkerlineradius2(),
					//that.scattermarkerlineradius()
					lineColor: component.scattermarkerlinecolor2() //
				},
				data: []
			});
		}

		/*if (component.tooltipshared()) {
		defaultValue.tooltip.pointFormatter = function() {
		var index = this.index;
		var allSeries = this.series.chart.series;
		var tooltipStr = '';
		$.each(allSeries, function(seriesIndex, seriesObj) {
		if (seriesObj.name != 'Bands 1' && seriesObj.name != 'Bands 2' && seriesObj.name != 'Bands 3') {
		if (seriesIndex != 4 || seriesIndex == 4 && comparativeMeasureIndex[0] != 'none') {
		tooltipStr += '<span style="color:' + seriesObj.data[index].color + '">\u25CF</span>' + seriesObj.name + ': <b>' + component.tooltipvalueprefix() + Highcharts.numberFormat(seriesObj.data[index].y, isNaN(component.tooltipvaluedecimals()) ? 2 : component.tooltipvaluedecimals(), component.bulletdecimalseparator(), component.bulletthousandseparator()) + ' ' + seriesObj.userOptions.unitOfMeasure + ' ' + component.tooltipvaluesuffix() + '</b><br/>';
		}
		}
		});

		return tooltipStr;
		};

		seriesData[4].tooltip.pointFormatter = defaultValue.tooltip.pointFormatter;
		if (seriesData.length == 6) {
		seriesData[5].tooltip.pointFormatter = defaultValue.tooltip.pointFormatter;
		}
		} else {
		defaultValue.tooltip.pointFormatter = function() {
		return '<span style="color:' + this.color + '">\u25CF</span> ' + this.series.name + ': <b>' + component.tooltipvalueprefix() + Highcharts.numberFormat(this.y, isNaN(component.tooltipvaluedecimals()) ? 2 : component.tooltipvaluedecimals(), component.bulletdecimalseparator(), component.bulletthousandseparator()) + ' ' + unitOfMeasureFMI + ' ' + component.tooltipvaluesuffix() + '</b><br/>';
		};
		}
		 */
		if (component.dataRes === undefined || component.dataRes === '' || component.dataRes['axis_columns'][0].indexOf(-1) < 1) {
			return '';
		}

		for (var i = 0; i < component.dataRes.dimensions.length; i++) {
			if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
				noOfColumns++;
			}
		}

		//var noOfRows = component.dataRes.dimensions.length - noOfColumns;
		//var selectedDimensions = [];
		var selectedColumndim = '';
		//var selectedRowdim = [];
		var selectedColumndimIndexes = [];
		var selectedRowdimIndexes = [];
		var qm1 = 0;
		var qm1Val = component.qualitativemeasure1();
		if (!isNaN(Number(qm1Val)) && qm1Val < measureMembersLength)
			// Managing Migrations
		{
			qm1 = qm1Val;
		} else {
			qm1 = measureJson[qm1Val] ? measureJson[qm1Val].index : 'none';
		}

		var qm1UnitOfMeasure = (component.showunit() || component.unitcurrency()) && qm1 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm1].unitOfMeasure || '' : '';
		var qm1Scf = (scalingFactorEnabled) && qm1 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm1].scalingFactor || '' : '';
		seriesData[2].unitOfMeasure = qm1UnitOfMeasure;
		if (qm1Scf !== '') {
			seriesData[2].scalingFactor = qm1Scf;
		}

		var qm2 = 0;
		var qm2Val = component.qualitativemeasure2();
		if (!isNaN(Number(qm2Val)) && qm2Val < measureMembersLength)
			// Managing Migrations
		{
			qm2 = qm2Val;
		} else {
			qm2 = measureJson[qm2Val] ? measureJson[qm2Val].index : 'none';
		}

		var qm2UnitOfMeasure = ((component.unitcurrency() || component.showunit()) && qm2 != 'none') ? component.dataRes.dimensions[measureDimensionIndex].members[qm2].unitOfMeasure || '' : '';
		var qm2Scf = ((scalingFactorEnabled) && qm2 != 'none') ? component.dataRes.dimensions[measureDimensionIndex].members[qm2].scalingFactor || '' : '';
		seriesData[1].unitOfMeasure = qm2UnitOfMeasure;
		if (qm2Scf !== '') {
			seriesData[1].scalingFactor = qm2Scf;
		}

		var qm3 = 0;
		var qm3Val = component.qualitativemeasure3();
		if (!isNaN(Number(qm3Val)) && qm3Val < measureMembersLength)
			// Managing Migrations
		{
			qm3 = qm3Val;
		} else {
			qm3 = measureJson[qm3Val] ? measureJson[qm3Val].index : 'none';
		}

		var qm3UnitOfMeasure = (component.showunit() || component.unitcurrency()) && qm3 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm3].unitOfMeasure || '' : '';
		var qm3Scf = scalingFactorEnabled && qm3 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm3].scalingFactor || '' : '';
		seriesData[0].unitOfMeasure = qm3UnitOfMeasure;
		if (qm3Scf !== '') {
			seriesData[0].scalingFactor = qm3Scf;
		}

		var bardatacustomizationJson = {
			'COLUMNS': [],
			'ROWS': []
		};
		if (component.bardatacustomization() !== '') {
			bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
		}
		if (component.datautility() && (bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0)) {
			this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
		} else {
			if (Object.keys(component.columnMembersJson).length > 0) {
				selectedColumndimIndexes = selectedColumndimIndexes.concat(component.columnMembersJson[Object.keys(component.columnMembersJson)[0]].index.split('-'));
				selectedColumndim = component.columnMembersJson[Object.keys(component.columnMembersJson)[0]].text;
			}

			for (var i = noOfColumns; i < component.dataRes.dimensions.length; i++) {
				selectedRowdimIndexes.push(i);
			}
		}

		var tuplesInARow = component.dataRes.tuples.slice(0, component.dataRes.columnCount);
		// Getting tuples for all Columns in first row of crosstab.
		var colRowIndexJson = {};
		var colNamesJson = {};
		for (var i = 0; i < tuplesInARow.length; i++) {
			var tempTuple = tuplesInARow[i].slice(0, noOfColumns);
			if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, undefined, component.showtotaldatabase()) === true) {
				var colKey = '';
				var colName = '';
				var textappend='';
				var unmatched = 0;
				if (tempTuple[measureDimensionIndex] == featuredMeasureIndex || tempTuple[measureDimensionIndex] == comparativeMeasureIndex[0] || tempTuple[measureDimensionIndex] == comparativeMeasureIndex[1] || tempTuple[measureDimensionIndex] == qm1 || tempTuple[measureDimensionIndex] == qm2 || tempTuple[measureDimensionIndex] == qm3) {
					colKey = measureDimensionIndex + ':' + tempTuple[measureDimensionIndex];
					colName = measureJson[component.dataRes.dimensions[measureDimensionIndex].members[tempTuple[measureDimensionIndex]].key].text;
					for (var j = 0; j < selectedColumndimIndexes.length; j++) {
						var tempCol = selectedColumndimIndexes[j].split(':');
						if (tempTuple[tempCol[0]] != tempCol[1]) {
							unmatched = 1;
							break;
						}
						if(colName!==" " && colName!==""){
							 textappend='-';
						}
						colName += textappend + component.dataRes.dimensions[tempCol[0]].members[tempCol[1]].text;
					}
				} else {
					unmatched = 1;
				}

				if (unmatched === 0) {
					colKey += '-' + selectedColumndimIndexes.join('-');
					// below lines to be used  if aggregation is available at column. As specific columns are selected, no need of an Array.
					/*if(typeof col_row_index_json[colKey] == "undefined")
				{
					col_row_index_json[colKey]=[];
					}
					col_row_index_json[colKey].push(i);   */
					colRowIndexJson[colKey] = i;
					colNamesJson[colKey] = colName;
				}
			}
		}
		//console.log("col_row_index_json="+JSON.stringify(col_row_index_json));
		//console.log("colNamesJson="+JSON.stringify(colNamesJson));
		var tupleToSkip = 0;
		var tuplesInColumn = [];
		//var rowIndexJson = {};
		var rowNames = {};
		var rowDataJson = {};
		var rowDataJsonWithInfo = {};
		var showtotaldatabase = component.showtotaldatabase();
		var datautility = component.datautility();
		var groupedRowIndexesJson = {};
		var rowDataJsonKeys = [];
		//alert("that.dataRes.rowCount="+that.dataRes.rowCount);
		if (component.showsubtotal() && selectedRowdimIndexes.length > 1) {
			for (var i = 0; i < component.dataRes.rowCount; i++) {
				//rowDataArr.push([]);
				tupleToSkip = component.dataRes.columnCount * i;
				tuplesInColumn.push(component.dataRes.tuples[tupleToSkip]);
				var tempTuple = tuplesInColumn[i];
				/*#VBX141-4729*/
				var hasResultIntuple = [];
				if (datautility && showtotaldatabase) {
					for (var j = noOfColumns, tLen = tempTuple.length; j < tLen; j++) {
						if (component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT") {
							hasResultIntuple.push(tempTuple[j]);
						}
					}
				}
				if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, 'ROWS', component.showtotaldatabase()) === true) {
					var rowKey = 0;
					var rowKeyIndex = 0;
					var rowHeader = 'Dimensions';
					var rowKeyIndexArr = [];
					if (selectedRowdimIndexes.length >= 1) {
						var parentIndex;
						for (var j = 0; j < selectedRowdimIndexes.length; j++) {
							if (j === 0) {
								rowKeyIndex = selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]];
								rowHeader = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].text;
								rowKey = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key.replace(/\s/g, '_');
								parentIndex = rowKeyIndex;
							} else {
								parentIndex = rowKeyIndex;
								rowKeyIndex += '-' + selectedRowdimIndexes[j] + ':' + tempTuple[selectedRowdimIndexes[j]];
								if (component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text) {
									rowHeader += (rowHeader !== "" ? '\\' : '') + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text;
								}
								rowKey += '/' + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].key.replace(/\s/g, '_');
							}

							rowKeyIndexArr.push(rowKeyIndex);
							if (typeof rowNames[rowKeyIndex] == 'undefined') {
								//rowDataJson[rowKey]=[];
								rowNames[rowKeyIndex] = {
									'text': rowHeader,
									'key': rowKey
								};
								if (groupedRowIndexesJson[parentIndex]) {
									if (!groupedRowIndexesJson[rowKeyIndex]) {
										groupedRowIndexesJson[parentIndex].push(rowKeyIndex);
										if (j < selectedRowdimIndexes.length - 1) {
											groupedRowIndexesJson[rowKeyIndex] = [];
										}
									}
								} else {
									groupedRowIndexesJson[parentIndex] = [];
								} //defaultValuexAxiscategories.push(rowKey);
								//series_category.push(rowHeader);
								//component.categoriesIndex.push(rowKeyIndex);
							}
						}
					}

					$.each(colRowIndexJson, function (key, value) {
						var curIndex = value + tupleToSkip;
						$.each(rowKeyIndexArr, function (ind, val) {
							var keygen = key + '_' + val;
							if (rowDataJson[keygen] === undefined) {
								rowDataJson[keygen] = [];
								rowDataJsonWithInfo[keygen] = [];
							}

							rowDataJson[keygen].push(component.dataRes.data[curIndex]);
							/*#VBX141-4729*/
							if (datautility && showtotaldatabase && hasResultIntuple.length) {
								var lastTempStore,
								lastTempstoreLen = 0;
								var totalLen = hasResultIntuple.length;
								if (rowDataJsonWithInfo[keygen].length) {
									lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
									lastTempstoreLen = lastTempStore[0];
								}
								if (lastTempstoreLen < totalLen) {
									rowDataJsonWithInfo[keygen].length = 0;
								}
								rowDataJsonWithInfo[keygen].push([totalLen, (component.dataRes.data[curIndex] === null ? 0 : component.dataRes.data[curIndex])]);
							}
						});
					});
				}
			}

			//console.log("groupedJson="+JSON.stringify(groupedRowIndexesJson));
			// Group members and their subtotal members
			var groupedRowIndexes = [];
			var createFlatMembers = function (grpmem) {
				groupedRowIndexes.push(grpmem);
				defaultValuexAxiscategories.push(rowNames[grpmem].key);
				seriesCategory.push(rowNames[grpmem].text);
				component.categoriesIndex.push(grpmem);
				if (groupedRowIndexesJson[grpmem]) {
					$.each(groupedRowIndexesJson[grpmem], function (ind, val) {
						createFlatMembers(val);
					});
				}
			};

			for (var i = 0; i < component.dataRes.dimensions[selectedRowdimIndexes[0]].members.length; i++) {
				var grpmem = selectedRowdimIndexes[0] + ':' + i;
				if (groupedRowIndexesJson[grpmem]) {
					createFlatMembers(grpmem);
				}
			}

			$.each(colRowIndexJson, function (key) {
				$.each(component.categoriesIndex, function (ind, val) {
					var keygen = key + '_' + val;
					rowDataJsonKeys.push(keygen);
				});
			});
		} else {
			for (var i = 0; i < component.dataRes.rowCount; i++) {
				//rowDataArr.push([]);
				tupleToSkip = component.dataRes.columnCount * i;
				tuplesInColumn.push(component.dataRes.tuples[tupleToSkip]);
				var tempTuple = tuplesInColumn[i];
				/*#VBX141-4729*/
				var hasResultIntuple = [];
				if (datautility && showtotaldatabase) {
					for (var j = noOfColumns, tLen = tempTuple.length; j < tLen; j++) {
						if (component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT") {
							hasResultIntuple.push(tempTuple[j]);
						}
					}
				}
				if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, 'ROWS', component.showtotaldatabase()) === true) {
					var rowKey = 0;
					var rowKeyIndex = 0;
					var rowHeader = 'Dimensions';
					if (selectedRowdimIndexes.length >= 1) {
						rowKeyIndex = selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]];
						rowHeader = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].text;
						rowKey = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key.replace(/\s/g, '_');
						for (var j = 1; j < selectedRowdimIndexes.length; j++) {
							//rowKey+=":"+temp_tuple[component.selectedRowIndex[j]];
							rowKeyIndex += '-' + selectedRowdimIndexes[j] + ':' + tempTuple[selectedRowdimIndexes[j]];
							if (component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text) {
								rowHeader += (rowHeader !== "" ? '\\' : '') + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text;
							}
							rowKey += '/' + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].key.replace(/\s/g, '_');
						}
					}

					if (typeof rowNames[rowKeyIndex] == 'undefined') {
						//rowDataJson[rowKey]=[];
						rowNames[rowKeyIndex] = {
							'text': rowHeader,
							'key': rowKey
						};
						defaultValuexAxiscategories.push(rowKey);
						seriesCategory.push(rowHeader);
						component.categoriesIndex.push(rowKeyIndex);
					}

					$.each(colRowIndexJson, function (key, value) {
						var curIndex = value + tupleToSkip;
						var keygen = key + '_' + rowKeyIndex;
						if (rowDataJson[keygen] === undefined) {
							rowDataJson[keygen] = [];
							rowDataJsonWithInfo[keygen] = [];
						}

						rowDataJson[keygen].push(component.dataRes.data[curIndex]);

						/*#VBX141-4729*/
						if (datautility && showtotaldatabase && hasResultIntuple.length) {
							var lastTempStore,
							lastTempstoreLen = 0;
							var totalLen = hasResultIntuple.length;
							if (rowDataJsonWithInfo[keygen].length) {
								lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
								lastTempstoreLen = lastTempStore[0];
							}
							if (lastTempstoreLen < totalLen) {
								rowDataJsonWithInfo[keygen].length = 0;
							}
							rowDataJsonWithInfo[keygen].push([totalLen, (component.dataRes.data[curIndex] === null ? 0 : component.dataRes.data[curIndex])]);
						}
					});
				}
			}

			rowDataJsonKeys = Object.keys(rowDataJson);
		}

		/*#VBX141-4729*/
		if (datautility && showtotaldatabase) {
			$.each(rowDataJsonWithInfo, function (k, v) {
				if (v.length) {
					rowDataJson[k].length = 0;
					for (var i = 0, len = v.length; i < len; i++) {
						rowDataJson[k].push(Number(v[i][1]));
					}
				}
			});
		}
		//console.log("rowNames="+JSON.stringify(rowNames));
		var noData = false; //Done for VBX141-3973
		// Due to issue VBX141-6373, Commenting the below code as the check for formattedValue leads to set noData = true when value = null but formattedValue = "$ 0"
		/*
		$.each(rowDataJsonKeys, function(ind, key) {
		var valueArr = rowDataJson[key];
		var colrowkey = key.split('_');
		if(colrowkey[0].split('-')[0].split(':')[1] == featuredMeasureIndex) { //performance measure
		if(  valueArr[0] === null  && valueArrFormatted[0]!=="" && /[-!$%^&*()_+|~=`{}\[\]:\";'<>?\/]/.test(valueArrFormatted[0])){
		noData = true; // to avoid date,time(unwanted) data
		}
		}
		if (colrowkey[0].split('-')[0].split(':')[1] == comparativeMeasureIndex[0]) { //comparativeMeasure1
		if(  valueArr[0] === null  && valueArrFormatted[0]!=="" && /[-!$%^&*()_+|~=`{}\[\]:\";'<>?\/]/.test(valueArrFormatted[0])){
		noData = true; // to avoid date,time(unwanted) data
		}
		}
		if (colrowkey[0].split('-')[0].split(':')[1] == comparativeMeasureIndex[1]) {//comparativeMeasure2
		if(  valueArr[0] === null  && valueArrFormatted[0]!=="" && /[-!$%^&*()_+|~=`{}\[\]:\";'<>?\/]/.test(valueArrFormatted[0])){
		noData = true; // to avoid date,time(unwanted) data
		}
		}

		if (colrowkey[0].split('-')[0].split(':')[1] == qm1) {//QualitativeMeasure1
		if(  valueArr[0] === null  && valueArrFormatted[0]!=="" && /[-!$%^&*()_+|~=`{}\[\]:\";'<>?\/]/.test(valueArrFormatted[0])){
		noData = true; // to avoid date,time(unwanted) data
		}
		}

		if (colrowkey[0].split('-')[0].split(':')[1] == qm2) {//QualitativeMeasure2
		if(  valueArr[0] === null  && valueArrFormatted[0]!=="" && /[-!$%^&*()_+|~=`{}\[\]:\";'<>?\/]/.test(valueArrFormatted[0])){
		noData = true; // to avoid date,time(unwanted) data
		}
		}

		if (colrowkey[0].split('-')[0].split(':')[1] == qm3) {//QualitativeMeasure3
		if(  valueArr[0] === null  && valueArrFormatted[0]!=="" && /[-!$%^&*()_+|~=`{}\[\]:\";'<>?\/]/.test(valueArrFormatted[0])){
		noData = true; // to avoid date,time(unwanted) data
		}
		}

		});*/
		var nullCount = 0;
		var valueCount = 0;
		_.each(rowDataJson, function (values) {
			nullCount += _.reduce(values, function (memo, value) {
				return _.isNull(value) ? memo + 1 : memo;
			}, 0);
			valueCount += values.length;
		});

		if (nullCount === valueCount) {
			noData = true;
		}

		if (!noData) { //if not invalid data
			var valArray = [];
			var totalArr = [];
			totalArr.length = seriesData.length;
			var seriesIndex = [];
			$.each(rowDataJsonKeys, function (ind, key) {
				var valueArr = rowDataJson[key];
        var colrowkey = key.split('_');
        var rowIndexKeyLength = colrowkey[1].split("-").length;
        var measureIndex = colrowkey[0].split('-')[0].split(':')[1];
				var yVal = that.bulletValueAggregation(component, valueArr); //mano
				seriesIndex = [];
				if (measureIndex == featuredMeasureIndex) {
					seriesData[3].name = colNamesJson[colrowkey[0]];
					seriesData[3].key = colrowkey[0];
					seriesData[3].data.push({
						name: rowNames[colrowkey[1]].text,
            key: rowNames[colrowkey[1]].key,
            rowIndex: colrowkey[1],
						y: yVal,
						color: self.getSeriesColors(component, seriesColor, seriesData[3].data.length, bulletDefaultColor)
					});
					seriesIndex.push(3);
					var k = 3;
					var i = seriesData[3].data.length - 1;
					var dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].scalingFactor || 0;
					seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
					if (scalingFactorPerformanceMeasure) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingFactorPerformanceMeasure);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingFactorPerformanceMeasure) + ')';
						}

						seriesData[3].scalingFactor = scalingFactorPerformanceMeasure;
					} else {
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, dsSscalingfactor) + ')';
						}
					}

					valArray.push(seriesData[k].data[i].y);
				} else if (measureIndex == comparativeMeasureIndex[0]) {
					seriesData[4].name = colNamesJson[colrowkey[0]];
					seriesData[4].key = colrowkey[0];
					seriesData[4].data.push({
						name: rowNames[colrowkey[1]].text,
            key: rowNames[colrowkey[1]].key,
            rowIndex: colrowkey[1],
						y: yVal
					});
					seriesIndex.push(4);
					var k = 4;
					var i = seriesData[4].data.length - 1;
					var dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].scalingFactor || 0;
					seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
					if (scalingFactorComparativeMeasure1) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingFactorComparativeMeasure1);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingFactorComparativeMeasure1) + ')';
						}

						seriesData[k].scalingFactor = scalingFactorComparativeMeasure1;
					} else {
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].scalingFactor || 0) + ')';
						}
					}

					valArray.push(seriesData[k].data[i].y);
				} else if (measureIndex == comparativeMeasureIndex[1]) {
					seriesData[5].name = colNamesJson[colrowkey[0]];
					seriesData[5].key = colrowkey[0];
					seriesData[5].data.push({
						name: rowNames[colrowkey[1]].text,
            key: rowNames[colrowkey[1]].key,
            rowIndex: colrowkey[1],
						y: yVal
					});
					seriesIndex.push(5);
					var k = 5;
					var i = seriesData[5].data.length - 1;
					var dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[1]].scalingFactor || 0;
					seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;

					if (scalingFactorComparativeMeasure2) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingFactorComparativeMeasure2);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingFactorComparativeMeasure2) + ')';
						}

						seriesData[k].scalingFactor = scalingFactorComparativeMeasure2;
					} else {
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[1]].scalingFactor || 0) + ')';
						}
					}

					valArray.push(seriesData[k].data[i].y);
				}

				if (measureIndex == qm1) {
					seriesData[2].name = colNamesJson[colrowkey[0]];
					seriesData[2].key = colrowkey[0];
					seriesData[2].data.push({
						name: rowNames[colrowkey[1]].text,
            key: rowNames[colrowkey[1]].key,
            rowIndex: colrowkey[1],
						y: yVal
					});
					seriesIndex.push(2);
				} else if (measureIndex == qm2) {
					seriesData[1].name = colNamesJson[colrowkey[0]];
					seriesData[1].key = colrowkey[0];
					seriesData[1].data.push({
						name: rowNames[colrowkey[1]].text,
            key: rowNames[colrowkey[1]].key,
            rowIndex: colrowkey[1],
						y: yVal
					});
					seriesIndex.push(1);
				} else if (measureIndex == qm3) {
					seriesData[0].name = colNamesJson[colrowkey[0]];
					seriesData[0].key = colrowkey[0];
					seriesData[0].data.push({
						name: rowNames[colrowkey[1]].text,
            key: rowNames[colrowkey[1]].key,
            rowIndex: colrowkey[1],
						y: yVal
					});
					seriesIndex.push(0);
				}

        /**
         * VBX141-4864
         */
				if (component.showtotal() && selectedRowdimIndexes.length === rowIndexKeyLength) {
					$.each(seriesIndex, function (k, v) {
						if (totalArr[v] === undefined) {
							totalArr[v] = valueArr;
						} else {
							totalArr[v] = totalArr[v].concat(valueArr);
						}
					});
				}
			});

			// VBX141-8422
			if(seriesData[3].data.length === 0){
				return 8; // for noData --> zero supprerssion enabled and there is not data for performance measure.
			}

			if (component.showtotal()) {
				for (var i = 0; i < seriesData.length; i++) {
					if (totalArr[i] !== undefined) {
						var y = that.bulletValueAggregation(component, totalArr[i]);
						if (i == 3) {
							if (scalingFactorPerformanceMeasure) {
								y = y * Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].scalingFactor || 0) / Math.pow(10, scalingFactorPerformanceMeasure);
							}

							valArray.push(y);
							seriesData[i].data.push({
								name: 'Total',
                key: 'Total',
								y: y,
								color: self.getSeriesColors(component, seriesColor, seriesData[3].data.length, bulletDefaultColor)
							});
						} else if (i == 4) {
							if (scalingFactorComparativeMeasure1) {
								y = y * Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].scalingFactor || 0) / Math.pow(10, scalingFactorComparativeMeasure1);
							}

							valArray.push(y);
							seriesData[i].data.push({
								name: 'Total',
                key: 'Total',
								y: y
							});
						} else if (i == 5) {
							if (scalingFactorComparativeMeasure2) {
								y = y * Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[1]].scalingFactor || 0) / Math.pow(10, scalingFactorComparativeMeasure2);
							}

							valArray.push(y);
							seriesData[i].data.push({
								name: 'Total',
                key: 'Total',
								y: y
							});
						} else {
							seriesData[i].data.push({
								name: 'Total',
                key: 'Total',
								y: y
							});
						}
					}
				}

				defaultValuexAxiscategories.push('Total');
				seriesCategory.push('Total Result');
			}
			//console.log("seriesData="+JSON.stringify(seriesData));
			//var categoryIndexes = [];
			seriesColor.splice(seriesData[3].data.length, seriesColor.length);
			var rangeSliderJson = {};
			var dsSscalingfactor = "";
			for (var i = 0; i < seriesData[3].data.length; i++) {
				rangeSliderJson[defaultValuexAxiscategories[i]] = {};
				rangeSliderJson[defaultValuexAxiscategories[i]].qm1 = 0;
				rangeSliderJson[defaultValuexAxiscategories[i]].qm2 = 0;
				rangeSliderJson[defaultValuexAxiscategories[i]].qm3 = 0;

				//console.log("defaultValuexAxiscategories[i]="+defaultValuexAxiscategories[i]);
				for (var k = 0; k < 3; k++) {
					if (k === 0) {
						//alert("seriesData[k].data["+i+"]="+seriesData[k].data[i]);
						if (typeof seriesData[k].data[i] == 'undefined') {
							seriesData[k].data.push({
								name: '',
								y: 0
							});
						}

						if (!isNaN(qm3)) {
							dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[qm3].scalingFactor || 0;
							seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
						}

						if (scalingfactorqualitativerange && !isNaN(qm3)) {
							seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingfactorqualitativerange);
							if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
								seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingfactorqualitativerange) + ')';
							}

							seriesData[k].scalingFactor = scalingfactorqualitativerange;
						} else if (scalingFactorEnabled === true && !isNaN(qm3) && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[qm3].scalingFactor || 0) + ')';
						}

						if (component.qualitativescale3colors() !== undefined && component.qualitativescale3colors() !== null && component.qualitativescale3colors() !== '') {
							seriesData[k].data[i].color = component.qualitativescale3colors();
						}
					} else if (k == 1) {
						if (typeof seriesData[k].data[i] == 'undefined') {
							seriesData[k].data.push({
								name: '',
								y: 0
							});
						}

						if (!isNaN(qm2)) {
							dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[qm2].scalingFactor || 0;
							seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
						}

						if (scalingfactorqualitativerange && !isNaN(qm2)) {
							seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingfactorqualitativerange);
							if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
								seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingfactorqualitativerange) + ')';
							}

							seriesData[k].scalingFactor = scalingfactorqualitativerange;
						} else if (scalingFactorEnabled === true && !isNaN(qm2) && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[qm2].scalingFactor || 0) + ')';
						}

						if (component.qualitativescale2colors() !== undefined && component.qualitativescale2colors() !== null && component.qualitativescale2colors() !== '') {
							seriesData[k].data[i].color = component.qualitativescale2colors();
						}
						/*if(typeof seriesData[k].data[i].y=== undefined){
						seriesData[k].data[i].y=0;
						}*/
						//rangeSliderJson[defaultValuexAxiscategories[i]].to = seriesData[k].data[i].y; //rangeSliderJson[defaultValuexAxiscategories[i]].to=rangeSliderJson[defaultValuexAxiscategories[i]].from + seriesData[k].data[i].y;
					} else if (k == 2) {
						if (typeof seriesData[k].data[i] == 'undefined') {
							seriesData[k].data.push({
								name: '',
								y: 0
							});
						}

						if (!isNaN(qm1)) {
							dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[qm1].scalingFactor || 0;
							seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
						}

						if (scalingfactorqualitativerange && !isNaN(qm1)) {
							seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingfactorqualitativerange);
							valArray.push(seriesData[k].data[i].y);
							if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
								seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingfactorqualitativerange) + ')';
							}

							seriesData[k].scalingFactor = scalingfactorqualitativerange;
						} else if (scalingFactorEnabled === true && !isNaN(qm1) && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[qm1].scalingFactor || 0) + ')';
						}

						if (component.qualitativescale1colors() !== undefined && component.qualitativescale1colors() !== null && component.qualitativescale1colors() !== '') {
							seriesData[k].data[i].color = component.qualitativescale1colors();
						}

						// rangeSliderJson[defaultValuexAxiscategories[i]].from = seriesData[k].data[i].y;
						//rangeSliderJson[defaultValuexAxiscategories[i]].to = rangeSliderJson[defaultValuexAxiscategories[i]].from + rangeSliderJson[defaultValuexAxiscategories[i]].to;
					}
				}
			}

			for (var j = 0; j < component.categoriesIndex.length; j++) {
				var catArr = [];
				var catNm = [];
				var category = component.categoriesIndex[j];
				catArr = catArr.concat(category.split('-'));
				for (var i = 0; i < catArr.length; i++) {
					var dimMemIndex = catArr[i].split(':');
					catNm.push(component.dataRes.dimensions[dimMemIndex[0]].members[dimMemIndex[1]].key);
				}

				membersJsonLocal[catNm.join('/')] = j;
			}

			//var tempMax = parseFloat(component.datamaxrange());
			var tempMin = parseFloat(component.dataminrange());
			tempMin = tempMin < 0 ? tempMin : 0;
			var dataMax = Math.max.apply(Math, valArray);
			var dataMin = Math.min.apply(Math, valArray);
			dataMin = dataMin < 0 ? dataMin : 0;
			component.datamaxrange(dataMax);
			component.dataminrange(dataMin);
			var rangeDiff = dataMax - dataMin;

			if (component.qualitativerange() !== null && component.qualitativerange() !== undefined && component.qualitativerange() !== '' && Object.keys(jQuery.parseJSON(component.qualitativerange())).toString() == defaultValuexAxiscategories.toString()) {
				rangeSliderJson = jQuery.parseJSON(component.qualitativerange());
				// making rangeSliderJson compatible with previous versions
				if (Object.keys(rangeSliderJson).length && !rangeSliderJson[Object.keys(rangeSliderJson)[0]].hasOwnProperty("qm1")) {
					rangeSliderJson = self.transformRangeSliderJson(rangeSliderJson, dataMin, dataMax);
				}
			}

			if (component.qualitativemeasure1() == 'none' && component.qualitativemeasure2() == 'none' && component.qualitativemeasure3() == 'none') {
				var fromVal = dataMin + rangeDiff / 3;
				var toVal = dataMax - rangeDiff / 3;
				fromVal = fromVal.toFixed(2);
				toVal = toVal.toFixed(2);

				for (var j = 0; j < defaultValuexAxiscategories.length; j++) {
					var qObj = rangeSliderJson[defaultValuexAxiscategories[j]] || '';
					if (!qObj || !qObj.config || qObj.config == "auto") {
						rangeSliderJson[defaultValuexAxiscategories[j]] = {
							qm1: dataMin,
							qm2: fromVal,
							qm3: toVal,
							max: dataMax,
							maxtype: "abs",
							config: "auto"
						};
					}
					if (rangeSliderJson[defaultValuexAxiscategories[j]]) {
						rangeSliderJson[defaultValuexAxiscategories[j]]['pm'] = seriesData[3].data[j].y;
					}
				}
				//console.log("getter==="+JSON.stringify(rangeSliderJson));
				var toVal = 0;
				for (var i = 2; i >= 0; i--) {
					for (var j = 0; j < defaultValuexAxiscategories.length; j++) {
						var qmObj = rangeSliderJson[defaultValuexAxiscategories[j]];
						if (i === 0) {
							toVal = qmObj.maxtype == "percent" ? seriesData[3].data[j].y * Number(qmObj.max) / 100 : Number(qmObj.max);
							if (stackedqm) {
								toVal = toVal - Number(qmObj.qm3);
							}
							seriesData[i].data[j].y = toVal;
							if (component.qualitativescale3colors() !== undefined && component.qualitativescale3colors() !== null && component.qualitativescale3colors() !== '') {
								seriesData[i].color = component.qualitativescale3colors();
							}
						} else if (i == 1) {
							toVal = stackedqm ? Number(qmObj.qm3) - Number(qmObj.qm2) : Number(qmObj.qm3);
							seriesData[i].data[j].y = toVal;
							if (component.qualitativescale2colors()) {
								seriesData[i].color = component.qualitativescale2colors();
							}
						} else {
							toVal = Number(qmObj.qm2) - Number(qmObj.qm1);
							seriesData[i].data[j].y = toVal;
							//console.log("seriesData["+i+"].data="+seriesData[i].data);
							if (component.qualitativescale1colors() !== undefined && component.qualitativescale1colors() !== null && component.qualitativescale1colors() !== '') {
								seriesData[i].color = component.qualitativescale1colors();
							}
						}
					}
				}
			} else if (component.qualitativemeasure1() != 'none' || component.qualitativemeasure2() != 'none' || component.qualitativemeasure3() != 'none') {
				var qm1Percent = 0,
				qm2Percent = 0,
				qm3Percent = 0;
				if (qm1 == 'none' && qm2 == 'none') {
					qm1Percent = isNaN(component.percentagequalitativerange1()) ? 0 : component.percentagequalitativerange1();
					qm2Percent = isNaN(component.percentagequalitativerange3()) ? 0 : component.percentagequalitativerange3();
					this.calculateQualitativeRange(qm1Percent, qm2Percent, seriesData, '0', rangeSliderJson, valArray, stackedqm);
				} else if (qm2 == 'none' && qm3 == 'none') {
					qm2Percent = isNaN(component.percentagequalitativerange1()) ? 0 : component.percentagequalitativerange1();
					qm3Percent = isNaN(component.percentagequalitativerange3()) ? 0 : component.percentagequalitativerange3();
					this.calculateQualitativeRange(qm2Percent, qm3Percent, seriesData, '2', rangeSliderJson, valArray, stackedqm);
				} else if (qm1 == 'none' && qm3 == 'none') {
					qm1Percent = isNaN(component.percentagequalitativerange1()) ? 0 : component.percentagequalitativerange1();
					qm3Percent = isNaN(component.percentagequalitativerange3()) ? 0 : component.percentagequalitativerange3();
					this.calculateQualitativeRange(qm1Percent, qm3Percent, seriesData, '1', rangeSliderJson, valArray, stackedqm);
				} else {
					this.populateRangeSliderJson(seriesData, rangeSliderJson, valArray, stackedqm);
				}

				component.datamaxrange(Math.max.apply(Math, valArray));
				component.dataminrange(Math.min.apply(Math, valArray));
				dataMax = parseFloat(component.datamaxrange());
				dataMin = parseFloat(component.dataminrange());
				rangeDiff = dataMax - dataMin;
			} else {
				this.createSmokeScreen(component.$(), 'Please select measure for atleast one Qualitative Measure');
			}

			var dataChangedFlag = 0;
			if (dataMax != component.yaxismaxval() || dataMin != component.yaxisminval()) {
				dataChangedFlag = 1;
				component.yaxismaxval(dataMax);
				component.yaxisminval(dataMin);
			}

			if (component.setQualitativeRangeCalled() === true) {
				rangeSliderJson = jQuery.parseJSON(component.qualitativerange());

				//var membersChanged = [];
				var qmObj = {};
				for (var i = 2; i >= 0; i--) {
					for (var j = 0; j < defaultValuexAxiscategories.length; j++) {
						qmObj = rangeSliderJson[defaultValuexAxiscategories[j]];
						if (i == 2) {
							/*if(seriesData[i].data[j].y != parseFloat(qmObj.qm2)){
							membersChanged.push(j);
							}*/
							seriesData[i].data[j].y = parseFloat(qmObj.qm2) - parseFloat(qmObj.qm1);
						} else if (i == 1) {
							var toVal = parseFloat(qmObj.qm3);
							if (stackedqm) {
								toVal = toVal - parseFloat(qmObj.qm2);
							}
							seriesData[i].data[j].y = toVal;
						} else {
							//if(membersChanged.indexOf(j)!=-1){
							var toVal = 0;

							if (qmObj.config == "auto") {
								toVal = dataMax;
							} else {
								toVal = qmObj.maxtype == "percent" ? seriesData[3].data[j].y * Number(qmObj.max) / 100 : Number(qmObj.max);
							}

							if (stackedqm) {
								toVal = toVal - parseFloat(qmObj.qm3);
							}
							seriesData[i].data[j].y = toVal;
							//}

						}
					}
				}
			}

			if (component.membersJson() != JSON.stringify(membersJsonLocal) || component.qualitativerange() != JSON.stringify(rangeSliderJson)) {
				component.qualChangedFlag = 1;
			}

			component.qualitativerange(JSON.stringify(rangeSliderJson));
			component.membersJson(JSON.stringify(membersJsonLocal));
			component.dataseriescolor(seriesColor.join());

			component["getorginal_Category"] = jQuery.extend(true, [], seriesCategory);
			defaultValue.xAxis.categories = seriesCategory;
			try {
				if (component.enablehierarchylabels() === true) {
					defaultValue.xAxis.categories = this.createHierarchyLabels(component.dataRes, selectedRowdimIndexes, component);
					//  defaultValue.xAxis.categories = this.createHierarchyLabelsStacked(component.dataRes);
					// Code to process subtotal in categories
					if (component.showsubtotal() && selectedRowdimIndexes.length > 1) {
						var oSubcat = defaultValue.xAxis.categories;
						$.each(oSubcat, function (i, cat) {
							that.insertSubTotalInCategory(cat);
						});
						//console.log(JSON.stringify(oSubcat));
					}
					/* Following code is required to manipulate the series according to the order of xAxis categories.
					This case will occur when the row Dimension selected in Data Utility is not in the same order as in Initial View.
					 */
					var selRowInd = [];
					selRowInd = selRowInd.concat(selectedRowdimIndexes);
					selRowInd.sort(function (a, b) {
						return a - b;
					});

					if (selRowInd.join(',') != selectedRowdimIndexes.join(',')) {
						var newCategoriesOrder = [];
						$.each(defaultValue.xAxis.categories, function (i, v) {
							that.createFlatCategory(v, newCategoriesOrder, [v.name]);
						});

						var newcategoryDataRowAggr = [];
						$.extend(true, newcategoryDataRowAggr, seriesData);
						$.each(newCategoriesOrder, function (i, v) {
							var k = seriesCategory.indexOf(v);
							$.each(newcategoryDataRowAggr, function (ind, ele) {
								var val = ele.data[k].y;
								seriesData[ind].data[i].y = val;
							});
						});
					}
				}
			} catch (e) {}

			defaultValue.series = seriesData;
			var dataToReturn = [];
			if (component.xaxisminval() !== 0 || component.xaxismaxval() != defaultValuexAxiscategories.length) {
				dataChangedFlag = 1;
				component.xaxisminval(0);
				component.xaxismaxval(defaultValuexAxiscategories.length);
			}

			dataToReturn = dataToReturn.concat(seriesCategory);
			var options = {
				seriesCategory: seriesCategory,
				seriesData: seriesData,
				component: component,
				defaultValue: defaultValue,
				defaultValuexAxiscategories: defaultValuexAxiscategories,
				stackedqm: stackedqm,
				rangeSliderJson: rangeSliderJson
			};

			if (component.individualscale()) {
				self.renderBulletWithIndividualScale(options);
			} else if (self.isQm1Same(rangeSliderJson)) {
				var threshold = Number(rangeSliderJson[Object.keys(rangeSliderJson)[0]].qm1);
				defaultValue.yAxis.min = threshold;
				defaultValue.plotOptions.bar.threshold = threshold;
				defaultValue.plotOptions.column.threshold = threshold;
				defaultValue.plotOptions.scatter.threshold = threshold;
				defaultValue.yAxis.tickPositioner = function () {
					var positions = this.tickPositions.slice(0);
					positions.splice(0, 1, this.min);
					// if new tick is very close to its neighbour then it overlaps. Hence moving the neighbour.
					if (positions[1] - positions[0] < this.tickInterval / 2) {
						positions[1] = positions[0] + this.tickInterval / 2;
					}
					return positions;
				};
			}

			return dataToReturn;
		} else {
			return 7; // for noData --> Invalid Data
		}
	};

	that.insertSubTotalInCategory = function (cat) {
		var that = this;
		if (cat.categories) {
			cat.categories.unshift(cat.name);
			$.each(cat.categories, function (i, val) {
				that.insertSubTotalInCategory(val);
			});
		}
	};

	that.renderBulletWithIndividualScale = function (options) {
		var seriesCategory = options.seriesCategory,
		seriesData = options.seriesData,
		defaultValue = options.defaultValue,
		component = options.component,
		seriesCategoryKey = options.defaultValuexAxiscategories,
		stackedqm = options.stackedqm,
		rangeSliderJson = options.rangeSliderJson,
		container = component.$(),
		containerProps = {
			height: (100 / seriesCategoryKey.length) + '%',
			width: "100%"
		},
		div = "",
		containerId = container.attr('id'),
		index = 0,
    JSONValidator = new trialLibrary();

    component.neighbourBullets = [];

		defaultValue.title.style.display = 'none';
		defaultValue.subtitle.style.display = 'none';
		defaultValue.exporting.buttons.contextButton.enabled = false;
		defaultValue.chart.margin = [5, 15, 30, 150];
		// if chart type is column then swap height and width
		if (defaultValue.chart.type == "column") {
			var temp = containerProps.height;
			containerProps.height = containerProps.width;
			containerProps.width = temp;
			defaultValue.chart.margin = [5, 15, 30, 30];

		}
		Highcharts.Renderer.prototype.symbols.line = function (x, y, width, height) {
			return ['M', x, y + width / 2, 'L', x + height, y + width / 2];
		};
		Highcharts.bulletMultiple = function (a, b, c) {
			var hasRenderToArg = typeof a === 'string' || a.nodeName,
			options = arguments[hasRenderToArg ? 1 : 0];
			defaultValue.chart.renderTo = options.chart && options.chart.renderTo || this;
			options = Highcharts.merge(defaultValue, options);
			return hasRenderToArg ? new Highcharts.Chart(a, options, c) : new Highcharts.Chart(options, b);
		};
		container.empty();
		for (var k = seriesCategoryKey.length - 1; k >= 0; k--) {
			index = k;
			if (defaultValue.chart.type == "column") {
				index = seriesCategoryKey.length - 1 - k; //start index from 0
			}
			var cat = seriesCategoryKey[index];
			var highchartObj = $.extend(true, {}, defaultValue);
			var mergedOpts = highchartObj;
			var bulletId = containerId + '_' + cat;
			div = $('<div style="height:' + containerProps.height + ';width:' + containerProps.width + '; float:left;" id="' + bulletId + '"></div>');
			highchartObj.xAxis.categories = [seriesCategory[index]];
			highchartObj.series = [{
					name: seriesData[0].name,
					key: seriesData[0].key,
					enableMouseTracking: false,
					borderWidth: 0,
					borderRadius: 0,
					stacking: stackedqm ? 'normal' : null,
					grouping: false,
					pointRange: 1,
					scalingFactor: seriesData[0].scalingFactor,
					'ds_scalingfactor': seriesData[0]['ds_scalingfactor'],
					unitOfMeasure: seriesData[0].unitOfMeasure,
					data: [seriesData[0].data[index]]
				}, {
					name: seriesData[1].name,
					key: seriesData[1].key,
					enableMouseTracking: false,
					borderWidth: 0,
					borderRadius: 0,
					stacking: stackedqm ? 'normal' : null,
					grouping: false,
					pointRange: 1,
					scalingFactor: seriesData[1].scalingFactor,
					'ds_scalingfactor': seriesData[1]['ds_scalingfactor'],
					unitOfMeasure: seriesData[1].unitOfMeasure,
					data: [seriesData[1].data[index]]
				}, {
					name: seriesData[2].name,
					key: seriesData[2].key,
					enableMouseTracking: false,
					borderWidth: 0,
					borderRadius: 0,
					stacking: stackedqm ? 'normal' : null,
					grouping: false,
					pointRange: 1,
					scalingFactor: seriesData[2].scalingFactor,
					'ds_scalingfactor': seriesData[2]['ds_scalingfactor'],
					unitOfMeasure: seriesData[2].unitOfMeasure,
					data: [seriesData[2].data[index]]
				}, {
					name: seriesData[3].name,
					key: seriesData[3].key,
					pointRange: 0.5,
					zIndex: 10,
					dataLabels: seriesData[3].dataLabels,
					scalingFactor: seriesData[3].scalingFactor,
					'ds_scalingfactor': seriesData[3]['ds_scalingfactor'],
					unitOfMeasure: seriesData[3].unitOfMeasure,
					data: [seriesData[3].data[index]]
				}, {
					name: seriesData[4].name,
					key: seriesData[4].key,
					type: 'scatter',
					color: component.scattermarkerlinecolor1(),
					zIndex: 20,
					marker: {
						symbol: 'line',
						lineWidth: component.scattermarkerlinewidth1(),
						//that.scattermarkerlinewidth()
						radius: component.scattermarkerlineradius1(),
						//that.scattermarkerlineradius()
						lineColor: component.scattermarkerlinecolor1() //
					},
					scalingFactor: seriesData[4].scalingFactor,
					'ds_scalingfactor': seriesData[4]['ds_scalingfactor'],
					unitOfMeasure: seriesData[4].unitOfMeasure,
					data: [seriesData[4].data[index]]
				}
			];

			if (seriesData[5]) {
				highchartObj.series.push({
					name: seriesData[5].name,
					key: seriesData[5].key,
					type: 'scatter',
					color: component.scattermarkerlinecolor2(),
					zIndex: 20,
					marker: {
						symbol: 'line',
						lineWidth: component.scattermarkerlinewidth2(),
						//that.scattermarkerlinewidth()
						radius: component.scattermarkerlineradius2(),
						//that.scattermarkerlineradius()
						lineColor: component.scattermarkerlinecolor2() //
					},
					scalingFactor: seriesData[5].scalingFactor,
					'ds_scalingfactor': seriesData[5]['ds_scalingfactor'],
					unitOfMeasure: seriesData[5].unitOfMeasure,
					data: [seriesData[5].data[index]]
				});
			}

			var qmObj = rangeSliderJson[seriesCategoryKey[index]] || '';

			if (qmObj) {
				var threshold = Number(qmObj.qm1);
				highchartObj.yAxis.min = threshold;
				highchartObj.plotOptions.bar.threshold = threshold;
				highchartObj.plotOptions.column.threshold = threshold;
				highchartObj.plotOptions.scatter.threshold = threshold;
				// making sure that tick starts at set minimum;
				highchartObj.yAxis.tickPositioner = function () {
					var positions = this.tickPositions.slice(0);
					positions.splice(0, 1, this.min);
					// if new tick is very close to its neighbour then it overlaps. Hence moving the neighbour.
					if (positions[1] - positions[0] < this.tickInterval / 2) {
						positions[1] = positions[0] + this.tickInterval / 2;
					}
					return positions;
				};

				// defaultValue.yAxis.max = qmObj.maxtype == "percent" ? qmObj.pm * Number(qmObj.max) / 100 : Number(qmObj.max);
			}

			if (JSONValidator.IsJsonString(component.chartthemejson()) && component.themeJSONEnabled()) {
				var jsonVal = eval('(' + JSON.parse(JSON.stringify(component.chartthemejson().replace(/(?:\r\n|\r|\n)/g, ''))) + ')'); //jshint ignore:line
				mergedOpts = JSONValidator.mergeOptions(highchartObj, jsonVal, 'bullet', component);
			}

			div.highcharts('bulletMultiple', mergedOpts);
			container.append(div);
			var eachBullet = $("[id='" + bulletId + "']").highcharts();
      eachBullet.reflow();
      component.neighbourBullets.push(eachBullet); //storing the higcharts object for each bullet for reference in scripting events

		}

	};

	that.createMeasuresData = function (component, type, defaultValue) {
		var self = this;
		var seriesColor = component.dataseriescolor().split(',');
		var scalingFactorEnabled = self.isScalingFactorEnabled(component);
		component.categoriesIndex = [];
		//var columnCount = 0;
		var stackedqm = component.stackedvalues();
		//console.log("Series Data");
		//    alert('overridden');
		var noOfColumns = 0;
		//var noOfCellsInRow = 1;
		var bulletDefaultColor = ['#000000'];
		seriesColor = [];
		if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
			seriesColor = [];
		} else {
			seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
		}

		var featuredMeasureIndex = 0;
		var measureDimensionIndex = self.getMeasureDimensionIndex(component);
		var membersJsonLocal = {};
		var scalingFactorPerformanceMeasure = 0;
		var scalingFactorComparativeMeasure1 = 0;
		var scalingFactorComparativeMeasure2 = 0;
		var scalingfactorqualitativerange = 0;
		var measureJson = JSON.parse(component.getMeasureJson());
		var measureMembersLength = Object.keys(measureJson).length;
		var measurelist = component.measurelistbullet();
		for (var i = 0; i < component.dataRes.dimensions[measureDimensionIndex].members.length; i++) {
			component.dataRes.dimensions[measureDimensionIndex].members[i].text = component.dataRes.dimensions[measureDimensionIndex].members[i].text;
		}

		if (measurelist !== null && measurelist !== undefined && measurelist !== '') {
			if (!isNaN(Number(measurelist)) && measurelist < measureMembersLength) {}
			else if (measureJson[component.measurelistbullet()]) {
				featuredMeasureIndex = measureJson[component.measurelistbullet()].index;
			}
		}

		if (component.scalingfactorperformancemeasure() != -1 && component.scalingfactorperformancemeasure() !== undefined && component.scalingfactorperformancemeasure() !== '' && component.scalingfactorperformancemeasure() !== ' ') {
			scalingFactorPerformanceMeasure = component.scalingfactorperformancemeasure();
		}

		if (component.scalingfactorcomparativemeasure1() !== undefined && component.scalingfactorcomparativemeasure1() !== '' && component.scalingfactorcomparativemeasure1() !== ' ') {
			scalingFactorComparativeMeasure1 = component.scalingfactorcomparativemeasure1();
		}

		if (component.scalingfactorcomparativemeasure2() !== undefined && component.scalingfactorcomparativemeasure2() !== '' && component.scalingfactorcomparativemeasure2() !== ' ') {
			scalingFactorComparativeMeasure2 = component.scalingfactorcomparativemeasure2();
		}

		if (component.scalingfactorqualitativerange() !== undefined && component.scalingfactorqualitativerange() !== '' && component.scalingfactorqualitativerange() !== ' ') {
			scalingfactorqualitativerange = component.scalingfactorqualitativerange();
		}
		/*else{
		scalingFactor = component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].scalingFactor || 0;
		}*/

		var unitOfMeasureFMI = (component.unitcurrency() || component.showunit()) ? component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].unitOfMeasure || '' : '';
		var scalingfactorFMI = scalingFactorEnabled ? component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].scalingFactor || '' : '';

		var seriesData = [{
				name: 'Bands 3',
				key: '',
				unitOfMeasure: '',
				enableMouseTracking: false,
				borderWidth: 0,
				borderRadius: 0,
				stacking: stackedqm ? 'normal' : null,
				grouping: false,
				color: 'rgba(156,156,156,.1)',
				data: []
			}, {
				name: 'Bands 2',
				key: '',
				unitOfMeasure: '',
				enableMouseTracking: false,
				borderWidth: 0,
				borderRadius: 0,
				stacking: stackedqm ? 'normal' : null,
				grouping: false,
				color: 'rgba(156,156,156,.4)',
				data: []
			}, {
				name: 'Bands 1',
				key: '',
				unitOfMeasure: '',
				enableMouseTracking: false,
				borderWidth: 0,
				borderRadius: 0,
				stacking: stackedqm ? 'normal' : null,
				grouping: false,
				color: 'rgba(156,156,156,.7)',
				data: []
			}, {
				name: 'Measure',
				key: '',
				unitOfMeasure: unitOfMeasureFMI,
				pointRange: 0.5,
				zIndex: 10,
				dataLabels: {
					enabled: component.datalabelenabled(),
					align: component.datalabelalign(),
					crop: component.datalabelcrop(),
					//defer: component.datalabeldefer(),
					backgroundColor: component.datalabelbackgroundcolor().trim() === '' ? undefined : component.datalabelbackgroundcolor(),
					borderColor: component.datalabelbordercolor(),
					borderRadius: component.datalabelborderradius(),
					borderWidth: component.datalabelborderwidth(),
					padding: component.datalabelpadding(),
					rotation: component.datalabelrotation(),
					shadow: component.datalabelshadow(),
					overflow: 'justify',
					verticalAlign: component.datalabelverticalalign(),
					inside: component.datalabelinside(),
					x: component.datalabelx(),
					y: component.datalabely(),
					formatter: function () {
						var temp = '';
						if (scalingFactorEnabled) {
							if (component.scalingfactorperformancemeasure() == -1 || !component.scalingfactorperformancemeasure()) {
								temp += ' (* ' + Math.pow(10, scalingfactorFMI) + ')';
							} else {
								temp += ' (* ' + Math.pow(10, component.scalingfactorperformancemeasure()) + ')';
							}
						}

						if (component.showunit() || component.unitcurrency()) {
							temp += (unitOfMeasureFMI !== '' ? ' (in ' + unitOfMeasureFMI + ')' : '');
						}

						return component.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, isNaN(component.decimal()) ? 2 : component.decimal(), component.bulletdecimalseparator(), component.bulletthousandseparator()) + /*(component.unitcurrency()?this.series.data[0].unitOfMeasure : "")+*/
						' ' + component.datalabelsuffix() + temp;
					},

					style: {
						color: component.datalabeltextcolor(),
						fontWeight: component.datalabelfontweight(),
						textDecoration: component.datalabelfontweight(),
						fontSize: component.datalabelfontsize() + 'px',
						fontFamily: component.globalfont() === true ? component.fontfamily() : component.datalabelfontfamily()
					}
				},
				data: []
			}, {
				name: '__Target__',
				key: '',
				type: 'scatter',
				color: component.scattermarkerlinecolor1(),
				zIndex: 20,
				marker: {
					symbol: 'line',
					lineWidth: component.scattermarkerlinewidth1(),
					//that.scattermarkerlinewidth()
					radius: component.scattermarkerlineradius1(),
					//that.scattermarkerlineradius()
					lineColor: component.scattermarkerlinecolor1() //
				},
				data: []
			}
		];

		var valignJson = {
			'left': 'right',
			'right': 'left',
			'center': 'center',
			'top': 'bottom',
			'bottom': 'top',
			'middle': 'middle'
		};
		if (component.bulletcharttype() == 'bar') {
			//seriesData[3].dataLabels.verticalAlign = valignJson[seriesData[3].dataLabels.verticalAlign];
			if (component.datalabelinside()) {
				seriesData[3].dataLabels.align = valignJson[seriesData[3].dataLabels.align];
			} //seriesData[3].dataLabels.align = valignJson[seriesData[3].dataLabels.align];
		} else {
			seriesData[3].dataLabels.align = valignJson[seriesData[3].dataLabels.align];
			if (!component.datalabelinside()) {
				seriesData[3].dataLabels.verticalAlign = valignJson[seriesData[3].dataLabels.verticalAlign];
			} //seriesData[3].dataLabels.align = valignJson[seriesData[3].dataLabels.align];
		}

		var defaultValuexAxiscategories = [];
		//var dispKeyText = component.dispkeytext();
		//var xAxisCategories = [];
		var comparativeMeasureIndex = [];
		var comparativemeasurelist1 = component.comparativemeasurelist1();
		if (comparativemeasurelist1 !== null && comparativemeasurelist1 !== undefined && comparativemeasurelist1 !== '') {
			if (!isNaN(Number(comparativemeasurelist1)) && comparativemeasurelist1 < measureMembersLength)
				// Managing Migrations
			{
				comparativeMeasureIndex = comparativeMeasureIndex.concat(comparativemeasurelist1);
			} else {
				comparativeMeasureIndex = comparativeMeasureIndex.concat(measureJson[comparativemeasurelist1] ? measureJson[comparativemeasurelist1].index : 'none');
			}
		} else {
			var cm = featuredMeasureIndex + 1;
			if (cm >= component.dataRes.dimensions[measureDimensionIndex].members.length) {
				cm = cm - 2;
			}

			comparativeMeasureIndex.push(cm);
		}
		//alert("component.datautility()="+component.datautility()+"   featuredMeasureIndex="+featuredMeasureIndex+" ,comparativeMeasureIndex="+comparativeMeasureIndex);
		component.measurelistbullet(component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].key);
		component.comparativemeasurelist1(comparativeMeasureIndex[0] == 'none' ? 'none' : component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].key);
		var unitOfMeasureCMI = ((component.showunit() || component.unitcurrency()) && comparativeMeasureIndex[0] != 'none') ? component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].unitOfMeasure || '' : '';
		//var scalingfactorCMI = (scalingFactorEnabled && comparativeMeasureIndex[0] != 'none') ? component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].scalingFactor || '' : '';
		seriesData[4].unitOfMeasure = unitOfMeasureCMI;
		//seriesData[4].scalingFactor = scalingfactorCMI;
		var comparativemeasurelist2 = component.comparativemeasurelist2();
		if (comparativemeasurelist2 !== null && comparativemeasurelist2 !== undefined && comparativemeasurelist2 !== '' && comparativemeasurelist2 != 'none') {
			if (!isNaN(Number(comparativemeasurelist2)) && comparativemeasurelist2 < measureMembersLength)
				// Managing Migrations
			{
				comparativeMeasureIndex = comparativeMeasureIndex.concat(comparativemeasurelist2);
			}

			if (measureJson[comparativemeasurelist2]) {
				comparativeMeasureIndex = comparativeMeasureIndex.concat(measureJson[comparativemeasurelist2].index);
			}
		}

		if (comparativeMeasureIndex.length >= 2) {
			unitOfMeasureCMI = (component.showunit() || component.unitcurrency()) && comparativeMeasureIndex[1] != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[1]].unitOfMeasure || '' : '';
			//scalingfactorCMI = (scalingFactorEnabled && comparativeMeasureIndex[1] != 'none') ? component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[1]].scalingFactor || '' : '';
			seriesData.push({
				name: '',
				key: '',
				type: 'scatter',
				unitOfMeasure: unitOfMeasureCMI,
				color: component.scattermarkerlinecolor2(),
				zIndex: 20,
				marker: {
					symbol: 'line',
					lineWidth: component.scattermarkerlinewidth2(),
					//that.scattermarkerlinewidth()
					radius: component.scattermarkerlineradius2(),
					//that.scattermarkerlineradius()
					lineColor: component.scattermarkerlinecolor2() //
				},
				data: []
			});
		}

		/*if (component.tooltipshared()) {
		defaultValue.tooltip.pointFormatter = function() {
		var index = this.index;
		var allSeries = this.series.chart.series;
		var tooltipStr = '';
		$.each(allSeries, function(seriesIndex, seriesObj) {
		if (seriesObj.name != 'Bands 1' && seriesObj.name != 'Bands 2' && seriesObj.name != 'Bands 3') {
		if (seriesIndex != 4 || seriesIndex == 4 && comparativeMeasureIndex[0] != 'none') {
		tooltipStr += '<span style="color:' + seriesObj.data[index].color + '">\u25CF</span>' + seriesObj.name + ': <b>' + component.tooltipvalueprefix() + Highcharts.numberFormat(seriesObj.data[index].y, isNaN(component.tooltipvaluedecimals()) ? 2 : component.tooltipvaluedecimals(), component.bulletdecimalseparator(), component.bulletthousandseparator()) + ' ' + seriesObj.userOptions.unitOfMeasure + ' ' + component.tooltipvaluesuffix() + '</b><br/>';
		}
		}
		});

		return tooltipStr;
		};

		seriesData[4].tooltip.pointFormatter = defaultValue.tooltip.pointFormatter;
		if (seriesData.length == 6) {
		seriesData[5].tooltip.pointFormatter = defaultValue.tooltip.pointFormatter;
		}
		} else {
		defaultValue.tooltip.pointFormatter = function() {
		return '<span style="color:' + this.color + '">\u25CF</span> ' + this.series.name + ': <b>' + component.tooltipvalueprefix() + Highcharts.numberFormat(this.y, isNaN(component.tooltipvaluedecimals()) ? 2 : component.tooltipvaluedecimals(), component.bulletdecimalseparator(), component.bulletthousandseparator()) + ' ' + unitOfMeasureFMI + ' ' + component.tooltipvaluesuffix() + '</b><br/>';
		};
		}*/
		/*defaultValue.tooltip.pointFormatter=function(){
		return "<span style=\"color:"+this.color+"\">\u25CF</span> "+this.series.name+": <b>"+component.tooltipvalueprefix()+Highcharts.numberFormat(this.y, isNaN(component.tooltipvaluedecimals())?2:component.tooltipvaluedecimals(), component.bulletdecimalseparator(), component.bulletthousandseparator())+" "+ (component.unitcurrency()?this.series.data[0].unitOfMeasure : "")+" "+component.tooltipvaluesuffix()+"</b><br/>";
		};*/
		for (var i = 0; i < component.dataRes.dimensions.length; i++) {
			if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
				noOfColumns++;
			}
		}

		//var noOfRows = component.dataRes.dimensions.length - noOfColumns;
		//var selectedDimensions = [];
		//var selectedColumndim = '';
		//var selectedRowdim = [];
		//var selectedColumndimIndexes = [];
		//var selectedRowdimIndexes = [];
		var qm1 = 0;
		var qm1Val = component.qualitativemeasure1();
		if (!isNaN(Number(qm1Val)) && qm1Val < measureMembersLength)
			// Managing Migrations
		{
			qm1 = qm1Val;
		} else {
			qm1 = measureJson[qm1Val] ? measureJson[qm1Val].index : 'none';
		}

		var qm1UnitOfMeasure = (component.showunit() || component.unitcurrency()) && qm1 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm1].unitOfMeasure || '' : '';
		//var qm1Scf = (scalingFactorEnabled && qm1 != 'none') ? component.dataRes.dimensions[measureDimensionIndex].members[qm1].scalingFactor || '' : '';
		seriesData[2].unitOfMeasure = qm1UnitOfMeasure;
		//seriesData[2].scalingFactor = qm1Scf;
		var qm2 = 0;
		var qm2Val = component.qualitativemeasure2();
		if (!isNaN(Number(qm2Val)) && qm2Val < measureMembersLength)
			// Managing Migrations
		{
			qm2 = qm2Val;
		} else {
			qm2 = measureJson[qm2Val] ? measureJson[qm2Val].index : 'none';
		}

		var qm2UnitOfMeasure = (component.showunit() || component.unitcurrency()) && qm2 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm2].unitOfMeasure || '' : '';
		//var qm2Scf = (scalingFactorEnabled) && qm2 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm2].unitOfMeasure || '' : '';
		seriesData[1].unitOfMeasure = qm2UnitOfMeasure;
		//seriesData[1].scalingFactor = qm2Scf;
		var qm3 = 0;
		var qm3Val = component.qualitativemeasure3();
		if (!isNaN(Number(qm3Val)) && qm3Val < measureMembersLength)
			// Managing Migrations
		{
			qm3 = qm3Val;
		} else {
			qm3 = measureJson[qm3Val] ? measureJson[qm3Val].index : 'none';
		}

		var qm3UnitOfMeasure = (component.showunit() || component.unitcurrency()) && qm3 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm3].unitOfMeasure || '' : '';
		//var qm3Scf =  scalingFactorEnabled && qm3 != 'none' ? component.dataRes.dimensions[measureDimensionIndex].members[qm3].unitOfMeasure || '' : '';
		seriesData[0].unitOfMeasure = qm3UnitOfMeasure;
		//seriesData[0].scalingFactor = qm3Scf;
		if (component.datautility() === true) {
			this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
		}

		//var categoryIndexes = [];
		for (var i = 0; i < component.dataRes.tuples.length; i++) {
			var seriesDataIndex = -1,
			seriesDataIndexQm = -1;
			var curTuple = component.dataRes.tuples[i];
			// current tuple being accessed
			//var tempNameCategory = '';
			//var tempCategoryIndexArr = [];
			//var tempKeyCategory = '';
			//  alert(featuredMeasureIndex);
			if (curTuple[measureDimensionIndex] == featuredMeasureIndex) {
				seriesData[3].name = measureJson[component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].key].text;
				seriesData[3].key = measureDimensionIndex + ':' + curTuple[measureDimensionIndex];
				//console.log("bulletDefaultColor in if="+bulletDefaultColor);
				seriesData[3].data.push({
					name: 'Measures',
					key: 'Measures',
					y: component.dataRes.data[i],
					color: self.getSeriesColors(component, seriesColor, 0, bulletDefaultColor)
					//unitOfMeasure: component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].unitOfMeasure || ''
				});
				component.columnSelected = seriesData[3].name;
				seriesDataIndex = 3;
			} else if (curTuple[measureDimensionIndex] == comparativeMeasureIndex[0]) {
				seriesData[4].name = measureJson[component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].key].text;
				seriesData[4].key = measureDimensionIndex + ':' + curTuple[measureDimensionIndex];
				seriesData[4].data.push({
					name: 'Measures',
					key: 'Measures',
					y: component.dataRes.data[i]
					//unitOfMeasure: component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].unitOfMeasure || ''
				});
				seriesDataIndex = 4;
			} else if (comparativeMeasureIndex[1] !== undefined) {
				if (curTuple[measureDimensionIndex] == comparativeMeasureIndex[1]) {
					seriesData[5].name = measureJson[component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].key].text;
					seriesData[5].key = measureDimensionIndex + ':' + curTuple[measureDimensionIndex];
					seriesData[5].data.push({
						name: 'Measures',
						key: 'Measures',
						y: component.dataRes.data[i]
						// unitOfMeasure: component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].unitOfMeasure || ''
					});
					seriesDataIndex = 5;
				}
			}

			if (curTuple[measureDimensionIndex] == qm1) {
				seriesData[2].name = measureJson[component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].key].text;
				seriesData[2].key = measureDimensionIndex + ':' + curTuple[measureDimensionIndex];
				seriesData[2].data.push({
					name: 'Measures',
					key: 'Measures',
					y: component.dataRes.data[i]
				});
				seriesDataIndexQm = 2;
			} else if (curTuple[measureDimensionIndex] == qm2) {
				seriesData[1].name = measureJson[component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].key].text;
				seriesData[1].key = measureDimensionIndex + ':' + curTuple[measureDimensionIndex];
				seriesData[1].data.push({
					name: 'Measures',
					key: 'Measures',
					y: component.dataRes.data[i]
				});
				seriesDataIndexQm = 1;
			} else if (curTuple[measureDimensionIndex] == qm3) {
				seriesData[0].name = measureJson[component.dataRes.dimensions[measureDimensionIndex].members[curTuple[measureDimensionIndex]].key].text;
				seriesData[0].key = measureDimensionIndex + ':' + curTuple[measureDimensionIndex];
				seriesData[0].data.push({
					name: 'Measures',
					key: 'Measures',
					y: component.dataRes.data[i]
				});
				seriesDataIndexQm = 0;
			}
		}

		// VBX141-8422
		if(seriesData[3].data.length === 0){
			return 8; // for noData --> zero supprerssion enabled and there is not data for performance measure.
		}

		seriesColor.splice(seriesData[3].data.length, seriesColor.length);
		var rangeSliderJson = {};
		var valArray = [];
		defaultValuexAxiscategories = [];
		defaultValuexAxiscategories.push('Measures');
		var dsSscalingfactor = 0;
		for (var i = 0; i < seriesData[3].data.length; i++) {
			//rangeSliderJson[defaultValuexAxiscategories[i]] = {};
			//rangeSliderJson[defaultValuexAxiscategories[i]].from = 0;
			//rangeSliderJson[defaultValuexAxiscategories[i]].to = 0;
			for (var k = 0; k < seriesData.length; k++) {
				if (typeof seriesData[k].data[i] == 'undefined' && k < 3) {
					seriesData[k].data.push({
						name: '',
						y: 0
					});
				}
				//seriesData[k].data[i].y=seriesData[k].data[i].y/Math.pow(10,scalingFactor);
				if (k == 3) {
					dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[featuredMeasureIndex].scalingFactor || 0;
					seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
					if (scalingFactorPerformanceMeasure) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingFactorPerformanceMeasure);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingFactorPerformanceMeasure) + ')';
						}

						seriesData[k].scalingFactor = scalingFactorPerformanceMeasure;
					} else {
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, dsSscalingfactor) + ')';
						}
					}
				} else if (k == 4 && comparativeMeasureIndex[0] != 'none') {

					dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[0]].scalingFactor || 0;
					seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;

					if (scalingFactorComparativeMeasure1) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingFactorComparativeMeasure1);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingFactorComparativeMeasure1) + ')';
						}

						seriesData[k].scalingFactor = scalingFactorComparativeMeasure1;
					} else {
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, dsSscalingfactor) + ')';
						}
					}
				} else if (k == 5) {
					dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[comparativeMeasureIndex[1]].scalingFactor || 0;
					seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
					if (scalingFactorComparativeMeasure2) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingFactorComparativeMeasure2);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingFactorComparativeMeasure2) + ')';
						}

						seriesData[k].scalingFactor = scalingFactorComparativeMeasure2;
					} else {
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, dsSscalingfactor) + ')';
						}
					}
				} else if (k === 0) {
					if (typeof seriesData[k].data[i].y === undefined) {
						seriesData[k].data[i].y = 0;
					}

					if (!isNaN(qm3)) {
						dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[qm3].scalingFactor || 0;
						seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
					}

					if (scalingfactorqualitativerange && !isNaN(qm3)) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingfactorqualitativerange);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingfactorqualitativerange) + ')';
						}

						seriesData[k].scalingFactor = scalingfactorqualitativerange;
					} else if (scalingFactorEnabled === true && !isNaN(qm3) && seriesData[k].name.indexOf('(*') == -1) {
						seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, dsSscalingfactor) + ')';
					}

					if (component.qualitativescale3colors() !== undefined && component.qualitativescale3colors() !== null && component.qualitativescale3colors() !== '') {
						seriesData[k].data[i].color = component.qualitativescale3colors();
					}
				} else if (k == 1) {
					if (typeof seriesData[k].data[i].y === undefined) {
						seriesData[k].data[i].y = 0;
					}

					if (!isNaN(qm2)) {
						dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[qm2].scalingFactor || 0;
						seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
					}

					if (scalingfactorqualitativerange && !isNaN(qm2)) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingfactorqualitativerange);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingfactorqualitativerange) + ')';
						}

						seriesData[k].scalingFactor = scalingfactorqualitativerange;
					} else if (scalingFactorEnabled === true && !isNaN(qm2) && seriesData[k].name.indexOf('(*') == -1) {
						seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, dsSscalingfactor) + ')';
					}

					if (component.qualitativescale2colors() !== undefined && component.qualitativescale2colors() !== null && component.qualitativescale2colors() !== '') {
						seriesData[k].data[i].color = component.qualitativescale2colors();
					}
					/*if(typeof seriesData[k].data[i].y=== undefined){
					seriesData[k].data[i].y=0;
					}*/
					//rangeSliderJson[defaultValuexAxiscategories[i]].to = seriesData[k].data[i].y; //rangeSliderJson[defaultValuexAxiscategories[i]].to=rangeSliderJson[defaultValuexAxiscategories[i]].from + seriesData[k].data[i].y;
				} else if (k == 2) {
					if (typeof seriesData[k].data[i].y === undefined) {
						seriesData[k].data[i].y = 0;
					}

					if (!isNaN(qm1)) {
						dsSscalingfactor = component.dataRes.dimensions[measureDimensionIndex].members[qm1].scalingFactor || 0;
						seriesData[k]["ds_scalingfactor"] = dsSscalingfactor;
					}

					if (scalingfactorqualitativerange && !isNaN(qm1)) {
						seriesData[k].data[i].y = seriesData[k].data[i].y * Math.pow(10, dsSscalingfactor) / Math.pow(10, scalingfactorqualitativerange);
						if (scalingFactorEnabled === true && seriesData[k].name.indexOf('(*') == -1) {
							seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, scalingfactorqualitativerange) + ')';
						}

						seriesData[k].scalingFactor = scalingfactorqualitativerange;
					} else if (scalingFactorEnabled === true && !isNaN(qm1) && seriesData[k].name.indexOf('(*') == -1) {
						seriesData[k].name = seriesData[k].name + ' (*' + Math.pow(10, dsSscalingfactor) + ')';
					}

					if (component.qualitativescale1colors() !== undefined && component.qualitativescale1colors() !== null && component.qualitativescale1colors() !== '') {
						seriesData[k].data[i].color = component.qualitativescale1colors();
					}

					//rangeSliderJson[defaultValuexAxiscategories[i]].from = seriesData[k].data[i].y;
					//rangeSliderJson[defaultValuexAxiscategories[i]].to = rangeSliderJson[defaultValuexAxiscategories[i]].from + rangeSliderJson[defaultValuexAxiscategories[i]].to;
				}

				if (seriesData[k].data.length) {
					valArray.push(seriesData[k].data[i].y);
				}

			}
		}

		var noData = false;
		var valArrayWithMeasures = valArray.slice(3);
		var nullCount = _.reduce(valArrayWithMeasures, function (memo, value) {
				return _.isNull(value) ? memo + 1 : memo;
			}, 0);

		if (nullCount === valArrayWithMeasures.length) {
			noData = true;
		}

		if (noData) {
			return 7; // for noData --> Invalid Data
		} else {

			//var tempMax = parseFloat(component.datamaxrange());
			var tempMin = parseFloat(component.dataminrange());
			tempMin = tempMin < 0 ? tempMin : 0;
			var dataMax = Math.max.apply(Math, valArray);
			var dataMin = Math.min.apply(Math, valArray);
			dataMin = dataMin < 0 ? dataMin : 0;
			component.datamaxrange(dataMax);
			component.dataminrange(dataMin);
			var rangeDiff = dataMax - dataMin;

			if (component.qualitativerange() !== null && component.qualitativerange() !== undefined && component.qualitativerange() !== '' && Object.keys(jQuery.parseJSON(component.qualitativerange())).toString() == defaultValuexAxiscategories.toString()) {
				rangeSliderJson = jQuery.parseJSON(component.qualitativerange());
				// making rangeSliderJson compatible with previous versions
				if (Object.keys(rangeSliderJson).length && !rangeSliderJson[Object.keys(rangeSliderJson)[0]].hasOwnProperty("qm1")) {
					rangeSliderJson = self.transformRangeSliderJson(rangeSliderJson, dataMin, dataMax);
				}
			}

			if (component.qualitativemeasure1() == 'none' && component.qualitativemeasure2() == 'none' && component.qualitativemeasure3() == 'none') {
				var fromVal = dataMin + rangeDiff / 3;
				var toVal = dataMax - rangeDiff / 3;
				fromVal = fromVal.toFixed(2);
				toVal = toVal.toFixed(2);

				for (var j = 0; j < defaultValuexAxiscategories.length; j++) {
					var qObj = rangeSliderJson[defaultValuexAxiscategories[j]] || '';
					if (!qObj || !qObj.config || qObj.config == "auto") {
						rangeSliderJson[defaultValuexAxiscategories[j]] = {
							qm1: dataMin,
							qm2: fromVal,
							qm3: toVal,
							max: dataMax,
							maxtype: "abs",
							config: "auto"
						};
					}
					if (rangeSliderJson[defaultValuexAxiscategories[j]]) {
						rangeSliderJson[defaultValuexAxiscategories[j]]['pm'] = seriesData[3].data[j].y;
					}
				}
				var toVal = 0;
				for (var i = 2; i >= 0; i--) {
					for (var j = 0; j < defaultValuexAxiscategories.length; j++) {
						var qmObj = rangeSliderJson[defaultValuexAxiscategories[j]];
						if (i === 0) {
							toVal = qmObj.maxtype == "percent" ? seriesData[3].data[j].y * Number(qmObj.max) / 100 : Number(qmObj.max);
							if (stackedqm) {
								toVal = toVal - Number(qmObj.qm3);
							}
							seriesData[i].data[j].y = toVal;
							if (component.qualitativescale3colors() !== undefined && component.qualitativescale3colors() !== null && component.qualitativescale3colors() !== '') {
								seriesData[i].color = component.qualitativescale3colors();
							}
						} else if (i == 1) {
							toVal = stackedqm ? Number(qmObj.qm3) - Number(qmObj.qm2) : Number(qmObj.qm3);
							seriesData[i].data[j].y = toVal;
							if (component.qualitativescale2colors()) {
								seriesData[i].color = component.qualitativescale2colors();
							}
						} else {
							toVal = Number(qmObj.qm2) - Number(qmObj.qm1);
							seriesData[i].data[j].y = toVal;
							//console.log("seriesData["+i+"].data="+seriesData[i].data);
							if (component.qualitativescale1colors() !== undefined && component.qualitativescale1colors() !== null && component.qualitativescale1colors() !== '') {
								seriesData[i].color = component.qualitativescale1colors();
							}
						}
					}
				}
			} else if (component.qualitativemeasure1() != 'none' || component.qualitativemeasure2() != 'none' || component.qualitativemeasure3() != 'none') {
				var qm1Percent = 0,
				qm2Percent = 0,
				qm3Percent = 0;
				if (qm1 == 'none' && qm2 == 'none') {
					qm1Percent = isNaN(component.percentagequalitativerange1()) ? 0 : component.percentagequalitativerange1();
					qm2Percent = isNaN(component.percentagequalitativerange3()) ? 0 : component.percentagequalitativerange3();
					this.calculateQualitativeRange(qm1Percent, qm2Percent, seriesData, '0', rangeSliderJson, valArray, stackedqm);
				} else if (qm2 == 'none' && qm3 == 'none') {
					qm2Percent = isNaN(component.percentagequalitativerange1()) ? 0 : component.percentagequalitativerange1();
					qm3Percent = isNaN(component.percentagequalitativerange3()) ? 0 : component.percentagequalitativerange3();
					this.calculateQualitativeRange(qm2Percent, qm3Percent, seriesData, '2', rangeSliderJson, valArray, stackedqm);
				} else if (qm1 == 'none' && qm3 == 'none') {
					qm1Percent = isNaN(component.percentagequalitativerange1()) ? 0 : component.percentagequalitativerange1();
					qm3Percent = isNaN(component.percentagequalitativerange3()) ? 0 : component.percentagequalitativerange3();
					this.calculateQualitativeRange(qm1Percent, qm3Percent, seriesData, '1', rangeSliderJson, valArray, stackedqm);
				} else {
					that.populateRangeSliderJson(seriesData, rangeSliderJson, valArray, stackedqm);
				}

				component.datamaxrange(Math.max.apply(Math, valArray));
				component.dataminrange(Math.min.apply(Math, valArray));
				dataMax = parseFloat(component.datamaxrange());
				dataMin = parseFloat(component.dataminrange());
				rangeDiff = dataMax - dataMin;

			} else {
				this.createSmokeScreen(component.$(), 'Please select measure for atleast one Qualitative Measure');
			}

			var dataChangedFlag = 0;
			if (dataMax != component.yaxismaxval() || dataMin != component.yaxisminval()) {
				dataChangedFlag = 1;
				component.yaxismaxval(dataMax);
				component.yaxisminval(dataMin);
			}

			if (component.setQualitativeRangeCalled() === true) {
				rangeSliderJson = jQuery.parseJSON(component.qualitativerange());

				//var membersChanged = [];
				var qmObj = {};
				for (var i = 2; i >= 0; i--) {
					for (var j = 0; j < defaultValuexAxiscategories.length; j++) {
						qmObj = rangeSliderJson[defaultValuexAxiscategories[j]];
						if (i == 2) {
							/*if(seriesData[i].data[j].y != parseFloat(qmObj.qm2)){
							membersChanged.push(j);
							}*/
							seriesData[i].data[j].y = parseFloat(qmObj.qm2) - parseFloat(qmObj.qm1);
						} else if (i == 1) {
							var toVal = parseFloat(qmObj.qm3);
							if (stackedqm) {
								toVal = toVal - parseFloat(qmObj.qm2);
							}
							seriesData[i].data[j].y = toVal;
						} else {
							//if(membersChanged.indexOf(j)!=-1){
							var toVal = 0;

							if (qmObj.config == "auto") {
								toVal = dataMax;
							} else {
								toVal = qmObj.maxtype == "percent" ? seriesData[3].data[j].y * Number(qmObj.max) / 100 : Number(qmObj.max);
							}

							if (stackedqm) {
								toVal = toVal - parseFloat(qmObj.qm3);
							}
							seriesData[i].data[j].y = toVal;
							//}

						}
					}
				}
			}

			if (component.membersJson() != JSON.stringify(membersJsonLocal) || component.qualitativerange() != JSON.stringify(rangeSliderJson)) {
				component.qualChangedFlag = 1;
			}
			//console.log(JSON.stringify(rangeSliderJson));
			component.qualitativerange(JSON.stringify(rangeSliderJson));
			component.membersJson(JSON.stringify(membersJsonLocal));
			component.dataseriescolor(seriesColor.join());
			defaultValue.series = seriesData;
			defaultValue.xAxis.categories = ['Measures'];
			var dataToReturn = [];
			dataToReturn = dataToReturn.concat(defaultValuexAxiscategories);

			var options = {
				seriesCategory: ['Measures'],
				seriesData: seriesData,
				component: component,
				defaultValue: defaultValue,
				defaultValuexAxiscategories: defaultValuexAxiscategories,
				stackedqm: stackedqm,
				rangeSliderJson: rangeSliderJson
			};

			if (component.individualscale()) {
				self.renderBulletWithIndividualScale(options);
			} else if (self.isQm1Same(rangeSliderJson)) {
				var threshold = Number(rangeSliderJson[Object.keys(rangeSliderJson)[0]].qm1);
				defaultValue.yAxis.min = threshold;
				defaultValue.plotOptions.bar.threshold = threshold;
				defaultValue.plotOptions.column.threshold = threshold;
				defaultValue.plotOptions.scatter.threshold = threshold;
				defaultValue.yAxis.tickPositioner = function () {
					var positions = this.tickPositions.slice(0);
					positions.splice(0, 1, this.min);
					// if new tick is very close to its neighbour then it overlaps. Hence moving the neighbour.
					if (positions[1] - positions[0] < this.tickInterval / 2) {
						positions[1] = positions[0] + this.tickInterval / 2;
					}
					return positions;
				};
			}
			return dataToReturn;
		}
	};

	that.globalgooglefont = function (component, defaultValue, fonttest) {
		/*added below code to check whether the call is from "ChartContainer" if so then skip x and y axis styling
		as chartcontainer only support styling of title,subtitle,legend,tooltip,credits */
		var container = false;
		if (component[0].id.indexOf('CHARTCONTAINER') != -1) {
			container = true;
		}

		try {
			defaultValue.title.style.fontFamily = fonttest;
			defaultValue.subtitle.style.fontFamily = fonttest;
			if (container === false) {
				defaultValue.xAxis.labels.style.fontFamily = fonttest;
				defaultValue.xAxis.title.style.fontFamily = fonttest;
				defaultValue.xAxis.plotLines[0].label.style.fontFamily = fonttest;
				defaultValue.xAxis.plotBands[0].label.style.fontFamily = fonttest;
				defaultValue.yAxis.labels.style.fontFamily = fonttest;
				defaultValue.yAxis.title.style.fontFamily = fonttest;
				defaultValue.yAxis.plotLines[0].label.style.fontFamily = fonttest;
				defaultValue.yAxis.plotBands[0].label.style.fontFamily = fonttest;
			}
			if (container === true) {
				if (defaultValue.xAxis) {
					defaultValue.xAxis.labels.style = {};
					defaultValue.xAxis.labels.style.fontFamily = fonttest;

				}
				if (defaultValue.yAxis) {
					defaultValue.yAxis.labels = {};
					defaultValue.yAxis.labels.style = {};
					defaultValue.yAxis.title={};
          			defaultValue.yAxis.title.style={};
					defaultValue.yAxis.title.style.fontFamily = fonttest;
					defaultValue.yAxis.labels.style.fontFamily = fonttest;
				}
			}
			defaultValue.tooltip.style.fontFamily = fonttest;
			/*defaultValue.legend.itemStyle.fontFamily= fonttest;
			defaultValue.legend.title.style.fontFamily= fonttest;
			defaultValue.legend.navigation.style.fontFamily= fonttest; */
			defaultValue.credits.style.fontFamily = fonttest;
		} catch (e) {}
	};
}
