function familyScatter(args) {//jshint ignore:line
  var that = this;
  /*
  	 * *********************************************************************
  	 * -Template for defining definition in familySeries
  	 * -All function definition need to be within the scope of familyXYZ
  	 * -Each definition of property should be based on the validation of
  	 *  method validateImplementMethod(args, [[function name string]])
  	 *
  	 *	Example:
  		 *	if (validateImplementMethod(args, 'cds')) {
  		 *		<-- Actual Function definition goes here -->
  		 *		that.cds = function() {
  		 *
  		 *			// Your own implementation starts here either extend or
  		 *			// write complete new implementation
  		 *
  		 *			// var result = SeriesLibrary.prototype.cds.call(that);
  		 *			// some specific implementation
  		 *
  		 *		};
  		 *	}
  	 *
  	 * -If function definition is defined without validateImplementMethod
  	 *  then particular method is included by default in all components that
  	 *  include this file!
  	 * *********************************************************************
  	 */
  // alert('[[Executed familyScatter]]');
  if (validateImplementMethod(args, 'cds')) {//jshint ignore:line
    that.cds = function() {
      alert('function cds "hasOwnProperty" accessed');  // jshint ignore:line
    };
  }

  if (validateImplementMethod(args, 'createPickerDataArray')) {//jshint ignore:line
    that.createPickerDataArray = function(component, resultEnabled, expandColumnEnabled, expandRowEnabled, columnCount, chartType) {//jshint ignore:line
      // Return Variable
     // var columnDimension = [];
      var rowDimension = [];
      //var selectedColumns = [];
      //var selectedRows = [];
      // New Return Variables in JSON
      var columnJSON = {};
      var rowJSON = {};
      // Flag variables
      var includeResult = resultEnabled === undefined ? false : resultEnabled;
      var expandColumn = expandColumnEnabled === undefined ? false : expandColumnEnabled;
      var expandRow = expandRowEnabled === undefined ? false : expandRowEnabled;
      var resultIndex = [];
      // Store RESULT type index
      //var feasibleColumn = [];
      var columnDimensionList = [];
      // Reference to dataSource JSON
      var dimensionsInJSON = component.dataRes.dimensions;
      var columnsTupleInJSON = component.dataRes["axis_columns"];
      var rowsTupleInJSON = component.dataRes["axis_rows"];
      var tupleMatrixInJSON = component.dataRes.tuples;
      // Measure Variables
      var nDimensions = component.dataRes.dimensions.length;
      var nDimensionInColumns = columnsTupleInJSON[0].indexOf(-1) == -1 ? columnsTupleInJSON[0].length : columnsTupleInJSON[0].indexOf(-1);
      var nColumns = component.dataRes.columnCount;
      var nRows = component.dataRes.rowCount;
      /*
      			 * --------------Add.Code for Scatter Chart Starts here
      			 */
      //console.log('Result JSON:' + JSON.stringify(component.dataRes));
      var pieDimensions = component.dataRes.dimensions;
      var columnDimensionList = [];
      component.columnDimensionIndex = {};
      var ColumnDimensionCount = component.dataRes["axis_columns"][0].indexOf(-1);
      if (ColumnDimensionCount == 1 && pieDimensions[0].containsMeasures === true) {
        for (var i = 0; i < pieDimensions[0].members.length; i++) {
          component.columnDimensionIndex[pieDimensions[0].members[i]["picker_text"]] = {
            name: pieDimensions[0].members[i]["picker_text"],
            index: i
          };
        }  //alert(JSON.stringify(component.columnDimensionIndex));
      } else {
        for (var i = 0; i < component.dataRes["axis_columns"].length; i++) {
          columnDimensionList[i] = '';
          for (var j = 0; j < ColumnDimensionCount; j++) {
            columnDimensionList[i] = columnDimensionList[i] + '!!!' + pieDimensions[j].members[component.dataRes["axis_columns"][i][j]]["picker_text"];
          }

          columnDimensionList[i] = columnDimensionList[i].substr(3);
          component.columnDimensionIndex[columnDimensionList[i].replace(/!!!/g, '-')] = {
            name: columnDimensionList[i].replace(/!!!/g, '-'),
            index: component.dataRes["axis_columns"][i].slice(0, ColumnDimensionCount)
          };
        }
      }
      /*
      			 * ------------Add.Code added for Scatter Chart Ends here
      			 */
      //alert('Column Dimension:' + nDimensionInColumns + ': Row Dimension' + nDimensionInRows);
      /*
      			 * For Including or Ignoring Result Column in Data Utility Window
      			 */
      for (var i = 0; i < nDimensions; ++i) {
        for (var j = 0; j < dimensionsInJSON[i].members.length; j++) {
          //	alert('resultIndex j: ' + j);
          if (dimensionsInJSON[i].members[j].type == 'RESULT') {
            resultIndex.push(j);
            break;
          }
        }

        if (resultIndex[i] === undefined) {
          resultIndex.push(-1);
        }
      }
      /*
      			 * Create Column-Wise data and add into the columnDimension[]
      			 */
      if (expandColumn) {
        // Expand to members
        for (var i = 0; i < nColumns; ++i) {
          /*
          					 * Validate the current row is RESULT row or not. If it is RESULT
          					 * row, skip this loop iteration if includeResult is set true. Below
          					 * If block do this.
          					 */
          if (!includeResult) {
            var matchedFlag = false;
            for (var n = 0; n < nDimensions; ++n) {
              if (tupleMatrixInJSON[i][n] == resultIndex[n]) {
                matchedFlag = true;
                break;
              }
            }

            if (matchedFlag) {
              // console.log('Current Row is Result Data - Skip this iteration');
              continue;
            }
          }

          var currentName = '';
          var currentColumn = columnsTupleInJSON[i];
          var currentKey = '';
          var currentIndexKey = '';
          for (var k = 0; k < currentColumn.length; ++k) {
            if (currentColumn[k] != -1) {
              if (currentName !== '') {
                currentName = currentName + '-' + dimensionsInJSON[k].members[currentColumn[k]]["picker_text"] || dimensionsInJSON[k].members[currentColumn[k]].key;
                currentIndexKey = currentIndexKey + '-' + k + ':' + currentColumn[k];
                currentKey = currentKey + '-' + dimensionsInJSON[k].members[currentColumn[k]].key;
              } else {
                currentName = dimensionsInJSON[k].members[currentColumn[k]]["picker_text"] || dimensionsInJSON[k].members[currentColumn[k]].key;
                currentIndexKey = k + ':' + currentColumn[k];
                currentKey = dimensionsInJSON[k].members[currentColumn[k]].key;
              }
            }
          }

          columnJSON[currentKey] = {
            text: currentName,
            index: currentIndexKey
          };  // OLD IMPLEMANTATION
          /*
      					columnDimension.push(currentName);
      					 */
        }
      } else {
        for (var i = 0; i < nDimensionInColumns; ++i) {
          //alert('column loop:' + i);
          if (dimensionsInJSON[i].containsMeasures === undefined) {
            columnJSON[dimensionsInJSON[i].key] = {
              text: dimensionsInJSON[i]["picker_text"] || dimensionsInJSON[i].key,
              index: i
            };  // OLD IMPLEMANTATION
            /*
        						columnDimension.push(dimensionsInJSON[i].text);
        						 */
          }
        }
      }
      /*
      			 * Populate rowDimension with the available row dimensions
      			 */
      if (expandRow) {
        // Expand to members
        for (var i = 0; i < nRows; ++i) {
          /*
          					 * Validate the current row is RESULT row or not. If it is RESULT
          					 * row, skip this loop iteration if includeResult is set true. Below
          					 * If block do this.
          					 */
          if (!includeResult) {
            var matchedFlag = false;
            for (var n = 0; n < nDimensions; ++n) {
              if (tupleMatrixInJSON[_.parseInt(i * nColumns)][n] == resultIndex[n]) {
                matchedFlag = true;
                break;
              }
            }

            if (matchedFlag) {
              // console.log('Current Row is Result Data - Skip this iteration');
              continue;
            }
          }
          /*
          					 * This part of the code is executed only if the above If block has
          					 * failed to skip this loop (Condition fails or current row is not
          					 * RESULT row). Now below Code will create expanded row header.
          					 */
          // console.log('Check Point: row label for axis labelling' + '');
          var currentName = '';
          var currentRow = rowsTupleInJSON[i];
          var currentKey = '';
          var currentIndexKey = '';
          for (var k = 0; k < currentRow.length; ++k) {
            if (currentRow[k] != -1) {
              if (currentName !== '') {
                currentName = currentName + ' / ' + dimensionsInJSON[k].members[currentRow[k]]["picker_text"] || dimensionsInJSON[k].members[currentRow[k]].key;
                currentIndexKey = currentIndexKey + '-' + k + ':' + currentRow[k];
                currentKey = currentKey + '/' + dimensionsInJSON[k].members[currentRow[k]].key;
              } else {
                currentName = dimensionsInJSON[k].members[currentRow[k]]["picker_text"] || dimensionsInJSON[k].members[currentRow[k]].key;
                currentIndexKey = k + ':' + currentRow[k];
                currentKey = dimensionsInJSON[k].members[currentRow[k]].key;
              }
            }
          }

          rowJSON[currentKey] = {
            text: currentName,
            index: currentIndexKey
          };
          rowDimension.push(currentName);
        }
      } else {
        for (var i = nDimensionInColumns; i < nDimensions; ++i) {
          //alert('row loop:' + i);
          if (dimensionsInJSON[i].containsMeasures === undefined) {
            rowJSON[dimensionsInJSON[i].key] = {
              text: dimensionsInJSON[i]["picker_text"] || dimensionsInJSON[i].key,
              index: i
            };
            rowDimension.push(dimensionsInJSON[i]["picker_text"]);
          }
        }
      }
      /*
      			 * <<<<< CAUTION >>>>> <<<<< CAUTION >>>>> <<<<< CAUTION >>>>>
      			 * Below lines to recreate bardatacustomization use pointer variable concept
      			 * to access JSON object literal of bardatacustomization (ie.,
      			 * barDataCustomizationJSON). So any modification should be done carefully.
      			 */
      /*
      			 * Following code recreate the data utility selections if there were already
      			 * some selection prior to current changes or if datasource is changed.
      			 */
      /*component.columnDimensionIndex
      			Var dataSourceChanged = false;
      			var barDataCustomizationJSON = {};
      			for(var i=0;i<component.bardatacustomization.COLUMNS)*/
      var barDataCustomizationJSON = {
        'COLUMNS': [],
        'ROWS': []
      };
      if (component.bardatacustomization() !== '') {
        barDataCustomizationJSON = jQuery.parseJSON(component.bardatacustomization());
      }

      if (barDataCustomizationJSON['COLUMNS'].length === 0 && barDataCustomizationJSON['ROWS'].length === 0) {
        //if (component.bardatacustomization()=== undefined || component.bardatacustomization() == '') {
        /*
        				 * If the previous selection were nothing
        				 */
        /*var barDataCustomizationJSON = {};
        				barDataCustomizationJSON.COLUMNS = [];
        				barDataCustomizationJSON.ROWS = [];*/
        component.bardatacustomization(JSON.stringify(barDataCustomizationJSON));
      } else {
        /*
        				 * There were some selection priorly so verifying & updating them
        				 */
        //var barDataCustomizationJSON = jQuery.parseJSON(component.bardatacustomization());
        var oldColumn = barDataCustomizationJSON.COLUMNS.splice(0);
        var oldRow = barDataCustomizationJSON.ROWS.splice(0);
        /*
        				 * Checking in Columns
        				 */
        if (oldColumn !== undefined) {
          var columnArray = [];
          var columnKeys = Object.keys(columnJSON);
          for (var i = 0; i < columnKeys.length; i++) {
            columnArray.push(columnJSON[columnKeys[i]].text);
          }

          for (var i = oldColumn.length - 1; i >= 0; i--) {
            if (columnArray.indexOf(oldColumn[i].text) == -1) {
              // particular index exists in the current JSON
              oldColumn.splice(i, 1);
            }
          }
        }

        if (oldRow !== undefined) {
          /*
          					 * Loop thru old selection, if any, and update the information with
          					 * current available rowJSON. If particular index is not available
          					 * in current rowJSON, remove that element
          					 */
          for (var i = 0, iLimit = oldRow.length; i < iLimit; ++i) {
            if (rowJSON[oldRow[i].key] !== undefined) {
              oldRow[i].text = rowJSON[oldRow[i].key].text;
              oldRow[i].index = rowJSON[oldRow[i].key].index;
            } else {
              // index not available
              oldRow.splice(i, 1);
            }
          }
        }
        //				var rowArray = [];
        //				var rowKeys = Object.keys(rowJSON);
        //				for(var i=0;i<rowKeys.length+1;i++)
        //				{
        //				rowArray.push(rowKeys[i]);
        //				}
        //				for(var i = oldRow.length-1; i>=0 ; i--){
        //				if(rowArray.indexOf(oldRow[i].text) == -1){
        //				oldRow.splice(i, 1);
        //				}
        //				}
        //				}
        /*
        				 * If No selection were made, add a default first element of
        				 * columnJSON & rowJSON, if available
        				 */
        //				if((oldColumn.length === 0) || (oldRow.length === 0)){
        if (oldColumn.length === 0) {
          //for (var i in columnJSON){
          if (Object.keys(columnJSON).length !== 0) {
            oldColumn[0] = {
              key: Object.keys(columnJSON)[0],
              index: columnJSON[Object.keys(columnJSON)[0]].index,
              text: columnJSON[Object.keys(columnJSON)[0]].text
            };
          }  //break;
          //}
        }

        if (oldRow.length === 0) {
          for (var i in rowJSON) {
            oldRow[0] = {
              index: rowJSON[i].index,
              key: i,
              text: rowJSON[i].text
            };
            break;
          }
        }
        //	}
        barDataCustomizationJSON.COLUMNS = oldColumn;
        barDataCustomizationJSON.ROWS = oldRow;
        component.bardatacustomization(JSON.stringify(barDataCustomizationJSON));
      }
      // alert("columnJSON="+JSON.stringify(columnJSON)+"====rowJSON="+JSON.stringify(rowJSON));
      // return [ columnDimension, rowDimension, selectedColumns, selectedRows ];
      return [
        columnJSON,
        rowJSON
      ];
    };
  }
}
