/* global  sap */
/*global $:false */
/*jshint unused:false*/
function heatMapChartSeries() {
    var that = this;
    /**
     * Map data from JSON Tuple to Highchart
     * @override
     * @param {object} component - Reference to component
     * @param {string} type - type of the chart
     * @param {object} defaultValue - HighCharts values
     * @return {Array} seriesNames
     */
    that.createSeriesData = function(component, type, defaultValue) {
        var self = this;
        var seriesColor = component.dataseriescolor().split(',');
        component.categoriesIndex = [];
        var columnCount = 0;
        //console.log("Series Data");
        //     alert('overridden');
        defaultValue.xAxis.categories = [];
        defaultValue.yAxis.categories = [];
        defaultValue.series = [{}];
        var colCount = 0;
        var rowCount = 0;
        var measureRow;
        var globalArray = [];
        var dimension = 0;
        var getDSResult = true;
        var localResult = component.showtotal();
        var xaxisLength = [];
        var yaxisLength = [];
        var resultData = [];
        var newmajorData = [];
        var dime;
        var finalCategoryNamesKeys = [];
        if (component.dataRes === undefined || component.dataRes === '') {
            return '';
        }
        //console.log(JSON.stringify(component.dataRes));
        var newsRowsIndex = [];
        var newsColsIndex = [];
        var categoryDataRowAggr = [];
        for (var lenn = 0; lenn < component.dataRes.dimensions.length; lenn++) {
            if (component.dataRes.dimensions[lenn].containsMeasures !== true) {
                dimension++;
                if (component.dataRes.dimensions[lenn].axis == 'COLUMNS') {
                    colCount++;
                    newsColsIndex.push(lenn);
                } else if (component.dataRes.dimensions[lenn].axis == 'ROWS') {
                    rowCount++;
                    newsRowsIndex.push(lenn);
                }
            } else {
                dime = lenn;
                if (component.dataRes.dimensions[dime].axis == 'ROWS') {
                    measureRow = false;
                } else {
                    measureRow = true;
                }
            }
        }
        /*
         *For loop for getting Col & Row
         */
        var ColArrayIndex = [];
        for (var i = 0; i < component.dataRes['axis_columns'].length; i++) {
            var ColName = '';
            var tempColumn = component.dataRes['axis_columns'][i];
            var dimensionMemberPair = '';
            /*  if(tempColumn[dime] != -1)
                    continue;*/
            for (var k = 0; k < tempColumn.length; k++) {
              if(!measureRow){
                dime = 0;
              }

                if (tempColumn[dime] !== 0) {
                    if (measureRow && colCount !== 0) {
                        continue;
                    }
                } else if ([dime] == k ) {
                    if (measureRow && colCount !== 0) {
                        continue;
                    }
                }
                /*
                 * Loop for getting only Measure[o] Value Alone.
                 */

                if (tempColumn[k] != -1 && tempColumn[dime] === 0) {
                    if (ColName !== '') {
                        ColName = ColName + '/ ' + component.dataRes.dimensions[k].members[tempColumn[k]].text;//VBX141-5817
                        dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempColumn[k];
                    } else {
                        ColName = component.dataRes.dimensions[k].members[tempColumn[k]].text;//VBX141-5817
                        if (component.dataRes.dimensions[k].containsMeasures) {
                            ColName = self.formatSeriesName(component, ColName, k + ':' + tempColumn[k], {});
                        }

                        dimensionMemberPair = k + ':' + tempColumn[k];
                    }
                }
            }

            if (tempColumn[dime] === 0) {
                xaxisLength.push(ColName);
                ColArrayIndex.push(dimensionMemberPair);
            }
        }
        /*
         * Column Level Aggregation Without Result
         */
        for (var i = 0; i < component.dataRes['axis_rows'].length; i++) {
            var RowName = '';
            var rowKey = '';
            var dimensionMemberPair = '';
            var tempRow = component.dataRes['axis_rows'][i]; /* */
            if (tempRow[dime] !== 0 &&measureRow) {
                if (!measureRow && rowCount !== 0) {
                    continue;
                }
            } else if (tempRow[dime] == k && measureRow) {
                if (!measureRow && rowCount !== 0) {
                    continue;
                }
            }
            /*
             * Loop for getting only Measure[o] Value Alone.
             */
            for (var k = 0; k < tempRow.length; k++) {
                if (tempRow[k] != -1) {
                    if (RowName !== '') {
                        RowName = RowName + '/ ' + component.dataRes.dimensions[k].members[tempRow[k]].text;//VBX141-5817 || component.dataRes.dimensions[k].members[tempRow[k]].key;
                        dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempRow[k];
                        rowKey = rowKey + '//' + component.dataRes.dimensions[k].members[tempRow[k]].key;
                    } else {
                        RowName = component.dataRes.dimensions[k].members[tempRow[k]].text;//VBX141-5817 || component.dataRes.dimensions[k].members[tempRow[k]].key;
                        dimensionMemberPair = k + ':' + tempRow[k];
                        rowKey = component.dataRes.dimensions[k].members[tempRow[k]].key;
                    }
                }
            }
                yaxisLength.push(RowName);
                component.categoriesIndex.push(dimensionMemberPair);
                finalCategoryNamesKeys.push(rowKey);
        }
        /*
         * Row Level Aggregation Without Result
         */
        var lengthAxis = yaxisLength.length;
        if (measureRow && colCount === 0) {
            xaxisLength.splice(1, xaxisLength.length - 1);
        }

        if (!measureRow && rowCount === 0) {
            yaxisLength.splice(1, yaxisLength.length - 1);
        }
        /*
         * Loop for getting only Measure[o] Value Alone.
         */

         if(yaxisLength.length === 0){
          yaxisLength.push(component.dataRes.dimensions[dime].members[0].text);
        }

        var majorData = [];
        var TempData = component.dataRes.tuples;
        for (var d = 0; d < component.dataRes.data.length; d++) {
            if (TempData[d][dime] === 0)
            /*
             * Condition for Measure[0]
             */
            {
                majorData.push(component.dataRes.data[d]);

            }
            /*
             * Condition for tuples not equal to "TYPE==RESULT"
             */
        }

        var globalArrayTotal = [];
        var logic = majorData.length / yaxisLength.length;
        var bardatacustomizationJson = {
            'COLUMNS': [],
            'ROWS': []
        };
        if (component.bardatacustomization() !== '') {
            bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
        }
//if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length !== 0 || bardatacustomizationJson['ROWS'].length !== 0)) {
        if (false) {
            //var localChanges = bardatacustomizationJson;
            var newlocalChanges = bardatacustomizationJson;
            var newsCols = [];
            var newsRows = [];
            newsRowsIndex = [];
            var colIndex = [];
            var rowIndex = [];
            newsColsIndex = [];
            for (var i = 0; i < newlocalChanges.COLUMNS.length; i++) {
                newsCols.push(newlocalChanges.COLUMNS[i].text);
                newsColsIndex.push(newlocalChanges.COLUMNS[i].index);
                if (colIndex[bardatacustomizationJson.COLUMNS[i].index] === undefined) {
                    colIndex[bardatacustomizationJson.COLUMNS[i].index] = [];
                }

                colIndex[bardatacustomizationJson.COLUMNS[i].index].push(bardatacustomizationJson.COLUMNS[i].index);
            }

            for (var i = 0; i < newlocalChanges.ROWS.length; i++) {
                newsRows.push(newlocalChanges.ROWS[i].text);
                if (rowIndex[bardatacustomizationJson.ROWS[i].index] === undefined) {
                    rowIndex[bardatacustomizationJson.ROWS[i].index] = [];
                }

                rowIndex[bardatacustomizationJson.ROWS[i].index].push(bardatacustomizationJson.ROWS[i].index);
                newsRowsIndex.push(newlocalChanges.ROWS[i].index);
            }

            var newCol = newsCols.toString();
            var newRow = newsRows.toString();
            var colArray = [];
            var rowArray = [];
            var DataRow = [];
            var DataColumn = [];
            var dataTuple = [];
            var rowTemp;
            var colTemp;
            var datas = [];
            /*
             * Getting the column Name and push to old Logic.
             * Need to check if the key name changes in logic!!
             */
            /*
             * Main For Loop For Getting Xaxis Length And Yaxis Text.
             * Getting Tuples Lengtht(Data-Utiltity)
             */
            component.categoriesIndex = [];
            for (var i = 0; i < component.dataRes['axis_rows'].length; i++) {
                var RowName = '';
                var rowKey = '';
                var tempRow = component.dataRes['axis_rows'][i]; /* */
                var dimensionMemberPair = '';
                for (var k = 0; k < rowIndex.length; k++) {
                    if (rowIndex[k] === null) {
                        continue;
                    }

                  if (tempRow[k] != -1) {
                    if (RowName != '') { // jshint ignore:line
                        RowName = RowName + '/ ' + component.dataRes.dimensions[k].members[tempRow[k]].text;//VBX141-5817 || component.dataRes.dimensions[k].members[tempRow[k]].key;
                        dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempRow[k];
                        rowKey = rowKey + '//' + component.dataRes.dimensions[k].members[tempRow[k]].key;
                    } else {
                        RowName = component.dataRes.dimensions[k].members[tempRow[k]].text;//VBX141-5817 || component.dataRes.dimensions[k].members[tempRow[k]].key;
                        dimensionMemberPair = k + ':' + tempRow[k];
                        rowKey = component.dataRes.dimensions[k].members[tempRow[k]].key;
                    }
                  }
                }

                if (RowName !== '' && $.inArray(RowName, DataRow) == -1) {
                    DataRow.push(RowName);
                    component.categoriesIndex.push(dimensionMemberPair);
                    finalCategoryNamesKeys.push(rowKey);
                }
            }
            /*
             * Including only the Data Utility Row Series
             */
            ColArrayIndex = [];
            for (var i = 0; i < component.dataRes['axis_columns'].length; i++) {
                var ColName = '';
                var dimensionMemberPair = '';
                var tempColumn = component.dataRes['axis_columns'][i];
                for (var k = 0; k < colIndex.length; k++) {
                    if (colIndex[k] === null) {
                        continue;
                    }

                    if (ColName !== '') {
                        ColName = ColName + '/ ' + component.dataRes.dimensions[k].members[tempColumn[k]].text;//VBX141-5817
                        dimensionMemberPair = dimensionMemberPair + '-' + k + ':' + tempColumn[k];
                    } else {
                        ColName = component.dataRes.dimensions[k].members[tempColumn[k]].text;//VBX141-5817
                        if (component.dataRes.dimensions[k].containsMeasures) {
                            ColName = self.formatSeriesName(component, ColName, k + ':' + tempColumn[k], {});
                        }

                        dimensionMemberPair = k + ':' + tempColumn[k];
                    }
                }

                if (ColName !== '' && $.inArray(ColName, DataColumn) == -1) {
                    DataColumn.push(ColName);
                    ColArrayIndex.push(dimensionMemberPair);
                }
            }
            /*
             *Including only the Data Utility Column Series.
             */
            if (newCol === '' && newRow === '') {
                this.createSmokeScreen(component.$(), 'Please select Minimum One Dimension in Row');
            } else if (newCol === '') {
                var tempdata = 0;
                var majorData1 = [];
                var majorData2 = [];
                var lastRow = newsRowsIndex[newsRowsIndex.length - 1];
                //var majorData_3 = [];
                if (bardatacustomizationJson.ROWS.length != rowCount) {
                    for (var i = 0; i < component.dataRes['axis_rows'].length; i++) {
                        var tempRow = component.dataRes['axis_rows'][i]; /* */
                        if (majorData1[tempRow[lastRow]] === undefined) {
                            majorData1[tempRow[lastRow]] = [];
                        }

                        majorData1[tempRow[lastRow]].push(majorData[i]);
                    }
                    /*
                     *Creating the Array according to the axis_rows Logic
                     */
                    for (var i = 0; i < majorData1.length; i++) {
                        var total;
                        majorData1[i] = majorData1[i].filter(function(n) {
                            return n != '/';
                        });

                        if (majorData1[i].length !== 0) {
                            switch (component.chartaggregation()) {
                                case 'sum':
                                    var total = majorData1[i].reduce(function(a, b) {
                                        return a + b;
                                    });

                                    break;
                                case 'min':
                                    var total = majorData1[i].reduce(function(a, b) {
                                        return a < b ? a : b;
                                    });

                                    break;
                                case 'max':
                                    var total = majorData1[i].reduce(function(a, b) {
                                        return a > b ? a : b;
                                    });

                                    break;
                                case 'avg':
                                    var total = majorData1[i].reduce(function(a, b) {
                                        return a + b;
                                    }) / majorData1[i].length;
                                    break;
                                case 'variance':
                                    var total = Math.stDeviation(majorData1[i]);
                                    break;
                                case 'sd':
                                    var total = Math.sqrt(Math.stDeviation(majorData1[i]));
                                    break;
                            }
                        } else {
                            total = '/';
                        }

                        majorData2.push(total);
                    }

                    globalArray = majorData2;
                } else {
                    globalArray = majorData;
                }
            } else {
                var newTestRow;
                var newrowTemp;
                var newRowLogic;
                var length;
                for (var i = 0; i < newCol.split(',').length; i++) {
                    var test = newCol.split(',');
                    var newTest = test[i];
                    var colLogic = test[0];
                    for (var k = 0; k < newRow.split(',').length; k++) {
                        var testRow = newRow.split(',');
                        var newTestRow = testRow[k];
                        length = k + 1 + i + 1;
                        if (k >= 1) {
                            newRowLogic = testRow[k - 1];
                        }
                        for (var j = 0; j < component.dataRes.dimensions.length; j++) {
                            if (newTest == component.dataRes.dimensions[j]['picker_text']) {
                                colArray[j] = j;
                            }

                            if (newTestRow == component.dataRes.dimensions[j]['picker_text']) {
                                rowArray[j] = j;
                                rowTemp = j;
                            }

                            if (newTest == component.dataRes.dimensions[j]['picker_text'] || newTestRow == component.dataRes.dimensions[j]['picker_text']) {
                                dataTuple[j] = j;
                            }

                            if (colLogic == component.dataRes.dimensions[j]['picker_text']) {
                                colTemp = j;
                            }

                            if (newRowLogic == component.dataRes.dimensions[j]['picker_text']) {
                                newrowTemp = j;
                            }
                        }
                    }
                }


                var utilityLogic = false;
                if (newsRows.length > 1) {
                    var utilityLogic = true;
                }
                /*Major issue is yet to solve
                 * Issue yet to solve in column dimension fix.
                 */
                if (newTestRow == component.dataRes.dimensions[component.dataRes.dimensions.length - 1]['picker_text']) {
                    if (newRow.split(',').length <= 1) {
                        utilityLogic = false;
                    } else {
                        utilityLogic = true;
                    }
                }
                var UtitlityData = component.dataRes.tuples;
                var matched = false;
                var arr = [];
                for (var i = 0; i < component.dataRes.data.length; i++) {
                    if (UtitlityData[i][dime] === 0) {
                        var matched = false;
                        /*
                         * Same logic as Edit Intial view for removing result value.
                         */
                        if (matched === false) {
                            if (utilityLogic === true) {
                                for (var q = 0; q < component.dataRes.dimensions[newrowTemp].members.length; q++) {

                                    if (arr[q] === undefined) {
                                        arr[q] = [];
                                    }

                                    if (UtitlityData[i][newrowTemp] == q) {
                                        for (var m = 0; m < component.dataRes.dimensions[rowTemp].members.length; m++) {

                                            if (arr[q][m] === undefined) {
                                                arr[q][m] = [];
                                            }

                                            if (UtitlityData[i][rowTemp] == m) {
                                                for (var n = 0; n < component.dataRes.dimensions[colTemp].members.length; n++) {

                                                    if (arr[q][m][n] === undefined) {
                                                        arr[q][m][n] = [];
                                                    }

                                                    if (UtitlityData[i][colTemp] == n) {
                                                        var temp = component.dataRes.data[i];
                                                        if (temp !== null) {
                                                            arr[q][m][n].push(temp);
                                                        }
                                                    }
                                                }
                                                /*
                                                 * For Loop condition of selected Column-Wise Aggregation of getting all the data into selected
                                                 * Column Array "Result Logic"
                                                 */
                                            }
                                        }
                                    }
                                }
                            } else {
                                for (var m = 0; m < component.dataRes.dimensions[rowTemp].members.length; m++) {

                                    if (arr[m] === undefined) {
                                        arr[m] = [];
                                    }

                                    if (UtitlityData[i][rowTemp] == m) {
                                        for (var n = 0; n < component.dataRes.dimensions[colTemp].members.length; n++) {

                                            if (arr[m][n] === undefined) {
                                                arr[m][n] = [];
                                            }

                                            if (UtitlityData[i][colTemp] == n) {
                                                var temp = component.dataRes.data[i];
                                                if (temp !== null) {
                                                    arr[m][n].push(temp);
                                                }
                                            }
                                        }
                                        /*
                                         * For Loop condition of selected Column-Wise Aggregation of getting all the data into selected
                                         * Column Array "Result Logic"
                                         */
                                    }
                                }
                                /*
                                 * Getting the selected dimension poistion and creating the Array
                                 * According to selected dimension members length.
                                 */
                            }
                        }
                    }
                    /*
                     * Selected Measures Member alone.
                     */
                }
                /*
                 * End of Data with Data Utility Part
                 */
                //Getting mean
                Math.stDeviation = function(array) {
                    var mean = array.reduce(function(a, b) {
                            return a + b;
                        }) / array.length,
                        dev = array.map(function(itm) {
                            return (itm - mean) * (itm - mean);
                        });

                    return dev.reduce(function(a, b) {
                        return a + b;
                    }) / array.length;
                };
                //Getting Deviation
                var standardLogic = [];
                if (component.dataRes.dimensions.length != length + 1 && utilityLogic === false) {
                    for (var o = 0; o < arr.length; o++) {
                        if (arr[o] !== null) {
                            for (var p = 0; p < arr[o].length; p++) {
                                if (arr[o][p] !== undefined && arr[o][p].length !== 0) {
                                    if (component.chartaggregation() == 'sum') {
                                        var total = arr[o][p].reduce(function(a, b) {
                                            return a + b;
                                        });
                                    } else if (component.chartaggregation() == 'min') {
                                        var total = arr[o][p].reduce(function(a, b) {
                                            return a < b ? a : b;
                                        });
                                    } else if (component.chartaggregation() == 'max') {
                                        var total = arr[o][p].reduce(function(a, b) {
                                            return a > b ? a : b;
                                        });
                                    } else if (component.chartaggregation() == 'avg') {
                                        var total = arr[o][p].reduce(function(a, b) {
                                            return a + b;
                                        });

                                        total = total / arr[o][p].length;
                                    } else if (component.chartaggregation() == 'variance') {
                                        var total = Math.stDeviation(arr[o][p]);
                                    } else if (component.chartaggregation() == 'sd') {
                                        var total = Math.sqrt(Math.stDeviation(arr[o][p]));
                                    }
                                } else {
                                    var total = null;
                                }

                                globalArray.push(total);
                            }
                        }
                    }
                }
                /*
                 * Adding all the values in the array  using .Reduce function*/
                else if (component.dataRes.dimensions.length != length + 1 && utilityLogic === true) {
                    for (var o = 0; o < arr.length; o++) {
                        if (arr[o] !== null && standardLogic[o] === undefined) {
                            standardLogic[o] = [];
                        }

                        for (var p = 0; p < arr[o].length; p++) {
                            if (arr[o][p] !== null) {
                                for (var q = 0; q < arr[o][p].length; q++) {
                                    if (standardLogic[o][p] === undefined) {
                                        standardLogic[o][p] = [];
                                    }

                                    standardLogic[o][p].push(arr[o][p][q]);
                                }
                            }
                        }
                    }
                    /*
                     * Getting the lasted Selected array And creating the array according previous selected member.
                     */
                    for (var o = 0; o < standardLogic.length; o++) {
                        if (standardLogic[o] !== null) {
                            for (var p = 0; p < standardLogic[o].length; p++) {
                                if (standardLogic[o][p] !== null) {
                                    for (var n = 0; n < standardLogic[o][p].length; n++) {
                                        if (standardLogic[o][p][n].length !== 0) {
                                            if (component.chartaggregation() == 'sum') {
                                                var total = standardLogic[o][p][n].reduce(function(a, b) {
                                                    return a + b;
                                                });
                                            } else if (component.chartaggregation() == 'min') {
                                                var total = standardLogic[o][p][n].reduce(function(a, b) {
                                                    return a < b ? a : b;
                                                });
                                            } else if (component.chartaggregation() == 'max') {
                                                var total = standardLogic[o][p][n].reduce(function(a, b) {
                                                    return a > b ? a : b;
                                                });
                                            } else if (component.chartaggregation() == 'avg') {
                                                var total = standardLogic[o][p][n].reduce(function(a, b) {
                                                    return a + b;
                                                });

                                                total = total / standardLogic[o][p][n].length;
                                            } else if (component.chartaggregation() == 'variance') {
                                                var total = Math.stDeviation(arr[o][p]);
                                            } else if (component.chartaggregation() == 'sd') {
                                                var total = Math.sqrt(Math.stDeviation(arr[o][p]));
                                            }
                                        } else {
                                            var total = null;
                                        }

                                        globalArray.push(total);
                                    }
                                }
                            }
                        }
                    }
                    /*
                     * Suming the entire value using ".reduce Method"
                     */
                } else {
                    globalArray = majorData;
                    /*
                     * Same Data-Source no need for different logic follow the Edit initial view Syntax
                     */
                }
            }

            var tempRowLen = DataRow.length || 1;
            var tempColLen = DataColumn.length || 1;
            for (var i = 0; i < tempRowLen; i++) {
                for (var j = 0; j < tempColLen; j++) {
                    var data = [
                        i,
                        j
                    ];
                    datas.push(data);
                }
            }
            /*
             * Matrix Data values for Highcharts
             */
            for (var d = 0; d < tempRowLen * tempColLen; d++) {
                datas[d].push(globalArray[d]);
            }
            /*
             * Matrix value According to DS structure
             */
            categoryDataRowAggr = [];
            categoryDataRowAggr.push({
                name: component.dataRes.dimensions[dime].members[0].text,
                uniquekey: component.dataRes.dimensions[dime].members[0].key,
                scalingFactor: component.dataRes.dimensions[dime].members[0].scalingFactor,
                unitOfMeasure: component.dataRes.dimensions[dime].members[0].unitOfMeasure,
                key: ColArrayIndex,
                data: datas
            });
            /// console.log("categoryDataRowAggr="+JSON.stringify(categoryDataRowAggr));

            if (component.enablehierarchylabels() === true) {
                // defaultValue.xAxis.categories = this.createHierarchyLabels(component.dataRes, newsRowsIndex, component);
                var xAxisDefaultCategories = [];
                defaultValue.xAxis.categories = DataRow;
                xAxisDefaultCategories = xAxisDefaultCategories.concat(defaultValue.xAxis.categories);
                var processedCategories = this.createHierarchyLabelsStacked(component, newsRowsIndex, xAxisDefaultCategories);
                defaultValue.xAxis.categories = processedCategories.withHier;
                ///   console.log("defaultValue.xAxis.categories="+JSON.stringify(defaultValue.xAxis.categories));
                  /* Following code is required to manipulate the series according to the order of xAxis categories.
                               This case will occur when the row Dimension selected in Data Utility is not in the same order as in Initial View.
                            */
                  var selRowInd = [];
                  selRowInd = selRowInd.concat(newsRowsIndex);
                  selRowInd.sort(function(a, b) {
                    return a - b;
                  });

                  if (selRowInd.join(',') != newsRowsIndex.join(',')) {
                    var newCategoriesOrder = [];
                    $.each(processedCategories.withoutHier, function(i, v) {
                      self.createFlatCategoryLabelsStacked(v, newCategoriesOrder, [v.key]);
                    });

                    //console.log(JSON.stringify(newCategoriesOrder));

                    var newcategoryDataRowAggr = [];
                    $.extend(true, newcategoryDataRowAggr, categoryDataRowAggr);
                    $.each(newCategoriesOrder, function(i, v) {
                      var k = finalCategoryNamesKeys.indexOf(v);
                      $.each(newcategoryDataRowAggr, function(ind, ele) {
                        var val = ele.data[k];
                        categoryDataRowAggr[ind].data[i] = val;
                      });
                    });
                  }

                if (newsColsIndex.length) {
                    defaultValue.yAxis.categories = this.createHierarchyLabels(component.dataRes, newsColsIndex, component, 'COLUMNS');
                }
            } else {
                //  console.log("DataRow="+JSON.stringify(DataRow));
                if (DataColumn.length === 0) {
                    //DataColumn.push(component.dataRes.dimensions[dime].members[0].text);
                    DataColumn.push(self.formatSeriesName(component, component.dataRes.dimensions[dime].members[0].text, dime + ':' + 0, {}));
                }

                defaultValue.xAxis.categories = DataRow;
                //Xaxis Values
                defaultValue.yAxis.categories = DataColumn; //Yaxis values
            }

            defaultValue.series = categoryDataRowAggr;
            return defaultValue.series[0].name;
        }
        /*
         * End Of Data Utility Part.
         */
        var datas = [];
        var tempYAxis = yaxisLength.length || 1;
        var tempXAxis = xaxisLength.length || 1;
        for (var i = 0; i < tempYAxis; i++) {
            for (var j = 0; j < tempXAxis; j++) {
                var data = [i, j];
                datas.push(data);
            }
        }
        /*
         * Matrix Data values for Highcharts
         */
        var logici = 0;
        for (var d = 0; d < tempXAxis * tempYAxis; d++) {
            if (d < tempXAxis * lengthAxis) {
                datas[d].push(majorData[d]);
            } else {
                datas[d].push(majorData[logici]);
                logici++;
            }
        }
        /*
         * Matrix value According to DS structure
         */
        categoryDataRowAggr = [];
        categoryDataRowAggr.push({
            name: component.dataRes.dimensions[dime].members[0].text,
            uniquekey: component.dataRes.dimensions[dime].members[0].key,
            scalingFactor: component.dataRes.dimensions[dime].members[0].scalingFactor,
            unitOfMeasure: component.dataRes.dimensions[dime].members[0].unitOfMeasure,
            key: ColArrayIndex,
            data: datas
        });

        if (component.enablehierarchylabels() === true) {
            var xAxisDefaultCategories = [];
                defaultValue.xAxis.categories = yaxisLength;
                xAxisDefaultCategories = xAxisDefaultCategories.concat(defaultValue.xAxis.categories);
                var processedCategories = this.createHierarchyLabelsStacked(component, newsRowsIndex, xAxisDefaultCategories);
                defaultValue.xAxis.categories = processedCategories.withHier;
                ///   console.log("defaultValue.xAxis.categories="+JSON.stringify(defaultValue.xAxis.categories));
                  /* Following code is required to manipulate the series according to the order of xAxis categories.
                               This case will occur when the row Dimension selected in Data Utility is not in the same order as in Initial View.
                            */
                  var selRowInd = [];
                  selRowInd = selRowInd.concat(newsRowsIndex);
                  selRowInd.sort(function(a, b) {
                    return a - b;
                  });

                  if (selRowInd.join(',') != newsRowsIndex.join(',')) {
                    var newCategoriesOrder = [];
                    $.each(processedCategories.withoutHier, function(i, v) {
                      self.createFlatCategoryLabelsStacked(v, newCategoriesOrder, [v.key]);
                    });

                    //console.log(JSON.stringify(newCategoriesOrder));

                    var newcategoryDataRowAggr = [];
                    $.extend(true, newcategoryDataRowAggr, categoryDataRowAggr);
                    $.each(newCategoriesOrder, function(i, v) {
                      var k = finalCategoryNamesKeys.indexOf(v);
                      $.each(newcategoryDataRowAggr, function(ind, ele) {
                        var val = ele.data[k];
                        categoryDataRowAggr[ind].data[i] = val;
                      });
                    });
                  }
            // Hierarchy labelling for Y-axis
            if (newsColsIndex.length) {
                defaultValue.yAxis.categories = this.createHierarchyLabels(component.dataRes, newsColsIndex, component, 'COLUMNS');
            } else {
                defaultValue.yAxis.categories = xaxisLength; //if array is undefined or not.
            }

        } else {
            if (xaxisLength.length === 0) {
                xaxisLength.push(self.formatSeriesName(component, component.dataRes.dimensions[dime].members[0].text, dime + ':' + 0, {}));
            }

            defaultValue.xAxis.categories = yaxisLength;
            //Xaxis Values
            defaultValue.yAxis.categories = xaxisLength; //Yaxis values
        }
        //console.log("xaxisLength="+JSON.stringify(defaultValue.yAxis.categories));

        defaultValue.series = categoryDataRowAggr;
        return defaultValue.series;
    };
}
