function sparklineSeries() { //jshint ignore:line
  //	 alert('[[Executed sparklineSeries]]');
  var that = this;
  /**
  	 * Map data from JSON Tuple to Highchart
  	 * @override
  	 * @param {object} component - Reference to component
  	 * @param {string} type - type of the chart
  	 * @param {object} defaultValue - HighCharts values
  	 * @return {Array} seriesNames
  	 */
  that.createMemberData = function(component, memberStr) {
    var memberArr = [];
    component.memberDataCollection = {};
    memberArr = memberArr.concat(memberStr.split('-'));
    if (component.dataRes.dimensions.length == 1) {
      component.memberDataCollection[component.dataRes.dimensions[memberArr[0]].key] = {
        'internalKey': component.dataRes.dimensions[memberArr[0]].members[memberArr[2]].key,
        'text': component.dataRes.dimensions[memberArr[0]].members[memberArr[2]].text
      };
    } else {
      for (var i = 0; i < memberArr.length; i += 2) {
        var j = i + 1;
        component.memberDataCollection[component.dataRes.dimensions[memberArr[i]].key] = {
          'internalKey': component.dataRes.dimensions[memberArr[i]].members[memberArr[j]].key,
          'text': component.dataRes.dimensions[memberArr[i]].members[memberArr[j]].text
        };
      }
    }

    return JSON.stringify(component.memberDataCollection);
  };

  that.sparklineValueAggregation = function(component, dataArr) {
    if(dataArr.length === 1){
    	return dataArr[0];
    }
    var getSum = function(numArr) {
      var sum = 0;
      $.each(numArr, function(index, value) {
        sum += value;
      });

      return sum;
    };
	var getNumWithSetDec = function(num, numOfDec) {
      var pow10s = Math.pow(10, numOfDec || 0);
      return numOfDec ? Math.round(pow10s * num) / pow10s : num;
    }, getAverageFromNumArr = function(numArr) {

      var sum = getSum(numArr);
      return getNumWithSetDec(sum / numArr.length, 2);
    }, getVariance = function(numArr) {

      var avg = getAverageFromNumArr(numArr), i = numArr.length, v = 0;
      while (i--) {
        v += Math.pow(numArr[i] - avg, 2);
      }

      v /= numArr.length;
      return getNumWithSetDec(v, 2);
    }, getStandardDeviation = function(numArr) {

      var stdDev = Math.sqrt(getVariance(numArr));
      return getNumWithSetDec(stdDev, 2);
    };

    

    if (component.chartaggregation() === '') {
      component.chartaggregation('sum');
    }

    if (component.chartaggregation() == 'sum') {
      return getSum(dataArr);
    } else if (component.chartaggregation() == 'avg') {
      return getAverageFromNumArr(dataArr);
    } else if (component.chartaggregation() == 'min') {
      return Math.min.apply(Math, dataArr);
    } else if (component.chartaggregation() == 'max') {
      return Math.max.apply(Math, dataArr);
    } else if (component.chartaggregation() == 'sd') {
      return getStandardDeviation(dataArr);
    } else if (component.chartaggregation() == 'variance') {
      return getVariance(dataArr);
    }
  };

  that.createSeriesData = function(component, charttype, bardatacustomizationJson, measureDimensionIndex, colNum) {
    component.selectedRowIndex = [];
    component.selectedColumnIndex = [];
    //var measureDimensionIndex=seriesLibrary.getMeasureDimensionIndex(that);
    //var colNum=seriesLibrary.getNumberOfRowsColumns(that,"COLUMNS");
    var measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
    // if (component.datautility() === true) {
    //   $.each(bardatacustomizationJson['ROWS'], function(index, element) {
    //     if (typeof component.dataRes.dimensions[element.index] != 'undefined') {
    //       component.selectedRowIndex.push(element.index);
    //     }
    //   });

    //   $.each(bardatacustomizationJson['COLUMNS'], function(index, element) {
    //     if (typeof component.dataRes.dimensions[element.index] != 'undefined') {
    //       component.selectedColumnIndex.push(element.index);
    //     }
    //   });
    // } else {
      for (var i = 0; i < component.dataRes.dimensions.length; i++) {
        if (i != measureDimensionIndex) {
          if (i >= colNum) {
            component.selectedRowIndex.push(i);
          } else {
            if (!measureInRow && component.selectedColumnIndex.length < 1) {
              component.selectedColumnIndex.push(i);
            } else if (measureInRow && component.selectedColumnIndex.length < 2) {
              component.selectedColumnIndex.push(i);
            }
          }
        }
      }
    //}
    //selectedRowIndex.push(1);
    //selectedRowIndex.push(3);
    //that.selectedColumnIndex.push(measureDimensionIndex);
    if (!measureInRow) {
      component.selectedColumnIndex.push(measureDimensionIndex);
      if (component.selectedRowIndex.length === 0) {
        if (typeof component.dataRes.dimensions[colNum] != 'undefined') {
          component.selectedRowIndex.push(colNum);
        }
      }

      if (charttype != 'bullet') {
        component.selectedColumnIndex.sort(function(a, b) {
          return a - b;
        });
      }
    } else {
      component.selectedRowIndex.push(measureDimensionIndex);
      if (component.selectedColumnIndex.length === 0) {
        if (typeof component.dataRes.dimensions[0] != 'undefined' && component.dataRes.dimensions[0].axis == 'COLUMNS') {
          component.selectedColumnIndex.push(colNum);
        }
      }  /*if(charttype!="bullet")
  			{
  				that.selectedRowIndex.sort(function(a, b){return a-b;});
  			}*/
    }

    var tuplesInARow = component.dataRes.tuples.slice(0, component.dataRes.columnCount);
    // Getting tuples for all Columns in first row of crosstab.
    //var colIndex_3darray = [];
    var colRowIndexJson = {};
    //var measureIndexEqualsSelectedColumnIndex;
    var noOfColumns = 0;
    component.colIndexJson = {};
    for (var i = 0; i < component.dataRes.dimensions.length; i++) {
      if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
        noOfColumns++;
      }
    }

    for (var i = 0; i < tuplesInARow.length; i++) {
      var tempTuple = tuplesInARow[i].slice(0, noOfColumns);
      if (that.vbiCharts.eliminateResult(component.dataRes, tempTuple,undefined,component.showtotaldatabase()) === true) {
        var colKey = [];
        var colName = [];
        var ColumnKey = [];
        for (var j = 0; j < component.selectedColumnIndex.length; j++) {
          var tempCol = component.selectedColumnIndex[j];
          colName.push(component.dataRes.dimensions[tempCol].members[tempTuple[tempCol]].text);
          ColumnKey.push(component.dataRes.dimensions[tempCol].members[tempTuple[tempCol]].key);
          colKey.push(tempCol + ':' + tempTuple[tempCol]);
        }

        var newKey = colKey.join('-');
        if (colKey[0] !== undefined && component.colIndexJson[colKey[0]] === undefined) {
          component.colIndexJson[colKey[0]] = [];
        }

        if (colKey[1] !== undefined && component.colIndexJson[colKey[0]].indexOf(colKey[1]) == -1) {
          component.colIndexJson[colKey[0]].push(colKey[1]);
        }

        if (typeof colRowIndexJson[newKey] == 'undefined') {
          colRowIndexJson[newKey] = [];
        }

        colRowIndexJson[newKey].push(i);
      }
    }
    //var rowDataArr=[]; // Array that holds data rowwise for each of the required columns with top level and next level.
    var tupleToSkip = 0;
    var tuplesInColumn = [];
    //var rowIndexJson = {};
    component.rowNames = {};
    component.rowNamesscaling = {};
    component.rownameunit = {};
    //var scaling_row = '';
    //var unit_row = '';
    var rowDataJson = {};
    for (var i = 0; i < component.dataRes.rowCount; i++) {
      tupleToSkip = component.dataRes.columnCount * i;
      tuplesInColumn.push(component.dataRes.tuples[tupleToSkip]);
      var tempTuple = tuplesInColumn[i];
      if (that.vbiCharts.eliminateResult(component.dataRes, tempTuple, 'ROWS',component.showtotaldatabase()) === true) {
        var rowKey = 0 + '';
        var rowHeader = 'Dimensions';
        if (component.selectedRowIndex.length >= 1) {
          rowKey = component.selectedRowIndex[0] + ':' + tempTuple[component.selectedRowIndex[0]];
          rowHeader = component.dataRes.dimensions[component.selectedRowIndex[0]].members[tempTuple[component.selectedRowIndex[0]]].text;
          for (var j = 1; j < component.selectedRowIndex.length; j++) {
            rowKey += '-' + component.selectedRowIndex[j] + ':' + tempTuple[component.selectedRowIndex[j]];
            if (component.dataRes.dimensions[component.selectedRowIndex[j]].hasOwnProperty('containsMeasures') === false) {
              // jscs:disable
              if(component.dataRes.dimensions[component.selectedRowIndex[j]].members[tempTuple[component.selectedRowIndex[j]]].text){
                rowHeader += ( rowHeader!=='' ? '/' : '' ) + component.dataRes.dimensions[component.selectedRowIndex[j]].members[tempTuple[component.selectedRowIndex[j]]].text;
              }
            } else {
              rowHeader += '/' + component.dataRes.dimensions[component.selectedRowIndex[j]].members[tempTuple[component.selectedRowIndex[j]]].text  ;
            }
            // jscs:enable
            if (component.showunit()) {
              if (component.dataRes.dimensions[component.selectedRowIndex[j]].members[tempTuple[component.selectedRowIndex[j]]].hasOwnProperty('unitOfMeasure')) {
                //rowHeader += ' ' + component.dataRes.dimensions[component.selectedRowIndex[j]].members[tempTuple[component.selectedRowIndex[j]]].unitOfMeasure;
              } else {
                rowHeader += '';
              }
            } else {
              rowHeader += '';
            }
          }
        }

        if (typeof component.rowNames[rowKey] == 'undefined') {
          component.rowNames[rowKey.replace(/:/g, '-')] = rowHeader;

        }

        $.each(colRowIndexJson, function(key, value) {
          $.each(value, function(index, newval) {
            var curIndex = newval + tupleToSkip;
            var colKey = [];
            colKey = colKey.concat(key.split('-'));
            var keygen = colKey[0] + '_' + rowKey;
            if (colKey.length >= 2) {
              if (rowDataJson[keygen] === undefined) {
                rowDataJson[keygen] = {};
              }

              if (rowDataJson[keygen][colKey[1]] === undefined) {
                rowDataJson[keygen][colKey[1]] = [];
              }

              rowDataJson[keygen][colKey[1]].push(component.dataRes.data[curIndex] === null || component.dataRes.data[curIndex] === 'null' ? 0 : component.dataRes.data[curIndex]);
            } else {
              if (rowDataJson[keygen] === undefined) {
                rowDataJson[keygen] = [];
              }

              rowDataJson[keygen].push(component.dataRes.data[curIndex]);
            }
          });
        });
      }
    }
    //console.log("component.rowNames="+JSON.stringify(component.rowNames));
    //*************New code ends**********************
    return rowDataJson;
  };
  //var rowNamesArr=[];
  that.makeTableBullet = function(component, rowDataJson, table, pm, cm, mi) {
    var self = this;
    var seriesColor = [];
    var columnsJson = {};
    var topColumnsArr = [];
    var rowNamesArr = [];
    var rangeSilderJsonNew = {};
    var defaultColors = ['#B8DC5A'];
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = [];
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }

    var row = $('<tr/>');
    row.append($('<th/>').css('padding', '5px'));
    if (component.selectedColumnIndex.length < 2) {
      columnsJson[0] = 'Measures';
      row.append($('<th/>').append('Measures'));
    } else {
      var i = 0;
      for (var keys in component.colIndexJson) {
        var tempKey = keys.split(':');
        columnsJson[i] = component.dataRes.dimensions[component.selectedColumnIndex[0]].members[i].text;
        topColumnsArr[i] = keys;
        //columnsJson[i]=component.dataRes.dimensions[component.selectedColumnIndex[0]].members[i].text;
        //columnsJson[i]=component.dataRes.dimensions[component.selectedColumnIndex[0]].members[i].text;

        if (component.dataRes.dimensions[tempKey[0]].hasOwnProperty('containsMeasures')) {
          row.append($('<th/>').append(self.formatSeriesName(component, component.dataRes.dimensions[tempKey[0]].members[tempKey[1]].text, tempKey[0] + ':' + tempKey[1], {})).css({
              'color': component.columnheadertextcolor(),
              'font-size': component.columnheaderfontsize() + 'px',
              'font-weight': component.columnheaderfontweight()
            }));
        } else {
          row.append($('<th/>').append(component.dataRes.dimensions[tempKey[0]].members[tempKey[1]].text).css({
              'color': component.columnheadertextcolor(),
              'font-size': component.columnheaderfontsize() + 'px',
              'font-weight': component.columnheaderfontweight()
            }));
        }

        i++;
      }
    }

    table.append(row);
    var maxrange = component.datamaxrange();
    var minrange = component.dataminrange();
    $.each(rowDataJson, function(rowIndex/*, key*/) {
      var row = $('<tr/>');
      row.append($('<td/>').append(component.rowNames[rowIndex]).css({
        'color': component.rowheadertextcolor(),
        'font-size': component.rowheaderfontsize() + 'px',
        'font-weight': component.rowheaderfontweight()
      }));
      rowNamesArr.push(component.rowNames[rowIndex]);
      if (component.selectedColumnIndex.length < 2) {
        var colIndex = 0;
        that.getSeriesColors(component, seriesColor, rowNamesArr.length - 1, defaultColors);
        var fromVal = minrange + component.rangeDiff / 3;
        var toVal = maxrange - component.rangeDiff / 3;
        rangeSilderJsonNew[rowIndex + '-' + colIndex] = {
          from: fromVal.toFixed(2),
          to: toVal.toFixed(2),
          max: maxrange,
          name: component.rowNames[rowIndex] + '-' + columnsJson[colIndex]
        };
        if (component.rangeFlag == 1 && typeof component.rangeSliderJson[rowIndex + '-' + colIndex] != 'undefined') {
          if (component.rangeSliderJson[rowIndex + '-' + colIndex].max == maxrange && component.rangeSliderJson[rowIndex + '-' + colIndex].name == component.rowNames[rowIndex] + '-' + columnsJson[colIndex]) {
            rangeSilderJsonNew[rowIndex + '-' + colIndex].from = component.rangeSliderJson[rowIndex + '-' + colIndex].from;
            rangeSilderJsonNew[rowIndex + '-' + colIndex].to = component.rangeSliderJson[rowIndex + '-' + colIndex].to;
          }
        }

        row.append($('<td/>').css({'padding': component.padding / 2 + 'px'}).highcharts('SparkLine', {
          yAxis: {
            max: maxrange,
            labels: {
              y: 10,
              style: {fontSize: '8px'}
            },
            plotBands: [
              {
                from: 0,
                to: rangeSilderJsonNew[rowIndex + '-' + colIndex].from,
                color: component.qualitativescale1colors()
              },
              {
                from: rangeSilderJsonNew[rowIndex + '-' + colIndex].from,
                to: rangeSilderJsonNew[rowIndex + '-' + colIndex].to,
                color: component.qualitativescale2colors()
              },
              {
                from: rangeSilderJsonNew[rowIndex + '-' + colIndex].to,
                to: maxrange,
                color: component.qualitativescale3colors()
              }
            ]
          },
          series: function() {
            var seriesArr = [];
            seriesArr.push({
              name: component.dataRes.dimensions[mi].members[pm].text,
              color: seriesColor[rowNamesArr.length - 1],
              rowname: component.rowNames[rowIndex],
              colname: columnsJson[colIndex],
              /*pointWidth:10,*/
              data: [{name: component.dataRes.dimensions[mi].members[pm].text, y: rowDataJson[rowIndex][pm][0]}],
              memberKey: rowIndex + '-' + mi + '-' + pm
            });

            for (var i = 0; i < cm.length; i++) {
              if (cm[i] != 'none') {
                //console.log("cm[i]="+cm[i]);
                seriesArr.push({
                  marker: {
                    lineColor: component['scattermarkerlinecolor' + (i + 1)](),
                    lineWidth: component['scattermarkerlinewidth' + (i + 1)](),
                    radius:parseFloat( component['scattermarkerlineradius' + (i + 1)]())
                  },
                  type: 'scatter',
                  name: component.dataRes.dimensions[mi].members[cm[i]].text,
                  rowname: component.rowNames[rowIndex],
                  colname: columnsJson[colIndex],
                  memberKey: rowIndex + '-' + mi + '-' + cm[i],
                  data: [{name: component.dataRes.dimensions[mi].members[cm[i]].text, y: rowDataJson[rowIndex][cm[i]][0]}]
                });
              }
            }
            //console.log("seriesArr="+JSON.stringify(seriesArr));
            return seriesArr;
          }(),

          chart: {
            type: 'bar',
            marginTop: isNaN(Number(component.chartmargintop())) ? 5 : Number(component.chartmargintop()),
            marginRight: isNaN(Number(component.chartmarginright())) ? 15 : Number(component.chartmarginright()),
            marginBottom: isNaN(Number(component.chartmarginbottom())) ? 10 : Number(component.chartmarginbottom()),
            marginLeft: isNaN(Number(component.chartmarginleft())) ? 50 : Number(component.chartmarginleft())
          }
        }));
      } else {
        $.each(rowDataJson[rowIndex], function(colIndex/*, c*/) {
          var partialMemberKey = rowIndex + '-' + topColumnsArr[colIndex].replace(/:/g, '-');
          that.getSeriesColors(component, seriesColor, rowNamesArr.length - 1, defaultColors);
          var fromVal = minrange + component.rangeDiff / 3;
          var toVal = maxrange - component.rangeDiff / 3;
          rangeSilderJsonNew[rowIndex + '-' + colIndex] = {
            from: fromVal.toFixed(2),
            to: toVal.toFixed(2),
            max: maxrange,
            name: component.rowNames[rowIndex] + '-' + columnsJson[colIndex]
          };
          if (component.rangeFlag == 1 && typeof component.rangeSliderJson[rowIndex + '-' + colIndex] != 'undefined') {
            if (component.rangeSliderJson[rowIndex + '-' + colIndex].max == maxrange && component.rangeSliderJson[rowIndex + '-' + colIndex].name == component.rowNames[rowIndex] + '-' + columnsJson[colIndex]) {
              rangeSilderJsonNew[rowIndex + '-' + colIndex].from = component.rangeSliderJson[rowIndex + '-' + colIndex].from;
              rangeSilderJsonNew[rowIndex + '-' + colIndex].to = component.rangeSliderJson[rowIndex + '-' + colIndex].to;
            }
          }
          //console.log("that.padding/2="+ component.padding/2);
          row.append($('<td/>').css({'padding': component.padding / 2 + 'px'}).highcharts('SparkLine', {
            yAxis: {
              max: maxrange,
              labels: {
                y: 10,
                style: {fontSize: '8px'}
              },
              plotBands: [
                {
                  from: 0,
                  to: rangeSilderJsonNew[rowIndex + '-' + colIndex].from,
                  color: component.qualitativescale1colors()
                },
                {
                  from: rangeSilderJsonNew[rowIndex + '-' + colIndex].from,
                  to: rangeSilderJsonNew[rowIndex + '-' + colIndex].to,
                  color: component.qualitativescale2colors()
                },
                {
                  from: rangeSilderJsonNew[rowIndex + '-' + colIndex].to,
                  to: maxrange,
                  color: component.qualitativescale3colors()
                }
              ]
            },
            series: function() {
              var seriesArr = [];
              seriesArr.push({
                name: component.dataRes.dimensions[mi].members[pm].text,
                color: seriesColor[rowNamesArr.length - 1],
                rowname: component.rowNames[rowIndex],
                colname: columnsJson[colIndex],
                /*pointWidth:10,*/
                data: [{name: component.dataRes.dimensions[mi].members[pm].text, y: rowDataJson[rowIndex][colIndex][pm]}],
                memberKey: partialMemberKey + '-' + mi + '-' + pm
              });
              for (var i = 0; i < cm.length; i++) {
                if (cm[i] != 'none') {
                  //console.log("cm[i]="+cm[i]);
                  seriesArr.push({
                    marker: {
                      lineColor: component['scattermarkerlinecolor' + (i + 1)](),
                      lineWidth: component['scattermarkerlinewidth' + (i + 1)](),
                      radius: parseFloat(component['scattermarkerlineradius' + (i + 1)]())
                    },
                    type: 'scatter',
                    name: component.dataRes.dimensions[mi].members[cm[i]].text,
                    rowname: component.rowNames[rowIndex],
                    colname: columnsJson[colIndex],
                    memberKey: partialMemberKey + '-' + mi + '-' + cm[i],
                    data: [{name: component.dataRes.dimensions[mi].members[cm[i]].text, y: rowDataJson[rowIndex][colIndex][cm[i]]}]
                  });
                }
              }
              //console.log("seriesArr="+JSON.stringify(seriesArr));
              return seriesArr;
            }(),

            chart: {
              type: 'bar',
              marginTop: isNaN(Number(component.chartmargintop())) ? 5 : Number(component.chartmargintop()),
              marginRight: isNaN(Number(component.chartmarginright())) ? 15 : Number(component.chartmarginright()),
              marginBottom: isNaN(Number(component.chartmarginbottom())) ? 10 : Number(component.chartmarginbottom()),
              marginLeft: isNaN(Number(component.chartmarginleft())) ? 50 : Number(component.chartmarginleft())
            }
          }));
        });
      }

      table.append(row);
    });

    component.qualitativerange(JSON.stringify(rangeSilderJsonNew));
    component.$().append('<div style=\'width:100%;height:100%;position:relative\'/>');
    if (!component.enablescroll()) {
      component.$().find('div').parent().css('overflow', 'hidden');
    }

    component.$().find('div').append(table);
    seriesColor.splice(rowNamesArr.length, seriesColor.length);
    component.dataseriescolor(seriesColor.join());
  };

  that.makeTable = function(component, rowDataJson, chart, table) {
    var self = this;
    var seriesColor = [];
    var topColumnsArr = [];
    var rowNamesArr = [];
    var defaultColors = ['#B8DC5A'];
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = [];
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }

    var measureMarkerPair;
    if (!(component.measuremarkerpair() === undefined || component.measuremarkerpair() === '')) {
      measureMarkerPair = JSON.parse(component.measuremarkerpair());
    }

    var globalMarkerKey = '';
    var row = $('<tr/>');
    row.append($('<th/>').css('padding', '5px'));
    if (component.selectedColumnIndex.length === 0) {
      row.append($('<th/>'));
    } else {
      for (var keys in component.colIndexJson) {

        var tempKey = keys.split(':');
        topColumnsArr.push(keys);
        var mColIndex = 0;
        for (var ij = 0; ij < component.dataRes.dimensions.length; ij++) {
          if (component.dataRes.dimensions[ij].containsMeasures){
			mColIndex = ij;
		  }
        }

        tempKey[2] = mColIndex.toString();

        //console.log(component.dataRes.dimensions[tempKey[0]].members[tempKey[1]].text + " +text")
        //columnsJson[i]=component.dataRes.dimensions[component.selectedColumnIndex[0]].members[i].text;

        if (component.dataRes.dimensions[tempKey[0]].hasOwnProperty('containsMeasures')) {
          //  alert(component.dataRes.dimensions[tempKey[0]].members[tempKey[1]].text);
          row.append($('<th/>').append(self.formatSeriesName(component, component.dataRes.dimensions[tempKey[0]].members[tempKey[1]].text, tempKey[0] + ':' + tempKey[1], {})).css({
              'color': component.columnheadertextcolor(),
              'font-size': component.columnheaderfontsize() + 'px',
              'font-weight': component.columnheaderfontweight()
            }));
        } else {
          row.append($('<th/>').append(component.dataRes.dimensions[tempKey[0]].members[tempKey[1]].text).css({
              'color': component.columnheadertextcolor(),
              'font-size': component.columnheaderfontsize() + 'px',
              'font-weight': component.columnheaderfontweight()
            }));
        }
      }
    }

    table.append(row);
    //var maxrange = component.datamaxrange();
    //var minrange = component.dataminrange();
    component.memberInfoForMarker = [];

    $.each(rowDataJson, function(rowIndex/*, key*/) {
      var row = $('<tr/>');
      row.append($('<td/>').append(component.rowNames[rowIndex]).css({
        'color': component.rowheadertextcolor(),
        'font-size': component.rowheaderfontsize() + 'px',
        'font-weight': component.rowheaderfontweight()
      }));

      var tempSeriesColor = that.getSeriesColors(component, seriesColor, rowNamesArr.length, defaultColors);
      rowNamesArr.push(component.rowNames[rowIndex]);
      $.each(rowDataJson[rowIndex], function(colIndex/*, c*/) {
        var memberKeyPartial = '';
        if (isNaN(Number(rowIndex))) {
          memberKeyPartial = rowIndex + (component.selectedColumnIndex.length === 0 ? '' : '-' + topColumnsArr[colIndex].replace(/:/g, '-'));
        } else {
          memberKeyPartial = (component.selectedColumnIndex.length === 0 ? '' : topColumnsArr[colIndex].replace(/:/g, '-'));
        }

        memberKeyPartial = memberKeyPartial.trim();
        row.append($('<td/>').highcharts('SparkLine', {
          series: [{
              color: tempSeriesColor,
              negativeColor: chart.type == 'winloss' ? component.losscolor() : null,
              data: function() {
                var dataArr = [];
                var negativeExist = false;
                for (var i = 0; i < rowDataJson[rowIndex][colIndex].length; i++) {
                  if (rowDataJson[rowIndex][colIndex][i] < 0) {
                    negativeExist = true;
                  }

                  dataArr.push({
                    name: component.selectedColumnIndex.length < 2 ? component.selectedColumnIndex.length === 0 ? 'Column' : component.dataRes.dimensions[component.selectedColumnIndex[0]].members[topColumnsArr[colIndex].split(':')[1]].text : component.dataRes.dimensions[component.selectedColumnIndex[1]].members[component.colIndexJson[topColumnsArr[colIndex]][i].split(':')[1]].text,
                    y: rowDataJson[rowIndex][colIndex][i],
                    memberKey: memberKeyPartial + (component.selectedColumnIndex.length >= 2 ? '-' + component.colIndexJson[topColumnsArr[colIndex]][i].replace(/:/g, '-') : '')
                  });
                }

                var memberKeyPartialArr = memberKeyPartial.split('-');
                var markerName = '', markerKey = '';
                for (var j = 0, k = 1; j < memberKeyPartialArr.length; j += 2, k = j + 1) {
                  markerName += '-' + component.dataRes.dimensions[memberKeyPartialArr[j]].members[memberKeyPartialArr[k]].text;
                  markerKey += '-' + component.dataRes.dimensions[memberKeyPartialArr[j]].members[memberKeyPartialArr[k]].key;
                }

                globalMarkerKey = markerKey.substring(1);
                var markerColor = tempSeriesColor;
                if (measureMarkerPair && globalMarkerKey !== '' && measureMarkerPair[globalMarkerKey] !== undefined) {
                  if (measureMarkerPair[globalMarkerKey].color !== undefined) {
                    markerColor = measureMarkerPair[globalMarkerKey].color;
                  }
                }

                component.memberInfoForMarker.push({
                  name: markerName.substring(1),
                  key: markerKey.substring(1),
                  color: markerColor
                });
                /*if(negativeExist == false && that.dataminrange()<0)
              		{
              			this.negativeColor='#FFFFFF';
              			dataArr.push({
              				name:"dummy",
              				y:that.dataminrange(),
              				memberKey:""});

              		}*/
                return dataArr;
              }(),

              //name: '<span>' + component.rowNames[rowIndex] + ' <br>' + component.dataRes.dimensions[tempKey[0]].members[colIndex].text + '</span>',
              rowname: component.rowNames[rowIndex],
              colname: component.dataRes.dimensions[tempKey[0]].members[colIndex].text,
              pointStart: 1,
              marker: function() {
                var markerarray = {
                  enabled: true,
                  fillColor: tempSeriesColor
                };

                if (measureMarkerPair && globalMarkerKey !== '' && measureMarkerPair[globalMarkerKey] !== undefined) {
                  markerarray = {
                    enabled: measureMarkerPair[globalMarkerKey].enabled,
                    radius: parseFloat(measureMarkerPair[globalMarkerKey].size),
                    symbol: measureMarkerPair[globalMarkerKey].symbol,
                    fillColor: measureMarkerPair[globalMarkerKey].color,
                    states: {
                      hover: {
                        enabled: measureMarkerPair[globalMarkerKey].hoverenable,
                        radius: parseFloat(measureMarkerPair[globalMarkerKey].size)
                      }
                    }
                  };
                }

                return markerarray;
              }()
            }],
          chart: {type: chart.type == 'winloss' ? 'column' : chart.type},
          yAxis: {min: component.dataminrange()}
        }));
      });

      table.append(row);
    });

    component.$().append('<div style=\'width:100%;height:100%;position:relative\'/>');
    if (!component.enablescroll()) {
      component.$().find('div').parent().css('overflow', 'hidden');
    }
    //alert($(".highcharts-container").html())
    component.$().find('div').append(table);
    // component.$().append(table);
    seriesColor.splice(rowNamesArr.length, seriesColor.length);
    component.dataseriescolor(seriesColor.join());
  };
}
